<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$lang=$Mainclass->LoadLanguage('addons/adminka/langs','','smiles-%');
$title=$lang['smiles_manag'];
$content=$error='';
if(isset($_POST['do']))
{
	switch($_POST['do'])
	{
		case 'add':
			if(empty($_POST['smile_emo']) or empty($_POST['smile_path']))
			{
				$error=$lang['empty_field'];
				break;
			}
			$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `emotion`={"1"} LIMIT 1',array('smiles','s_'.$_POST['smile_emo']),__file__,__line__);
			if($Mainclass->Db->Num_rows()>0)
				$error=$lang['emp_exists'];
			else
				$Mainclass->Db->Insert('smiles',array('emotion'=>$_POST['smile_emo'],'path'=>$_POST['smile_path'],'pos'=>$_POST['smile_pos']));
		break;
		case 'find':
			if(!empty($_POST['smile_path']) and is_dir($tdir=$Mainclass->FormatPath($_POST['smile_path'])))
			{
				$types=empty($_POST['smile_types']) ? 'gif' : $_POST['smile_types'];
				$types=explode(',',$types);
				foreach($types as $k=>$v)
				{
					$v=preg_quote(trim($v),'#');
					if(!$v)
						unset($types[$k]);
					else
						$types[$k]=$v;
				}
				if(!$types)
					$types[]='gif';
				$dump=array();
				$p=0;
				$Mainclass->Db->Query('SELECT `path`, `pos` FROM `prefix_smiles`',__file__,__line__);
				while($temp=$Mainclass->Db->Fetch_row())
				{
					$dump[]=$temp[0];
					if($temp[1]>$p)
						$p=$temp[1];
				}
				$fdir=$Mainclass->CheckSlash($_POST['smile_path']);
				$hdir=opendir($tdir);
				$insert=array();
				while($entry=readdir($hdir))
					if(is_file($tdir.'/'.$entry) and preg_match('#\.('.implode('|',$types).')$#i',$entry)>0 and !in_array($fdir.$entry,$dump))
					{
						$insert['emotion'][]=':'.substr($entry,0,strrpos($entry,'.')).':';
						$insert['path'][]=$fdir.$entry;
						$insert['pos'][]=++$p;
					}
				if($insert)
					$Mainclass->Db->Insert('smiles',array('emotion'=>$insert['emotion'],'path'=>$insert['path'],'pos'=>$insert['pos']),__file__,__line__);
				closedir($hdir);
			}
			else
				$error=$lang['no_folder'];
		break;
		case 'upload':
			if(is_uploaded_file($_FILES['file']['tmp_name']) and $_FILES['file']['size']<=524288)
			{
				$f=file($_FILES['file']['tmp_name']);
				foreach($f as $v)
				{
					if(strpos($v,'=')===false)
						continue;
					$vals=explode('=',$v,2);
					$Mainclass->Db->Update('smiles',array('emotion'=>$vals[1]),'`path`=\''.$Mainclass->Db->EscapeString($vals[0]).'\' LIMIT 1',__file__,__line__);
				}
			}
			else
				$error=$lang['file_not_load'];
		break;
		case 'save':
			if(isset($_POST['delete']) and is_array($_POST['delete']))
				$Mainclass->Db->Delete('smiles','`id`'.$Mainclass->Db->In($_POST['delete']));
			if(isset($_POST['emotion']) and is_array($_POST['emotion']))
			foreach($_POST['emotion'] as $k=>$v)
				$Mainclass->Db->Update('smiles',array('emotion'=>$v,'pos'=>isset($_POST['pos'][$k]) ? $_POST['pos'][$k] : '1'),'`id`='.(int)$k.' LIMIT 1');
		break;
		default:
			$error=$lang['unknown_event'];
		break;
	}
	if(!$error)
		UpdateSmilesCache();
}
$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->Title($title).$Mainclass->Template->OpenTable()
.'<form id="sm_form" action="" method="post"><table class="tabstyle"><tr class="first tablethhead"><th width="30">'.$lang['smile'].'</th><th width="60">'.$lang['emo'].'</th><th>'.$lang['path'].'</th><th width="50">'.$lang['pos'].'</th><th width="1">'.Template::Check('mass',false,'id="sm_mass_check" title="'.$Mainclass->lang['main']['delete'].'"').'</th></tr>';
$Mainclass->Db->Query('SELECT `id`,`path`,`emotion`,`pos` FROM `prefix_smiles` ORDER BY `pos` ASC',__file__,__line__);
$cnt=$Mainclass->Db->Num_rows();
$n=1;
while($arr=$Mainclass->Db->Fetch_assoc())
{
	$full=$Mainclass->FormatPath($arr['path']);
	if(!is_file($full))
	{
		$arr['path']='<span style="color: red"><b>'.$arr['path'].'</b></span>';
		$smile='<i>'.$Mainclass->lang['main']['no'].'</i>';
	}
	else
		$smile='<img src="'.$arr['path'].'" alt="" />';
	$content.='<tr class="'.($cnt==$n ? 'last ' : '').($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td align="center">'.$smile.'</td><td align="center">'.Template::Edit('emotion['.$arr['id'].']',$arr['emotion'],'style="width:50px"').'</td><td>'.$arr['path'].'</td><td align="center">'.Template::Edit('pos['.$arr['id'].']',$arr['pos'],'style="width:30px"').'</td><td align="center">'.Template::Check('delete[]',false,'value="'.$arr['id'].'"').'</td></tr>';
	$n++;
}
global $jscripts;
$jscripts[]='js/tabcontent.js';
$content.='</table><div class="submitline">'.Template::Button().Template::Control('do','hidden','save').'</div></form>
<script type="text/javascript">
One2AllCheckboxes("sm_form","sm_mass_check","delete[]");
</script><ul id="smilestabs" class="linetabs">
<li><a href="#" rel="tab1" class="selected"><b>'.$lang['add'].'</b></a></li>
<li><a href="#" rel="tab2"><b>'.$lang['search'].'</b></a></li>
<li><a href="#" rel="tab3"><b>'.$lang['load_conf'].'</b></a></li>
</ul>
<div id="tab1" class="tabcontent">
<form action="" method="post">
<table class="tabstyle tabform">
<tr><td class="label">'.$lang['fpath'].'</td><td>'.Template::Edit('smile_path',isset($_POST['smile_path']) ? $_POST['smile_path'] : '').'</td></tr>
<tr><td class="label">'.$lang['emo'].':</td><td>'.Template::Edit('smile_emo',isset($_POST['smile_emo']) ? $_POST['smile_emo'] : '').'</td></tr>
<tr><td class="label">'.$lang['pos'].':</td><td>'.Template::Edit('smile_pos',isset($_POST['smile_pos']) ? $_POST['smile_pos'] : '').'</td></tr>
</table><div class="submitline">'.Template::Button($lang['add']).Template::Control('do','hidden','add').'</div>
</form>
</div>
<div id="tab2" class="tabcontent">
<form action="" method="post">
<table class="tabstyle tabform">
<tr><td class="label">'.$lang['fopath'].'</td><td>'.Template::Edit('smile_path').'</td></tr>
<tr><td class="label">'.$lang['types'].'</td><td>'.Template::Edit('smile_types','gif,png').'</td></tr>
</table><div class="submitline">'.Template::Button($lang['find']).Template::Control('do','hidden','find').'</div>
</form>
</div>
<div id="tab3" class="tabcontent">
<form action="" method="post" enctype="multipart/form-data">
<table class="tabstyle tabform">
<tr><td class="label">'.$lang['up_file'].'</td><td>'.Template::Control('file','file').'</td></tr>
</table><div class="submitline">'.Template::Button().Template::Control('do','hidden','upload').'</div>
</form>
</div>
<script type="text/javascript">//<![CDATA[
var countries=new ddtabcontent("smilestabs");
countries.setpersist(true);
countries.setselectedClassTarget("link");
countries.init();
//]]></script>'.$Mainclass->Template->CloseTable();
$Mainclass->ShowDecoration();
echo $content;

function UpdateSmilesCache()
{global $Mainclass;
	$arr=array();
	$Mainclass->Db->Query('SELECT `path`,`emotion` FROM `prefix_smiles` ORDER BY `pos` ASC',__file__,__line__);
	while($temp=$Mainclass->Db->Fetch_row())
		if($temp[0] and $temp[1])
			$arr[$temp[1]]=$temp[0];
	$Mainclass->Cache->Put('smiles',array_unique($arr),0,false);
}
?>