<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey

	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadLanguage('addons/adminka/langs','user_g','user_groups-%');
global $groups_params, $mainpage;
/*
	Название; Массив (Заголовок, тип, значение по-умолчанию, extra, Описание, addon, если 1 то $_POST нет - $Mainclass->POST
	Для раздела, напишите просто ключевой текст
*/
$groups_params=array(
$Mainclass->lang['user_g']['base_o'],
'title'=>array($Mainclass->lang['user_g']['g_name'],'Edit','','','',''),
'html_pref'=>array($Mainclass->lang['user_g']['html_pref'],'Edit','','',$Mainclass->lang['user_g']['html_pref_d'],'',1),
'html_end'=>array($Mainclass->lang['user_g']['html_suf'],'Edit','','',$Mainclass->lang['user_g']['html_suf_d'],'',1),
$Mainclass->lang['user_g']['global_r'],
'access_cp'=>array($Mainclass->lang['user_g']['admin'],'Check',false,'',$Mainclass->lang['user_g']['admin_d'],'onclick="if(this.checked) return confirm(\''.$Mainclass->lang['main']['are_you_sure'].'\')"'),
'banned'=>array($Mainclass->lang['user_g']['ban'],'Check',false,'',$Mainclass->lang['user_g']['ban_d'],''),
$Mainclass->lang['user_g']['uploader'],
'use_files'=>array($Mainclass->lang['user_g']['on'],'Check',false,'',$Mainclass->lang['user_g']['uploader_d'],''),
'del_files'=>array($Mainclass->lang['user_g']['del_files'],'Check',false,'',$Mainclass->lang['user_g']['del_files_d'],''),
'max_upload'=>array($Mainclass->lang['user_g']['max_size'],'Edit','0','',$Mainclass->lang['user_g']['max_size_d'],''),
);
$mainpage=false;
if(isset($_GET['do']))
	DoIt(strtolower($_GET['do']));
elseif(isset($_GET['edit']))
	AddEditGroup((int)$_GET['edit']);
elseif(isset($_GET['save']))
	SaveGroup($_GET['save']=='new' ? true : (int)$_GET['save']);
elseif(isset($_GET['delete']))
	DeleteGroup((int)$_GET['delete']);
else
{
	GroupsList();
	$mainpage=true;
}

function DoIt($task)
{global $mainpage;
	switch ($task)
	{
		case 'newgroup':
			AddEditGroup(true);
		break;
		default:
			GroupsList();
			$mainpage=true;
		break;
	}
}

$Mainclass->navigation=array(
	array($Mainclass->Url->Prefix(false),($mainpage ? '!' : '').$Mainclass->GetModVal('title')),
	array($Mainclass->Url->ConstructUrl(array('do'=>'NewGroup')),((isset($_GET['do']) and $_GET['do']=='newgroup') ? '!' : '').$Mainclass->lang['user_g']['new_g']),
);

function GroupsList()
{global $Mainclass, $title;
	$title=$Mainclass->lang['user_g']['g_list'];
	$content=$Mainclass->Template->Title($title).$Mainclass->Template->OpenTable().'<table class="tabstyle"><tr class="first tablethhead"><th>'.$Mainclass->lang['main']['name'].'</th><th title="'.$Mainclass->lang['user_g']['access_admin'].'">'.$Mainclass->lang['user_g']['access_a'].'</th><th>'.$Mainclass->lang['user_g']['prot'].'</th><th>'.$Mainclass->lang['user_g']['users'].'</th><th width="70">'.$Mainclass->lang['main']['functs'].'</th></tr>';
	$Mainclass->Db->Query('SELECT `g`.`id`,`g`.`title`,`g`.`html_pref`,`g`.`html_end`,`g`.`protected`,`g`.`access_cp`,COUNT(`u`.`id`) `cnt` FROM `prefix_groups` `g` LEFT JOIN `prefix_users` `u` ON `g`.`id`=`u`.`group` GROUP BY `g`.`id` ORDER BY `g`.`title` ASC',__file__,__line__);
	$n=1;
	$cnt=$Mainclass->Db->Num_rows();
	while($arr=$Mainclass->Db->Fetch_assoc())
		$content.='<tr class="'.($cnt==$n ? 'last ' : '').($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td>'.$arr['html_pref'].$arr['title'].$arr['html_end'].'</td><td align="center">'.($arr['access_cp'] ? $Mainclass->lang['main']['yes'] : '<b>'.$Mainclass->lang['main']['no'].'</b>').'</td><td align="center">'.($arr['protected'] ? $Mainclass->lang['main']['yes'] : '<b>'.$Mainclass->lang['main']['no'].'</b>').'</td><td align="center">'.$arr['cnt'].'</td><td class="function">'.($arr['protected'] ? '' : '<a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a>').'<a href="'.$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a></td></tr>';
	$content.='</table>';
	$Mainclass->ShowDecoration(false);
	echo $content.$Mainclass->Template->CloseTable();
}

function AddEditGroup($id,$error='',$like=0)
{global $Mainclass,$title,$groups_params,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$arr_params=array();
	if($id===true)
	{
		foreach($groups_params as $k=>$v)
			$arr_params[$k]=$v[2];
		$title=$Mainclass->lang['user_g']['adding_g'];
		$id='new';
		if($like)
		{
			$Mainclass->Db->Query('SELECT * FROM `prefix_groups` WHERE `id`='.$like.' LIMIT 1',__file__,__line__);
			$arr=$Mainclass->Db->Fetch_assoc();
			foreach($arr as $k=>$v)
				$arr_params[$k]=$v;
		}
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT * FROM `prefix_groups` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPrefix();
			$arr_params=$Mainclass->Db->Fetch_assoc();
		}
		$title=$Mainclass->lang['user_g']['editing_g'];
	}
	if($error)
	{
		foreach($groups_params as $k=>$v)
		if(isset($_POST[$k]) and is_array($v))
			$arr_params[$k]=strcasecmp($v[1],'editor')==0 ? $Mainclass->Editor->GetHTML($k) : $_POST[$k];
		else
			$arr_params[$k]='';
	}
	$content=$Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable()
	.'<form action="'.$Mainclass->Url->ConstructUrl(array('save'=>$id)).'" method="post">
	<table class="tabstyle tabform">';
	foreach($groups_params as $k=>$v)
	{
		if(!is_array($v))
		{
			$content.='<tr class="infolabel"><td colspan="2">'.$v.'</td></tr>';
			continue;
		}
		$mn=false;
		switch(strtolower($v[1]))
		{
			case 'user':
				if(!is_callable($v[3]))
					continue 2;
				$update_arr[$k]=call_user_func($v[3],'save',null,$v[5]);
			break;
			case 'editor':
				$value=$Mainclass->Editor->Area($k,$arr_params[$k],5);
			break;
			case 'radios':
				$value=Template::Radios($k,$v[3],$arr_params[$k],'<br />',$v[5]);
			break;
			case 'edit':
			case 'text':
				$value=Template::$v[1]($k,$arr_params[$k],$v[5],!empty($v[6]));
			break;
			case 'items':
				$arr_params[$k]=explode(',',$arr_params[$k]);
			case 'item':
				$mn=true;
			case 'select':
				$value='';
				foreach($v[3] as $k_=>$v_)
					$value.=Template::Option($v_,$k_,is_array($arr_params[$k]) ? in_array($k_,$arr_params[$k]) : $arr_params[$k]==$k_);
				$arr_params[$k]=$value;
				if($mn)
				{
					$value=Template::$v[1]($k,$arr_params[$k],10,$v[5]);
					break;
				}
			default:
				$value=Template::$v[1]($k,$arr_params[$k],$v[5]);
			break;
		}
		$content.='<tr><td class="label">'.(empty($v[4]) ? '' : '<span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($v[4],ENT_QUOTES).'\')">(?)</span>').$v[0].'</td><td>'.$value.'</td></tr>';
	}
	$content.='</table><div class="submitline">'.Template::Button().'</div></form>';
	$Mainclass->ShowDecoration(false);
	echo $content.$Mainclass->Template->CloseTable();
}

function SaveGroup($id)
{global $Mainclass, $groups_params;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditGroup($id);
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$arr_params=array();
	foreach($groups_params as $k=>$v)
		if(is_array($v))
			switch(strtolower($v[1]))
				{
					case 'user':
						if(!is_callable($v[3]))
							continue 2;
						$arr_params[$k]=call_user_func($v[3],'save',null,$v[5]);
					break;
					case 'editor':
						$arr_params[$k]=$Mainclass->Editor->GetHTML($k);
					break;
					case 'check':
						$arr_params[$k]=isset($_POST[$k]) ? '1' : 0;
					break;
					default:
						if(empty($_POST[$k]))
							$arr_params[$k]='';
						else
							$arr_params[$k]=is_array($_POST[$k]) ? ','.implode(',',$_POST[$k]).',' : (empty($v[6]) ? $Mainclass->POST[$k] : $_POST[$k]);
					break;
				}
	$arr_params['title']=trim($arr_params['title']);
	if(!$arr_params['title'])
		return AddEditGroup($id,$Mainclass->lang['user_g']['empty_title']);
	if(!$arr_params['access_cp'] and $id!==true)
	{
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_groups` WHERE `access_cp` AND `id`!='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			return AddEditGroup($id,$Mainclass->lang['user_g']['no_admins']);
	}
	if(is_int($id))
		$Mainclass->Db->Update('groups',$arr_params,'`id`='.$id.' LIMIT 1',__file__,__line__);
	else
		$Mainclass->Db->Insert('groups',$arr_params,__file__,__line__);
	ExitPrefix();
}

function DeleteGroup($id)
{global $Mainclass, $title;
	$Mainclass->Db->Query('SELECT `title`, `html_pref`, `html_end` FROM `prefix_groups` WHERE `id`='.$id.' AND `protected`=0',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return $Mainclass->Template->ErrorScreen($Mainclass->lang['user_g']['cant_del']);
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		$Mainclass->Db->Delete('groups','`id`='.$id.' AND `protected`=0',__file__,__line__);
		ExitPrefix();
	}
	else
	{
		list($stitle,$html_pref,$html_end)=$Mainclass->Db->Fetch_row();
		$title=$Mainclass->lang['user_g']['del_confirm'];
		$Mainclass->ShowDecoration(false);
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'	=>sprintf($Mainclass->lang['user_g']['deleting'],$html_pref.$stitle.$html_end)
													)
											);
	}
}
?>