tinyMCE.init({
	language : "ru",
	mode : "specific_textareas",
	editor_selector : "tiny_mce_editor",
	theme : "advanced",
	plugins : "safari,pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template",
	theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontsizeselect",
	theme_advanced_buttons2 : "link,unlink,anchor,|,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,|,sub,sup,|,forecolor,backcolor",
	theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,insertdate,inserttime,iespell",
	theme_advanced_buttons4 : "code,fullscreen,newdocument,cleanup,|,blockquote,cite,abbr,acronym,del,ins,|,nonbreaking,pagebreak,|,charmap,emotions,|,image,media",
	theme_advanced_toolbar_location : "top",
	theme_advanced_toolbar_align : "left",
	theme_advanced_statusbar_location : "bottom",
	theme_advanced_resizing : true,
	theme_advanced_styles : "Style 1=style1;Style 2=style2;Style 3=Style3;Small=small",
	setup:function(tiny)
	{
		EDITOR.NewEditor(
							tiny.id,
							function(text){tiny.execCommand("mceInsertContent",false,text);},
							function(text){tiny.setContent(text)},
							function(){return tiny.getContent()}
		);
		tiny.onActivate.add(function(){EDITOR.ActivateEditor(tiny.id)});
	}
	});