<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
$start=microtime();#Начало отсчета времени движка.
define('CMS',true);
require dirname(__file__).'/classes/mainclass.php';
$Mainclass=MainClass::getInstance();
$Mainclass->start_time=$start;
$Mainclass->service_id='1';#ID сервиса
$Mainclass->file_name=basename(__file__);
if(0<$t=strpos($Mainclass->site_path,$Mainclass->file_name))
	$Mainclass->site_path=$t==1 ? '' : substr($Mainclass->site_path,0,$t-1);
$Mainclass->module_gfc='GetModuleInfo';
$Mainclass->module_sfc='SetModuleInfo';
$Mainclass->module['sub_module']=array();
$Mainclass->LoadOptions(array('system','blocker','login','mailer','public'));
$Mainclass->LoadService();
if($Mainclass->vars['multilang'])
{
	if(isset($_GET['language']) and is_string($_GET['language']))
	{
		if($Mainclass->Login->IsUser())
			$Mainclass->Account->Manage->UpdateUser(array('lang'=>$_GET['language']));
		else
			$Mainclass->Functions->SetLangCookie($_GET['language'],$Mainclass->service.'_lang');
		ExitBack();
	}
	if($Mainclass->Login->IsUser() and $lang=$Mainclass->Account->GetValue('lang') and isset($Mainclass->langs[$lang]))
		$Mainclass->lang_name=$lang;
	else
		$Mainclass->Functions->GetLangCookie(true,$Mainclass->service.'_lang');
}
$Mainclass->LoadLanguage('langs','main','admin-%');
$Mainclass->Template->default_replace['site']=$Mainclass->domain.$Mainclass->site_path;
if($Mainclass->vars['url_static_delimeter'])
	$Mainclass->Url->s_delimeter=$Mainclass->vars['url_static_delimeter'];
if($Mainclass->vars['url_static_defis'])
	$Mainclass->Url->s_defis=$Mainclass->vars['url_static_defis'];
if($Mainclass->vars['url_static_ending'])
	$Mainclass->Url->ending=$Mainclass->vars['url_static_ending'];
if($Mainclass->vars['url_rep_space'])
	$Mainclass->Url->rep_space=$Mainclass->vars['url_rep_space'];
$title=$head_addon='';
$jscripts[]='js/jquery.min.js';
$jscripts[]='js/lang-'.$Mainclass->lang_name.'.js';
$jscripts[]='js/class_ajax.js';
$jscripts[]='js/jMainclass.js';
$jscripts[]='js/admin_scripts.js';
$Mainclass->Cache->FilterLangVars();
if($Mainclass->Login->IsUser())
{
	$Mainclass->on_begin_callback='Begin';
	if(isset($_POST['logout']) or isset($_GET['logout']))
	{
		$Mainclass->Login->LogOut();
		Functions::Redirect($Mainclass->file_name);
		exit;
	}
	$Mainclass->Account->AddSession();
	$Mainclass->Permission->IsAdmin();
	$section=isset($_GET['section']) ? strtolower($_GET['section']) : '';
	$section_does=false;
	$Mainclass->admin_prefix=$Mainclass->file_name.$Mainclass->Url->ConstructUrl(array('section'=>'modules','key'=>$Mainclass->Login->key));
	switch ($section)
	{
		case 'options':
			$Mainclass->module['title']=$Mainclass->lang['main']['options'];
			$Mainclass->module['name']='options';
			$Mainclass->module['image']='setting-%.png';
			$Mainclass->Url->d_prefix=str_replace('modules','options',$Mainclass->admin_prefix).$Mainclass->Url->GetDel();
			$section_does=$Mainclass->LoadModule('addons/adminka/modules',false,'section_options');
		break;
		case 'management':
			$Mainclass->module['title']=$Mainclass->lang['main']['management'];
			$Mainclass->module['name']='management';
			$Mainclass->Url->d_prefix=str_replace('modules','management',$Mainclass->admin_prefix).$Mainclass->Url->GetDel();
			$section_does=$Mainclass->LoadModule('addons/adminka/modules',false,'section_management');
		break;
		case 'modules':
			$Mainclass->module['title']=$Mainclass->lang['main']['modules'];
			$Mainclass->module['name']='modules';
			$Mainclass->module['image']='modules-%.png';
			$Mainclass->Url->d_prefix=$Mainclass->admin_prefix.$Mainclass->Url->GetDel();
			$section_does=$Mainclass->LoadModule('addons/adminka/modules',false,'section_modules');
		break;
	}
	if(!$section_does)
	{
		$Mainclass->module['title']=$Mainclass->lang['main']['main page'];
		$Mainclass->module['name']=$_GET['section']='general';
		$Mainclass->module['general']=true;
		$Mainclass->Url->d_prefix=str_replace('modules','general',$Mainclass->admin_prefix).$Mainclass->Url->GetDel();
		$Mainclass->LoadModule('addons/adminka/modules',false,'section_general');
	}
}
else
{
	$error='';
	$whereform = empty($_SERVER['QUERY_STRING']) ? '' : base64_encode($_SERVER['QUERY_STRING']);
	if(isset($_POST['user_name'],$_POST['pass']))
		if($Mainclass->Login->Login())
		{
			$Mainclass->Account->DelCurrSession();
			$query=isset($_POST['whereform']) ? '?'.base64_decode($_POST['whereform']) : '';
			$query=preg_replace('/key=[a-f0-9]{32}/i','key='.$Mainclass->Login->key,$query);
			Functions::Redirect($Mainclass->file_name.$query);
			exit;
		}
		else
		{
			$error=$Mainclass->Login->error;
			if(isset($_POST['whereform']))
				$whereform=$_POST['whereform'];
		}
	$Mainclass->Account->AddSession();
	$arr=array(
				'file'		=>$Mainclass->file_name,
				'charset'	=>ELEANOR_DISPLAYCHARSET,
				'msg'		=>$error ? $Mainclass->Template->Message($error) : '',
				'whereform'	=>$whereform
	);
	$Mainclass->Template->default_replace+=$arr;
	$Mainclass->ShowDecoration(true,'Enter');
}

function Begin()
{global $title, $jscripts, $Mainclass, $head_addon;
	$general_title=$Mainclass->lang['main']['adminka'].' &raquo; '.$Mainclass->module['title'];
	if(($temp=$Mainclass->GetModVal('title'))!=$Mainclass->module['title'])
		$general_title.=' &raquo; '.$temp;
	$head='<meta http-equiv="content-type" content="text/html; charset='.ELEANOR_DISPLAYCHARSET.'" />
<meta name="eleanor_version" content="'.ELEANOR_VERSION.'" />
<title>'.$general_title.($title ? ' &raquo; ' : '').(is_array($title) ? join(' &raquo; ',$title) : $title).'</title>'
		.(isset($head_addon) ? "\r\n".$head_addon : '');
	$head.=Strings::JsVars(array(
										'cookie_domain'	=>$Mainclass->vars['cookie_domain'],
										'cookie_prefix'	=>$Mainclass->vars['cookie_prefix'],
										'cookie_path'	=>$Mainclass->vars['cookie_path'],
										'cookie_time'	=>$Mainclass->vars['cookie_save_time'],
										'site_path'		=>$Mainclass->site_path,
										'site_lang'		=>$Mainclass->lang_name,
	));
	$jscripts=array_unique($jscripts);
	foreach($jscripts as &$v)
		$head.="\r\n".Strings::AddJS($v);
	$Mainclass->Template->default_replace['HEAD']=$head;
}

function GetModuleInfo($param,$hope_value)
{
	$Mainclass=Mainclass::getInstance();
	$module=$Mainclass->module['sub_module']+$Mainclass->module;
	unset($module['sub_module']);
	if($hope_value===null)
		return isset($module[$param]) ? $module[$param] : false;
	elseif(is_array($hope_value))
		return isset($module[$param]) and in_array($module[$param],$hope_value);
	else
		return isset($module[$param]) and $module[$param]==$hope_value;
}

function SetModuleInfo($param,$value)
{global $Mainclass;
	$Mainclass->module['sub_module'][$param]=$value;
}

function CheckKey()
{global $Mainclass;
	return (isset($_GET['key']) and Strings::IsMd5($_GET['key']) and $Mainclass->Login->key==$_GET['key']);
}

function ExitPrefix($addon=array())
{global $Mainclass;
	$addon=$addon ? html_entity_decode($Mainclass->Url->ConstructUrl($addon)) : $Mainclass->Url->Prefix();
	Functions::Redirect(ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.$addon);
}

function Author($author,$author_id)
{global $Mainclass;
	$uniq=uniqid('u');
	if(!$author)
		$author=$Mainclass->Account->GetValue('name',false);
	if($author_id=='')
		$author_id=$Mainclass->Account->GetValue('id',false);
	return Template::Edit('author',$author,'id="a'.$uniq.'"').' '.$Mainclass->lang['main']['id'].Template::Edit('author_id',$author_id,'style="width: 25px" id="u'.$uniq.'"')
			.'<a href="#" title="'.$Mainclass->lang['main']['select_user'].'" onclick="var h=380,w=360;window.open(\''
			.str_replace('modules','management',$Mainclass->admin_prefix.$Mainclass->Url->GetDel())
			.$Mainclass->Url->ConstructUrl(array('module'=>'users','do'=>'userlist','unique'=>$uniq),false).'\',\'ul'.$uniq.'\',\'height=\'+h+\',width=\'+w+\',toolbar=no,menubar=no,location=no,scrollbars=no,focus=yes,top=\'+Math.round((screen.height-h)/2)+\',left=\'+Math.round((screen.width-w)/2)); return false;">'
			.' <img src="'.$Mainclass->Template->GetImage('select_users.png').'" width="16" height="16" alt="" /></a>';
}

function ExitBack()
{global $Mainclass;
	$ref=$Mainclass->MyGetEnv('HTTP_REFERER');
	if(!$ref)
		return ExitPrefix();
	else
		Functions::Redirect($ref);
}
?>