<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$not_create=true;
class Strings extends BaseClass
{
	const
		ALL		='a-zA-Z0-9абвгдеёжзийклмнопрстуфхцчшщьъыэюяєіїАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЬЪЫЭЮЯЄІЇ',
		ALL_CYR	='абвгдеёжзийклмнопрстуфхцчшщьъыэюяєіїАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЬЪЫЭЮЯЄІЇ';

	public static function ScriptText($text,$tag=true)
	{
		return ($tag ? '<script type="text/javascript">//<![CDATA['."\r\n" : '')
			.'document.write("'.addslashes(str_replace(array("\r\n","\n","\r",'    '),'',$text)).'");'
			.($tag ? "\r\n".'//]]></script>'."\r\n" : '');
	}

	public static function AddJS($path)
	{
		return '<script type="text/javascript" src="'.$path.'"></script>';
	}

	/*
		Функция служит для вывода переменных в JavaScript. Полностью сохраняет структуру переменной.
		$arr - массив в виде имя переменной (ключ массива) => значение. Поддерживаются многомерные массивы.
		$tag - признак обрамления результата в <script...>...</script>
		$arr_name - если результат требуется в виде массива, в эту переменную следует указать имя этого массива.
	*/
	public static function JsVars($arr,$tag=true,$arr_name=false)
	{
		$result='';
		if($arr_name)
		{
			$result=$arr_name===true ? '{' : 'var '.$arr_name.'={';
			foreach($arr as $k=>&$v)
			{
				if(is_array($v))
					$value=self::JsVars($v,false,true);
				else
					$value=substr($v,0,2)=='!_' ?  substr($v,2) : '"'.addslashes($v).'"';
				$result.=(is_int($k) ? $k : '\''.$k.'\'').':'.$value.',';
			}
			$result=rtrim($result,',').'}';
			if($arr_name===true)
				return $result;
			$result.=";\r\n";
		}
		else
			foreach($arr as $k=>&$v)
				$result.='var '.$k.'='.(substr($v,0,2)=='!_' ?  substr($v,2) : '"'.addslashes($v).'"').";\r\n";
		return ($tag ? "<script type=\"text/javascript\">//<![CDATA[\r\n".$result.'//]]></script>' : $result);
	}

	public static function MakePHPFile($values)
	{
		if(is_array($values))
			$values=implode("\r\n",$values);
		return '<?php'."\r\n".'if(!defined(\'CMS\'))'."\r\n\t".'die(\'Попытка взлома?\');'."\r\n\r\n".$values."\r\n".'?>';
	}

	public static function Text2Hex($text,$decode=true)
	{
		if($decode)
			$text=htmlspecialchars_decode($text);
		$new_text='';
		$t_len=mb_strlen($text,ELEANOR_CHARSET);
		for($i=0;$i<$t_len;$i++)
		{
			$o=dechex(ord($text[$i]));
			$s='';
			$s=str_pad($s,2-strlen($o),'0',STR_PAD_LEFT).$o;
			$new_text.=$s;
		}
		return $new_text;
	}

	public static function Hex2Text($hex)
	{
		$nhex='';
		$h_cnt=strlen($hex);
		for($i=0;$i<$h_cnt;$i=$i+2)
			$nhex.=chr(hexdec(substr($hex,$i,2)));
		return $nhex;
	}

	public static function CutStr($str,$cnt=30,$end='...')
	{
		if(strlen($str)>$cnt)
		{
			$str=substr($str,0,$cnt);
			$str=preg_replace('#[&<][^;]+$#','',$str).$end;
		}
		return $str;
	}

	public static function MarkWords($words,$text,$color='#FFFF00',$bcolor='#FF0000')
	{
		if(!$text or !$words)
			return '';
		if(!is_array($words))
			$words=explode(' ',$words);
		foreach($words as $k=>&$v)
		{
			$v=trim($v);
			if($v)
				$v=str_replace(array('<','>'),'',$v);
			else
				unset($words[$k]);
		}
		$text=preg_replace('#(?<=>|^)([^<]+)#e','self::DoMarkWords(\'\1\',$words,$color,$bcolor)',$text);
		return $text;
	}

	protected static function DoMarkWords($text,$words,$color,$bcolor)
	{
		$text=stripslashes($text);
		return preg_replace('#(?:\b)('.join('|',$words).')(?:\b)#i','<span style="background-color: '.$color.'; color: '.$bcolor.';">\1</span>',$text);
	}

	public static function IsMd5($str)
	{
		return ctype_xdigit($str) and strlen($str)==32;
	}

	public static function Translit($str)
	{
		$rus_letters='абвгдезиійклмнопрстуфхцы';
		$eng_letters='abvgdeziiyklmnoprstufhcy';
		$arr_letters=array(
							'ё'=>'yo',
							'ж'=>'zh',
							'ч'=>'ch',
							'ш'=>'sh',
							'щ'=>'sch',
							'э'=>'ye',
							'ю'=>'yu',
							'я'=>'ya',
							'ї'=>'yi',
							'ъ'=>'',
							'ь'=>'',
		);
		$rus_letters_big='АБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЬЪЫЭЮЯЄІЇ';
		$rus_letters_small='абвгдеёжзийклмнопрстуфхцчшщьъыэюяєії';
		$str=trim($str);
		$str=strtr($str,$rus_letters_big,$rus_letters_small);
		$str=strtr($str,$rus_letters,$eng_letters);
		$str=strtr($str,$arr_letters);
		return $str;
	}

	/*
		Функция добавляет заданное количество символа \t (tab) в начало каждой строки передаваемого текста
	*/
	public static function AddTabs($text,$tabs=1)
	{
		$s=str_repeat("\t",$tabs);
		return $s.str_replace("\n","\n".$s,trim($text));
	}

	public static function GenPass($cnt)
	{
		$cnt=(int)$cnt;
		$pass='';
		for($i=0;$i<$cnt;$i++)
		{
			$sym=mt_rand(48, 122);
			if(($sym>57 and $sym<65) or ($sym>90 and $sym<97))
				$sym=$sym - 9;
			$pass.=chr($sym);
		}
		return $pass;
	}

	public static function CleanForExplode($string,$str=',')
	{
		$str_=preg_quote($str,'/');
		$string=preg_replace('/(?:'.$str_.'){2,}/',$str,$string);
		return preg_replace(array('/(?:'.$str_.')$/','/^(?:'.$str_.')/'),'',$string);
	}

	/*
		Функция проверяет корректность даты в формате YYYY-MM-DD или YYYY-MM-DD HH:II:SS
	*/
	public static function CheckDate($sdate,$time=false)
	{
		if(preg_match('#^(\d{4})\D(\d{2})\D(\d{2})'.($time ? '\s(\d{2}):(\d{2}):(\d{2})' : '').'$#',$sdate,$matches)==0)
			$correct=false;
		else
		{
				$correct=CheckDate($matches[2],$matches[3],$matches[1]);
			if($time)
				$correct&=($matches[4]<24 and $matches[4]>=0 and $matches[5]<60 and $matches[5]>=0 and $matches[6]<60 and $matches[6]>=0);
		}
		return $correct ? preg_replace('#\D+#','-',$sdate,2) : date('Y-m-d'.($time ? ' H:i:s' : ''));
	}

	public static function PassHash($salt,$pass,$already_md=false)
	{
		return md5(md5($salt).($already_md ? $pass : md5($pass)));
	}

	/*
		Функция проверяет, соответствует ли строка маске.
		Маска вводиться как:
		% - один любой символ
		* - любая последовтальность символов
		=====
		Я знаю о функции fnmatch, но "На данный момент эта функция недоступна в Windows и других POSIX-несовместимых системах."
	*/
	public static function MatchMask($mask,$string)
	{
		$mask=preg_quote($mask);
		$mask=str_replace(array('%','\*'),array('.?','.*?'),$mask);
		return preg_match('~'.$mask.'~is',$string)>0;
	}

	/*
		Две функции, которые делают из строки 1,2,3-7 строку 1,2,3,4,5,6,7
	*/
	public static function FillInt($str)
	{
		$str=preg_replace('#[^0-9,\-]+#','',$str);
		$str=preg_replace_callback('/([0-9]+)\-([0-9]+)/',array(__class__,'FillInt2'),$str);
		return $str;
	}

	private static function FillInt2($arr)
	{
		$a=(int)$arr[1];
		$b=(int)$arr[2];
		if($a>=$b)
			return $a.','.$b;
		$result='';
		for($a;$a<$b;$a++)
			$result.=$a.',';
		return $result.$b;
	}

	public static function XssCheckUrl($url)
	{
		$url=trim($url);
		if(strpos($url,'mailto:')===0)
			return Functions::CheckEmail(substr($url,7));
		return preg_match('~^([a-z]{3,10}://[a-zа-я0-9/\._\-:]+\.[a-z]{2,5}/)?(?:[^\s@{}]*)?$~i',$url)>0;
		/*Определеить все ссылки в тексте:
		\b(?:(?:[a-z]+://|www\.)(?:[a-z0-9-]+\.)*[a-z0-9]+|(?:[a-z0-9][a-z0-9-]*\.)+(?:ru|com|net|org)(?![\w-]))\S*(?:(?<![[:punct:]])|(?<=[-/&+*]))
		http://xpoint.ru/know-how/PHP/GotovyieResheniya
		*/
	}

	public static function MatchType($file_name,$types='')
	{
		if(!$types)
			return true;
		if(is_array($types))
		{
			foreach($types as $k=>$v)
				$types[$k]=preg_quote($v,'#');
			$types=join('|',$types);
		}
		else
			$types=preg_quote($types,'#');
		return preg_match('#\.('.$types.')$#i',$file_name)>0;
	}

	/*
		Функция делает человекопонятную дату из строки YYYY-MM-DD => 19 января 2008 г.
		$str может быть и массивом array('y'=>YYYY,'m'=>MM,'d'=>DD)
		$today - Выводить надписи "Сегодня", "Вчера" вместо полной даты
	*/
	public static function HumanDate($str,$today=true,$time=false)
	{static $lang;
		if(!isset($lang))
			$lang=Mainclass::getInstance()->LoadLanguage('langs','','strings_date-%');
		$d=true;
		if(is_string($str))
		{
			if(strlen($str)<=7)
			{
				$str.='-01';
				$d=false;
				$time=false;
			}
			if(preg_match('#^(\d{4})\D(\d{1,2})\D(\d{1,2})'.($time ? '(.*)' : '').'$#',$str,$matches)==0 or !CheckDate($matches[2],$matches[3],$matches[1]))
				return '';
			$str=array('y'=>(int)$matches[1],'m'=>(int)$matches[2]);
			if($d)
				$str['d']=(int)$matches[3];
		}
		elseif(is_array($str))
		{
			if(empty($str['y']) or empty($str['m']))
				return '';
			if(empty($str['d']))
			{
				$str['d']=1;
				$d=false;
			}
			if(!CheckDate($str['m'],$str['d'],$str['y']))
				return '';
		}
		else
			return '';
		if($today and $d)
		{
			if(mktime(0,0,0,date('m'),date('d'),date('Y'))==$mk=mktime(0,0,0,$str['m'],$str['d'],$str['y']))
				return $lang['today'].($time ? $matches[4] : '');
			if(mktime(0,0,0,date('m'),date('d')-1,date('Y'))==$mk)
				return $lang['yesterday'].($time ? $matches[4] : '');
		}
		$monthes=array('',$lang['jan'],$lang['feb'],$lang['mar'],$lang['apr'],$lang['may'],$lang['jun'],$lang['jul'],$lang['aug'],$lang['sep'],$lang['oct'],$lang['nov'],$lang['dec']);
		$monthes_d=array('',$lang['jan_'],$lang['feb_'],$lang['mar_'],$lang['apr_'],$lang['may_'],$lang['jun_'],$lang['jul_'],$lang['aug_'],$lang['sep_'],$lang['oct_'],$lang['nov_'],$lang['dec_']);
		return ($d ? $str['d'].' '.$monthes_d[$str['m']].' '.$str['y'] : $monthes[$str['m']].' '.$str['y']).($time ? $matches[4] : '');
	}

	public static function MakeKeyWords($text,$symlimit=300,$minlen=3,$maxlen=30)
	{
		$text=strip_tags($text);
		$lets=array('`','\'','№',';',':','?','-','=','|','\'','\\','/','~','!','@','#','$','%','^','&','*','(',')','_','+','[',']','{','}',',','.','<','>',"\r","\n","\t","\r",'  ');
		$text=str_replace($lets,' ',$text);
		if(isset($text[$symlimit]))
			$text=mb_substr($text,0,strpos($text,' ',$symlimit),ELEANOR_CHARSET);
		$ends=array('ые','ое','ие','ий','ая','ый','ой','ми');
		$words=array_unique(explode(' ',$text));
		foreach($words as $k=>&$word)
		{
			$l=mb_strlen($word,ELEANOR_CHARSET);
			if($l<$minlen or $l>$maxlen or is_numeric($word) or in_array(substr($word,-2),$ends))
				unset($words[$k]);
		}
		return htmlspecialchars(implode(',',$words),ENT_QUOTES);
	}

	public static function UcFirst($str)
	{
		if(!$str)
			return '';
		$first=mb_substr($str,0,1,ELEANOR_CHARSET);
		$first=mb_strtoupper($first,ELEANOR_CHARSET);
		return $first.mb_substr($str,1);
	}

	/*
		Функция служит для того, чтобы распарсить строку параметров вида
		param1="value1" param2=   value2 param3="v      arlue3"
		$str - строка
		$first_param служит для указания имени первого параметра, если $str начинается с =value
	*/
	public static function ParseParams($str,$first_param=0)
	{
		$arr=array();
		$str=trim($str).' ';
		$len=strlen($str);
		if($len>1)
		{
			$cur_pos=0;
			$letters='ABCDEFGHIJKLMNOPQRSTUVWXYZ012345679';
			$strep=array(' ',"\t");
			$in_value=$fin_param=false;
			$quot=$param=$value='';
			while($cur_pos<$len)
			{
				if($cur_pos==0 and mb_substr($str,$cur_pos,1,ELEANOR_CHARSET)=='=')
				{
					$param=$first_param;
					++$cur_pos;
					$fin_param=true;
					continue;
				}
				if(stripos($letters,mb_substr($str,$cur_pos,1,ELEANOR_CHARSET))!==false)
				{
					if($in_value)
						$value.=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
					elseif($fin_param)
					{
						$quot='';
						$in_value=true;
						$value=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
					}
					else
						$param.=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
				}
				elseif(mb_substr($str,$cur_pos,1,ELEANOR_CHARSET)=='"' or mb_substr($str,$cur_pos,1,ELEANOR_CHARSET)=="'")
				{
					if($quot==mb_substr($str,$cur_pos,1,ELEANOR_CHARSET) and $in_value)
					{
						$arr[trim($param)]=trim($value);
						$quot=$value=$param='';
						$fin_param=$in_value=false;
					}
					elseif($in_value)
						$value.=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
					elseif($fin_param)
					{
						$in_value=true;
						$quot=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
					}
					else
					{
						$quot=$value=$param='';
						$fin_param=$in_value=false;
					}
				}
				elseif(in_array(mb_substr($str,$cur_pos,1,ELEANOR_CHARSET),$strep))
				{
					if($in_value)
						if($quot=='')
						{
							$arr[trim($param)]=trim($value);
							$quot=$value=$param='';
							$fin_param=$in_value=false;
						}
						else
							$value.=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
					elseif($param)
					{
						$arr[trim($param)]=trim($param);
						$quot=$value=$param='';
						$fin_param=$in_value=false;
					}
				}
				elseif($fin_param)
				{
					$in_value=true;
					$value.=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
				}
				elseif($in_value)
					$value.=mb_substr($str,$cur_pos,1,ELEANOR_CHARSET);
				elseif(mb_substr($str,$cur_pos,1,ELEANOR_CHARSET)=='=')
				{
					if($param)
						$fin_param=true;
					else
					{
						++$cur_pos;
						while(!in_array(mb_substr($str,$cur_pos,1,ELEANOR_CHARSET),$strep) and $cur_pos<$len)
							++$cur_pos;
					}
				}
				++$cur_pos;
			}
		}
		return $arr;
	}

	/*
		Функция для показа страниц
		$nums - количество контента
		$per_page - сколько единиц на страницу
		$link_arr - массив ссылок
		$all (bool) - показывать все страницы или нет.
		$page - номер текущей страницы (полезно для AJAX).
				Если $page равна 0 или 1, то страницы считаются от 1 до $pages, причем, только если она больше 1, то это значение будет
				использоваться для расчетов. В противоположном - значение будет браться с $_GET
				Если $page равна -1, то страницы будут выстариваться от $pages до 1.
		$onclick - тут пишется только часть, после return. Это строка, в которой содержиться участок {page} - сюда подставляется значение страницы.
	*/
	public static function Pages($nums,$per_page,$link_arr=array(),$all=false,$page=0,$onclick='',$gap=8)
	{global $head_addon;
		$Mainclass=Mainclass::getInstance();
		$links=is_array($link_arr) ? $Mainclass->Url->ConstructUrl(array_merge($link_arr,array(array('page'=>'{page}')))) : $link_arr;
		$links=str_ireplace('%7Bpage%7D','{page}',$links);
		$result=array();
		$pages=ceil((int)$nums/$per_page);
		$gap=ceil($gap/2);

		$page=(int)$page;
		$reverse=false;
		if($page==0)
			$page=empty($_GET['page']) ? 1 : (int)$_GET['page'];
		elseif($page<0)
		{
			$page=empty($_GET['page']) ? $pages : (int)$_GET['page'];
			$reverse=true;
		}
		$page=abs($page);
		if($pages>1)
		{
			$result[]='<a href="#" onclick="return JumpToPage(\''.$links.'\',\''.$pages.'\',\''.addslashes($onclick).'\');"><img src="'.$Mainclass->Template->GetImage('gotopage.png').'" alt="'.$Mainclass->lang['main']['goto_page'].'" /></a>';
			if(strpos($links,'{page}')!==false)
			{
				if($reverse)
				{
					if($page<$pages)
						$head_addon.='<link rel="prev" href="'.str_ireplace('{page}',$page+1,$links).'" />';
					if($page>1)
						$head_addon.='<link rel="next" href="'.str_ireplace('{page}',$page-1,$links).'" />';
				}
				else
				{
					if($page>1)
						$head_addon.='<link rel="prev" href="'.str_ireplace('{page}',$page-1,$links).'" />';
					if($page<$pages)
						$head_addon.='<link rel="next" href="'.str_ireplace('{page}',$page+1,$links).'" />';
				}
			}
			$i=$reverse ? $pages : 1;
			for(;;)
			{
				if($i<1 or $i>$pages)
					break;
				if($i==$page)
					$result[]='<span>'.$i.'</span>';
				elseif($all or ($i<=$gap or $i>($pages-$gap) or $i>=($page-$gap) and $i<=($page+$gap)))
				{
					$event=$onclick ? ' onclick="return '.str_ireplace('{page}',$i,$onclick).'"' : '';
					$result[]='<a href="'.str_ireplace('{page}',$i,$links).'"'.$event.'>'.$i.'</a>';
				}
				else
				{
					$result[]='<span class="numbersmore">...</span>';
					if($i>($page+$gap))
						$i=$reverse ? $page+$gap : $pages-$gap+1;
					else
						$i=$reverse ? $gap : $page-$gap;
					continue;
				}
				if($reverse)
					$i--;
				else
					$i++;
			}
			return '<div class="numbers"><b>'.$Mainclass->lang['main']['pages'].' </b>'.implode(' ',$result).'</div>';
		}
		return '';
	}
	/*
		Функция парсинка своих ББ кодов. Парсятся как буд-то для экрана пользователя
	*/
	public static function ParseOwnBB($text)
	{
		$Mainclass=Mainclass::getInstance();
		if(!isset($Mainclass->OwnBb))
			$Mainclass->LoadClass('classes/others/class_ownbb.php','OwnBb','OwnBbCodes');
		$text=$Mainclass->OwnBb->ParseAll($text);
		$js='';
		foreach(BaseOwnBbCode::$jscripts as &$v)
			$js.=self::AddJS($v);
		return $js.$text;
	}
}
?>