<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');
final class User extends BaseClass implements LoginClass
{
	public
		$error='',
		$key;
	private
		$login=null;
	public function Login($user_name='',$pass='')
	{
		if ($user_name=='' and isset($_POST['user_name']))
			$user_name=$_POST['user_name'];
		if ($pass=='' and isset($_POST['user_password']))
			$pass=$_POST['user_password'];
		$this->error='';
		if($user_name=='' or $pass=='')
		{
			$this->error=$this->Mainclass->Account->lang['empty_login'];
			if(isset($_POST['login']))
				$this->EnterForm($this->error);
			return false;
		}
		if ($this->Mainclass->Account->AuthByName($user_name,$pass,isset($_POST['already_md'])))
		{
			$this->login=null;
			$this->key=$this->Mainclass->Account->GetValue('login_key');
			$cookie=base64_encode($this->key.'|'.$this->Mainclass->Account->GetValue('id'));
			$this->Mainclass->SCookie('User',$cookie,365,true);
			$this->Mainclass->Account->SetStrongHold();
			if($lang=$this->Mainclass->Account->GetValue('lang') and isset($this->Mainclass->langs[$lang]))
				$this->Mainclass->lang_name=$lang;
			return $this->login=true;
		}
		$this->error=$this->Mainclass->Account->error_exp;
		if (isset($_POST['login']))
			$this->EnterForm();
		return false;
	}

	public function IsUser($hard=false)
	{
		if($this->login===null or $hard)
			do
			{
				if($this->Mainclass->GCookie('User')===false)
				{
					$this->login=false;
					break;
				}
				$t=explode('|',base64_decode($this->Mainclass->GCookie('User')),2);
				$lkey=$t[0];
				$id=isset($t[1]) ? $t[1] : 0;
				if(!$lkey or !$id)
				{
					$this->login=false;
					break;
				}
				if ($this->Mainclass->Account->AuthByKey($id,$lkey)===false)
				{
					$this->login=false;
					break;
				}
				if(isset($_GET['logout']) or !$this->Mainclass->Account->IsStrongHold())
					return $this->Logout();
				$this->key=$lkey;
				return $this->login=true;
			}while(false);
		return $this->login;
	}

	public function Logout()
	{
		$this->login=false;
		$this->Mainclass->Account->LogOut();
		$this->Mainclass->SCookie('User',false,null,true);
		if (isset($_GET['logout']))
			ExitBack();
	}

	public function UserLink($user_name,$user_id=0)
	{
		$arr=array('module'=>'account');
		if($user_name and $user_id)
			$arr['info']=html_entity_decode($user_name);
		elseif($user_id)
			$arr[]=array('infoid'=>$user_id);
		else
			return false;
		return $this->Mainclass->Url->DynamicBegin().$this->Mainclass->Url->ConstructUrl($arr,false);
	}

	private function EnterForm()
	{global $title;
		$title=$this->Mainclass->Account->lang['user_login'];
		$this->Mainclass->ShowDecoration();
		echo $this->Mainclass->Template->ModuleMenu('login','','',array('title'=>$title),__class__).($this->error ? $this->Mainclass->Template->Message($this->error) : '')
		.$this->Mainclass->Template->OpenTable()
		.$this->Mainclass->Template->GetThemeFile('Login',array(),array(__class__,__class__.'_'.$this->Mainclass->lang_name))
		.$this->Mainclass->Template->CloseTable();
		$this->Mainclass->SetModVal('not_load_module',true);
	}
}
?>