<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
$start=microtime();#Начало отсчета времени движка.
define('CMS',true);
require dirname(__file__).'/classes/mainclass.php';
$Mainclass=MainClass::getInstance();
$Mainclass->start_time=$start;
$Mainclass->service_id='5';#ID сервиса
$Mainclass->file_name=basename(__file__);
if(0<$t=strpos($Mainclass->site_path,$Mainclass->file_name))
	$Mainclass->site_path=$t==1 ? '' : substr($Mainclass->site_path,0,$t-1);
$Mainclass->LoadOptions(array('system','public','blocker','login'));
$Mainclass->LoadService();
if(!empty($_REQUEST['module']))
{
	$module=$_REQUEST['module'];
	$where=ctype_digit($module) ? '`id`='.(int)$module : '(`name`=\''.($mid=$Mainclass->Db->EscapeString($module)).'\' OR `path` LIKE \'%'.$module.'\')';
	$Mainclass->Db->Query('SELECT `id`,`services`,`name`,`title`,`path`,`multiservice`,`file`,`is_class`,`resources`,`image`,`user_groups` FROM `prefix_modules` WHERE '.$where.' AND `active` LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitPage();
	$arr=$Mainclass->Db->Fetch_Assoc();
	$arr['user_groups']=Strings::CleanForExplode($arr['user_groups']);
	if($arr['user_groups'])
	{
		$groups=explode(',',$arr['user_groups']);
		$user_groups=$Mainclass->Account->GetUserGroups();
		if(count(array_intersect($groups,$user_groups))==0)
			ExitPage();
	}
	if(strpos($arr['services'],','.$Mainclass->service_id.',')===false and $arr['resources'])
	{
		$resources=explode('·',Strings::CleanForExplode($arr['resources']));
		foreach($resources as &$v)
		{
			$temp=explode('=',$v,2);
			if($Mainclass->service==$temp[0])
			{
				$arr['file']=$temp[1];
				break;
			}
		}
	}
	if(!$arr['file'])
		ExitPage();
	$Mainclass->module['name']=$arr['name'];
	$Mainclass->module['title']=$arr['title'];
	$Mainclass->module['image']=$arr['image'];
	$Mainclass->module['path']=$arr['path'];
	$Mainclass->module['general']=false;
	$Mainclass->module['id']=$arr['id'];
	if(!$Mainclass->LoadModule($arr['path'],$arr['multiservice'],$arr['file'] ? $arr['file'] : 'index',$arr['is_class']))
		ExitPage();
}
elseif(isset($_GET['captcha']))
{
	$Mainclass->Loadclass('classes/captcha/class_captcha.php');
	$Mainclass->Captcha->GetImage('',$_GET['captcha']);
}
elseif(isset($_GET['download']))
{
	$fn=$Mainclass->Url->DecodeParam($_GET['download']);
	$needed_file=basename($fn);
	$needed_dir=$Mainclass->FormatPath(Mainclass::UPLOADS_DIR.'/'.dirname($fn));
	if(isset($Mainclass->Login))
	{
		if($Mainclass->services[$Mainclass->service_id]['login']==$Mainclass->services[1]['login'])
		{
			$old_service=$Mainclass->service;
			$old_id=$Mainclass->service_id;
			$Mainclass->service='admin';
			$Mainclass->service_id='1';
		}
		$Mainclass->Login->IsUser();
		if(!empty($Mainclass->vars['site_closed']) and !$Mainclass->Permission->IsAdmin())
			ExitPage();
		if(isset($old_service))
		{
			$Mainclass->service=$old_service;
			$Mainclass->service_id=$old_id;
		}
		if($Mainclass->Permission->IsBanned())
			throw new EE(null,EE::BAN);
	}
	if(is_file($needed_dir.'/.htaccess') and stripos(trim(file_get_contents($needed_dir.'/.htaccess')),'allow from all')===0)
		OutPutFile($needed_file, $needed_dir);
	else
	{
		if(!empty($Mainclass->vars['download_catch_wrong_referrer']) and !empty($_SERVER['HTTP_REFERER']))
		{
			$ref_host=substr($_SERVER['HTTP_REFERER'],strpos($_SERVER['HTTP_REFERER'],'//')+2);
			$ref_host=substr($ref_host,0,strpos($ref_host,'/'));
			$ref_host=preg_replace('#^www\.#i','',$ref_host);
			$domain=preg_replace('#^www\.#i','',$Mainclass->domain);
			if(strcasecmp($ref_host,$domain)!=0 and strcasecmp($ref_host,$Mainclass->vars['site_domain'])!=0)
				ExitPage();
		}
		if(!empty($Mainclass->vars['download_catch_no_session']))
		{
			$Mainclass->Db->FQuery('SELECT `enter_time` FROM {"0"} WHERE `ip`={"1"} LIMIT 1',array('t_sessions','s_'.$Mainclass->ip),__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPage();
		}
		OutPutFile($needed_file, $needed_dir);
	}
}
elseif(isset($_REQUEST['direct']) and is_string($_REQUEST['direct']) and is_file($f=$Mainclass->root_path.'addons/direct/'.preg_replace('#[^a-z0-9]+#i','',$_REQUEST['direct']).'.php'))
	include $f;
else
	ExitPage();

function ExitPage($redirect=true)
{global $Mainclass;
	if(!headers_sent() and !empty($Mainclass->vars['download_redirect']) and $redirect)
		Functions::Redirect(str_replace('*',$Mainclass->domain.$Mainclass->site_path,$Mainclass->vars['download_redirect']));
	else
	{
		#Страница с Error
		$Mainclass->module['name']='errors';
		$Mainclass->Url->string='';
		$_GET['url']=403;
		$Mainclass->module['path']='modules/errors';
		$Mainclass->Url->SetPrefix($Mainclass->vars['multilang'] ? array('lang'=>$Mainclass->get_lang,'module'=>'errors') : array('module'=>'errors'),false);
		include $Mainclass->root_path.'modules/errors/user/index.php';
		die;
	}
}

function OutPutFile($needed_file, $needed_dir)
{global $Mainclass;
	$direct=preg_match('#\.(gif|png|jpe?g|bmp)$#i',$needed_file)>0;
	if(isset($Mainclass->Login) and ($Mainclass->Login instanceof LoginClass) and !$direct)
		$Mainclass->Account->AddSession();
	$filename=$Mainclass->Functions->FixWinFileS($needed_dir.'/'.$needed_file);
	if(!file_exists($filename))
		return ExitPage();
	$from=$to=0;
	if(isset($_SERVER['HTTP_RANGE']))
	{
		$range=substr($_SERVER['HTTP_RANGE'],strpos($_SERVER['HTTP_RANGE'],'=')+1);
		$from=strtok($range,'-');
		$to=strtok('/');
		if($to>0)
			$to++;
		if($to>0)
			$to-=$from;
		header('HTTP/1.1 206 Partial Content');
		$cr='Content-Range: bytes '.$from.'-'.($to>0 ? $to.'/'.$to+1 : filesize($filename));
	}
	else
		header('HTTP/1.1 200 Ok');
	$etag=md5($filename);
	$etag=substr($etag,0,8).'-'.substr($etag,8,7).'-'.substr($etag,15,8);
	header('ETag: "'.$etag.'"');
	header('Accept-Ranges: bytes');
	header('Content-Length: '.(filesize($filename)-$to+$from));
	if(isset($cr))
		header($cr);
	header('Connection: close');
	header('Content-Type: '.Functions::FileMimeType($needed_file,'auto-detect'));
	header('Last-Modified: '.gmdate('r',filemtime($filename)));
	if(!$direct)
		header('Content-Disposition: attachment; filename="'.mb_convert_encoding($needed_file,'utf-8',ELEANOR_CHARSET).'";');
	$f=fopen($filename,'r');
	if($from>0)
		fseek($f, $from, SEEK_SET);
	if(!$to)
		$size=filesize($filename)-$from;
	else
		$size=$to;
	$downloaded=0;
	while(!feof($f) and connection_status()==0 and $downloaded<$size)
	{
		$block = min(1024*16,$size-$downloaded);
		echo fread($f,$block);
		$downloaded+=$block;
		flush();
	}
	fclose($f);
	exit;
}

#Функция "Будь как", делает сервис AJAX похожим на другой сервис
function BeAs($idname='')
{global $Mainclass;
	if($Mainclass->service==$idname or $Mainclass->service_id==$idname)
		return;
	if(!$idname)
		$idname=2;
	foreach($Mainclass->services as &$arr)
		if($arr['id']==$idname or $arr['id']==$idname)
			break;
	$Mainclass->Permission->CleanAll();
	$id=$Mainclass->service_id;
	$name=$Mainclass->service;
	$Mainclass->service_id=$arr['id'];
	$Mainclass->service=$arr['name'];
	$Mainclass->file_name=$arr['file'];
	$Mainclass->Functions->GetLangCookie(true,$Mainclass->service.'_lang');
	$Mainclass->LoadLanguage('langs','main',$arr['name'].'-%');
	if(!empty($arr['login']) and $Mainclass->services[$id]['login']!=$arr['login'])
	{
		$Mainclass->Account->LogOut(false);
		if(isset($Mainclass->Login) and ($Mainclass->Login instanceof LoginClass))
			unset($Mainclass->Login);
		$Mainclass->LoadLogin($arr['login']);
	}
	$Mainclass->Login->IsUser();
	$Mainclass->service_id=$id;
	$Mainclass->service=$name;
	$Mainclass->Template->theme=$arr['theme'];
	$Mainclass->Url->furl=$arr['id']==2 ? $Mainclass->vars['furl'] : false;
	$Mainclass->service=$arr['name'];
}
?>