<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum.Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
class Update_1 extends BaseClass implements UpdateClass
{
	public function DoUpdate($step=0)
	{
		if (!$step)
			$this->DoSettings();
		return array(
						'text'=>$step ? '' : '<div align="center"><h1>'.sprintf($this->Mainclass->lang['install']['update_to_complete'],'RC2').'</h1></div>',
						'errors'=>array(),
						'url'=>$step ? '' : 1,
						'done'=>$step,
		);
	}

	private function DoSettings()
	{
		$s='
<eleanor_options>
<version>1.0</version>
<ogroup>
	<title>Настройки модуля "Новости"</title>
	<name>module_news</name>
	<descr></descr>
	<protected>0</protected>
	<keyword>module_news</keyword>
	<onexists>full update</onexists>
</ogroup>
<option>
	<title>Включить загрузку файлов на сервер?</title>
	<name>m_news_upload</name>
	<descr>
		xfHr6CDk4O3t4P8g7u/26P8g4urr/vfl7eAsIPLuIO/w6CDk7uHg4uvl7ejoIO3u4u7x8uXpIC0g
		7+7r/Ofu4uDy5evoIPHs7uPz8iDn4Ovo4uDy/CD04Onr+yDx8ODn8yDqIMLg7CDt4CDx5fDi5fAu
	</descr>
	<group>module_news</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Отключить регистрацию</title>
	<name>register_off</name>
	<descr></descr>
	<group>reg</group>
	<type>check</type>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Причина закрытия сайта</title>
	<name>site_close_mes</name>
	<descr>
		0+rg5ujy5SDv8Oj36O3zIOfg6vD78uj/IPHg6fLgLiDF8evoIPHg6fIg7vLq8PvyIC0g8OXq7uzl
		7eTz5fLx/yDu9+j54PL8IO/u6+Ug5Ov/IP3q7u3u7OjoIO/g7P/y6C4=
	</descr>
	<group>general options</group>
	<type>editor</type>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
</eleanor_options>';
		if (!isset($this->Mainclass->Settings))
			$this->Mainclass->LoadClass('classes/others/class_settings.php');
		if (!isset($this->Mainclass->Cache))
		{
			$this->Mainclass->LoadClass('classes/class_cache.php');
			$this->Mainclass->Cache->Init();
		}
		$this->Mainclass->Settings->ProcessImport($s);
	}
}
?>