<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum.Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
class Update_2 extends BaseClass implements UpdateClass
{
	public function DoUpdate($step=0)
	{
		if (!$step)
			$this->DoSettings();
		else
			$this->FixStatic();
		return array(
						'text'=>$step ? '' : '<div align="center"><h1>'.sprintf($this->Mainclass->lang['install']['update_to_complete'],'RC3').'</h1></div>',
						'errors'=>array(),
						'url'=>$step ? '' : 1,
						'done'=>$step,
		);
	}

	private function DoSettings()
	{
		$s='
<eleanor_options>
<version>1.0</version>
<ogroup>
	<title>Пользователи и система аккаунтинга</title>
	<name>accounting</name>
	<descr>Настройка системы аккаунтинга, сессий, логина и регистрации пользователей.</descr>
	<protected>1</protected>
	<keyword>login</keyword>
	<onexists>full update</onexists>
</ogroup>
<ogroup>
	<title>Модуль "Статические страницы"</title>
	<name>module_static</name>
	<descr></descr>
	<protected>0</protected>
	<keyword>module_static</keyword>
	<onexists>full update</onexists>
</ogroup>
<ogroup>
	<title>Операции с файлами</title>
	<name>files</name>
	<descr>Найстройка файловых операций</descr>
	<protected>1</protected>
	<keyword>files</keyword>
	<onexists>full update</onexists>
</ogroup>
<option>
	<title>Часовой пояс</title>
	<name>time_zone</name>
	<descr></descr>
	<group>locale</group>
	<type>select</type>
	<value>
		RXVyb3BlL0tpZXY=
	</value>
	<default>
		RXRjL0dNVCsy
	</default>
	<eval></eval>
	<extra>
		UGFjaWZpYy9Ld2FqYWxlaW49KEdNVCAtMTI6MDApIEVuaXdldG9rLCBLd2FqYWxlaW63UGFjaWZp
		Yy9TYW1vYT0oR01UIC0xMTowMCkgTWlkd2F5IElzbGFuZCwgU2Ftb2G3VVMvSGF3YWlpPShHTVQg
		LTEwOjAwKSBIYXdhaWm3VVMvQWxhc2thPShHTVQgLTk6MDApIEFsYXNrYbdDYW5hZGEvUGFjaWZp
		Yz0oR01UIC04OjAwKSBQYWNpZmljIFRpbWUgKFVTICZhbXA7IENhbmFkYSm3Q2FuYWRhL01vdW50
		YWluPShHTVQgLTc6MDApIE1vdW50YWluIFRpbWUgKFVTICZhbXA7IENhbmFkYSm3Q2FuYWRhL0Nl
		bnRyYWw9KEdNVCAtNjowMCkgQ2VudHJhbCBUaW1lIChVUyAmYW1wOyBDYW5hZGEpLCBNZXhpY28g
		Q2l0ebdDYW5hZGEvRWFzdGVybj0oR01UIC01OjAwKSBFYXN0ZXJuIFRpbWUgKFVTICZhbXA7IENh
		bmFkYSksIEJvZ290YSwgTGltYbdDYW5hZGEvQXRsYW50aWM9KEdNVCAtNDowMCkgQXRsYW50aWMg
		VGltZSAoQ2FuYWRhKSwgQ2FyYWNhcywgTGEgUGF6t0NhbmFkYS9OZXdmb3VuZGxhbmQ9KEdNVCAt
		MzozMCkgTmV3Zm91bmRsYW5kt0JyYXppbC9FYXN0PShHTVQgLTM6MDApIEJyYXppbCwgQnVlbm9z
		IEFpcmVzLCBHZW9yZ2V0b3dut0F0bGFudGljL0Jlcm11ZGE9KEdNVCAtMjowMCkgTWlkLUF0bGFu
		dGljt0F0bGFudGljL0F6b3Jlcz0oR01UIC0xOjAwIGhvdXIpIEF6b3JlcywgQ2FwZSBWZXJkZSBJ
		c2xhbmRzt0V1cm9wZS9Mb25kb249KEdNVCkgV2VzdGVybiBFdXJvcGUgVGltZSwgTG9uZG9uLCBM
		aXNib24sIENhc2FibGFuY2G3RXVyb3BlL1BhcmlzPShHTVQgKzE6MDAgaG91cikgQnJ1c3NlbHMs
		IENvcGVuaGFnZW4sIE1hZHJpZCwgUGFyaXO3RXVyb3BlL0tpZXY9KEdNVCArMjowMCkgS2FsaW5p
		bmdyYWQsIFNvdXRoIEFmcmljYSwgSGVsc2lua2ksIFJpZ2EsIEtpZXYsIFNvZmlhLCBUYWxsaW4s
		IFZpbG5pdXO3RXVyb3BlL01vc2Nvdz0oR01UICszOjAwKSBCYWdoZGFkLCBSaXlhZGgsIE1vc2Nv
		dywgU3QuIFBldGVyc2J1cme3QXNpYS9UZWhyYW49KEdNVCArMzozMCkgVGVocmFut0FzaWEvQmFr
		dT0oR01UICs0OjAwKSBBYnUgRGhhYmksIE11c2NhdCwgQmFrdSwgVGJpbGlzabdBc2lhL0thYnVs
		PShHTVQgKzQ6MzApIEthYnVst0FzaWEvVGFzaGtlbnQ9KEdNVCArNTowMCkgRWthdGVyaW5idXJn
		LCBJc2xhbWFiYWQsIEthcmFjaGksIFRhc2hrZW50t0FzaWEvQ2FsY3V0dGE9KEdNVCArNTozMCkg
		Qm9tYmF5LCBDYWxjdXR0YSwgTWFkcmFzLCBOZXcgRGVsaGm3QXNpYS9EaGFrYT0oR01UICs2OjAw
		KSBBbG1hdHksIERoYWthLCBDb2xvbWJvt0FzaWEvQmFuZ2tvaz0oR01UICs3OjAwKSBCYW5na29r
		LCBIYW5vaSwgSmFrYXJ0YbdBc2lhL1NpbmdhcG9yZT0oR01UICs4OjAwKSBCZWlqaW5nLCBQZXJ0
		aCwgU2luZ2Fwb3JlLCBIb25nIEtvbme3QXNpYS9Ub2t5bz0oR01UICs5OjAwKSBUb2t5bywgU2Vv
		dWwsIE9zYWthLCBTYXBwb3JvLCBZYWt1dHNrt0F1c3RyYWxpYS9EYXJ3aW49KEdNVCArOTozMCkg
		QWRlbGFpZGUsIERhcndpbrdBc2lhL1ZsYWRpdm9zdG9rPShHTVQgKzEwOjAwKSBFYXN0ZXJuIEF1
		c3RyYWxpYSwgR3VhbSwgVmxhZGl2b3N0b2u3QXNpYS9NYWdhZGFuPShHTVQgKzExOjAwKSBNYWdh
		ZGFuLCBTb2xvbW9uIElzbGFuZHMsIE5ldyBDYWxlZG9uaWG3QXNpYS9LYW1jaGF0a2E9KEdNVCAr
		MTI6MDApIEF1Y2tsYW5kLCBXZWxsaW5ndG9uLCBGaWppLCBLYW1jaGF0a2E=
	</extra>
	<start_group></start_group>
	<end_group>1</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Активировать закладки?</title>
	<name>allow_bookmarks</name>
	<descr>
		z/DoIOLq6/735e3o6CD98u7pIO7v9ujoLCDv7uv85+7i4PLl6+gg8ezu4/PyIPHu5+Tg4uDy/CDx
		4u7oIOfg6uvg5OroIO3gIOv+4fvs6OUg8fLw4O3o9vsgwuD45ePuIPHg6fLg
	</descr>
	<group>accounting</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group>Разное</start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Страница для главной</title>
	<name>m_static_general</name>
	<descr>
		xfHr6CDC+yDi6uv+9+jr6CDu8u7h8ODm5e3o5SDs7uTz6/8gItHy4PLo9+Xx6ujlIPHy8ODt6Pb7
		IiDt4CDj6+Di7e7pIPHy8ODt6PblIPHg6fLgLCDy7iDiIP3y7uwg7+7r5SDs7ubl8uUg8+rg5+Dy
		/CBVUkwg8fLw4O3o9vssIOru8u7w4P8g5O7r5u3gIO7y7uHw4Obg8vzx/y4gxfHr6CDC+yD17vLo
		8uUg7vLu4fDg5+jy/CDt5fHq7uv86u4g8fLw4O3o9iAtIPPq4Obo8uUg6PUgVVJM+yD35fDl5yDn
		4O//8vP+LiDN4O/w6Ozl8DogcGFnZTEscGFnZTIscGFnZTM=
	</descr>
	<group>module_static</group>
	<type>edit</type>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Включить?</title>
	<name>img_preview</name>
	<descr>
		4OLy7uzg8uj35fHq7uUg8e7n5ODt6OUg7/Dl4vz++OXqIOTr/yDn4OPw8+bg5ez79SDo5+7h8ODm
		5e3o6T8=
	</descr>
	<group>files</group>
	<type>check</type>
	<value>
		MA==
	</value>
	<default>
		MA==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group>Превью изображений</start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>توضیحاتы файлов:</title>
	<name>img_preview_types</name>
	<descr>
		0+rg5ujy5SDy6O/7IPTg6evu4iDk6/8g6u7y7vD79SDh8+Tz8iDx7ufk4OLg8vzx/yDv8OXi/P74
		6uguINfl8OXnIOfg7//y8/4u
	</descr>
	<group>files</group>
	<type>edit</type>
	<value>
		cG5nLGpwZyxibXA=
	</value>
	<default>
		cG5nLGpwZyxibXA=
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Ширина превьюшек:</title>
	<name>img_preview_width</name>
	<descr>
		wiDv6Orx5ev/9Q==
	</descr>
	<group>files</group>
	<type>edit</type>
	<value>
		MjAw
	</value>
	<default>
		MjAw
	</default>
	<eval>
		JHZhbHVlPWludHZhbCgkdmFsdWUpOw==
	</eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
</eleanor_options>';
		if (!isset($this->Mainclass->Settings))
			$this->Mainclass->LoadClass('classes/others/class_settings.php');
		if (!isset($this->Mainclass->Cache))
		{
			$this->Mainclass->LoadClass('classes/class_cache.php');
			$this->Mainclass->Cache->Init();
		}
		$this->Mainclass->Settings->ProcessImport($s);
	}

	private function FixStatic()
	{
		if (is_dir($this->Mainclass->root_path.'modules/static') and !is_dir($this->Mainclass->root_path.'modules/static/DIRECT'))
		{
			@mkdir($this->Mainclass->root_path.'modules/static/DIRECT');
			if ($arr=glob($Mainclass->root_path.'modules/static/*.*htm*'))
				foreach($arr as &$v)
					@rename($v,$this->Mainclass->root_path.'modules/static/DIRECT/'.basename($v));
		}
	}
}
?>