<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
define('CMS',true);
define('INSTALL',true);
define('UPDATE',true);
require './init.php';
$step=isset($_GET['step']) ? (int)$_GET['step'] : 1;
$Mainclass->Functions->GetLangCookie(true,ELEANOR_LC);
$Mainclass->lang['install']=$lang=$Mainclass->LoadLanguage('install/lang','','update-%');
$percent=0;
$num=0;
$title=$text='';
$Mainclass->StartSession('EL_UPDATE_SESSION',isset($_REQUEST['session']) ? $_REQUEST['session'] : '');
if(true===$ability=Install::CheckAbilityInstall(false))
	switch($step)
	{
		case 5:
			$percent=100;
			$navi=$lang['finish'];
			if(isset($_SESSION['update']['upd_id']))
			{
				$num=4;
				Install::IncludeDb();
				$Mainclass->Db->Delete('steps','`res1`=\'update\' AND `id`='.$_SESSION['update']['upd_id'].' LIMIT 1',__file__,__line__);
				$Mainclass->Db->Update('config_l',array('value'=>''),'`id` IN (SELECT `id` FROM `prefix_config` WHERE `name`IN(\'site_copyrights_remove\',\'site_license_key\'))',__file__,__line__);
				$Mainclass->LoadClass('classes/class_cache.php');
				$Mainclass->Cache->Init();
				$Mainclass->Cache->UpdateOptionsByKeyWords(array('system'));
				$Mainclass->Db->Insert('upgrade_hist',array('version'=>ELEANOR_VERSION,'!date'=>'NOW()','build'=>ELEANOR_BUILD,'uid'=>$_SESSION['update']['uid']),__file__,__line__);

				file_put_contents($Mainclass->root_path.'install/install.lock',1);
				$path=preg_replace('#/install$#','',$Mainclass->site_path);
				$url1='http://'.$Mainclass->domain.$path.'/index.php';
				$title=$lang['finish'];
				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div><div class="wpmid"><div class="wpcont"><div class="information" align="center"><h4 style="color: green;">'.$title.'</h4></div><div class="information">'.sprintf($lang['upd_fin_text'],ELEANOR_VERSION).'</div><div class="submitbox">'
				.sprintf($lang['links'],$url1).'</div></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
			}
			else
			{
				header('location: update.php?session='.session_id());
				die;
			}
		break;
		case 4:
			$navi=$lang['updating'];
			$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div><div class="wpmid"><div class="wpcont">';
			if(!isset($_SESSION['update']['build']) or empty($_SESSION['update']['auth']))
			{
				header('location: update.php?session='.session_id());
				die;
			}
			if($_SESSION['update']['build']>ELEANOR_BUILD)
			{
				header('location: update.php?step=3&session='.session_id());
				die;
			}
			$num=3;
			$news=false;
			Install::IncludeDb();
			if(isset($_SESSION['update']['upd_id']))
			{
				$Mainclass->Db->Query('SELECT `step`,`data` FROM `prefix_steps` WHERE `res1`=\'update\' AND `id`='.(int)$_SESSION['update']['upd_id'].' LIMIT 1',__file__,__line__);
				if($Mainclass->Db->Num_rows()==0)
					$news=true;
				else
				{
					list($updateto,$data)=$Mainclass->Db->Fetch_row();
					$data=unserialize($data);
				}
			}
			else
				$news=true;
			if($news)
			{
				$data=array('build'=>$_SESSION['update']['build']);
				$folders=glob($Mainclass->root_path.'install/data_update/*',GLOB_ONLYDIR);
				foreach($folders as &$v)
					$v=substr($v,strrpos($v,'/')+1);
				$data['to_update']=array_values(array_intersect(range($data['build']+1,ELEANOR_BUILD),$folders));
				$data['current_upd']=0;
				$data['queries_done']=$data['update_done']=false;
				$_SESSION['update']['upd_id']=$Mainclass->Db->Insert('steps',array('unique'=>uniqid(),'step'=>$data['current_upd'],'data'=>serialize($data),'res1'=>'update'),__file__,__line__);
			}
			$p=ceil(80/count($data['to_update']));
			$p*=$data['current_upd'] ? $data['current_upd'] : 1;
			if($p>80)
				$p=80;
			$percent=20+$p;
			if(!isset($data['to_update'][$data['current_upd']]))
			{
				header('location: update.php?step=5&session='.session_id());
				die;
			}
			$udir=&$data['to_update'][$data['current_upd']];
			if(!file_exists($Mainclass->root_path.'install/data_update/'.$udir.'/queries.php'))
				$data['queries_done']=true;
			if(!$data['update_done'] and file_exists($Mainclass->root_path.'install/data_update/'.$udir.'/update.php') and ($data['queries_done'] or file_exists($Mainclass->root_path.'install/data_update/'.$udir.'/invert')))
			{
				$prefix=$Mainclass->sql_tbl_prefix;
				include($Mainclass->root_path.'install/data_update/'.$udir.'/update.php');
				if(class_exists($cl_name='Update_'.$udir,false))
				{
					$Upd=new $cl_name($Mainclass);
					$res=$Upd->DoUpdate(isset($_GET['substep']) ? (int)$_GET['substep'] : 0);
					if(!empty($res['errors']) and is_array($res['errors']))
						foreach($res['errors'] as &$v)
							$text.=$Mainclass->Template->Message($v);
					if(isset($res['rtime']))
						$rtime=(int)$res['rtime'];
					$text.='<div class="information">'.$res['text'].'</div>';
					$data['update_done']=$res['done'];
					$url='&amp;substep='.$res['url'];
				}
				else
				{
					$url='';
					$data['update_done']=true;
				}
				$url='update.php?step=4&amp;updateto='.$data['current_upd'].'&amp;session='.session_id().$url;
			}
			elseif(!$data['queries_done'] and file_exists($Mainclass->root_path.'install/data_update/'.$udir.'/queries.php'))
			{
				$prefix=$Mainclass->sql_tbl_prefix;
				include($Mainclass->root_path.'install/data_update/'.$udir.'/queries.php');
				$qnames=array();
				$cnt=0;
				$Mainclass->Db->Transaction('BEGIN',__file__,__line__);
				foreach($queries as $k=>$v)
				{
					$v=str_replace(
								array(
										'\\d',
										'\\D',
										'\\w',
										'\\W',
										'\\s',
										'\\S',
								),
								array(
										'\\\\d',
										'\\\\D',
										'\\\\w',
										'\\\\W',
										'\\\\s',
										'\\\\S',
								),
								$v
					);
					$db_error=false;
					try
					{
						$Mainclass->Db->FQuery($v,array(),__file__,__line__);
						++$cnt;
					}
					catch(EE $e)
					{
						$db_error=$e->getMessage();
					}
					if(!is_int($k))
						$qnames[]='<span style="font-weight:bold;color:'.($db_error ? 'red' : 'green').'" title="'.($db_error ? htmlspecialchars($db_error) : 'OK').'">'.$k.'</span>';
#					elseif($db_error)
#						$qnames[]='<span style="font-weight:bold;color:red" title="'.htmlspecialchars($db_error).'">'.$k.'</span>';
				}
				$Mainclass->Db->Transaction('COMMIT',__file__,__line__);
				$data['queries_done']=true;
				$text.='<div class="information"><h4>'.sprintf($lang['queries_done'],$cnt).'</h4>'.join(', ',$qnames).'</div>';
				$url='update.php?step=4&amp;updateto='.$data['current_upd'].'&amp;session='.session_id();
			}
			else
				$data['queries_done']=$data['update_done']=true;
			if($data['queries_done'] and $data['update_done'])
			{
				$data['queries_done']=$data['update_done']=false;
				$Mainclass->Db->Update('steps',array('step'=>++$data['current_upd'],'data'=>serialize($data)),'`res1`=\'update\' AND `id`='.$_SESSION['update']['upd_id'].' LIMIT 1',__file__,__line__);
				header('location: update.php?step=4&updateto='.$data['current_upd'].'&session='.session_id());
				die;
			}
			$Mainclass->Db->Update('steps',array('data'=>serialize($data)),'`res1`=\'update\' AND `id`='.$_SESSION['update']['upd_id'].' LIMIT 1',__file__,__line__);
			$Mainclass->Template->RedirectScreen($url,isset($rtime) ? $rtime : 5);
			$title=$lang['updating'];
			$text.='<div class="submitline"><a href="'.$url.'">'.$lang['press_here'].'</a></div>
			</div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
		break;
		case 3:
			$percent=20;
			$navi=$lang['sure_upd'];
			$num=2;
			if(!empty($_SESSION['update']['auth']))
			{
				Install::IncludeDb();
				$Mainclass->Db->Query('SELECT `version`, `build` FROM `prefix_upgrade_hist` ORDER BY `id` DESC LIMIT 1',__file__,__line__);
				$arr=$Mainclass->Db->Fetch_assoc();
				$title=$lang['sure_upd'];
				$text='<div class="information" align="center">'.$lang['you_are_logined'].' '.htmlspecialchars($_SESSION['update']['uname']).'</div>';
				if($arr['build']>=ELEANOR_BUILD)
				{
					$path=preg_replace('#/install$#','',$Mainclass->site_path);
					$url1='http://'.$Mainclass->domain.$path.'/index.php';
					$percent=100;
					$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
					<div class="wpmid"><div class="wpcont"><div class="information" align="center"><h3>'.$lang['update_not_need'].'</h3><div class="submitline">'.sprintf($lang['links'],$url1).'</div></div>
					</div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				}
				else
				{
					$_SESSION['update']['build']=$arr['build'];

				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
					<div class="wpmid"><div class="wpcont"><form method="post" action="update.php?step=4">
					<div class="information" align="center"><h3>'.sprintf($lang['update_ver_to'],$arr['version'],ELEANOR_VERSION).'</h3></div>
					<div class="submitline">'.Template::Control('session','hidden',session_id())
					.Template::Button($lang['no'],'button','class="button" onclick="window.close()"')
					.Template::Button($lang['yes'],'submit','class="button"').'</div></form></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				}
				break;
			}
		case 2:
			$percent=10;
			$navi=$lang['enter_a_pass'];
			$error=array();
			if(isset($_POST['driver'],$_POST['host'],$_POST['name'],$_POST['user'],$_POST['pass'],$_POST['pref']) and file_exists($Mainclass->root_path.'config_general.bak'))
			{
				do
				{
					$arr=array(
								'host'=>$_POST['host'],
								'user'=>$_POST['user'],
								'pass'=>$_POST['pass'],
								'prefix'=>$_POST['pref'],
								'db'=>$_POST['name'],
								'type'=>$_POST['driver'],
								'force'=>true,
								'languages'=>(isset($_POST['languages']) and is_array($_POST['languages'])) ? $_POST['languages'] : array(),
					);
					$langs=array();
					foreach($arr['languages'] as &$v)
						if(isset($preinstlled_lang[$v]))
							$langs[]=$preinstlled_lang[$v][0];
					try
					{
						Install::InitDb($arr);
					}
					catch(EE $e)
					{
						$error=$e->getMessage();
						break;
					}
					if($_POST['driver']=='mysql' and !Install::CheckMySQLVersion())
					{
						$error=$lang['low_mysql'];
						break;
					}
					$_SESSION['update']=$arr;
					$Mainclass->Db->ShowTables();
					$tables=array();
					while($arr=$Mainclass->Db->Fetch_row())
						$tables[]=$arr[0];
					if(!in_array($_POST['pref'].'services',$tables) or !in_array($_POST['pref'].'config',$tables))
					{
						$error=$lang['no_tables_sql'];
						break;
					}
					$title=$lang['cr_config'];
					$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
					<div class="wpmid"><div class="wpcont">
					<form method="post" action="update.php?step=2&amp;do=create">
					<ul class="reset formfield">
					<li class="ffield"><span class="label">'.$lang['db_drive'].'</span><div class="ffdd"><h4>'.$_POST['driver'].'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_host'].'</span><div class="ffdd"><h4>'.$_POST['host'].'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_name'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['name']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_user'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['user']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_pass'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['pass']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['addonl'].'</span><div class="ffdd"><h4>'.($langs ? implode(', ',$langs) : $lang['no']).'</h4></div></li>
					</ul>
					<div class="submitline">'.Template::Control('session','hidden',session_id())
					.Template::Button($lang['back'],'button','class="button" onclick="history.go(-1)"')
					.Template::Button($lang['next'],'submit','class="button"').'</div></form>
					</div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				}while(false);
				if(!$error)
					break;
			}
			elseif(isset($_GET['do'],$_POST['session']))
			{
				if(isset($_SESSION['update']))
				{
					$from=array(
								'[driver]',
								'[language]',
								'[antinull]',
								'[version]',
								'[sql_host]',
								'[sql_db]',
								'[sql_user]',
								'[sql_pass]',
								'[sql_prefix]',
								'[charset]',
								'[display_charset]',
								'[db_charset]',
					);
					$to=array(
								$_SESSION['update']['type'],
								$Mainclass->lang_name,
								ELEANOR_ANKEY.'_'.Strings::GenPass(10),
								ELEANOR_VERSION,
								$_SESSION['update']['host'],
								$_SESSION['update']['db'],
								$_SESSION['update']['user'],
								$_SESSION['update']['pass'],
								$_SESSION['update']['prefix'],
								ELEANOR_CHARSET,
								ELEANOR_DISPLAYCHARSET,
								ELEANOR_DBCHARSET,
					);
					foreach($preinstlled_lang as $k=>$v)
					{
						if($k==$Mainclass->lang_name or in_array($k,$_SESSION['install']['languages']))
							$from[]='#[lang_'.$k.']';
						else
							$from[]='[lang_'.$k.']';
						$to[]='';
					}
					file_put_contents($Mainclass->root_path.'config_general.php',str_replace($from,$to,file_get_contents($Mainclass->root_path.'config_general.bak')));
					unlink($Mainclass->root_path.'config_general.bak');
					header('location: update.php?step=2&session='.session_id());
					die;
				}
				else
					$error='Session lost!';
			}
			elseif(file_exists($Mainclass->root_path.'config_general.php') and !file_exists($Mainclass->root_path.'config_general.bak'))
			{
				$num=1;
				Install::IncludeDb();
				if(isset($_POST['login'],$_POST['pass']))
				{
					$grs=array();
					$Mainclass->Db->Query('SELECT `id` FROM `prefix_groups` WHERE `access_cp`',__file__,__line__);
					while($t=$Mainclass->Db->Fetch_row())
						$grs[]=$t[0];
					$Mainclass->Db->FQuery('SELECT `id`, `name`, `pass_salt`, `pass_hash` FROM {"0"} WHERE `l_name`=LOWER({"1"}) AND (`group`'.$Mainclass->Db->In($grs).' OR `other_group` LIKE "%,'.join(',%,',$grs).',%") LIMIT 1',array('users','s_'.$_POST['login']),__file__,__line__);
					if($Mainclass->Db->Num_rows()>0)
					{
						$arr=$Mainclass->Db->Fetch_assoc();
						if(Strings::PassHash($arr['pass_salt'],$_POST['pass'])==$arr['pass_hash'])
						{
							$_SESSION['update']['auth']=true;
							$_SESSION['update']['uid']=$arr['id'];
							$_SESSION['update']['uname']=$arr['name'];
							header('location: update.php?step=3&session='.session_id());
							die;
						}
						else
							$error=$lang['incorrect_pass'];
					}
					else
						$error=$lang['login_incorrect'];
				}
				$title=$lang['enter_a_pass'];
				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
				<div class="wpmid"><div class="wpcont">
				<div class="information">'.$lang['for_enter_a'].'</div>'.($error ? $Mainclass->Template->Message($error) : '').'
				<form method="post" action="update.php?step=2">
				<ul class="reset formfield">
					<li class="ffield">
						<span class="label">'.$lang['login'].'</span><div class="ffdd">'.Template::Edit('login',isset($_POST['login']) ? $_POST['login'] : '','class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label">'.$lang['db_pass'].'</span><div class="ffdd">'.Template::Control('pass','password','','class="f_text"').'</div>
					</li>
				</ul>
				<div class="submitline">'.Template::Control('session','hidden',session_id()).Template::Button($lang['next'],'submit','class="button"').'</div>
				</form></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				break;
			}
		default:
			$percent=0;
			$navi=$lang['cr_config'];
			if(false===$cerror=CheckConfigFile())
			{
				$db_driver=isset($_POST['driver']) ? $_POST['driver'] : 'mysql';
				$db_host=isset($_POST['host']) ? $_POST['host'] : 'localhost';
				$db_name=isset($_POST['name']) ? $_POST['name'] : '';
				$db_user=isset($_POST['user']) ? $_POST['user'] : '';
				$db_pass=isset($_POST['pass']) ? $_POST['pass'] : '';
				$db_pref=isset($_POST['pref']) ? $_POST['pref'] : 'el_';
				$langs=(isset($_POST['languages']) and is_array($_POST['languages'])) ? $_POST['languages'] : array();

				$title=$lang['cr_config'];
				$num=0;
				$db_drivers=(function_exists('mysql_connect') ? Template::Option('MySQL','mysql','mysql'==$db_driver) : '')
				.(function_exists('mysqli_connect') ? Template::Option('MySQLi','mysqli','mysqli'==$db_driver) : '');

				$languages='';
				foreach($preinstlled_lang as $k=>$v)
					if($k!=$Mainclass->lang_name)
						$languages.=Template::Option($v[0],$k,in_array($k,$langs));
				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
				<div class="wpmid"><div class="wpcont">'.($error ? $Mainclass->Template->Message($error) : '').'
				<form method="post" action="update.php?step=2">
				<ul class="reset formfield">
					<li class="ffield">
						<span class="label"><b>'.$lang['db_drive'].'</b></span><div class="ffdd">'.Template::Select('driver',$db_drivers,'class="f_select"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_host'].'</b></span><div class="ffdd">'.Template::Edit('host',$db_host,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_name'].'</b></span><div class="ffdd">'.Template::Edit('name',$db_name,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_user'].'</b></span><div class="ffdd">'.Template::Edit('user',$db_user,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_pass'].'</b></span><div class="ffdd">'.Template::Edit('pass',$db_pass,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_pref'].'</b></span><div class="ffdd">'.Template::Edit('pref',$db_pref,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['addonl'].'</b></span><br /><span class="small">'.$lang['addonl_d'].'</span><div class="ffdd">'.Template::Items('languages',$languages,5,'class="f_text"').'</div>
					</li>
				</ul>
				<div class="submitline">'.Template::Control('session','hidden',session_id()).Template::Button($lang['next'],'submit','class="button"').'</div>
				</form></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
			}
			else
			{
				$title=$lang['error'];
				$text='<h4>'.$title.'</h4>';
				foreach($cerror as &$v)
					$text.=$Mainclass->Template->Message($v);
			}
		break;
	}
else
{
	$navi=$title=$lang['error'];
	$text='<h4>'.$title.'</h4>';
	foreach($ability as &$v)
		$text.=$Mainclass->Template->Message($v);
}

function CheckConfigFile()
{global $Mainclass,$preinstlled_lang;
	$error=false;
	if(file_exists($Mainclass->root_path.'config_general.bak'))
	{
		if(!is_writeable($Mainclass->root_path.'config_general.bak'))
			$error=$Mainclass->lang['install']['bak_error'];
		if(file_exists($Mainclass->root_path.'config_general.php'))
			if(is_writeable($Mainclass->root_path.'config_general.php'))
			{
				include($Mainclass->root_path.'config_general.php');
				rename($Mainclass->root_path.'config_general.php',$Mainclass->root_path.'config_general_old.php');
				$from=array(
							'[driver]',
							'[language]',
							'[antinull]',
							'[version]',
							'[sql_host]',
							'[sql_db]',
							'[sql_user]',
							'[sql_pass]',
							'[sql_prefix]',
							'[charset]',
							'[display_charset]',
							'[db_charset]',
				);
				$to=array(
								ELEANOR_DB_DRIVER,
								$Mainclass->lang_name,
								ELEANOR_ANKEY.'_'.Strings::GenPass(10),
								ELEANOR_VERSION,
								$general['sql_host'],
								$general['sql_db'],
								$general['sql_user'],
								$general['sql_pass'],
								$general['sql_tbl_prefix'],
								ELEANOR_CHARSET,
								ELEANOR_DISPLAYCHARSET,
								ELEANOR_DBCHARSET,
				);
				foreach($preinstlled_lang as $k=>$v)
				{
					if($k==$Mainclass->lang_name or isset($general['langs'][$k]))
						$from[]='#[lang_'.$k.']';
					else
						$from[]='[lang_'.$k.']';
					$to[]='';
				}
				file_put_contents($Mainclass->root_path.'config_general.php',str_replace($from,$to,file_get_contents($Mainclass->root_path.'config_general.bak')));
				unlink($Mainclass->root_path.'config_general.bak');
				header('location: update.php?step=2&session='.session_id());
				die;
			}
			else
				$error=$Mainclass->lang['install']['cphp_error'];
	}
	elseif(file_exists($Mainclass->root_path.'config_general.php'))
	{
		header('location: update.php?step=2&session='.session_id());
		die;
	}
	else
		$error=$lang['bak_error'];
	return $error;
}

OutPut();
echo $Mainclass->Template->GetThemeFile(
										'index',
										array(
												'percent'=>$percent,
												'navi'=>$navi,
												'title'=>$title,
												'text'=>$text,
										)
);
?>