/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
function ChangeUploaderVisible(div,hide,show,a)
{
	if(typeof a.showed=='undefined')
		a.showed=false;
	if(a.showed)
	{
		$('#'+div).fadeOut('slow');
		$('b',a).text(show);
		a.showed=false;
	}
	else
	{
		$('#'+div).fadeIn('slow');
		$('b',a).text(hide);
		a.showed=true;
	}
	return false;
}
function EleanorUploader(u,w,s)
{
	this.u=u;
	this.watermark=w;
	this.page=1;
	this.s=s;
	this.Update=function()
	{
		this.Go('');
		return false;
	}
	this.AddFolder=function()
	{
		var f_name=prompt(el_lang['new_folder'],'');
		var th=this;
		if(!f_name)
			return false;
		Ajax(
			-1,
			{
				'start_folder':this.start_folder,
				'goal':'new_folder',
				'folder':f_name,
				'type':'files',
				'uniq':this.u,
				'session':this.s
			},
			function(result)
			{
				th.Update();
			},
			false
		);
		return false;
	}
	this.Lock=function()
	{
		var icons=Id('icons_'+this.u);
		Ajax(
			-1,
			{
				'start_folder':this.start_folder,
				'goal':'lock_folder',
				's_id':this.service,
				'type':'files',
				'uniq':this.u,
				'session':this.s
			},
			function(result)
			{
				$(icons).html(result['lock']);
			},
				false
		);
		return false;
	}
	this.Go=function(to,page)
	{
		not_loading=true;
		if(!page)
			page=this.page;
		else
			this.page=page;
		var icons=Id('icons_'+this.u);
		var files=Id('files_'+this.u);
		var pages=Id('pages_'+this.u);
		var info=Id('info_'+this.u);
		var th=this;
		var folder = this.start_folder;
		Ajax(
			-1,
			{
				'start_folder':this.start_folder,
				'destination':to,
				'goal':'get_files',
				's_id':this.service,
				'type':'files',
				'page':page,
				'uniq':this.u,
				'session':this.s
			},
			function(result)
			{
				if (result['error'])
					alert(result['error']);
				$(icons).html(result['icons']);
				$(files).html(result['files']);
				$(info).html(result['info']);
				if (result['pages'])
				{
					$(pages).show();
					$(pages).html(result['pages']);
				}
				else
					$(pages).hide();
				th.start_folder=result['folder'];
				th.page=result['page'];
				var swf=eval("swf_"+th.u);
				if(swf)
				{
					swf.addPostParam('folder',result['folder']);
					if(result['upload'])
					{
						swf.setButtonDisabled(false);
						swf.setButtonText(el_lang['upload_text']);
					}
					else
					{
						swf.setButtonDisabled(true);
						swf.setButtonText(el_lang['upload_text_dis']);
					}
				}
			},
			false
		);
		not_loading=false;
		return false;
	}
	this.DeleteFile=function(file_name)
	{
		if(!confirm(el_lang['are_you_sure_delete']+file_name+'"?'))
			return false;
		var th=this;
		Ajax(
			-1,
			{
				'start_folder':this.start_folder,
				'goal':'delete',
				'file':file_name,
				'type':'files',
				'uniq':this.u,
				'session':this.s
			},
			function(result)
			{
				th.Update();
			},
			false
		);
		return false;
	}
	this.Rename=function(file_name)
	{
		var newname=prompt(el_lang['enter_new_name'],file_name);
		var th=this;
		if (!newname || newname==file_name)
			return false;
		Ajax(
			-1,
			{
				'start_folder':this.start_folder,
				'goal':'rename',
				'file':file_name,
				'to':newname,
				'type':'files',
				'uniq':this.u,
				'session':this.s
			},
			function(result)
			{
				th.Update();
			},
			false
		);
		return false;
	}
	this.InsertLink=function(link)
	{
		var evt=window.event;
		link=window.location.protocol+'//'+window.location.hostname+site_path+'/'+this.uploads_dir+'/'+(this.start_folder ? this.start_folder+'/' : '')+link;
		if (!evt || !evt.altKey)
			EDITOR.Insert(link);
		else
			prompt(el_lang['copy_and_paste'],link);
		return false;
	}
	this.InsertAttach=function(link,preview)
	{
		var evt=window.event;
		//window.location.protocol+'//'+window.location.hostname+site_path+'/'+
		preview=preview ? ' preview='+this.uploads_dir+'/'+(this.start_folder ? this.start_folder+'/' : '')+preview : '';
		link='[attach='+this.uploads_dir+'/'+(this.start_folder ? this.start_folder+'/' : '')+link+preview+']';
		if (!evt || !evt.altKey)
			EDITOR.Insert(link);
		else
			prompt(el_lang['copy_and_paste'],link);
		return false;
	}
	this.Open=function(url)
	{
		url=this.uploads_dir+'/'+(this.start_folder ? this.start_folder+'/' : '')+url;
		window.open(url);
		return false;
	}
	this.WaterMark=function(obj)
	{
		if(obj)
		{
			obj.className=this.watermark ? "deactive" : "active";
			this.watermark=!this.watermark;
		}
		else if(Id("watermark_"+this.u))
			Id("watermark_"+this.u).className=this.watermark ? "active" : "deactive";
		if(eval("swf_"+this.u))
			eval("swf_"+this.u+".addPostParam('watermark',"+(this.watermark ? '1' : '0')+");");
		return false;
	}
}