<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
#Пользовательские функции. Поставить в false, если используется интеграция.
$Mainclass->user_funcs=true;

$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'account','lang_user-%');
$Mainclass->LoadOptions(array('reg'),false);
$Mainclass->Url->params=array('info');
$Mainclass->Url->Parse();
$task=isset($_GET['do']) ? $_GET['do'] : '';
if(isset($_GET['info']))
	AcUserInfo($_GET['info']);
elseif(isset($_GET['showuser']))
	AcUserInfo($_GET['showuser'],true);
elseif($Mainclass->Login->IsUser())
{
	if(isset($_POST['referer']) and strpos($_POST['referer'],ELEANOR_PROTOCOL.$Mainclass->domain)===0)
	{
		Functions::Redirect($_POST['referer']);
		die;
	}
	if(isset($_GET['editbookmark']))
		$task='editbookmark';
	elseif(isset($_GET['savebookmark']))
		$task='savebookmark';
	switch(strtolower($task))
	{
		case 'avatar':
			if($Mainclass->user_funcs)
			{
				AcAvatarSet();
				break;
			}
		case 'options':
			if($Mainclass->user_funcs)
			{
				AcOptions();
				break;
			}
		case 'signature':
			if($Mainclass->user_funcs)
			{
				AcSignature();
				break;
			}
		case 'change_pass':
			if($Mainclass->user_funcs)
			{
				AcChangePass();
				break;
			}
		case 'change_email':
			if($Mainclass->user_funcs)
			{
				AcChangeEmail();
				break;
			}
		default:
			AcUserBeginPage();
		break;
		case 'editbookmark':
			EditBookMark((int)$_GET['editbookmark']);
		break;
		case 'savebookmark':
			SaveBookMark((int)$_GET['savebookmark']);
		break;
	}
}
else
	switch(strtolower($task))
	{
		case 'register':
			AcRegister();
		break;
		case 'activate':
			AcActivate();
		break;
		case 'passlost':
			AcPassLost();
		break;
		case 'complete':
			AcComplete();
		break;
		default:
			AcLoginPage();
		break;
	}

function AcMenu()
{global $Mainclass;
	$opts=$Mainclass->user_funcs
	? array(
				'<a href="'.$Mainclass->Url->Prefix(false,true,true).'">'.$Mainclass->lang['account']['bookmarks'].'</a>',
				'<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'avatar'))).'">'.$Mainclass->lang['account']['avatara'].'</a>',
				'<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'options'))).'">'.$Mainclass->lang['account']['profile_'].'</a>',
				'<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'signature'))).'">'.$Mainclass->lang['account']['signature_'].'</a>',
				'<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'change_pass'))).'">'.$Mainclass->lang['account']['change_pass'].'</a>',
				'<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'change_email'))).'">'.$Mainclass->lang['account']['change_email'].'</a>',
	)
	: array(
				'<a href="'.$Mainclass->Url->Prefix(false,true,true).'">'.$Mainclass->lang['account']['bookmarks'].'</a>'
	);
	return $Mainclass->Template->ModuleMenu('login','','',array('title'=>$Mainclass->lang['account']['l_cabinet'],'options'=>$opts));
}

function AcLoginPage()
{global $Mainclass, $title;
	$title=$Mainclass->lang['account']['l_cabinet'];
	$referer=isset($_POST['referer']) ? $_POST['referer'] : '';
	if(!$referer and empty($_POST) and isset($_GET['referer']))
	{
		$referer=$Mainclass->MyGetEnv('HTTP_REFERER');
		if(!$referer)
			$referer=$_GET['referer'];
	}
	$addon=$referer ? Template::Control('referer','hidden',$referer) : '';
	Head();
	echo AcMenu().$Mainclass->Template->OpenTable().$Mainclass->Template->GetThemeFile('Login',array('addon'=>$addon),$Mainclass->lang_name).$Mainclass->Template->CloseTable();
}

function AcUserInfo($name,$is_id=false)
{global $Mainclass, $title;
	if($is_id)
		$Mainclass->Db->FQuery('SELECT u.`id`, u.`name`, u.`group`, u.`other_group`, u.`register`, u.`last_visit`, e.* FROM {"0"} AS `u` INNER JOIN {"1"} AS `e` USING (`id`) WHERE `id`={"2"} LIMIT 1',array('users','users_extra','i_'.$name),__file__,__line__);
	else
		$Mainclass->Db->FQuery('SELECT u.`id`, u.`name`, u.`group`, u.`other_group`, u.`register`, u.`last_visit`, e.* FROM {"0"} AS `u` INNER JOIN {"1"} AS `e` USING (`id`) WHERE `l_name`=LOWER({"2"}) LIMIT 1',array('users','users_extra','s_'.$name),__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
	{
		$title=$Mainclass->lang['account']['u_n_f'];
		$content=$Mainclass->Template->Message($Mainclass->lang['account']['u_n_f']);
	}
	else
	{
		$arr=$Mainclass->Db->Fetch_assoc();
		$arr['name']=$title=htmlspecialchars($arr['name']);
		$av=$Mainclass->Account->GetAvatar($arr);
		$Mainclass->Db->Query('SELECT `id`, `title`, `html_pref`, `html_end` FROM `prefix_groups` WHERE `id`'.$Mainclass->Db->In(explode(',',Strings::CleanForExplode($arr['other_group'].','.$arr['group'],','))).' ORDER BY `title` ASC',__file__,__line__);
		$arr['other_group']=array();
		while($temp=$Mainclass->Db->Fetch_assoc())
			if($arr['group']==$temp['id'])
				$arr['group']=$temp['html_pref'].$temp['title'].$temp['html_end'];
			else
				$arr['other_group'][]=$temp['html_pref'].$temp['title'].$temp['html_end'];
		if(!$arr['group'])
			$arr['group']='<i>'.$Mainclass->lang['main']['no'].'</i>';
		$dop_s=($arr['icq'] ? '<tr><td class="label">ICQ:</td><td><img src="http://status.icq.com/online.gif?icq='.$arr['icq'].'&amp;img=5" border="0" alt="" title="" />'.number_format($arr['icq'],0,3,'-').'</td></tr>' : '')
		.($arr['aim']		? '<tr><td class="label">AIM:</td><td>'.$arr['aim'].'</td></tr>' : '')
		.($arr['yahoo']		? '<tr><td class="label">Yahoo!:</td><td>'.$arr['yahoo'].'</td></tr>' : '')
		.($arr['msn']		? '<tr><td class="label">MSN:</td><td>'.$arr['msn'].'</td></tr>' : '')
		.($arr['skype']		? '<tr><td class="label">Skype:</td><td><a href="skype:'.htmlspecialchars($arr['skype']).'">'.$arr['skype'].'</a></td></tr>' : '')
		.($arr['website']	? '<tr><td class="label">'.$Mainclass->lang['account']['site'].'</td><td><a href="go.php?int='.Strings::Text2Hex($arr['website'],false).'" target="_blank">'.$arr['website'].'</a></td></tr>' : '')
		.($arr['bio']		? '<tr><td class="label">'.$Mainclass->lang['account']['bio'].'</td><td>'.$arr['bio'].'</td></tr>' : '')
		.($arr['interests'] ? '<tr><td class="label">'.$Mainclass->lang['account']['interests'].'</td><td>'.$arr['interests'].'</td></tr>' : '')
		.($arr['location']	? '<tr><td class="label">'.$Mainclass->lang['account']['wfrom'].'</td><td>'.$arr['location'].'</td></tr>' : '')
		.($arr['signature'] ? '<tr><td class="label">'.$Mainclass->lang['account']['signature'].'</td><td>'.Strings::ParseOwnBB($arr['signature']).'</td></tr>' : '');
		$content='<table class="formeditor">
	<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['gdata'].'</td></tr>
	<tr><td colspan="2">
			<div style="float: left; margin-right: 10px;">
				<img src="'.$av['avatar'].'" width="'.$av['w'].'" height="'.$av['h'].'" alt="'.$arr['name'].'" />
			</div>
			<div>
		<p><strong>'.$arr['name'].'</strong></p>
		<p>'.$Mainclass->lang['account']['gen_gr'].' '.$arr['group'].'</p>
		'.($arr['other_group'] ? '<p>'.$Mainclass->lang['account']['oth_gr'].' '.implode(', ',$arr['other_group']).'</p>' : '')
		.'<p>'.$Mainclass->lang['account']['registered'].' '.$arr['register'].'</p>
		<p>'.$Mainclass->lang['account']['last_visit'].' '.date('Y-m-d H:i:s',$arr['last_visit']).'</p>
			</div>
	</td></tr>'.($dop_s ? '<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['a_data'].'</td></tr>'.$dop_s : '').'</table>';
	}
	Head();
	echo $content;
}

function AcRegister()
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/module_account.js';
	$Mainclass->Loadclass('classes/captcha/class_captcha.php');
	if(isset($_GET['captcha']))
	{
		$Mainclass->Captcha->GetImage();
		die;
	}
	$content=$login=$email=$error='';
	if(!empty($Mainclass->vars['register_off']))
	{
		unset($_POST['name']);
		$content.=$Mainclass->Template->Message($Mainclass->lang['account']['reg_off'],'error');
	}
	if(isset($_POST['name'],$_POST['pass']) and isset($_POST['pass2']))
		do
		{
			$login=$_POST['name'];
			$email=$_POST['email'];
			if($_POST['pass']!=$_POST['pass2'])
			{
				$error=$Mainclass->lang['account']['pass_mm'];
				break;
			}
			$pass=$_POST['pass'];
			if(!$pass)
				$pass=Strings::GenPass(10);
			if(!Functions::CheckEmail($email) or $Mainclass->Account->Manage->IsEmailBlocked($email))
			{
				$error=$Mainclass->lang['account']['incor_email'];
				break;
			}
			else
			{
				$Mainclass->Db->FQuery('SELECT `email` FROM {"0"} WHERE `email`={"1"} LIMIT 1',array('users','s_'.$email));
				if($Mainclass->Db->Num_rows()!=0)
				{
					$error=$Mainclass->lang['account']['emailinuse'];
					break;
				}
			}
			$long=false;
			if($Mainclass->Account->Manage->IsNameBlocked($login) or $long=strlen($login)>(int)$Mainclass->vars['user_nick_length'])
			{
				$error=$long ? $Mainclass->lang['account']['nick_too_long'] : $Mainclass->lang['account']['incor_nick'];
				break;
			}
			else
			{
				$Mainclass->Db->FQuery('SELECT `l_name` FROM {"0"} WHERE `l_name`=LOWER({"1"}) LIMIT 1',array('users','s_'.$login));
				if($Mainclass->Db->Num_rows()!=0)
				{
					$error=$Mainclass->lang['account']['nick_in_use'];
					break;
				}
			}
			if(!$Mainclass->Captcha->PostCheck('check'))
			{
				$error=$Mainclass->lang['account']['wrong_c'];
				break;
			}
			$data=array(
						'name'=>$login,
						'pass_hash'=>$pass,
						'email'=>$email
			);
			if($Mainclass->vars['account_reg_type']==1)
			{
				$res=$Mainclass->Account->Manage->AddUser($login,$pass,$data);
				if($res===false)
				{
					$error=$Mainclass->Account->error_exp;
					break;
				}
				$Mainclass->Template->RedirectScreen($Mainclass->Url->Prefix(false,true,true));
				$content.=$Mainclass->Template->Title($Mainclass->lang['account']['thanks'])
						.$Mainclass->Template->OpenTable()
						.$Mainclass->lang['account']['success_reg']
						.$Mainclass->Template->CloseTable();
				include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php');
				$Mainclass->Mail(
									$email,
									str_replace(
												array(
														'%title%',
														'%link%',
														'%nick%',
														'%pass%',
												),
												array(
														$Mainclass->vars['site_name'],
														ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
														htmlspecialchars($login),
														$pass,
												),
												$letters['letter_e']
									),
									array(
											'html'=>true,
											'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_e_tit']),
									)
				);
				$title=$Mainclass->lang['account']['reg_fin'];
			}
			else
			{
				$arr=$Mainclass->Functions->ConfCreate(serialize($data+array('ac'=>'register')),$Mainclass->vars['reg_act_hours']);
				$content.=$Mainclass->Template->Title($Mainclass->lang['account']['check_mail'])
						.$Mainclass->Template->OpenTable()
						.sprintf($Mainclass->lang['account']['f_st_reg_f'],$Mainclass->vars['reg_act_hours'])
						.$Mainclass->Template->CloseTable();
				include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php');
				$Mainclass->Mail(
									$email,
									str_replace(
												array(
														'%title%',
														'%link%',
														'%nick%',
														'%pass%',
														'%hours%',
														'%confirm%',
												),
												array(
														$Mainclass->vars['site_name'],
														ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
														$_POST['name'],
														$Mainclass->POST['pass'],
														$Mainclass->vars['reg_act_hours'],
														ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path
														.'/'.$Mainclass->Url->DynamicBegin(true)
														.$Mainclass->Url->ConstructUrl(array(
																								'module'=>$Mainclass->GetModVal('name'),
																								'do'=>'activate',
																								'id'=>$arr['id'],
																								'hash'=>$arr['hash']),false,false,false),
												),
												$letters['letter_regconf']
									),
									array(
											'html'=>true,
											'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_regconf_tit']),
									)
				);
				$title=$Mainclass->lang['account']['wait_act'];
			}
			$Mainclass->Captcha->Destroy();
		}while(false);
	if(!$content)
	{
		$title=$Mainclass->lang['account']['form_reg'];
		$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().Strings::JsVars(array('module_id'=>$Mainclass->GetModVal('id'))).'
		<form method="post" action="" onsubmit="return CheckReg()"><table class="formeditor">
			<tr><td class="label">'.$Mainclass->lang['account']['login'].'<span class="impfields">*</span></td><td class="input">'.Template::Edit('name',$login,'id="login" onblur="CheckLogin()" style="width:90%"').' <a href="#" onclick="return CheckLogin()" title="'.$Mainclass->lang['account']['chech_avail'].'"><img src="'.$Mainclass->Template->GetImage('no_dublicate.png').'" alt="'.$Mainclass->lang['account']['chech_avail'].'" /></a><br /><span id="login_check" style="color:green">'.$Mainclass->lang['account']['enter_g_login'].'</span></td><td class="description">'.$Mainclass->lang['account']['login_descr'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['your_email'].'<span class="impfields">*</span></td><td class="input">'.Template::Edit('email',$email,'id="email" onblur="CheckEmail()" style="width:90%"').' <a href="#" onclick="return CheckEmail()" title="'.$Mainclass->lang['account']['chech_avail'].'"><img src="'.$Mainclass->Template->GetImage('no_dublicate.png').'" alt="'.$Mainclass->lang['account']['chech_avail'].'" /></a><br /><span id="email_check" style="color:green">'.$Mainclass->lang['account']['enter_g_email'].'</span></td><td class="description">'.$Mainclass->lang['account']['email_descr'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['pass_'].'<span class="impfields">*</span></td><td class="input">'.Template::Control('pass','password','','id="pass1"').'</td><td class="description" rowspan="2">'.$Mainclass->lang['account']['pass_descr'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['rep_pass'].'<span class="impfields">*</span></td><td class="input">'.Template::Control('pass2','password','','id="pass2"').'</td></tr>'
			.($Mainclass->Captcha->disabled ? '' : '<tr><td class="label">'.$Mainclass->lang['account']['captcha'].'</td><td class="input">'.$Mainclass->Captcha->GetCode(array('do'=>'register','captcha'=>'1')).'</td><td class="description" rowspan="2">'.$Mainclass->lang['account']['captcha_descr'].'</td></tr><tr><td class="label">'.$Mainclass->lang['account']['c_code'].'</td><td class="input">'.Template::Edit('check').'</td></tr>')
			.'<tr><td colspan="3" align="center">'.Template::Button($Mainclass->lang['account']['do_reg']).'</td></tr>
		</table></form>'.$Mainclass->Template->CloseTable();
	}
	Head();
	echo AcMenu().$content;
}

function AcActivate()
{global $Mainclass;
	$act=true;
	$error=false;
	if(isset($_GET['id'],$_GET['hash']))
		do
		{
			$data=$Mainclass->Functions->ConfCheck($_GET['id'],$_GET['hash']);
			if($data===false or false===$data=@unserialize($data) or !is_array($data) or !isset($data['ac']) or $data['ac']!='register')
			{
				$act=false;
				break;
			}
			unset($data['ac']);
			$res=$Mainclass->Account->Manage->AddUser($data['name'],$data['pass_hash'],$data);
			if($res===false)
			{
				$error=$Mainclass->Account->error_exp;
				break;
			}
		}while(false);
	if($act)
	{
		$Mainclass->Template->RedirectScreen($Mainclass->Url->Prefix(false,true,true));
		$content=$Mainclass->Template->Title($Mainclass->lang['account']['thanks'])
				.$Mainclass->Template->OpenTable()
				.$Mainclass->lang['account']['success_reg']
				.$Mainclass->Template->CloseTable();
		include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php');
		$Mainclass->Mail(
							$data['email'],
							str_replace(
										array(
												'%title%',
												'%link%',
												'%nick%',
												'%pass%',
										),
										array(
												$Mainclass->vars['site_name'],
												ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
												htmlspecialchars($data['name']),
												$data['pass_hash'],
										),
										$letters['letter_e']
							),
							array(
									'html'=>true,
									'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_e_tit']),
							)
		);
		$title=$Mainclass->lang['account']['reg_fin'];
	}
	else
		$content=$Mainclass->Template->Title($Mainclass->lang['account']['error']).$Mainclass->Template->Message($error ? $error : $Mainclass->lang['account']['reg_not_act']);
	Head();
	echo AcMenu().$content;
}

function AcPassLost($id='',$hash='')
{global $Mainclass,$title;
	$Mainclass->Loadclass('classes/captcha/class_captcha.php');
	if(isset($_GET['captcha']))
	{
		$Mainclass->Captcha->GetImage();
		die;
	}
	$content=$error=$name='';
	if(isset($_GET['id'],$_GET['hash']))
	{
		do
		{
			$data=$Mainclass->Functions->ConfCheck($_GET['id'],$_GET['hash'],false);
			if($data===false or false===$data=@unserialize($data) or !is_array($data) or !isset($data['ac']) or $data['ac']!='passlost')
			{
				$act=false;
				break;
			}
			if($Mainclass->vars['account_pass_rec_t']==2)
			{
				$pass=Strings::GenPass(10);
				$act=true;
				$Mainclass->Template->RedirectScreen($Mainclass->Url->Prefix(false,true,true));
				$content.=$Mainclass->Template->Title($Mainclass->lang['account']['thanks'])
						.$Mainclass->Template->OpenTable()
						.$Mainclass->lang['account']['new_pass_sent']
						.$Mainclass->Template->CloseTable();
				break;
			}
			else
			{
				if(isset($_POST['new_pass'],$_POST['new_pass2']))
					if($_POST['new_pass']==$_POST['new_pass2'])
					{
						$pass=$_POST['new_pass'] ? $_POST['new_pass'] : Strings::GenPass(10);
						$act=true;
						$Mainclass->Template->RedirectScreen($Mainclass->Url->Prefix(false,true,true));
						$content.=$Mainclass->Template->Title($Mainclass->lang['account']['thanks'])
								.$Mainclass->Template->OpenTable()
								.$Mainclass->lang['account']['pass_changed']
								.$Mainclass->Template->CloseTable();
						break;
					}
					else
						$error=$Mainclass->lang['account']['pass_mm'];
				$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().Strings::JsVars(array('module_id'=>$Mainclass->GetModVal('id'))).'
				<span class="option"><b>'.htmlspecialchars($data['name']).'</b>'.$Mainclass->lang['account']['pls_ent_np'].'</span><br />
				<form method="post" action=""><table class="formeditor">
					<tr><td class="label">'.$Mainclass->lang['account']['pass_'].'<span class="impfields">*</span></td><td class="input">'.Template::Control('new_pass','password','','id="pass1"').'</td><td class="description" rowspan="2">'.$Mainclass->lang['account']['pass_descr'].'</td></tr>
					<tr><td class="label">'.$Mainclass->lang['account']['rep_pass'].'<span class="impfields">*</span></td><td class="input">'.Template::Control('new_pass2','password','','id="pass2"').'</td></tr>
					<tr><td colspan="3" align="center">'.Template::Button().'</td></tr>
				</table></form>'.$Mainclass->Template->CloseTable();
			}
		}while(false);
		if(isset($act))
			if($act)
			{
				$Mainclass->Functions->ConfDel($_GET['id'],$_GET['hash']);
				include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php');
				$Mainclass->Mail(
									$data['email'],
									str_replace(
												array(
														'%title%',
														'%link%',
														'%nick%',
														'%pass%',
												),
												array(
														$Mainclass->vars['site_name'],
														ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
														$data['name'],
														$pass,
												),
												$letters['letter_pls']
									),
									array(
											'html'=>true,
											'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_pls_tit']),
									)
				);
				$Mainclass->Account->Manage->ChangePass($pass,$data['id']);
			}
			else
				$error=$Mainclass->lang['account']['inf_frpnf'];
	}
	elseif(isset($_POST['name']))
		do
		{
			if(!$Mainclass->Captcha->PostCheck('check'))
			{
				$error=$Mainclass->lang['account']['wrong_c'];
				break;
			}
			$Mainclass->Captcha->Destroy();
			$name=$_POST['name'];
			$Mainclass->Db->FQuery('SELECT `id`, `email` FROM {"0"} WHERE `l_name`=LOWER({"1"}) LIMIT 1',array('users','s_'.$_POST['name'],__file__,__line__));
			if($Mainclass->Db->Num_rows()!=0)
			{
				list($id,$email)=$Mainclass->Db->Fetch_row();
				$content=$Mainclass->Template->Title($Mainclass->lang['account']['check_mail'])
						.$Mainclass->Template->OpenTable()
						.$Mainclass->lang['account']['cont_resp']
						.$Mainclass->Template->CloseTable();
				$arr=$Mainclass->Functions->ConfCreate(serialize(array('ac'=>'passlost','id'=>$id,'name'=>$_POST['name'],'email'=>$email)),$Mainclass->vars['reg_act_hours']);
				include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php');
				$Mainclass->Mail(
									$email,
									str_replace(
												array(
														'%title%',
														'%link%',
														'%nick%',
														'%email%',
														'%hours%',
														'%confirm%',
												),
												array(
														$Mainclass->vars['site_name'],
														ELEANOR_PROTOCOL.$Mainclass->domain,
														$name,
														$email,
														$Mainclass->vars['reg_act_hours'],
														ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'
														.$Mainclass->Url->DynamicBegin(true)
														.$Mainclass->Url->ConstructUrl(array(
																								'module'=>$Mainclass->GetModVal('name'),
																								'do'=>'passlost',
																								'id'=>$arr['id'],
																								'hash'=>$arr['hash']),false,false,false),
												),
												$letters['letter_regplconf']
									),
									array(
											'html'=>true,
											'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_regplconf_tit']),
									)
				);
			}
			else
				$error=$Mainclass->lang['account']['u_n_f'];
		}while(false);
	if(!$content)
	{
		$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().'
		<form method="post" action="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'passlost'))).'"><table class="formeditor">
			<tr><td class="label">'.$Mainclass->lang['account']['login'].'<span class="impfields">*</span></td><td class="input">'.Template::Edit('name',$name).'</td><td class="description">'.$Mainclass->lang['account']['for_bprpel'].'</td></tr>'
			.($Mainclass->Captcha->disabled ? '' : '<tr><td class="label">'.$Mainclass->lang['account']['captcha'].'</td><td class="input">'.$Mainclass->Captcha->GetCode(array('do'=>'passlost','captcha'=>'1')).'</td><td class="description" rowspan="2">'.$Mainclass->lang['account']['captcha_descr'].'</td></tr><tr><td class="label">'.$Mainclass->lang['account']['c_code'].'</td><td class="input">'.Template::Edit('check').'</td></tr>')
			.'<tr><td colspan="3" align="center">'.Template::Button($Mainclass->lang['account']['continue']).'</td></tr>
		</table></form>'.$Mainclass->Template->CloseTable();
	}
	$title=$Mainclass->lang['account']['restpass'];
	Head();
	echo AcMenu().$content;
}


function AcChangeEmail()
{global $Mainclass,$title;
	$content=$error=$email='';
	if(isset($_GET['id'],$_GET['hash']))
		do
		{
			$data=$Mainclass->Functions->ConfCheck($_GET['id'],$_GET['hash'],false);
			if($data===false or false===$data=@unserialize($data) or !is_array($data) or !isset($data['id']) or $data['id']!=$Mainclass->Account->GetValue('id') or !isset($data['ac']) or $data['ac']!='change_email')
			{
				$error=$Mainclass->lang['account']['inffche'];
				break;
			}
			$email=$data['email'];
			if(!Functions::CheckEmail($data['email']))
			{
				$error=$Mainclass->lang['account']['new_em_err'];
				break;
			}
			if($Mainclass->Account->Manage->IsEmailBlocked($data['email']))
			{
				$error=$Mainclass->lang['account']['email_blocked'];
				break;
			}
			$Mainclass->Db->FQuery('SELECT `email` FROM {"0"} WHERE `email`={"1"} AND `id`!={"2"} LIMIT 1',array('users','s_'.$data['email'],'i_'.$Mainclass->Account->GetValue('id')),__file__,__line__);
			if($Mainclass->Db->Num_rows()!=0)
			{
				$error=$Mainclass->lang['account']['emailinuse'];
				break;
			}
			$Mainclass->Account->Manage->UpdateUser(array('email'=>$data['email']));
			$Mainclass->Template->RedirectScreen($Mainclass->Url->Prefix(false,true,true));
			$content.=$Mainclass->Template->Title($Mainclass->lang['account']['thanks'])
					.$Mainclass->Template->OpenTable()
					.$Mainclass->lang['account']['email_changed']
					.$Mainclass->Template->CloseTable();
		}while(false);
	elseif(isset($_POST['email']))
		do
		{
			if(!Functions::CheckEmail($_POST['email']))
			{
				$error=$Mainclass->lang['account']['new_em_err'];
				break;
			}
			if($Mainclass->Account->Manage->IsEmailBlocked($_POST['email']))
			{
				$error=$Mainclass->lang['account']['email_blocked'];
				break;
			}
			$Mainclass->Db->FQuery('SELECT `email` FROM {"0"} WHERE `email`={"1"} AND `id`!={"2"} LIMIT 1',array('users','s_'.$_POST['email'],'i_'.$Mainclass->Account->GetValue('id')),__file__,__line__);
			if($Mainclass->Db->Num_rows()!=0)
			{
				$error=$Mainclass->lang['account']['emailinuse'];
				break;
			}
			$content=$Mainclass->Template->Title($Mainclass->lang['account']['check_mail'])
					.$Mainclass->Template->OpenTable()
					.$Mainclass->lang['account']['for_aneclm']
					.$Mainclass->Template->CloseTable();
			$arr=$Mainclass->Functions->ConfCreate(serialize(array('ac'=>'change_email','id'=>$Mainclass->Account->GetValue('id'),'email'=>$_POST['email'])),$Mainclass->vars['reg_act_hours']);
			include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php');
			$Mainclass->Mail(
								$_POST['email'],
								str_replace(
											array(
													'%title%',
													'%link%',
													'%nick%',
													'%email%',
													'%old_email%',
													'%hours%',
													'%confirm%',
											),
											array(
													$Mainclass->vars['site_name'],
													ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
													$Mainclass->Account->GetValue('name'),
													$email,
													$Mainclass->Account->GetValue('email'),
													$Mainclass->vars['reg_act_hours'],
													ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'
														.$Mainclass->Url->DynamicBegin(true)
														.$Mainclass->Url->ConstructUrl(array(
																								'module'=>$Mainclass->GetModVal('name'),
																								'do'=>'change_email',
																								'id'=>$arr['id'],
																								'hash'=>$arr['hash']),false,false,false),
											),
											$letters['letter_emact']
								),
								array(
										'html'=>true,
										'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_emact_tit']),
								)
			);
		}while(false);
	if(!$content)
	{
		$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().'
		<form method="post" action="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'change_email'))).'">
		<table class="formeditor">
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['changing_email'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['curr_email'].'</td><td class="input"><b>'.$Mainclass->Account->GetValue('email').'</b></td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['new_email'].'</td><td class="input">'.Template::Edit('email',$email).'</td></tr>
			<tr><td colspan="3" align="center">'.Template::Button($Mainclass->lang['account']['continue']).'</td></tr>
		</table></form>'.$Mainclass->Template->CloseTable();
	}
	$title=$Mainclass->lang['account']['changing_email'];
	Head();
	echo AcMenu().$content;
}

function AcAvatarSet()
{global $Mainclass, $title, $jscripts;
	$content=$error='';
	$type=$Mainclass->Account->GetValue('avatar_type');
	$av=$Mainclass->Account->GetAvatar();
	$my_avatar=$av['no'] ? '<b><i>'.$Mainclass->lang['account']['no_avatar'].'</i></b>' : '<img src="'.$av['avatar'].'" width="'.$av['w'].'" height="'.$av['h'].'" alt="" /><div>'.htmlspecialchars($av['avatar']).'</div>';
	if(isset($_POST['do']))
		switch($_POST['do'])
		{
			case 'savea':
				if(!empty($_POST['avatar']))
				{
					$dir=$Mainclass->Url->UrlString($_POST['galery']);
					$avatar=preg_match('#^['.Strings::ALL.'\.]+$#i',$_POST['avatar'])>0 ? $_POST['avatar'] : '';
					if(is_file($Mainclass->root_path.'images/avatars/'.$dir.'/'.$avatar) and preg_match('#\.(jpg|png|gif|bmp|jpeg)$#i',$avatar)>0)
					{
						list($w,$h)=@getimagesize($Mainclass->root_path.'images/avatars/'.$dir.'/'.$avatar);
						$avatar=array(
										'avatar_type'=>'local',
										'avatar_location'=>$dir.'/'.$avatar,
										'avatar_size'=>$w.'x'.$h,
						);
					}
					else
					{
						$error=$Mainclass->lang['account']['av_not_f'];
						break;
					}
				}
				elseif(!empty($_FILES['afile']['size']) and is_uploaded_file($_FILES['afile']['tmp_name']))
				{
					if(preg_match('#\.(jpe?g|bmp|png|gif)$#i',$_FILES['afile']['name'],$m)==0)
						break;
					$avatar['avatar_type']='upload';
					list($limw,$limh)=explode(' ',$Mainclass->vars['avatar_size']);
					if(false===list($w,$h)=@getimagesize($_FILES['afile']['tmp_name']))
						break;
					if($limw>=$w and $limh>=$h and $_FILES['afile']['size']<=$Mainclass->vars['avatar_bytes'])
					{
						if($Mainclass->Functions->Upload('afile','uploaded_avatars',$loc='av-'.$Mainclass->Account->GetValue('id').'.'.$m[1]))
						{
							$avatar['avatar_location']=$loc;
							$avatar['avatar_size']=$w.'x'.$h;
						}
						else
						{
							unset($avatar['avatar_location'],$avatar['avatar_size']);
							break;
						}
					}
					else
					{
						$error=$Mainclass->lang['account']['av_size_too'];
						break;
					}
				}
				elseif(!empty($_POST['alink']) and Strings::XssCheckUrl($_POST['alink']))
				{
					$avlink=$_POST['alink'];
					if(strpos($_POST['alink'],'://',2)===false)
						$avlink=ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.$avlink;
					$avatar['avatar_type']='url';
					list($limw,$limh)=explode(' ',$Mainclass->vars['avatar_size']);
					$Mainclass->no_log=true;
					if(!list($w,$h)=@getimagesize($avlink))
					{
						$error=$Mainclass->lang['account']['av_load_error'];
						break;
					}
					$Mainclass->no_log=false;
					if($limw>=$w and $limh>=$h)
					{
						$avatar['avatar_location']=$_POST['alink'];
						$avatar['avatar_size']=$w.'x'.$h;
					}
					else
					{
						$error=$Mainclass->lang['account']['av_size_too'];
						break;
					}
				}
				else
				{
					$error=$Mainclass->lang['account']['av_load_error'];
					break;
				}
			case 'deletea':
				if($type=='upload')
				{
					if(is_file($Mainclass->root_path.$av['avatar']))
						@unlink($Mainclass->root_path.$av['avatar']);
				}
				if($_POST['do']=='deletea')
					$Mainclass->Account->Manage->UpdateUserExtra(array('avatar_location'=>'','avatar_size'=>''));
				else
					$Mainclass->Account->Manage->UpdateUserExtra($avatar);
				$av=$Mainclass->Account->GetAvatar();
				$my_avatar=$av['no'] ? '<b><i>'.$Mainclass->lang['account']['no_avatar'].'</i></b>' : '<img src="'.$av['avatar'].'" width="'.$av['w'].'" height="'.$av['h'].'" alt="" /><div>'.htmlspecialchars($av['avatar']).'</div>';
			break;
		}
	elseif(isset($_GET['galery']))
	{
		$galery='';
		$dir=$Mainclass->Url->UrlString($_GET['galery']);
		if(is_dir($Mainclass->root_path.'images/avatars/'.$dir))
		{
			$dirh=opendir($Mainclass->root_path.'images/avatars/'.$dir);
			while($en=readdir($dirh))
				if(preg_match('#\.(jpg|png|gif|bmp|jpeg)$#i',$en)>0)
					$galery.=Template::Control('avatar','image',$en,'src="images/avatars/'.$dir.'/'.$en.'" onclick="Id(\'avatar\').value=this.value" style="margin: 2px;"');
			closedir($dirh);
		}
		if($galery)
			$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().'
				<form method="post" action="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'avatar'))).'">'.Template::Control('do','hidden','savea').Template::Control('galery','hidden',$dir).Template::Control('avatar','hidden','','id="avatar"')
				.'<table class="formeditor">
					<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['your_curr_av'].'</td></tr>
					<tr><td colspan="2" align="center">'.$my_avatar.'</td></tr>
					<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['av_select'].'</td></tr>
					<tr><td colspan="2" align="center">'.$galery.'</td></tr>
					<tr><td colspan="2"><a href="#" onclick="history.go(-1); return false;"><b>'.$Mainclass->lang['main']['back'].'</b></a></td></tr>
				</table></form>'.$Mainclass->Template->CloseTable();
	}
	if(!$content)
	{
		$galery='';
		$gals=glob($Mainclass->root_path.'images/avatars/*',GLOB_MARK | GLOB_ONLYDIR);
		foreach($gals as &$v)
		{
			$name=basename($v);
			$image='';
			if(is_file($v.'config.txt'))
			{
				$arr=parse_ini_file($v.'config.txt');
				if(isset($arr[$Mainclass->lang_name]))
					$descr=$arr[$Mainclass->lang_name];
				elseif(isset($arr[ELEANOR_DEFAULT_LANGUAGE]))
					$descr=$arr[ELEANOR_DEFAULT_LANGUAGE];
				else
					$descr=$v;
				if(isset($arr['cover']) and is_file($v.$arr['cover']))
					$image='images/avatars/'.$name.'/'.$arr['cover'];
				else
				{
					$temp=glob($v.'*.{jpg,png,jpeg,bmp,gif}',GLOB_BRACE);
					if(!$temp)
						continue;
					$image='images/avatars/'.$name.'/'.basename($temp[0]);
				}
			}
			if(!$image)
			{
				$descr=$v;
				$temp=glob($v.'*.{jpg,png,jpeg,bmp,gif}',GLOB_BRACE);
				if(!$temp)
					continue;
				$image='images/avatars/'.$name.'/'.basename($temp[0]);
			}
			$galery.='<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'avatar'),array('galery'=>$name))).'"><b><img src="'.$image.'" alt="'.$descr.'" /><span>'.$descr.'</span></b></a>';
		}
		$galery=$galery ? '<div class="galleryavatars">'.$galery.'</div>' : '<i>'.$Mainclass->lang['account']['gal_not_f'].'</i>';
		$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable()
		.'<table class="formeditor">
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['your_curr_av'].'</td></tr>
			<tr><td colspan="2" align="center">'.$my_avatar.($av['no'] ? '' : ' <form method="post" action="">'.Template::Control('do','hidden','deletea').Template::Button($Mainclass->lang['account']['del_avatar']).'</form>').'</td></tr>
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['av_sel_gal'].'</td></tr>
			<tr><td colspan="2" align="center">'.$galery.'</td></tr>
			</table><form method="post" action="" enctype="multipart/form-data">'.Template::Control('do','hidden','savea')
		.'<table class="formeditor"><tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['priv_av'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['link_av'].'</td><td>'.Template::Edit('alink').'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['upload'].'</td><td>'.Template::Control('afile','file').'</td></tr>
			<tr><td colspan="2" align="center">'.Template::Button().'</td></tr>
		</table></form>'.$Mainclass->Template->CloseTable();
	}
	$title=$Mainclass->lang['account']['av_opts'];
	Head();
	echo AcMenu().$content;
}

function AcChangePass()
{global $Mainclass, $title;
	$error='';
	if(isset($_POST['old_pass'],$_POST['new_pass1']) and isset($_POST['new_pass2']))
		do
		{
			if($_POST['new_pass2']!=$_POST['new_pass1'])
			{
				$error=$Mainclass->lang['account']['pass_mm'];
				break;
			}
			if(!$_POST['new_pass2'])
			{
				$error=$Mainclass->lang['account']['empty_pass'];
				break;
			}
			if(!$Mainclass->Account->Manage->MatchPass($_POST['old_pass']))
			{
				$error=$Mainclass->lang['account']['old_pass_in'];
				break;
			}
			$Mainclass->Account->Manage->ChangePass($_POST['new_pass1']);
			$Mainclass->Template->RedirectScreen($Mainclass->Url->Prefix(false,true,true));
			$content=$Mainclass->Template->Title($Mainclass->lang['account']['thanks'])
					.$Mainclass->Template->OpenTable()
					.$Mainclass->lang['account']['pass_changed']
					.$Mainclass->Template->CloseTable();
		}while(false);
	if(empty($content))
		$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().'
		<form method="post" action="" onsubmit="if(Id(\'new_pass1\').value!=Id(\'new_pass2\').value){alert(\''.$Mainclass->lang['account']['pass_mm'].'\') return false;}">
		<table class="formeditor">
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['your_curr_pass'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['en_ycp'].'</td><td>'.Template::Control('old_pass','password').'</td></tr>
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['new_pass'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['ent_newp'].'</td><td>'.Template::Control('new_pass1','password').'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['rep_newp'].'</td><td>'.Template::Control('new_pass2','password').'</td></tr>
			<tr><td colspan="2" align="center">'.Template::Button().'</td></tr>
		</table></form>'.$Mainclass->Template->CloseTable();
	$title=$Mainclass->lang['account']['changing_pass'];
	Head();
	echo AcMenu().$content;
}

function AcOptions()
{global $Mainclass, $title,$jscripts;
	$load=true;
	$error=$content='';
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$editor=$Mainclass->Account->GetValue('editor');
	if(isset($_POST['save']))
		do
		{
			$arr['icq']=empty($_POST['icq']) ? '' : preg_replace('#[^0-9]+#','',$_POST['icq']);
			$arr['jabber']=$_POST['jabber'];
			$arr['aim']=$Mainclass->POST['aim'];
			$arr['yahoo']=$Mainclass->POST['yahoo'];
			$arr['msn']=$Mainclass->POST['msn'];
			$arr['skype']=$_POST['skype'];
			$arr['website']=str_replace(array('<','>','"'),array('&lt;','&gt;','"'),$_POST['website']);
			if($arr['website'] and preg_match('#^(http|news|https|ftp|mms)://#',$arr['website'])==0)
				$arr['website']='http://'.$arr['website'];
			if(preg_match('#^(http|news|https|ftp|mms)://([a-z0-9](?:[\.\-a-z0-9][a-z0-9])*)+\.[a-z]{2,6}#',$arr['website'])==0)
				$arr['website']='';
			$arr['interests']=$Mainclass->Editor->GetHTML('interests');
			$arr['location']=$Mainclass->POST['location'];
			$arr['bio']=$Mainclass->Editor->GetHTML('bio');
			$load=false;
			if($arr['icq'] and strlen($arr['icq'])<5)
			{
				$error=$Mainclass->lang['account']['too_short_icq'];
				break;
			}
			if($arr['jabber'] and !Functions::CheckEmail($arr['jabber']))
			{
				$error=$Mainclass->lang['account']['err_jabber'];
				break;
			}
			$Mainclass->Account->Manage->UpdateUserExtra($arr);
			$new_editor=isset($_POST['editor']) ? (int)$_POST['editor'] : -1;
			if($editor!=$new_editor and isset($Mainclass->Editor->editors[$new_editor]))
				$Mainclass->Account->Manage->UpdateUser(array('editor'=>$new_editor));
			$Mainclass->Template->RedirectScreen($Mainclass->Url->ConstructUrl(array(array('do'=>'options'))));
			$content.=$Mainclass->Template->Title($Mainclass->lang['account']['thanks']);
		}while(false);
	if($load)
	{
		$Mainclass->Db->Query('SELECT * FROM `prefix_users_extra` WHERE `id`='.$Mainclass->Account->GetValue('id').' LIMIT 1',__file__,__line__);
		$arr=$Mainclass->Db->Fetch_assoc();
	}
	$editors=Template::Option($Mainclass->lang['account']['default'],-1,$editor==-1);
	foreach($Mainclass->Editor->editors as $k=>$v)
		$editors.=Template::Option($v,$k,$k==$editor);
	if(!$content)
		$content.=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable()
		.'<form method="post" action="">
		<table class="formeditor">
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['options'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['editor'].'</td><td>'.Template::Select('editor',$editors).'</td></tr>
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['prof_opts'].'</td></tr>
			<tr><td class="label">Jabber:</td><td>'.Template::Edit('jabber',$arr['jabber']).'</td></tr>
			<tr><td class="label">ICQ:</td><td>'.Template::Edit('icq',$arr['icq']).'</td></tr>
			<tr><td class="label">AIM:</td><td>'.Template::Edit('aim',$arr['aim']).'</td></tr>
			<tr><td class="label">Yahoo!:</td><td>'.Template::Edit('yahoo',$arr['yahoo']).'</td></tr>
			<tr><td class="label">MSN:</td><td>'.Template::Edit('msn',$arr['msn']).'</td></tr>
			<tr><td class="label">Skype:</td><td>'.Template::Edit('skype',$arr['skype']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['site'].'</td><td>'.Template::Edit('website',$arr['website']).'</td></tr>
			<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['account']['about_u'].'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['wfrom'].'</td><td>'.Template::Edit('location',$arr['location']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['interests'].'</td><td>'.$Mainclass->Editor->Area('interests',$arr['interests']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['bio'].'</td><td>'.$Mainclass->Editor->Area('bio',$arr['bio']).'</td></tr>
			<tr><td colspan="2" align="center">'.Template::Control('save','hidden','1').Template::Button().'</td></tr>
		</table></form>'.$Mainclass->Template->CloseTable();
	$title=$Mainclass->lang['account']['prof_opts'];
	Head();
	echo AcMenu().$content;
}

function AcSignature()
{global $Mainclass, $title, $jscripts;
	$error='';
	$Mainclass->Loadclass('classes/others/class_editor.php');
	if(isset($_POST['signature']))
		do
		{
			#Тут можно вставить какие-то проверки для подписи, но я оставлю это на потом
			$Mainclass->Account->Manage->UpdateUserExtra(array('signature'=>$Mainclass->Editor->GetHTML('signature')));
		}while(false);
	$content=($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable().'
	<form method="post" action="">
	<table class="formeditor">
		<tr class="infolabel"><td>'.$Mainclass->lang['account']['curr_sign'].'</td></tr>
		<tr><td>'.Strings::ParseOwnBb($Mainclass->Account->GetValue('signature',false)).'</td></tr>
		<tr class="infolabel"><td>'.$Mainclass->lang['account']['change_sign'].'</td></tr>
		<tr><td>'.$Mainclass->Editor->Area('signature',$Mainclass->Account->GetValue('signature',false),10).'</td></tr>
		<tr><td align="center">'.Template::Button($Mainclass->lang['account']['upd_sign']).'</td></tr>
	</table></form>'.$Mainclass->Template->CloseTable();
	$title=$Mainclass->lang['account']['editing_sign'];
	Head();
	echo AcMenu().$content;
}

function AcUserBeginPage()
{global $Mainclass, $title, $jscripts;
	$content='';
	if(!empty($Mainclass->vars['allow_bookmarks']))
	{
		$title=$Mainclass->lang['account']['your_boo'];
		$jscripts[]='js/bookmarks.js';
		$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_bookmarks` WHERE `uid`='.$Mainclass->Account->GetValue('id'),__file__,__line__);
		list($cnt)=$Mainclass->Db->Fetch_row();
		$per_page=50;
		$pages=ceil($cnt/$per_page);
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$offset=abs(($page-1)*$per_page);
		$content=$Mainclass->Template->Title($title).$Mainclass->Template->OpenTable();
		$old_mid=-1;
		$Mainclass->Db->Query('SELECT b.`id`, b.`mid`, b.`title` AS `value`, b.`href`, b.`descr`, b.`imp`, m.`title`, m.`name` FROM `prefix_bookmarks` AS b LEFT JOIN `prefix_modules` AS m ON b.`mid`=m.`id` WHERE `uid`='.$Mainclass->Account->GetValue('id').' ORDER BY m.`id` DESC, b.`imp` DESC LIMIT '.$offset.', '.$per_page);
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			if($old_mid!=$arr['mid'])
			{
				$content.=($arr['mid']
							? '<h2 class="subheading">'.$Mainclass->lang['account']['m_part'].'<a href="'.$Mainclass->Url->DynamicBegin().$Mainclass->Url->ConstructUrl(array('module'=>$arr['name']),false).'" target="_blank">'.$arr['title'].'</a></h2>'
							: '<h2 class="subheading">'.$Mainclass->lang['account']['mo_m_l'].'</h2>'
				);
				$old_mid=$arr['mid'];
			}
			$content.='<div><h3><a href="'.$arr['href'].'">'.$arr['value'].'</a></h3>'.($arr['descr'] ? $arr['descr'] : '').'
			<table width="100%"><tr>
			<td align="left"><b>'.$Mainclass->lang['account']['imp'].'</b> '.str_repeat('<img src="images/star.png" style="vertical-align: middle;" alt="" />',$arr['imp']).'</td>
			<td align="right">
			<a href="'.$Mainclass->Url->ConstructUrl(array(array('EditBookMark'=>$arr['id']))).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" style="margin: 0 1px;" /></a>
			<a href="#" onclick="if(confirm(\''.$Mainclass->lang['account']['are_you_sure'].'\')) DeleteBookMark('.$arr['id'].',this.parentNode.parentNode.parentNode.parentNode.parentNode); return false;" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" style="margin: 0 1px;" /></a>
			</td></tr></table><hr /><br /></div>';
		}
		$content.=$Mainclass->Template->CloseTable().Strings::JsVars(array('module_id'=>$Mainclass->GetModVal('id'))).'<div align="center"><a href="#" onclick="return ShowAddBookMarkForm()" class="link-button" style="width:150px"><b>'.$Mainclass->lang['account']['add_bookmark'].'</b></a></div><br /><div id="bookmark_params" style="display:none"></div>';
	}
	Head();
	echo AcMenu().$content;
}

function EditBookMark($id,$error='')
{global $Mainclass,$title;
	if(empty($Mainclass->vars['allow_bookmarks']))
		return ExitPrefix();
	$title=$Mainclass->lang['account']['edit_bm'];
	$uid=$Mainclass->Account->GetValue('id');
	if(!$error)
	{
		$Mainclass->Db->Query('SELECT `title`, `href`, `descr`, `imp` FROM `prefix_bookmarks` WHERE `uid`='.$uid.' AND `id`='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			return ExitBack();
		$params=$Mainclass->Db->Fetch_assoc();
	}
	else
	{
		$values['title']=$_POST['title'];
		$values['descr']=$_POST['descr'];
		$values['href']=$_POST['href'];
		$values['imp']=$_POST['imp'];
	}
	$t=range(1,5);
	$imp='';
	foreach($t as &$v)
		$imp.=Template::Option($v,'',$v==$params['imp']);
	$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$content='<form method="post" action="'.$Mainclass->Url->ConstructUrl(array(array('SaveBookMark'=>$id))).'"><table class="formeditor">
			<tr><td class="label">'.$Mainclass->lang['account']['link_tit'].'<span class="impfields">*</span></td><td>'.Template::Edit('title',$params['title']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['descr'].'</td><td>'.Template::Text('descr',$params['descr'],'',true).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['link'].'<span class="impfields">*</span></td><td>'.Template::Edit('href',$params['href'],'').'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['account']['imp'].'</td><td>'.Template::Select('imp',$imp).'</td></tr>
			<tr><td></td><td>'.($ref ? Template::Control('back','hidden',base64_encode($ref)) : '').Template::Button($Mainclass->lang['account']['add']).'</td></tr></table></form>';
	Head();
	echo AcMenu().$Mainclass->Template->Title($title).$content;
}

function SaveBookMark($id)
{global $Mainclass;
	if(empty($Mainclass->vars['allow_bookmarks']))
		return ExitPrefix();
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return EditBookMark($id,$Mainclass->lang['account']['empty_title']);
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_bookmarks` WHERE `uid`='.$uid.' AND `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitBack();
	$href=isset($_POST['href']) ? $_POST['href'] : '';
	if(!Strings::XssCheckUrl($href))
		return EditBookMark($id,$Mainclass->lang['account']['href_inc']);
	$imp=isset($_POST['imp']) ? abs((int)$_POST['imp']) : 0;
	if($imp>5)
		$imp=5;
	$Mainclass->Db->Update(
							'bookmarks',
							array(
									'title'=>$title,
									'descr'=>isset($_POST['descr']) ? $Mainclass->POST['descr'] : '',
									'href'=>$href,
									'imp'=>$imp,
							),
							'`id`='.$id.' LIMIT 1',
							__file__,
							__line__
	);
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}
?>