<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadOptions('module_blogs',false);
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'blogs','lang_admin-%');
$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs` WHERE `status`=-1',__file__,__line__);
list($ncnt)=$Mainclass->Db->Fetch_row();
$Mainclass->navigation=array
(
	array($Mainclass->Url->Prefix(false),$Mainclass->lang['blogs']['b_list']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'news')),((isset($_GET['do']) and $_GET['do']=='news') ? '!' : '').sprintf($Mainclass->lang['blogs']['n_blog'],$ncnt)),
	array($Mainclass->Url->ConstructUrl(array('do'=>'add_blog')),((isset($_GET['do']) and $_GET['do']=='add_blog') ? '!' : '').$Mainclass->lang['blogs']['c_blog']),
	'addsome'=>'',
	array($Mainclass->Url->ConstructUrl(array('do'=>'options')),((isset($_GET['do']) and $_GET['do']=='options' and !isset($_GET['event'])) ? '!' : '').$Mainclass->lang['main']['options']),
);
global $mainpage;
$mainpage=false;
if(isset($_GET['editblog']))
	AddEditBlog((int)$_GET['editblog']);
elseif(isset($_GET['saveblog']))
	SaveBlog($_GET['saveblog']=='new' ? true : (int)$_GET['saveblog']);
elseif(isset($_GET['deleteblog']))
	DeleteBlog((int)$_GET['deleteblog']);
elseif(isset($_GET['addcat']))
	AddEditCat(true,'',(int)$_GET['addcat']);
elseif(isset($_GET['editcat']))
	AddEditCat((int)$_GET['editcat']);
elseif(isset($_GET['savecat']))
	SaveCat($_GET['savecat']=='new' ? true : (int)$_GET['savecat']);
elseif(isset($_GET['deletecat']))
	DeleteCat((int)$_GET['deletecat']);
elseif(isset($_GET['tags']))
	ShowTags((int)$_GET['tags']);
elseif(isset($_GET['edittag']))
	EditTag((int)$_GET['edittag']);
elseif(isset($_GET['deletetag']))
	DeleteTag((int)$_GET['deletetag']);
elseif(isset($_GET['savetag']))
	SaveTag((int)$_GET['savetag']);
elseif(isset($_GET['swapblog']))
	SwapBlog((int)$_GET['swapblog']);
elseif(isset($_GET['categs']))
	ShowCategs((int)$_GET['categs']);
elseif(isset($_GET['do']))
	DoIt($_GET['do']);
else
{
	ShowBlogs();
	$mainpage=true;
}

if($mainpage and isset($Mainclass->navigation[0]))
	$Mainclass->navigation[0][1]='!'.$Mainclass->navigation[0][1];

function DoIt($task)
{global $Mainclass,$mainpage,$jscripts,$title;
	switch ($task)
	{
		case 'tags':
			ShowTags();
		break;
		case 'news':
			ShowBlogs(-1);
		break;
		case 'add_blog':
			AddEditBlog(true);
		break;
		case 'options':
			BlogsOptions();
		break;
		default:
			ShowBlogs();
			$mainpage=true;
		break;
	}
}

function BlogsOptions()
{global $Mainclass,$title,$jscripts;
	$Mainclass->Url->SetPrefix(array(array('do'=>'options')),true);
	$Mainclass->LoadClass('classes/others/class_settings.php');
	$content=$Mainclass->Settings->ShowGroup('module_blogs',false);
	$title=$Mainclass->Settings->title;
	$jscripts=array_merge($jscripts,$Mainclass->Settings->jscripts);
	$Mainclass->navigation=array_merge($Mainclass->navigation,$Mainclass->Settings->navigation);
	$Mainclass->ShowDecoration();
	echo $content;
}

function ShowBlogs($active=0)
{global $Mainclass,$title,$jscripts;
	switch($active)
	{
		case 0:
		default:
			$title=$Mainclass->lang['blogs']['b_list'];
			$where='`status`>=0';
			$pages_arr=array();
		break;
		case -1:
			$title=$Mainclass->lang['blogs']['nblog.'];
			$where='`status`=-1';
			$pages_arr=array('do'=>'news');
		break;
	}
	$ficat=0;
	$fititle='';
	if(!empty($_REQUEST['filter']))
	{
		if(!empty($_REQUEST['fititle']))
		{
			$pages_arr['fititle']=$fititle=$_REQUEST['fititle'];
			$where.=' AND `title` LIKE \'%'.$Mainclass->Db->EscapeString($fititle).'%\'';
		}
	}
	if(count($pages_arr)<=1)
		unset($pages_arr['filter']);
	if(CheckKey() and isset($_POST['op'])  and $_POST['mass'] and is_array($_POST['mass']))
	{
		switch($_POST['op'])
		{
			case 'b':
				$Mainclass->Db->Update('blogs',array('status'=>0),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 'a':
				$Mainclass->Db->Update('blogs',array('status'=>1),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 'k':
				require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
				$Plug=new $class_name($Mainclass);
				$Plug->DeleteBlog($_POST['mass']);
				unset($Plug);
			break;
			case 'n':
				$Mainclass->Db->Update('blogs',array('status'=>-1),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
		}
		CleanCache();
	}
	$op_list=Template::Option($Mainclass->lang['main']['activate'],'a').Template::Option($Mainclass->lang['blogs']['block'],'b').Template::Option($Mainclass->lang['main']['delete'],'k').Template::Option($Mainclass->lang['main']['mark_new'],'n');
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$per_page=30;
	$offset=abs(($page-1)*$per_page);
	$n=1;
	$content=$Mainclass->Template->GetClass('ablogs')->BlogsListBegin($title,$fititle,$pages_arr,$page);
	$Mainclass->Db->Query('SELECT `id`,`url`,`crdate`,`title`,`descr`,`logo`,`type`,`author`,`author_id`,`categs`,`status` FROM `prefix_blogs` WHERE '.$where.' ORDER BY `id` DESC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
	if(0==$cnt=$Mainclass->Db->Num_rows())
		$content.=$Mainclass->Template->GetClass('ablogs')->BlogsListEmpty();
	while($arr=$Mainclass->Db->Fetch_assoc())
		$content.=$Mainclass->Template->GetClass('ablogs')->BlogsListLine($arr,$cnt);
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs` WHERE '.$where,__file__,__line__);
	$temp=$Mainclass->Db->Fetch_row();
	$content.=$Mainclass->Template->GetClass('ablogs')->BlogsListEnd($op_list,$temp[0],$per_page,$pages_arr);
	$Mainclass->ShowDecoration(false);
	echo $content;
}

function SwapBlog($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Update('blogs',array('!status'=>'NOT `status`'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	CleanCache();
	ExitBack();
}

function AddEditBlog($id,$error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	require $Mainclass->root_path.'addons/addons.php';
	$jscripts[]='js/module_blogs.js';
	$jscripts[]='addons/swfupload/swfupload.js';
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	$uid=$Mainclass->Account->GetValue('id');
	if($id===true)
	{
		$values['id']='new';
		$values['status']=1;
		$values['url']=$values['title']=$values['descr']=$values['logo']=$values['author']=$values['author_id']='';
		$values['per_page']=10;
		$values['categs']=false;
		$values['type']='personal';
		$values['crdate']=date('Y-m-d H:i:s',$Mainclass->MyTime());
		$bvalue=$Mainclass->lang['blogs']['c_blog'];
		$images=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/new-'.$uid.'.*');
		if($images)
		{
			$dis='';
			$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($images[0]).'?'.uniqid();
			array_shift($images);
			if($images)
				foreach($images as &$v)
					@unlink($v);
		}
		else
		{
			$dis=' disabled="disabled"';
			$image='images/no_blog_image.png';
		}
		$title=$Mainclass->lang['blogs']['c_blog'];
	}
	else
	{
		$Mainclass->Db->Query('SELECT `logo` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			ExitPrefix();
		list($img)=$Mainclass->Db->Fetch_row();
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT `id`,`url`,`crdate`,`author`,`author_id`,`title`,`descr`,`logo`,`per_page`,`type`,`categs`,`status` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			$values=$Mainclass->Db->Fetch_assoc();
			if($values['logo'] and is_file($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$values['logo']))
			{
				$dis='';
				$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($values['logo']).'?'.uniqid();
			}
			else
			{
				$dis=' disabled="disabled"';
				$image='images/no_blog_image.png';
			}
		}
		$title=$Mainclass->lang['blogs']['e_blog'];
		$bvalue=EL_LANG_SAVE;
	}
	if($error)
	{
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['crdate']=isset($_POST['crdate']) ? $_POST['crdate'] : '';
		$values['author']=isset($_POST['author']) ? $_POST['author'] : '';
		$values['author_id']=isset($_POST['author_id']) ? $_POST['author_id'] : '';
		$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
		$values['descr']=$Mainclass->Editor->GetHtml('descr');
		$values['logo']=isset($_POST['logo']) ? $_POST['logo'] : '';
		$values['per_page']=isset($_POST['per_page']) ? (int)$_POST['per_page'] : '';
		$values['categs']=isset($_POST['categs']);
		$values['type']=isset($_POST['type']) ? $_POST['type'] : 'personal';
		$values['status']=isset($_POST['status']) ? (int)$_POST['status'] : '';
		if(is_int($id))
		{
			$images=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.'-new-'.$uid.'.*');
			if($images)
			{
				$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($images[0]);
				array_shift($images);
				if($images)
					foreach($images as &$v)
						@unlink($v);
			}
			else
				$images=is_file($image=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$img);
			if($images)
				$dis='';
			else
			{
				$dis=' disabled="disabled"';
				$image='images/no_blog_image.png';
			}
		}
		else
		{
			$images=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/new-'.$uid.'.*');
			if($images)
			{
				$dis='';
				$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($images[0]).'?'.uniqid();
				array_shift($images);
				if($images)
					foreach($images as &$v)
						@unlink($v);
			}
			else
			{
				$dis=' disabled="disabled"';
				$image='images/no_blog_image.png';
			}
		}
	}
	$Mainclass->StartSession();
	$_SESSION['user_id']=$uid;
	$_SESSION['id']=(int)$values['id'];
	$content=$Mainclass->Template->GetClass('ablogs')->AddEditBlog($error,$title,$bvalue,$values,$dis,$image);
	$Mainclass->ShowDecoration();
	echo Strings::JsVars(array('module_id'=>$Mainclass->GetModVal('id'))).$content;
}

function SaveBlog($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditBlog($id);
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return AddEditBlog($id,$Mainclass->lang['blogs']['empbln']);
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and.' LIMIT 1',array('blogs','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$author=isset($_POST['author']) ? $Mainclass->POST['author'] : '';
	$author_id=isset($_POST['author_id']) ? (int)$_POST['author_id'] : '';
	if(!$author)
		$author=$Mainclass->Account->GetValue('name');
	if(!$author_id)
		$author_id=$Mainclass->Account->GetValue('id');
	if($author_id==-1)
		$author_id=$Mainclass->Account->GetUserIdByName($author);
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	$uid=$Mainclass->Account->GetValue('id');
	$arr_values=array(
						'url'=>$url,
						'crdate'=>isset($_POST['crdate']) ? Strings::CheckDate($_POST['crdate'],true) : '',
						'author'=>$author,
						'author_id'=>$author_id,
						'title'=>$title,
						'descr'=>$Mainclass->Editor->GetHtml('descr'),
						'per_page'=>isset($_POST['per_page']) ? (int)$_POST['per_page'] : '',
						'categs'=>isset($_POST['categs']),
						'type'=>isset($_POST['type']) ? $_POST['type'] : 'personal',
						'status'=>isset($_POST['status']) ? (int)$_POST['status'] : '',
	);
	if(is_int($id))
	{
		$Mainclass->Db->Query('SELECT `logo` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if(!$arr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
		$logos=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.'-new-'.$uid.'.*');
		if($logos)
		{
			if($arr['logo'] and is_file($file=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$arr['logo']))
				unlink($file);
			$type=substr($logos[0],strrpos($logos[0],'.'));
			if(rename($logos[0],$img=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.$type))
			{
				$arr_values['logo']=basename($img);
				array_shift($logos);
			}
		}
		$Mainclass->Db->Update('blogs',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	else
	{
		$id=$Mainclass->Db->Insert('blogs',$arr_values,__file__,__line__);
		$logos=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/new-'.$uid.'.*');
		$logo=false;
		if($logos)
		{
			$type=substr($logos[0],strrpos($logos[0],'.'));
			if(rename($logos[0],$img=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.$type))
			{
				$logo=basename($img);
				array_shift($logos);
			}

		}
		if($logo)
			$Mainclass->Db->Update('blogs',array('logo'=>$logo),'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	CleanCache();
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteBlog($id)
{global $Mainclass,$title;
	if(!CheckKey())
		Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array('deleteblog'=>$id))));
	$Mainclass->Db->Query('SELECT `title` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitBack();
	list($btitle)=$Mainclass->Db->Fetch_row();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
		$Plug=new $class_name($Mainclass);
		$Plug->DeleteBlog($id);
		CleanCache();
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	else
	{
		$title=$Mainclass->lang['blogs']['condel'];
		$back=isset($_POST['back']) ? $_POST['back'] : $Mainclass->MyGetEnv('HTTP_REFERER');
		if(isset($_GET['no_back']))
			$back='';
		$Mainclass->ShowDecoration(false);
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'=>sprintf($Mainclass->lang['blogs']['aystdb'],$btitle).($back ? Template::Control('back','hidden',base64_encode($back)) : ''),
												)
		);
	}
}

function ShowCategs($bid)
{global $Mainclass,$title,$jscripts;
	$Mainclass->Db->Query('SELECT `title` FROM `prefix_blogs` WHERE `id`='.$bid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if(!list($title)=$Mainclass->Db->Fetch_row())
		return ExitPrefix();
	if(CheckKey() and isset($_POST['op'])  and $_POST['mass'] and is_array($_POST['mass']))
	{
		switch($_POST['op'])
		{
			case 'k':
				require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
				$Plug=new $class_name($Mainclass);
				$Plug->DeleteCat($_POST['mass']);
				unset($Plug);
			break;
		}
		CleanCache();
	}
	$Mainclass->navigation['addcat']=array(array($Mainclass->Url->ConstructUrl(array('addcat'=>$bid)),$Mainclass->lang['blogs']['crecat']));
	$op_list=Template::Option($Mainclass->lang['main']['delete'],'k');
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$per_page=30;
	$offset=abs(($page-1)*$per_page);
	$n=1;
	$content=$Mainclass->Template->GetClass('ablogs')->CategsListBegin($title,$bid,$page);
	$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`posts`,`logo` FROM `prefix_blogs_categories` WHERE `bid`='.$bid.' ORDER BY `pos` DESC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
	if(0==$cnt=$Mainclass->Db->Num_rows())
		$content.=$Mainclass->Template->GetClass('ablogs')->CategsListEmpty();
	while($arr=$Mainclass->Db->Fetch_assoc())
		$content.=$Mainclass->Template->GetClass('ablogs')->CategsListLine($arr,$cnt);
	$Mainclass->Db->Query('SELECT COUNT(`bid`) FROM `prefix_blogs_categories` WHERE `bid`='.$bid,__file__,__line__);
	$temp=$Mainclass->Db->Fetch_row();
	$content.=$Mainclass->Template->GetClass('ablogs')->CategsListEnd($op_list,$temp[0],$per_page,$bid);
	$Mainclass->ShowDecoration(false);
	echo $content;
}

function AddEditCat($id,$error='',$bid=0)
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	if($id===true)
	{
		$Mainclass->Db->Query('SELECT `title` FROM `prefix_blogs_categories` WHERE `id`='.$bid.' LIMIT 1',__file__,__line__);
		if(!list($btitle)=$Mainclass->Db->Fetch_row())
			return ExitPrefix();
		$values['id']='new';
		$values['bid']=$bid;
		$values['url']=$values['title']=$values['descr']=$values['logo']=$values['pos']='';
		$title=sprintf($Mainclass->lang['blogs']['crcat_'],$btitle);
	}
	else
	{
		$Mainclass->Db->Query('SELECT `id`,`bid`,`url`,`title`,`descr`,`logo`,`pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		$values=$Mainclass->Db->Fetch_assoc();
		if($error)
			$values=array('bid'=>$values['bid']);
		$title=$Mainclass->lang['blogs']['editca'];
	}
	if($error)
	{
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
		$values['descr']=$Mainclass->Editor->GetHtml('descr');
		$values['logo']=isset($_POST['logo']) ? $_POST['logo'] : '';
		$values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : '';
	}
	$image_list=array();
	$hdir=opendir($Mainclass->root_path.'images/categories/');
	while($entry=readdir($hdir))
		if(preg_match('/\.(?:gif|jpe?g|png|bmp)$/i',$entry)>0 and stripos($entry,'none')!==0)
			$image_list[$entry]=Template::Option($entry,'images/categories/'.$entry,$entry==$values['logo']);
	closedir($hdir);
	ksort($image_list,SORT_STRING);
	$values['image']='images/categories/'.$values['logo'];
	$content=$Mainclass->Template->GetClass('ablogs')->AddEditCategory($error,$title,$values,join('',$image_list));
	$Mainclass->ShowDecoration();
	echo $content;
}

function SaveCat($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditCat($id);
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return AddEditCat($id,$Mainclass->lang['blogs']['empcan']);
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	$bid=isset($_POST['bid']) ? (int)$_POST['bid'] : 0;
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$bid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and.' AND `bid`='.$bid.' LIMIT 1',array('blogs_categories','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	$image=isset($_POST['image']) ? basename($_POST['image']) : '';
	if(!is_file($Mainclass->root_path.'images/categories/'.$image))
		$image='';
	$arr_values=array(
						'url'=>$url,
						'title'=>$title,
						'descr'=>$Mainclass->Editor->GetHtml('descr'),
						'logo'=>$image,
						'pos'=>'',
	);
	if(is_int($id))
	{
		$arr_values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		$Mainclass->Db->Query('SELECT `pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($pos)=$Mainclass->Db->Fetch_row();
		if($pos!=$arr_values['pos'])
		{
			$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`-1'),'`pos`>'.$pos.' AND `bid`='.$bid,__file__,__line__);
			$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`+1'),'`pos`>='.$arr_values['pos'].' AND `bid`='.$bid,__file__,__line__);
		}
		$Mainclass->Db->Update('blogs_categories',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	else
	{
		$arr_values['pos']=isset($_POST['pos']) ? $_POST['pos'] : 0;
		$arr_values['bid']=$bid;
		if($arr_values['pos']=='')
		{
			$Mainclass->Db->Query('SELECT MAX(`pos`) FROM `prefix_blogs_categories` WHERE `bid`='.$bid,__file__,__line__);
			list($position)=$Mainclass->Db->Fetch_row();
			$arr_values['pos']=$position===null ? 0 : $position+1;
		}
		else
			$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`+1'),'`pos`>='.(int)$arr_values['pos'].' AND `bid`='.$bid,__file__,__line__);
		$Mainclass->Db->Insert('blogs_categories',$arr_values,__file__,__line__);
	}
	CleanCache();
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteCat($id)
{global $Mainclass,$title;
	if(!CheckKey())
		Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array('deletecat'=>$id))));
	$Mainclass->Db->Query('SELECT `title` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitBack();
	list($ctitle)=$Mainclass->Db->Fetch_row();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
		$Plug=new $class_name($Mainclass);
		$Plug->DeleteCat($id,isset($_POST['deleteposts']));
		CleanCache();
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	else
	{
		$title=$Mainclass->lang['blogs']['condel'];
		$back=isset($_POST['back']) ? $_POST['back'] : $Mainclass->MyGetEnv('HTTP_REFERER');
		if(isset($_GET['no_back']))
			$back='';
		$Mainclass->ShowDecoration(false);
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'=>sprintf($Mainclass->lang['blogs']['aystdc'],$ctitle)
														.'<br /><label>'.Template::Check('deleteposts').' '.$Mainclass->lang['blogs']['dposts'].'</label>'
														.($back ? Template::Control('back','hidden',base64_encode($back)) : ''),
												)
		);
	}
}

function ShowTags($bid)
{global $Mainclass,$title,$jscripts;
	$Mainclass->Db->Query('SELECT `title` FROM `prefix_blogs` WHERE `id`='.$bid.' LIMIT 1',__file__,__line__);
	if(!list($title)=$Mainclass->Db->Fetch_row())
		return ExitPrefix();
	if(CheckKey() and isset($_POST['op'],$_POST['mass']) and $_POST['mass'] and is_array($_POST['mass']))
	{
		switch($_POST['op'])
		{
			case 'k':
				$Mainclass->Db->Delete('blogs_tags','`id`'.$Mainclass->Db->In($_POST['mass']).' AND `bid`='.$bid,__file__,__line__);
				$Mainclass->Db->Delete('blogs_bt','`tid`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
		}
		CleanCache();
	}
	$op_list=Template::Option($Mainclass->lang['main']['delete'],'k');
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$per_page=30;
	$offset=abs(($page-1)*$per_page);
	$n=1;
	$content=$Mainclass->Template->GetClass('ablogs')->TagsListBegin($title,$bid,$page);
	$Mainclass->Db->Query('SELECT `t`.`id`,`t`.`name`,COUNT(`p`.`tid`) `posts` FROM `prefix_blogs_tags` `t` LEFT JOIN `prefix_blogs_bt` `p` ON `t`.`id`=`p`.`tid` WHERE `t`.`bid`='.$bid.' GROUP BY `t`.`id` ORDER BY `posts` DESC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
	if(0==$cnt=$Mainclass->Db->Num_rows())
		$content.=$Mainclass->Template->GetClass('ablogs')->TagsListEmpty();
	while($arr=$Mainclass->Db->Fetch_assoc())
		$content.=$Mainclass->Template->GetClass('ablogs')->TagsListLine($arr,$cnt);
	$Mainclass->Db->Query('SELECT COUNT(`bid`) FROM `prefix_blogs_tags` WHERE `bid`='.$bid,__file__,__line__);
	$temp=$Mainclass->Db->Fetch_row();
	$content.=$Mainclass->Template->GetClass('ablogs')->TagsListEnd($op_list,$temp[0],$per_page,$bid);
	$Mainclass->ShowDecoration(false);
	echo $content;
}

function EditTag($id,$error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->Db->Query('SELECT `id`,`name` FROM `prefix_blogs_tags` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	$values=$Mainclass->Db->Fetch_assoc();
	$title=$Mainclass->lang['blogs']['editag'];
	if($error)
		$values['name']=isset($_POST['name']) ? $_POST['name'] : '';
	$content=$Mainclass->Template->GetClass('ablogs')->EditTag($error,$title,$values);
	$Mainclass->ShowDecoration();
	echo $content;
}

function SaveTag($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return EditTag($id);
	$name=isset($_POST['name']) ? trim($Mainclass->POST['name']) : '';
	if(!$name)
		return EditTag($id,$Mainclass->lang['blogs']['emptag']);
	$arr_values=array(
						'name'=>$name,
	);
	if(is_int($id))
		$Mainclass->Db->Update('blogs_tags',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
	else
		$Mainclass->Db->Insert('blogs_tags',$arr_values,__file__,__line__);
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteTag($id)
{global $Mainclass;
	$Mainclass->Db->Delete('blogs_tags','`id`='.$id.' LIMIT 1',__file__,__line__);
	$Mainclass->Db->Delete('blogs_bt','`tid`='.$id,__file__,__line__);
	return ExitBack();
}

function CleanCache()
{global $Mainclass;
	$Mainclass->Cache->CleanCacheByTag('news_mainpage');
}
?>