<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
global $head_addon;
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'blogs','lang_user-%');
$head_addon.=$Mainclass->Functions->RssLink(array(),$Mainclass->lang['blogs']['rss_all']);
$Mainclass->LoadOptions('module_blogs',false);
$Mainclass->Url->ending=$Mainclass->vars['m_blogs_ending'];
$last=$Mainclass->Cache->Get('blogs_last_status',false);
if($last!=date('Ymd'))
{
	$Mainclass->Db->Update('blogs_posts',array('status'=>1),'`date`<=NOW() AND `status`=2');
	$Mainclass->Cache->Put('blogs_last_status',date('Ymd'),86500,false);
}
$i=1;
if($Mainclass->Url->IsStatic())
{
	$Mainclass->Url->params=array('blog','cat','post');
	$cnt=substr_count($Mainclass->Url->string,$Mainclass->Url->s_delimeter);
	$str=strtolower($Mainclass->Url->GetEnding());
	$Mainclass->Url->string=substr($Mainclass->Url->string,0,-strlen($str));
	$is_post=strcasecmp($str,$Mainclass->Url->ending)==0;
	$Mainclass->Url->Parse();
	if($is_post and !isset($_GET['post']) and isset($_GET['cat']))
		$_GET['post']=$_GET['cat'];
}
$bid=isset($_GET['bid']) ? (int)$_GET['bid'] : 0;
$cid=isset($_GET['cid']) ? (int)$_GET['cid'] : 0;
$pid=isset($_GET['pid']) ? (int)$_GET['pid'] : 0;
$blog=isset($_GET['blog']) ? $_GET['blog'] : '';
$post=isset($_GET['post']) ? $_GET['post'] : '';
$cat=isset($_GET['cat']) ? $_GET['cat'] : '';
$Mainclass->SetModVal('general_ending',$Mainclass->vars['m_blogs_ending']);

if($Mainclass->GetModVal('general'))
	BlogsBeginPage(true);
elseif(isset($_GET['savepost']))
	SavePost($_GET['savepost']=='new' ? true : (int)$_GET['savepost'],$bid);
elseif($pid or $post and($bid or $blog))
	ShowPost($pid,$post,$bid,$blog);
elseif($cid or $cat and ($bid or $blog))
	BlogsCategory($cid,$cat,$bid,$blog);
elseif($bid or $blog)
	ShowBlog($bid,$blog);
elseif(isset($_GET['tag']))
	ShowTag($_GET['tag'],$bid,$blog);
elseif(isset($_GET['search']))
	ResultBlogs($_GET['search']);
elseif(isset($_GET['newpost']))
	AddEditPost(true,'',(int)$_GET['newpost'],$cid);
elseif(isset($_GET['editpost']))
	AddEditPost((int)$_GET['editpost']);
elseif(isset($_GET['deletepost']))
	DeletePost((int)$_GET['deletepost']);
elseif(isset($_GET['editblog']))
	AddEditBlog((int)$_GET['editblog']);
elseif(isset($_GET['saveblog']))
	SaveBlog($_GET['saveblog']=='new' ? true : (int)$_GET['saveblog']);
elseif(isset($_GET['deleteblog']))
	DeleteBlog((int)$_GET['deleteblog']);
elseif(isset($_GET['newcat']))
	AddEditCat(true,'',(int)$_GET['newcat']);
elseif(isset($_GET['movecatup']))
	MoveCatUp((int)$_GET['movecatup']);
elseif(isset($_GET['movecatdown']))
	MoveCatDown((int)$_GET['movecatdown']);
elseif(isset($_GET['editcat']))
	AddEditCat((int)$_GET['editcat']);
elseif(isset($_GET['savecat']))
	SaveCat($_GET['savecat']=='new' ? true : (int)$_GET['savecat']);
elseif(isset($_GET['deletecat']))
	DeleteCat((int)$_GET['deletecat']);
elseif(isset($_GET['edittag']))
	EditTag((int)$_GET['edittag']);
elseif(isset($_GET['savetag']))
	SaveTag((int)$_GET['savetag']);
elseif(isset($_GET['deletetag']))
	DeleteTag((int)$_GET['deletetag']);
elseif(isset($_GET['do']))
	BlogsDoIt($_GET['do']);
elseif(isset($_GET['userblogs']))
	UserBlogs((int)$_GET['userblogs']);
elseif(isset($_GET['categories']))
	BlogCategories((int)$_GET['categories']);
elseif(isset($_GET['tags']))
	BlogTags((int)$_GET['tags']);
elseif(isset($_GET['userposts']))
	UserPosts((int)$_GET['userposts']);
else
	BlogsBeginPage();

function BlogsDoIt($task)
{global $Mainclass;
	switch(strtolower($task))
	{
		case 'blogs':
			ShowAllBlogs();
		break;
		case 'newblog':
			AddEditBlog(true);
		break;
		case 'search':
			SearchBlogs();
		break;
		case 'tags':
			AllBlogsTags();
		break;
		case 'my':
			MyBlogs();
		break;
		case 'authors':
			Authors();
		break;
		default:
			BlogsBeginPage();
		break;
	}
}
/*
	Генерирование тегов
*/
function GenTags($bid='',$blog='')
{global $Mainclass;
	$tags=$Mainclass->Cache->Get('blogs_tags'.$bid,false);
	if($tags===false)
	{
		$tags=array();
		$i=0;
		$Mainclass->Db->Query('SELECT `t`.`name`,COUNT(`b`.`tid`) `cnt` FROM `prefix_blogs_tags` `t` LEFT JOIN `prefix_blogs_bt` `b` ON `b`.`tid`=`t`.`id`'.($bid ? ' WHERE `t`.`bid`='.$bid : '').' GROUP BY `t`.`id`',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			if($arr['cnt']<10)
				$size='style="font-size:10px" class="smallest"';
			elseif($arr['cnt']>=10 and $arr['cnt']<50)
				$size='style="font-size:14px" class="small"';
			elseif($arr['cnt']>=50 and $arr['cnt']<200)
				$size='style="font-size:18px" class="medium"';
			elseif($arr['cnt']>=200 and $arr['cnt']<500)
				$size='style="font-size:22px" class="large"';
			elseif($arr['cnt']>=500)
				$size='style="font-size:26px" class="largest"';
			$tags[$i++.'_'.$arr['cnt']]='<a href="'.$Mainclass->Url->ConstructUrl(array(array($blog,'bid'=>$bid),array('tag'=>$arr['name']))).'" '.$size.'>'.$arr['name'].'</a>';
		}
		$Mainclass->Cache->Put('blogs_tags'.$bid,$tags,3600,false);
	}
	$Mainclass->SetModVal('tags',$tags);
	return $tags;
}

function MenuBlogs()
{global $Mainclass;
	$add='';
	if($Mainclass->Login->IsUSer())
		$add='<a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'my'))).'">'.$Mainclass->lang['blogs']['myblogs'].'</a>';
	return $Mainclass->Template->ModuleMenu(
											$Mainclass->GetModVal('name'),
											'<a href="'.$Mainclass->Url->Prefix(false,true,true).'">'.$Mainclass->lang['blogs']['allpost'].'</a><a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'blogs'))).'">'.$Mainclass->lang['blogs']['blogs'].'</a><a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'authors'))).'">'.$Mainclass->lang['blogs']['authors'].'</a><a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'tags'))).'">'.$Mainclass->lang['main']['tags'].'</a><a href="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'search'))).'">'.$Mainclass->lang['main']['search'].'</a>'.$add,
											'<form name="searchmodule" action="'.$Mainclass->Url->ConstructUrl(array(array('do'=>'search'))).'" method="post"><label><input maxlength="100" type="text" name="search_word" size="17" /><input type="image" src="templates/'.$Mainclass->Template->theme.'/images/searchmod_btn.png" alt="'.$Mainclass->lang['blogs']['find'].'" title="'.$Mainclass->lang['blogs']['find'].'" class="btn" value="'.$Mainclass->lang['blogs']['find'].'" /></label></form>',
											array('title'=>$Mainclass->lang['blogs']['blogs'])
	);
}

function BlogsBeginPage($general=false)
{global $Mainclass,$title,$jscripts;
	GenTags();
	$jscripts[]='js/rating.js';
	$jscripts[]='js/module_blogs.js';
	$title=array($Mainclass->lang['blogs']['blogs']);
	$content='';
	$sizes=array();
	$type=$date_f=$date_sql='';
	if(!$general)
	{
		$content=MenuBlogs();
		if(isset($_GET['date']))
		{
			$date_f=$_GET['date'];
			if($month=strlen($date_f)<8)
				$date_f.='-01';
			$date_f=Strings::CheckDate($date_f);
			if($month)
			{
				$date_sql=' `date`>=\''.$date_f.'\' AND ';
				$date_f=substr($date_f,0,-3);
				$date_sql.='`date`<=\''.$date_f.'-31\' AND ';
				$type='month';
			}
			else
				$date_sql=' `date`=\''.$date_f.'\' AND ';
			$title[]=$Mainclass->lang['blogs']['postfor'].Strings::HumanDate($date_f);
		}
		$cnt=$Mainclass->Cache->Get('blogs_pages_total'.$date_f,false);
		if($cnt===false)
		{
			$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs_posts` WHERE'.$date_sql.' `status`=1',__file__,__line__);
			list($cnt)=$Mainclass->Db->Fetch_row();
			$Mainclass->Cache->Put('blogs_pages_total'.$date_f,$cnt,600,false);
		}
		else
			$cnt=(int)$cnt;
		$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
		if(!$date_f)
			$page=$pages-(isset($_GET['page']) ? (int)$_GET['page'] : $pages) + 1;
		else
			$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page==0)
			$page=1;
		$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
		$pages=Strings::Pages($cnt,$Mainclass->vars['m_blogs_per_page'],array(array('date'=>$date_f)),false,$date_f ? $page : -1);
	}
	else
	{
		$page=1;
		$offset=0;
	}
	$content='';
	$result=$Mainclass->Db->Query('SELECT `p`.`id`,`p`.`date`,`p`.`url`,`p`.`title`,`p`.`text`,`p`.`author`,`p`.`author_id`,`p`.`comments`,`p`.`reads`,`p`.`allow_comm`,`p`.`total`,`p`.`votes`,`p`.`editdate`,`b`.`id` `bid`,`b`.`url` `burl`,`b`.`title` `btitle`,`b`.`author_id` `baid`,`b`.`categs`,`c`.`id` `cid`,`c`.`url` `curl`,`c`.`title` `ctitle` FROM `prefix_blogs_posts` `p` LEFT JOIN `prefix_blogs` `b` ON `b`.`id`=`p`.`bid` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`p`.`cid` WHERE `p`.`status`=1 ORDER BY `p`.`date` DESC LIMIT '.$offset.', '.($general ? $Mainclass->vars['m_blogs_ppgen'] : $Mainclass->vars['m_blogs_per_page']),__file__,__line__);
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	while($arr=$Mainclass->Db->Fetch_assoc($result))
	{
		$sizes[$arr['id']]=array($arr['total'],$arr['votes']);
		$seppos=strpos($arr['text'],'[separator]');
		if($seppos!==false)
			$arr['text']=mb_substr($arr['text'],0,$seppos,ELEANOR_CHARSET);
		$arr['text']=Strings::ParseOwnBb($arr['text']);
		$content.=$Tpl->PostInList($arr,($general or !$Mainclass->vars['m_blogs_rating']) ? '' : '{rating_'.$arr['id'].'}',$type);
	}
	if($Mainclass->vars['m_blogs_rating'])
	{
		if(!$Mainclass->vars['m_blogs_vote_general'])
			$Mainclass->Functions->PrepareVoting(array_keys($sizes));
		foreach($sizes as $k=>$v)
		{
			$steps=(!$Mainclass->vars['m_blogs_vote_general'] and $Mainclass->Functions->CanVoting($k)) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
			$content=str_replace('{rating_'.$k.'}',$Mainclass->Functions->ShowRating($v[0],$v[1],$steps,array('id'=>$k)),$content);
		}
	}
	$content.=$pages ? $Mainclass->Template->OpenTable().$pages.$Mainclass->Template->CloseTable() : '';
	Head();
	echo MenuBlogs().$content;
}

function MyBlogs()
{global $Mainclass,$title,$jscripts;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$jscripts[]='js/module_blogs.js';
	GenTags();
	$title=$Mainclass->lang['blogs']['listyob'];
	$uid=(int)$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT COUNT(`author_id`) FROM `prefix_blogs` WHERE `author_id`='.$uid,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
	$content=$Mainclass->Template->Title($Mainclass->lang['blogs']['listyob']).$Mainclass->Template->OpenTable();
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$canadd=$Mainclass->vars['m_blogs_bcr'] and ($Mainclass->vars['m_blogs_blim']==0 or $cnt<$Mainclass->vars['m_blogs_blim']);
	$content.=$Tpl->BlogsBeginTable($canadd);
	$categs=array();
	$Mainclass->Db->Query('SELECT `b`.`id`,`b`.`url`,`b`.`crdate`,`b`.`title`,`b`.`descr`,`b`.`logo`,`b`.`last_cid`,`b`.`last_id`,`b`.`last_url`,`b`.`last_title`,`b`.`last_date`,`b`.`last_author`,`b`.`last_author_id`,`b`.`type`,`b`.`categs`,`b`.`status`,`b`.`posts`,`c`.`url` `curl` FROM `prefix_blogs` `b` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`b`.`last_cid` WHERE `b`.`author_id`='.$uid.' ORDER BY `b`.`title` ASC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		$content.=$Tpl->BlogsEmptyTable($canadd);
	else
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			$content.=$Tpl->MyBlogsTableList($arr);
			if($arr['categs'])
				$categs[$arr['id']]=$arr['url'];
		}
	if($categs)
	{
		$cats=$oldbid='';
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`bid` FROM `prefix_blogs_categories` WHERE `bid`'.$Mainclass->Db->In(array_keys($categs)).' ORDER BY `bid` ASC, `pos` ASC',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			if($oldbid!=$arr['bid'] and $oldbid)
			{
				$content=str_replace('<!-- CAT'.$oldbid.' -->',trim($cats,', '),$content);
				$cats='';
			}
			$oldbid=$arr['bid'];
			$cats.=$Tpl->CatsSubLine($arr,$categs).', ';
		}

	}
	$content.=$Tpl->BlogsEndTable($canadd)
			.Strings::Pages($cnt,$Mainclass->vars['m_blogs_per_page'],array(array('do'=>'my')))
			.$Mainclass->Template->CloseTable();
	Head();
	echo MenuBlogs().$content;
}

function Authors()
{global $Mainclass,$title,$jscripts;
	GenTags();
	$jscripts[]='js/module_blogs.js';
	$title=$Mainclass->lang['blogs']['allablo'];
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content=$Tpl->AuthorsListBegin();
	$data=array();
	$result=$Mainclass->Db->Query('SELECT `author`,`author_id`,0 `cntp`,COUNT(`id`) `cntb` FROM `prefix_blogs` GROUP BY `id`',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc($result))
		$data[$arr['author']]=$arr;
	$result=$Mainclass->Db->Query('SELECT `author`,`author_id`,0 `cntb`,COUNT(`id`) `cntp` FROM `prefix_blogs_posts` GROUP BY `id`',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc($result))
	{
		if(isset($data[$arr['author']]))
			$data[$arr['author']]['cntp']=$arr['cntp'];
		else
			$data[$arr['author']]=$arr;
	}
	ksort($data,SORT_STRING);
	foreach($data as $k=>&$v)
		$content.=$Tpl->AuthorsList($v);

	unset($data);
	$content.=$Tpl->AuthorsListEnd();
	Head();
	echo MenuBlogs().$content;
}

function ShowAllBlogs()
{global $Mainclass,$title,$jscripts;
	GenTags();
	$title=$Mainclass->lang['blogs']['allblog'];
	$jscripts[]='js/module_blogs.js';
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs`',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
	$content=$Mainclass->Template->Title($title).$Mainclass->Template->OpenTable();
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content.=$Tpl->BlogsBeginTable();
	$categs=array();
	$Mainclass->Db->Query('SELECT `b`.`id`,`b`.`url`,`b`.`author`,`b`.`author_id`,`b`.`crdate`,`b`.`title`,`b`.`descr`,`b`.`logo`,`b`.`last_cid`,`b`.`last_id`,`b`.`last_url`,`b`.`last_title`,`b`.`last_date`,`b`.`last_author`,`b`.`last_author_id`,`b`.`type`,`b`.`categs`,`b`.`status`,`b`.`posts`,`c`.`url` `curl` FROM `prefix_blogs` `b` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`b`.`last_cid` WHERE `status`=1 ORDER BY `b`.`id` ASC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		$content.=$Tpl->BlogsEmptyTable();
	else
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			$content.=$Tpl->BlogsTableList($arr);
			if($arr['categs'])
				$categs[$arr['id']]=$arr['url'];
		}
	if($categs)
	{
		$cats=$oldbid='';
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`bid` FROM `prefix_blogs_categories` WHERE `bid`'.$Mainclass->Db->In(array_keys($categs)).' ORDER BY `bid` ASC, `pos` ASC',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			if($oldbid!=$arr['bid'] and $oldbid)
			{
				$content=str_replace('<!-- CAT'.$oldbid.' -->',trim($cats,', '),$content);
				$cats='';
			}
			$oldbid=$arr['bid'];
			$cats.=$Tpl->CatsSubLine($arr,$categs).', ';
		}

	}
	$content.=$Tpl->BlogsEndTable()
			.Strings::Pages($cnt,$Mainclass->vars['m_blogs_per_page'],array(array('do'=>'blogs')))
			.$Mainclass->Template->CloseTable();
	Head();
	echo MenuBlogs().$content;
}

function UserBlogs($id)
{global $Mainclass,$title,$jscripts,$head_addon;
	$jscripts[]='js/module_blogs.js';
	$uid=(int)$Mainclass->Account->GetValue('id');
	if($uid==$id)
		return MyBlogs();
	if(!$arr=$Mainclass->Account->SelectUserById($id,array('name')))
		return ExitPrefix();
	GenTags();
	$uname=htmlspecialchars($arr['name'],ENT_QUOTES);
	$title=sprintf($Mainclass->lang['blogs']['blouser'],$uname);
	$Mainclass->Db->Query('SELECT COUNT(`author_id`) FROM `prefix_blogs` WHERE `author_id`='.$id,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
	$content=$Mainclass->Template->Title($uname).$Mainclass->Template->OpenTable();
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content.=$Tpl->BlogsBeginTable();
	$categs=array();
	$Mainclass->Db->Query('SELECT `b`.`id`,`b`.`url`,`b`.`crdate`,`b`.`title`,`b`.`descr`,`b`.`logo`,`b`.`last_cid`,`b`.`last_id`,`b`.`last_url`,`b`.`last_title`,`b`.`last_date`,`b`.`last_author`,`b`.`last_author_id`,`b`.`type`,`b`.`categs`,`b`.`status`,`b`.`posts`,`c`.`url` `curl` FROM `prefix_blogs` `b` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`b`.`last_cid` WHERE `b`.`author_id`='.$id.' AND `status`=1 ORDER BY `b`.`title` ASC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		$content.=$Tpl->BlogsEmptyTable();
	else
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			$content.=$Tpl->BlogsTableList($arr);
			if($arr['categs'])
				$categs[$arr['id']]=$arr['url'];
		}
	if($categs)
	{
		$oldbid='';
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`bid` FROM `prefix_blogs_categories` WHERE `bid`'.$Mainclass->Db->In(array_keys($categs)).' ORDER BY `bid` ASC, `pos` ASC',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			if($oldbid!=$arr['bid'] and $oldbid)
			{
				$content=str_replace('<!-- CAT'.$oldbid.' -->',trim($cats,', '),$content);
				$cats='';
			}
			$oldbid=$arr['bid'];
			$cats.=$Tpl->CatsSubLine($arr,$categs).', ';
		}

	}
	$content.=$Tpl->BlogsEndTable()
			.Strings::Pages($cnt,$Mainclass->vars['m_blogs_per_page'],array(array('userblogs'=>$id)))
			.$Mainclass->Template->CloseTable();
	$head_addon.=$Mainclass->Functions->RssLink(array('aid'=>$id),sprintf($Mainclass->lang['blogs']['posts_fa'],$uname));
	Head();
	echo MenuBlogs().$content;
}

function UserPosts($id)
{global $Mainclass,$title,$jscripts,$head_addon;
	$jscripts[]='js/module_blogs.js';
	if(!$arr=$Mainclass->Account->SelectUserById($id,array('name')))
		return ExitPrefix();
	GenTags();
	$uname=htmlspecialchars($arr['name'],ENT_QUOTES);
	$title=sprintf($Mainclass->lang['blogs']['usposts'],$uname);
	$Mainclass->Db->Query('SELECT COUNT(`author_id`) FROM `prefix_blogs_posts` WHERE `author_id`='.$id.' AND `status`='.$id,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content=$Tpl->UserPostsBegin($uname,$id,$cnt);
	if($cnt>0)
	{
		$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
		$jscripts[]='js/rating.js';
		$sizes=array();
		$result=$Mainclass->Db->Query('SELECT `p`.`id`,`p`.`date`,`p`.`url`,`p`.`title`,`p`.`text`,`p`.`author`,`p`.`author_id`,`p`.`comments`,`p`.`reads`,`p`.`allow_comm`,`p`.`total`,`p`.`votes`,`p`.`editdate`,`b`.`id` `bid`,`b`.`url` `burl`,`b`.`title` `btitle`,`b`.`author_id` `baid`,`b`.`categs`,`c`.`id` `cid`,`c`.`url` `curl`,`c`.`title` `ctitle` FROM `prefix_blogs_posts` `p` LEFT JOIN `prefix_blogs` `b` ON `b`.`id`=`p`.`bid` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`p`.`cid` WHERE `p`.`author_id`='.$id.' AND `p`.`status`=1 ORDER BY `p`.`date` DESC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc($result))
		{
			$sizes[$arr['id']]=array($arr['total'],$arr['votes']);
			$seppos=strpos($arr['text'],'[separator]');
			if($seppos!==false)
				$arr['text']=mb_substr($arr['text'],0,$seppos,ELEANOR_CHARSET);
			$arr['text']=Strings::ParseOwnBb($arr['text']);
			$content.=$Tpl->PostInList($arr,$Mainclass->vars['m_blogs_rating'] ? '{rating_'.$arr['id'].'}' : '');
		}
		if($Mainclass->vars['m_blogs_rating'])
		{
			if(!$Mainclass->vars['m_blogs_vote_general'])
				$Mainclass->Functions->PrepareVoting(array_keys($sizes));
			foreach($sizes as $k=>$v)
			{
				$steps=(!$Mainclass->vars['m_blogs_vote_general'] and $Mainclass->Functions->CanVoting($k)) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
				$content=str_replace('{rating_'.$k.'}',$Mainclass->Functions->ShowRating($v[0],$v[1],$steps,array('id'=>$k)),$content);
			}
		}
		$pages=Strings::Pages($cnt,$Mainclass->vars['m_blogs_per_page'],array(),false,$page);
		$content.=$pages ? $Mainclass->Template->OpenTable().$pages.$Mainclass->Template->CloseTable() : '';
	}
	$head_addon.=$Mainclass->Functions->RssLink(array('aid'=>$id),sprintf($Mainclass->lang['blogs']['posts_fa'],$uname));
	Head();
	echo MenuBlogs().$content;
}

function AddEditBlog($id,$error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/module_blogs.js';
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	GenTags();
	$jscripts[]='addons/swfupload/swfupload.js';
	$title=$Mainclass->lang['blogs']['creblog'];
	$uid=(int)$Mainclass->Account->GetValue('id');
	$content='';
	if($id===true)
	{
		$Mainclass->Db->Query('SELECT COUNT(`author_id`) FROM `prefix_blogs` WHERE `author_id`='.$uid,__file__,__line__);
		list($cnt)=$Mainclass->Db->Fetch_row();
		if(!$Mainclass->vars['m_blogs_bcr'] and $Mainclass->vars['m_blogs_blim']>0 and $cnt<$Mainclass->vars['m_blogs_blim'])
		{
			$content.=$Mainclass->Template->Message($Mainclass->lang['blogs']['unacrbl'],'error');
			Head();
			echo MenuBlogs().$content;
			return;
		}
	}
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	if($id===true)
	{
		$values['id']='new';
		$values['status']=$values['url']=$values['title']=$values['descr']=$values['logo']='';
		$values['per_page']=10;
		$values['categs']=false;
		$values['type']='personal';
		$bvalue=$Mainclass->lang['blogs']['creblog'];
		$images=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/new-'.$uid.'.*');
		if($images)
		{
			$dis='';
			$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($images[0]).'?'.uniqid();
			array_shift($images);
			if($images)
				foreach($images as &$v)
					@unlink($v);
		}
		else
		{
			$dis=' disabled="disabled"';
			$image='images/no_blog_image.png';
		}
	}
	else
	{
		$Mainclass->Db->Query('SELECT `logo` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			ExitPrefix();
		list($img)=$Mainclass->Db->Fetch_row();
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`logo`,`per_page`,`type`,`categs` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			$values=$Mainclass->Db->Fetch_assoc();
			if($values['logo'] and is_file($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$values['logo']))
			{
				$dis='';
				$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($values['logo']).'?'.uniqid();
			}
			else
			{
				$dis=' disabled="disabled"';
				$image='images/no_blog_image.png';
			}
		}
		$title=$Mainclass->lang['blogs']['editblo'];
		$bvalue=EL_LANG_SAVE;
	}
	if($error)
	{
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
		$values['descr']=$Mainclass->Editor->GetHtml('descr');
		$values['logo']=isset($_POST['logo']) ? $_POST['logo'] : '';
		$values['per_page']=isset($_POST['per_page']) ? (int)$_POST['per_page'] : '';
		$values['categs']=isset($_POST['categs']);
		$values['type']=isset($_POST['type']) ? $_POST['type'] : 'personal';
		if(is_int($id))
		{
			$images=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.'-new-'.$uid.'.*');
			if($images)
			{
				$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($images[0]);
				array_shift($images);
				if($images)
					foreach($images as &$v)
						@unlink($v);
			}
			else
				$images=is_file($image=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$img);
			if($images)
				$dis='';
			else
			{
				$dis=' disabled="disabled"';
				$image='images/no_blog_image.png';
			}
		}
		else
		{
			$images=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/new-'.$uid.'.*');
			if($images)
			{
				$dis='';
				$image=Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.basename($images[0]).'?'.uniqid();
				array_shift($images);
				if($images)
					foreach($images as &$v)
						@unlink($v);
			}
			else
			{
				$dis=' disabled="disabled"';
				$image='images/no_blog_image.png';
			}
		}
	}
	$Mainclass->StartSession();
	$_SESSION['user_id']=$uid;
	$_SESSION['id']=(int)$values['id'];
	$content=$Mainclass->Template->GetClass('Blogs')->AddEditBlog($error,$title,$bvalue,$values,$dis,$image);
	Head();
	echo Strings::JsVars(array('module_id'=>$Mainclass->GetModVal('id'))).MenuBlogs().$content;
}

function SaveBlog($id)
{global $Mainclass,$title;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditBlog($id);
	$uid=$Mainclass->Account->GetValue('id');
	if($id===true)
	{
		$Mainclass->Db->Query('SELECT COUNT(`author_id`) FROM `prefix_blogs` WHERE `author_id`='.$uid,__file__,__line__);
		list($cnt)=$Mainclass->Db->Fetch_row();
		if(!$Mainclass->vars['m_blogs_bcr'] and $Mainclass->vars['m_blogs_blim']>0 and $cnt<$Mainclass->vars['m_blogs_blim'])
		{
			$content.=$Mainclass->Template->Message($Mainclass->lang['blogs']['unacrbl'],'error');
			Head();
			echo MenuBlogs().$content;
			return;
		}
	}
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return AddEditBlog($id,$Mainclass->lang['blogs']['erbltem']);
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and.' LIMIT 1',array('blogs','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	$arr_values=array(
						'url'=>$url,
						'title'=>$title,
						'descr'=>$Mainclass->Editor->GetHtml('descr'),
						'per_page'=>isset($_POST['per_page']) ? (int)$_POST['per_page'] : '',
						'categs'=>isset($_POST['categs']),
						'type'=>isset($_POST['type']) ? $_POST['type'] : 'personal',
	);
	if(is_int($id))
	{
		$Mainclass->Db->Query('SELECT `logo` FROM `prefix_blogs` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if(!$arr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
		$logos=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.'-new-'.$uid.'.*');
		if($logos)
		{
			if($arr['logo'] and is_file($file=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$arr['logo']))
				unlink($file);
			$type=substr($logos[0],strrpos($logos[0],'.'));
			if(rename($logos[0],$img=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.$type))
			{
				$arr_values['logo']=basename($img);
				array_shift($logos);
			}
		}
		$Mainclass->Db->Update('blogs',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	else
	{
		$arr_values+=array(
							'!crdate'=>'NOW()',
							'author'=>$Mainclass->Account->GetValue('name'),
							'author_id'=>$uid,
							'status'=>$Mainclass->vars['m_blogs_bcr'],
		);
		$id=$Mainclass->Db->Insert('blogs',$arr_values,__file__,__line__);
		$logos=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/new-'.$uid.'.*');
		$logo=false;
		if($logos)
		{
			$type=substr($logos[0],strrpos($logos[0],'.'));
			if(rename($logos[0],$img=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$id.$type))
			{
				$logo=basename($img);
				array_shift($logos);
			}

		}
		if($logo)
			$Mainclass->Db->Update('blogs',array('logo'=>$logo),'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array(array('do'=>'my')))));
}

function DeleteBlog($id)
{global $Mainclass,$title;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `url`,`title`,`crdate` FROM `prefix_blogs` WHERE `id`='.$id.' AND `author_id`='.$uid.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
		$Plug=new $class_name($Mainclass);
		$Plug->DeleteBlog($id);
		return Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array(array('do'=>'my')))));
	}
	$arr=$Mainclass->Db->Fetch_assoc();
	$content=$Mainclass->Template->GetClass('Blogs')->DeleteBlog($arr);
	GenTags();
	Head();
	echo MenuBlogs().$content;
}

function BlogCategories($id)
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/module_blogs.js';
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=(int)$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `id`,`title`,`url` FROM `prefix_blogs` WHERE `id`='.$id.' AND `author_id`='.$uid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if(!$barr=$Mainclass->Db->Fetch_assoc())
		return ExitPrefix();
	GenTags();
	$title=sprintf($Mainclass->lang['blogs']['mancatb'],$barr['title']);
	$Mainclass->Db->Query('SELECT COUNT(`bid`) FROM `prefix_blogs_categories` WHERE `bid`='.$id.' LIMIT 1',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content=$Mainclass->Template->Title($title).$Tpl->MyCatsListBegin($barr);
	if($cnt==0)
		$content.=$Tpl->MyCatsListEmpty($barr);
	else
	{
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`posts`,`logo`,`pos` FROM `prefix_blogs_categories` WHERE `bid`='.$id.' ORDER BY `pos` ASC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
			$content.=$Tpl->MyCatsList($arr,$barr,$cnt);
	}
	$content.=$Tpl->MyCatsListEnd($barr);
	Head();
	echo MenuBlogs().$content;
}

function AddEditCat($id,$error='',$bid=0)
{global $Mainclass,$title,$jscripts;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	GenTags();
	$title=$Mainclass->lang['blogs']['crcateg'];
	$uid=(int)$Mainclass->Account->GetValue('id');
	$content='';
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	if($id===true)
	{
		$values['id']='new';
		$values['url']=$values['title']=$values['descr']=$values['logo']=$values['pos']='';
		$values['bid']=$bid;
		$bvalue=$Mainclass->lang['blogs']['crcateg'];
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`bid`,`logo`,`pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			$values=$Mainclass->Db->Fetch_assoc();
		}
		$title=$Mainclass->lang['blogs']['editcat'];
		$bvalue=EL_LANG_SAVE;
	}
	if($error)
	{
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
		$values['descr']=$Mainclass->Editor->GetHtml('descr');
		$values['logo']=isset($_POST['logo']) ? basename($_POST['logo']) : '';
		$values['bid']=isset($_POST['bid']) ? (int)$_POST['bid'] : '';
		$values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : '';
	}
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$values['bid'].' AND `author_id`='.$uid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$blogs='';
	$Mainclass->Db->Query('SELECT `id`,`title` FROM `prefix_blogs` WHERE `author_id`='.$uid.' ORDER BY `title`',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
		$blogs.=Template::Option($arr['title'],$arr['id'],$arr['id']==$values['bid']);
	$image_list=array();
	$hdir=opendir($Mainclass->root_path.'images/categories/');
	while($entry=readdir($hdir))
		if(preg_match('/\.(?:gif|jpe?g|png|bmp)$/i',$entry)>0 and stripos($entry,'none')!==0)
			$image_list[$entry]=Template::Option($entry,'images/categories/'.$entry,$entry==$values['logo']);
	closedir($hdir);
	ksort($image_list,SORT_STRING);
	$values['image']='images/categories/'.$values['logo'];
	$content=$Mainclass->Template->GetClass('Blogs')->AddEditCat($error,$title,$bvalue,$values,join('',$image_list),$blogs);
	Head();
	echo MenuBlogs().$content;
}

function SaveCat($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditCat($id);
	$uid=$Mainclass->Account->GetValue('id');
	$bid=isset($_POST['bid']) ? (int)$_POST['bid'] : 0;
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$bid.' AND `author_id`='.$uid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return AddEditCat($id,$Mainclass->lang['blogs']['erunmbc']);
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return AddEditCat($id,$Mainclass->lang['blogs']['erctiem']);
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and.' AND `bid`='.$bid.' LIMIT 1',array('blogs_categories','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	$image=isset($_POST['image']) ? basename($_POST['image']) : '';
	if(!is_file($Mainclass->root_path.'images/categories/'.$image))
		$image='';
	$arr_values=array(
						'url'=>$url,
						'title'=>$title,
						'descr'=>$Mainclass->Editor->GetHtml('descr'),
						'bid'=>$bid,
						'logo'=>$image,
						'pos'=>'',
	);
	if(is_int($id))
	{
		$arr_values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		$Mainclass->Db->Query('SELECT `bid`,`pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($oldbid,$pos)=$Mainclass->Db->Fetch_row();
		if($pos!=$arr_values['pos'])
		{
			$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`-1'),'`pos`>'.$pos.' AND `bid`='.$bid,__file__,__line__);
			$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`+1'),'`pos`>='.$arr_values['pos'].' AND `bid`='.$bid,__file__,__line__);
		}
		$Mainclass->Db->Update('blogs_categories',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
		if($oldbid!=$bid)
		{
			$Mainclass->Db->Update('blogs_posts',array('bid'=>$bid),'`cid`='.$id,__file__,__line__);
			$Mainclass->Db->Update('blogs',array('!posts'=>'(SELECT COUNT(`bid`) FROM `prefix_blogs_posts`) WHERE `bid`='.$bid.')'),'`id`='.$bid,__file__,__line__);
			$Mainclass->Db->Update('blogs',array('!posts'=>'(SELECT COUNT(`bid`) FROM `prefix_blogs_posts`) WHERE `bid`='.$oldbid.')'),'`id`='.$oldbid,__file__,__line__);
		}
	}
	else
	{
		$arr_values['pos']=isset($_POST['pos']) ? $_POST['pos'] : 0;
		if($arr_values['pos']=='')
		{
			$Mainclass->Db->Query('SELECT MAX(`pos`) FROM `prefix_blogs_categories` WHERE `bid`='.$bid,__file__,__line__);
			list($position)=$Mainclass->Db->Fetch_row();
			$arr_values['pos']=$position===null ? 0 : $position+1;
		}
		else
			$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`+1'),'`pos`>='.(int)$arr_values['pos'].' AND `bid`='.$bid,__file__,__line__);
		$Mainclass->Db->Insert('blogs_categories',$arr_values,__file__,__line__);
	}
	Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array(array('categories'=>$bid)))));
}

function MoveCatUp($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `bid`,`pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($bid,$posit)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$bid.' AND `author_id`='.$uid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs_categories` WHERE `pos`=(SELECT MAX(`pos`) FROM `prefix_blogs_categories` WHERE `pos`<'.$posit.' AND `bid`='.$bid.') AND `bid`='.$bid,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if($cnt>0)
	{
		if($cnt>1)
		{
			OptimizeBCategs($bid,false);
			$Mainclass->Db->Query('SELECT `pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$Mainclass->Db->Fetch_row();
		}
		$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`+1'),'`pos`='.--$posit.' AND `bid`='.$bid.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`-1'),'`id`='.$id.' AND `bid`='.$bid.' LIMIT 1',__file__,__line__);
	}
	ExitBack();
}

function MoveCatDown($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `bid`,`pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($bid,$posit)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$bid.' AND `author_id`='.$uid.' AND `categs`=1 LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs_categories` WHERE `pos`=(SELECT MIN(`pos`) FROM `prefix_blogs_categories` WHERE `pos`>'.$posit.' AND `bid`='.$bid.') AND `bid`='.$bid,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if($cnt>0)
	{
		if($cnt>1)
		{
			OptimizeBCategs($bid,false);
			$Mainclass->Db->Query('SELECT `pos` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$Mainclass->Db->Fetch_row();
		}
		$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`-1'),'`pos`='.++$posit.' AND `bid`='.$bid.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Update('blogs_categories',array('!pos'=>'`pos`+1'),'`id`='.$id.' AND `bid`='.$bid.' LIMIT 1',__file__,__line__);
	}
	ExitBack();
}

function OptimizeBCategs($bid,$redirect=true)
{
	$result=$Mainclass->Db->Query('SELECT `id`,`pos` FROM `prefix_blogs_categories` WHERE `bid`='.$bid.' ORDER BY `pos` ASC',__file__,__line__);
	$cnt=0;
	while($arr=$Mainclass->Db->Fetch_assoc($result))
		$Mainclass->Db->Update('blogs_categories',array('pos'=>$cnt++),'`id`='.$arr['id'].' LIMIT 1',__file__,__line__);
	if($redirect)
		ExitBack();
}

function DeleteCat($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `url`,`title`,`bid` FROM `prefix_blogs_categories` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$arr=$Mainclass->Db->Fetch_assoc();
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$arr['bid'].' AND `author_id`='.$uid.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
		$Plug=new $class_name($Mainclass);
		$Plug->DeleteCat($id,isset($_POST['deleteposts']));
		return Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array(array('categories'=>$arr['bid'])))));
	}
	GenTags();
	$content=$Mainclass->Template->GetClass('Blogs')->DeleteCat($arr);
	Head();
	echo MenuBlogs().$content;
}

function BlogTags($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=(int)$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `id`,`title`,`url` FROM `prefix_blogs` WHERE `id`='.$id.' AND `author_id`='.$uid,__file__,__line__);
	if(!$barr=$Mainclass->Db->Fetch_assoc())
		return ExitPrefix();
	GenTags();
	$title=sprintf($Mainclass->lang['blogs']['mantags'],$barr['title']);
	$Mainclass->Db->Query('SELECT COUNT(`bid`) FROM `prefix_blogs_tags` WHERE `bid`='.$id.' LIMIT 1',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	$pages=ceil($cnt/$Mainclass->vars['m_blogs_per_page']);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content=$Mainclass->Template->Title($title).$Tpl->MyTagsListBegin($barr);
	if($cnt==0)
		$content.=$Tpl->MyTagsListEmpty($barr);
	else
	{
		$Mainclass->Db->Query('SELECT `t`.`id`,`t`.`name`,COUNT(`p`.`tid`) `posts` FROM `prefix_blogs_tags` `t` INNER JOIN `prefix_blogs_bt` `p` WHERE `t`.`bid`='.$id.' GROUP BY `t`.`id` ORDER BY `posts` DESC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
			$content.=$Tpl->MyTagsList($arr,$barr);
	}
	$content.=$Tpl->MyTagsListEnd($barr);
	Head();
	echo MenuBlogs().$content;
}

function EditTag($id,$error='')
{global $Mainclass,$title,$jscripts;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$title=$Mainclass->lang['blogs']['edittag'];
	$uid=(int)$Mainclass->Account->GetValue('id');
	if(!$error)
	{
		$Mainclass->Db->Query('SELECT `id`,`bid`,`name` FROM `prefix_blogs_tags` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		$values=$Mainclass->Db->Fetch_assoc();
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$values['bid'].' AND `author_id`='.$uid.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			return ExitPrefix();
	}
	if($error)
		$values['name']=isset($_POST['name']) ? $_POST['name'] : '';
	$content=$Mainclass->Template->GetClass('Blogs')->EditTag($error,$title,$values);
	GenTags();
	Head();
	echo MenuBlogs().$content;
}

function SaveTag($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditCat($id);
	$Mainclass->Db->Query('SELECT `bid` FROM `prefix_blogs_tags` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($bid)=$Mainclass->Db->Fetch_row();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.(int)$bid.' AND `author_id`='.$uid.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return EditTag($id,$Mainclass->lang['blogs']['erunedt']);
	$name=isset($_POST['name']) ? $Mainclass->POST['name'] : '';
	if(!$name)
		return EditTag($id,$Mainclass->lang['blogs']['erttage']);
	$arr_values=array(
						'name'=>$name,
	);
	if(is_int($id))
		$Mainclass->Db->Update('blogs_tags',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
	else
		$Mainclass->Db->Insert('blogs_tags',$arr_values,__file__,__line__);
	Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array(array('tags'=>$bid)))));
}

function DeleteTag($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`=(SELECT `bid` FROM `prefix_blogs_tags` WHERE `id`='.$id.' LIMIT 1) AND `author_id`='.$uid.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$Mainclass->Db->Delete('blogs_tags','`id`='.$id.' LIMIT 1',__file__,__line__);
	$Mainclass->Db->Delete('blogs_bt','`tid`='.$id,__file__,__line__);
	return ExitBack();
}

function AddEditPost($id,$error='',$bid=false,$cid='')
{global $Mainclass,$jscripts,$title;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=(int)$Mainclass->Account->GetValue('id');
	$content='';
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Loadclass('classes/others/class_uploader.php');
	$Mainclass->Editor->bb_detail=true;
	if($id===true)
	{
		$title=$Mainclass->lang['blogs']['crepost'];
		$values['id']='new';
		$values['cid']=$cid;
		$values['url']=$values['title']=$values['text']=$values['allow_comm']=$values['show_sokr']=$values['tags']='';
		$values['cats']=array();
		$values['bid']=$bid;
		$values['status']=true;
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT `id`,`bid`,`cid`,`cats`,`url`,`title`,`text`,`allow_comm`,`show_sokr`,`status` FROM `prefix_blogs_posts` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			$values=$Mainclass->Db->Fetch_assoc();
			$values['cats']=$values['cats'] ? explode(',',Strings::CleanForExplode($values['cats'])) : array();
			$tags=array();
			$Mainclass->Db->Query('SELECT `t`.`name` FROM `prefix_blogs_bt` `bt` INNER JOIN `prefix_blogs_tags` `t` ON `bt`.`tid`=`t`.`id` WHERE `bt`.`pid`='.$id.' ORDER BY t.`name`',__file__,__line__);
			while(list($temp)=$Mainclass->Db->Fetch_row())
				$tags[]=$temp;
			$values['tags']=implode(', ',$tags);
		}
		$title=sprintf($Mainclass->lang['blogs']['editpos'],$values['title']);
	}
	$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`categs` FROM `prefix_blogs` WHERE `id`='.$values['bid'].($Mainclass->Permission->IsAdmin() ? '' : ' AND (`author_id`='.$uid.' OR `type`=\'public\')').' LIMIT 1',__file__,__line__);
	if(!$barr=$Mainclass->Db->Fetch_assoc())
		return ExitPrefix();
	if($error)
	{
		$values['cid']=isset($_POST['cid']) ? (int)$_POST['cid'] : 0;
		$values['cats']=(isset($_POST['cats']) and is_array($_POST['cats'])) ? $_POST['cats'] : array();
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
		$values['text']=$Mainclass->Editor->GetHtml('text');
		$values['allow_comm']=isset($_POST['allow_comm']);
		$values['show_sokr']=isset($_POST['show_sokr']);
		$values['status']=isset($_POST['status']);
	}
	if($barr['categs'])
	{
		$cats=Template::Option($Mainclass->lang['main']['no'],0,$values['cid']==0);
		$other_cats='';
		$Mainclass->Db->Query('SELECT `id`,`url`,`title` FROM `prefix_blogs_categories` WHERE `bid`='.$values['bid'].' ORDER BY `title` ASC',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			$cats.=Template::Option($arr['title'],$arr['id'],$values['cid']==$arr['id']);
			$other_cats.=Template::Option($arr['title'],$arr['id'],in_array($arr['id'],$values['cats']));
		}
	}
	else
		$cats=$other_cats=false;
	$Mainclass->Uploader->new_folder=is_object($Mainclass->Account) ? 'new-'.(int)$Mainclass->Account->GetValue('id') : 'guest-new';
	$Mainclass->Uploader->allow_walk=$Mainclass->Uploader->allow_lock=$Mainclass->Uploader->allow_new=false;
	$upload=$Mainclass->Uploader->Show($id===true ? 'blogs/temp_posts' : ($values['status']==0 ? 'blogs/temp_posts' : 'blogs/posts').'/'.$id,$id===true);
	$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$content=$Mainclass->Template->GetClass('Blogs')->AddEditPost($barr,$error,$title,$values,$cats,$other_cats,$upload,$back);
	GenTags();
	Head();
	echo MenuBlogs().$content;
}

function SavePost($id,$bid)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=(int)$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `categs` FROM `prefix_blogs` WHERE `id`='.$bid.' AND (`author_id`='.$uid.' OR `type`=\'public\') LIMIT 1',__file__,__line__);
	if(!list($categs)=$Mainclass->Db->Fetch_row() and !$Mainclass->Permission->IsAdmin())
		return ExitPrefix();
	if($categs)
	{
		$cid=isset($_POST['cid']) ? (int)$_POST['cid'] : 0;
		$cats=(isset($_POST['cats']) and is_array($_POST['cats'])) ? $_POST['cats'] : array();
		$cids=array();
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs_categories` WHERE `bid`='.$bid,__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
			$cids[]=$arr['id'];
		$cats=array_intersect($cids,$cats);
		if(!in_array($cid,$cids))
			$cid=0;
	}
	else
		$cid=$cats='';
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"} AND `bid`='.$bid.$q_and.' LIMIT 1',array('blogs_posts','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$tags=explode(',',Strings::CleanForExplode($Mainclass->POST['tags']));
	foreach($tags as $k=>$v)
	{
		$v=trim($v);
		if($v)
			$tags[$k]=$v;
		else
			unset($tags[$k]);
	}
	$db_tags=array();
	if($tags)
	{
		$deleted=array();
		foreach($tags as $kt=>$tag)
			foreach($tags as $kt2=>$tag2)
				if(strcasecmp($tag,$tag2)==0 and $kt!=$kt2 and !in_array($kt,$deleted))
				{
					$deleted[]=$kt2;
					unset($tags[$kt2]);
				}
		unset($deleted);
		$used_tags=array();
		$Mainclass->Db->Query('SELECT `id`,`name` FROM `prefix_blogs_tags` WHERE `bid`='.$bid.' AND `name`'.$Mainclass->Db->In($tags),__file__,__line__);
		while($temp=$Mainclass->Db->Fetch_assoc())
			$used_tags[$temp['id']]=$temp['name'];
		if(count($used_tags)<count($tags))
		{
			$addon=array_diff($tags,$used_tags);
			$num=$Mainclass->Db->Insert('blogs_tags',array('bid'=>array_fill(0,count($addon),$bid),'name'=>$addon),__file__,__line__);
			while(list(,$used_tags[$num++])=each($addon));
		}
		$db_tags=array_keys($used_tags);
	}
	unset($tags,$used_tags);
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Loadclass('classes/others/class_uploader.php');
	$Mainclass->Uploader->new_folder=is_object($Mainclass->Account) ? 'new-'.(int)$Mainclass->Account->GetValue('id') : 'guest-new';
	$arr_values=array(
						'bid'=>$bid,
						'cid'=>$cid,
						'cats'=>$cats ? ','.join(',',$cats).',' : '',
						'url'=>$url,
						'title'=>$Mainclass->POST['title'],
						'allow_comm'=>isset($_POST['allow_comm']),
						'show_sokr'=>isset($_POST['show_sokr']),
						'tags'=>$db_tags ? join(',',$db_tags) : 0,
						'status'=>isset($_POST['status']),
	);
	if($id===true)
	{
		$arr_values+=array(
							'!date'=>'NOW()',
							'author'=>$Mainclass->Account->GetValue('name'),
							'author_id'=>$Mainclass->Account->GetValue('id'),
		);
		$pid=$Mainclass->Db->Insert('blogs_posts',$arr_values,__file__,__line__);
		$text=str_replace(Mainclass::UPLOADS_DIR.'/blogs/temp_posts/'.$Mainclass->Uploader->new_folder,Mainclass::UPLOADS_DIR.'/'.($arr_values['status']==0 ? 'blogs/temp_posts' : 'blogs/posts').'/'.$pid,$Mainclass->Editor->GetHtml('text'));
		$Mainclass->Uploader->RenameNew('blogs/temp_posts','/'.Mainclass::UPLOADS_DIR.'/blogs/'.($arr_values['status']==0 ? 'temp_posts' : 'posts').'/'.$pid);
		$Mainclass->Db->Update('blogs_posts',array('text'=>$text),'`id`='.$pid.' LIMIT 1',__file__,__line__);
		if($arr_values['status'])
			$Mainclass->Db->Update('blogs',array(
													'!posts'=>'`posts`+1',
													'last_cid'=>$arr_values['cid'],
													'last_id'=>$pid,
													'last_url'=>$arr_values['url'],
													'last_title'=>$arr_values['title'],
													'!last_date'=>'NOW()',
													'last_author'=>$arr_values['author'],
													'last_author_id'=>$arr_values['author_id'],
											),'`id`='.$arr_values['bid'].' LIMIT 1',__file__,__line__);
		if($arr_values['cid'] and $arr_values['status'])
			$Mainclass->Db->Update('blogs_categories',array('!posts'=>'`posts`+1'),'`id`='.$arr_values['cid'].' LIMIT 1',__file__,__line__);
	}
	else
	{
		$arr_values+=array(
							'text'=>$Mainclass->Editor->GetHtml('text'),
							'!editdate'=>'NOW()'
		);
		#Переименовывание папки
		$Mainclass->Db->Query('SELECT `cid`,`status`,`tags` FROM `prefix_blogs_posts` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($old_cid,$status,$tags)=$Mainclass->Db->Fetch_row();
		$from=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/'.($status==0 ? 'temp_posts' : 'posts').'/'.$id;
		if($status<=0 xor $arr_values['status']<=0)
		{
			$to=$Mainclass->root_path.Mainclass::UPLOADS_DIR.'/blogs/'.($arr_values['status']==0 ? 'temp_posts' : 'posts').'/'.$id;
			if(file_exists($from))
			{
				$rep=rename($from,$to);
				if(!$rep)
					return AddEditPost($id,'Can\'r rename folder!');
				$from=$to;
			}
			$Mainclass->Db->Update('blogs',array('!posts'=>'`posts`'.($arr_values['status']>0 ? '+1' : -1)),'`id`='.$arr_values['bid'].' LIMIT 1',__file__,__line__);
			if($arr_values['cid'] and $arr_values['status'])
				$Mainclass->Db->Update('blogs_categories',array('!posts'=>'`posts`'.($arr_values['status']>0 ? '+1' : -1)),'`id`='.$arr_values['cid'].' LIMIT 1',__file__,__line__);
		}
		$files=glob($from.'/*');
		if(!$files)
			Functions::RmDir($from);
		$Mainclass->Db->Update('blogs_posts',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
		$tags=$tags ? explode(',',$tags) : array();
		if($tags and $in=array_diff($tags,$db_tags))
			$Mainclass->Db->Delete('blogs_bt','`pid`='.$id.' AND `tid`'.$Mainclass->Db->In($in),__file__,__line__);
		$db_tags=array_diff($db_tags,$tags);
		if($arr_values['cid']!=$old_cid)
		{
			if($old_cid and $status)
				$Mainclass->Db->Update('blogs_categories',array('!posts'=>'`posts`-1'),'`id`='.$old_cid.' LIMIT 1',__file__,__line__);
			if($arr_values['cid'] and $arr_values['status'])
				$Mainclass->Db->Update('blogs_categories',array('!posts'=>'`posts`+1'),'`id`='.$arr_values['cid'].' LIMIT 1',__file__,__line__);
		}
	}
	if($db_tags)
		$Mainclass->Db->Insert('blogs_bt',array('pid'=>array_fill(0,count($db_tags),$id),'tid'=>$db_tags),__file__,__line__);
	if(empty($_POST['back']) or $id===true)
		Functions::Redirect(ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.html_entity_decode($Mainclass->Url->ConstructUrl(array(array('pid'=>$pid)))));
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeletePost($id)
{global $Mainclass;
	if(!$Mainclass->Login->IsUser())
		return ExitPrefix();
	$uid=$Mainclass->Account->GetValue('id');
	$Mainclass->Db->Query('SELECT `id`,`bid`,`title` FROM `prefix_blogs_posts` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$arr=$Mainclass->Db->Fetch_assoc();
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs` WHERE `id`='.$arr['bid'].' AND `author_id`='.$uid.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
		$Plug=new $class_name($Mainclass);
		$Plug->DeletePost($id);
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$content=$Mainclass->Template->GetClass('Blogs')->DeletePost($arr,$back);
	GenTags();
	Head();
	echo MenuBlogs().$content;
}

function ShowBlog($bid,$blog)
{global $Mainclass,$jscripts,$title,$head_addon;
	$jscripts[]='js/rating.js';
	$jscripts[]='js/module_blogs.js';
	if($bid)
		$where='`id`='.(int)$bid;
	elseif($blog)
		$where='`url`=\''.$Mainclass->Db->EscapeString($blog).'\'';
	else
		return ExitPage(false);
	$Mainclass->Db->Query('SELECT `id`,`url`,`crdate`,`author`,`author_id`,`title`,`descr`,`logo`,`per_page`,`type`,`categs`,`posts` FROM `prefix_blogs` WHERE '.$where.' AND `status`=1 LIMIT 1',__file__,__line__);
	if(!$barr=$Mainclass->Db->Fetch_assoc())
		return ExitPrefix();
	$head_addon.=$Mainclass->Functions->RssLink(array('bid'=>$barr['id']),sprintf($Mainclass->lang['blogs']['posts_fb'],$barr['title']));
	$title=sprintf($Mainclass->lang['blogs']['posfblo'],$barr['title']);
	$carr=array();
	if($barr['categs'])
	{
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`logo`,`posts` FROM `prefix_blogs_categories` WHERE `bid`='.$barr['id'].' ORDER BY `pos` ASC',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
			$carr[$arr['id']]=$arr;
	}
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content=$Tpl->ShowBlog($barr,$carr);
	if($barr['posts']>0)
	{
		$pages=ceil($barr['posts']/$barr['per_page']);
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$offset=abs(($page-1)*$barr['per_page']);
		$jscripts[]='js/rating.js';
		$sizes=array();
		$result=$Mainclass->Db->Query('SELECT `id`,`bid`,`cid`,`date`,`url`,`title`,`text`,`author`,`author_id`,`comments`,`reads`,`allow_comm`,`show_sokr`,`total`,`votes`,`editdate` FROM `prefix_blogs_posts` WHERE `bid`='.$barr['id'].' AND `status`=1 ORDER BY `date` DESC LIMIT '.$offset.', '.$barr['per_page'],__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc($result))
		{
			$sizes[$arr['id']]=array($arr['total'],$arr['votes']);
			$seppos=strpos($arr['text'],'[separator]');
			if($seppos!==false)
				$arr['text']=mb_substr($arr['text'],0,$seppos,ELEANOR_CHARSET);
			$arr['text']=Strings::ParseOwnBb($arr['text']);
			$content.=$Tpl->PostsInBlog($arr,$barr,isset($carr[$arr['cid']]) ? $carr[$arr['cid']] : array(),$Mainclass->vars['m_blogs_rating'] ? '{rating_'.$arr['id'].'}' : '');
		}
		if($Mainclass->vars['m_blogs_rating'])
		{
			if(!$Mainclass->vars['m_blogs_vote_general'])
				$Mainclass->Functions->PrepareVoting(array_keys($sizes));
			foreach($sizes as $k=>$v)
			{
				$steps=(!$Mainclass->vars['m_blogs_vote_general'] and $Mainclass->Functions->CanVoting($k)) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
				$content=str_replace('{rating_'.$k.'}',$Mainclass->Functions->ShowRating($v[0],$v[1],$steps,array('id'=>$k)),$content);
			}
		}
		$pages=Strings::Pages($barr['posts'],$barr['per_page'],array(array($barr['url'],'bid'=>$barr['id'])),false,$page);
		$content.=$pages ? $Mainclass->Template->OpenTable().$pages.$Mainclass->Template->CloseTable() : '';
	}
	GenTags($barr['id'],$barr['url']);
	$Mainclass->SetModVal('description',Strings::CutStr(str_replace("\r\n",'',strip_tags($barr['descr'])),250,''));
	$Mainclass->SetModVal('keywords',Strings::MakeKeywords($barr['descr']));
	Head();
	echo MenuBlogs().$content;
}

function BlogsCategory($cid,$cat,$bid,$blog)
{global $Mainclass,$jscripts,$title,$head_addon;
	$jscripts[]='js/rating.js';
	$jscripts[]='js/module_blogs.js';
	if($cid)
	{
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`logo`,`posts` FROM `prefix_blogs_categories` WHERE `id`='.$cid.' LIMIT 1',__file__,__line__);
		if(!$carr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
		$Mainclass->Db->Query('SELECT `id`,`url`,`crdate`,`author`,`author_id`,`title`,`descr`,`logo`,`per_page`,`type`,`categs`,`posts` FROM `prefix_blogs` WHERE `id`='.$carr['bid'].' AND `status`=1 LIMIT 1',__file__,__line__);
		if(!$barr=$Mainclass->Db->Fetch_assoc() or !$barr['categs'])
			return ExitPrefix();
	}
	elseif($blog)
	{
		if($bid)
			$where='`id`='.(int)$bid;
		elseif($blog)
			$where='`url`=\''.$Mainclass->Db->EscapeString($blog).'\'';
		else
			return ExitPage(false);
		$Mainclass->Db->Query('SELECT `id`,`url`,`crdate`,`author`,`author_id`,`title`,`descr`,`logo`,`per_page`,`type`,`categs`,`posts` FROM `prefix_blogs` WHERE '.$where.' AND `status`=1 LIMIT 1',__file__,__line__);
		if(!$barr=$Mainclass->Db->Fetch_assoc() or !$barr['categs'])
			return ExitPrefix();
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`descr`,`logo`,`posts` FROM `prefix_blogs_categories` WHERE `bid`='.$barr['id'].' AND `url`=\''.$Mainclass->Db->EscapeString($cat).'\' LIMIT 1',__file__,__line__);
		if(!$carr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
	}
	else
		return ExitPage(false);
	$head_addon.=$Mainclass->Functions->RssLink(array('bid'=>$barr['id']),sprintf($Mainclass->lang['blogs']['posts_fb'],$barr['title'])).($carr ? $Mainclass->Functions->RssLink(array('cid'=>$carr['id']),sprintf($Mainclass->lang['blogs']['posts_fc'],$carr['title'])) : '');
	$title=array($carr['title'],sprintf($Mainclass->lang['blogs']['posfcat'],$carr['title']));
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$content=$Tpl->ShowCategory($barr,$carr);
	if($carr['posts']>0)
	{
		$pages=ceil($carr['posts']/$barr['per_page']);
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$offset=abs(($page-1)*$barr['per_page']);
		$jscripts[]='js/rating.js';
		$sizes=array();
		$result=$Mainclass->Db->Query('SELECT `id`,`bid`,`cid`,`date`,`url`,`title`,`text`,`author`,`author_id`,`comments`,`reads`,`allow_comm`,`show_sokr`,`total`,`votes`,`editdate` FROM `prefix_blogs_posts` WHERE (`cid`='.$carr['id'].' OR `cats` LIKE \','.$carr['id'].',\') AND `status`=1 ORDER BY `date` DESC LIMIT '.$offset.', '.$barr['per_page'],__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc($result))
		{
			$sizes[$arr['id']]=array($arr['total'],$arr['votes']);
			$seppos=strpos($arr['text'],'[separator]');
			if($seppos!==false)
				$arr['text']=mb_substr($arr['text'],0,$seppos,ELEANOR_CHARSET);
			$arr['text']=Strings::ParseOwnBb($arr['text']);
			$content.=$Tpl->PostsInBlog($arr,$barr,$carr,$Mainclass->vars['m_blogs_rating'] ? '{rating_'.$arr['id'].'}' : '');
		}
		if($Mainclass->vars['m_blogs_rating'])
		{
			if(!$Mainclass->vars['m_blogs_vote_general'])
				$Mainclass->Functions->PrepareVoting(array_keys($sizes));
			foreach($sizes as $k=>$v)
			{
				$steps=(!$Mainclass->vars['m_blogs_vote_general'] and $Mainclass->Functions->CanVoting($k)) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
				$content=str_replace('{rating_'.$k.'}',$Mainclass->Functions->ShowRating($v[0],$v[1],$steps,array('id'=>$k)),$content);
			}
		}
		$pages=Strings::Pages($carr['posts'],$barr['per_page'],array(array($carr['url'] ? $barr['url'] : '','bid'=>$barr['id'],true),array($carr['url'],'cid'=>$carr['id'])),false,$page);
		$content.=$pages ? $Mainclass->Template->OpenTable().$pages.$Mainclass->Template->CloseTable() : '';
	}
	GenTags($barr['id'],$barr['url']);
	$Mainclass->SetModVal('description',Strings::CutStr(str_replace("\r\n",'',strip_tags($carr['descr'])),250,''));
	$Mainclass->SetModVal('keywords',Strings::MakeKeywords($carr['descr']));
	Head();
	echo MenuBlogs().$content;
}

function AllBlogsTags()
{global $Mainclass,$title,$jscripts;
	$title[]=$Mainclass->lang['blogs']['blogs'];
	$title[]=$Mainclass->lang['blogs']['taglist'];
	if($res=GenTags())
		$content=implode(', ',$res);
	else
		$content='<div align="center"><i>'.$Mainclass->lang['main']['no'].'</i></div>';
	Head();
	echo MenuBlogs().$Mainclass->Template->Title($Mainclass->lang['blogs']['taglist']).$Mainclass->Template->OpenTable().$content.$Mainclass->Template->CloseTable();
}

function ShowTag($tag,$bid,$blog)
{global $Mainclass,$title,$jscripts;
	if($bid or $blog)
	{
		if($bid)
			$where='`id`='.(int)$bid;
		elseif($blog)
			$where='`url`=\''.$Mainclass->Db->EscapeString($blog).'\'';
		$Mainclass->Db->Query('SELECT `id`,`url`,`title` FROM `prefix_blogs` WHERE '.$where.' AND `status`=1 LIMIT 1',__file__,__line__);
		if(!$barr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
		$bid=$barr['id'];
	}
	else
		$bid=$barr=false;
	$tag=FilterArrays::Filter($tag);
	$tarr=array();
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs_tags` WHERE `name`=\''.$Mainclass->Db->EscapeString($tag).'\''.($bid ? ' AND `bid`='.$bid : ''),__file__,__line__);
	while($temp=$Mainclass->Db->Fetch_row())
		$tarr[]=$temp[0];
	if(!$tarr)
		return ExitPage(false);
	$title[]=$tag;
	if($barr)
		$title[]=$barr['title'];
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$tid=count($tarr)>1 ? 0 : reset($tarr);
	$cnt=$Mainclass->Cache->Get('blogs_tag_cnt_'.$tid.'_'.$bid,false);
	if($cnt===false)
	{
		$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_blogs_posts` WHERE `id`IN(SELECT `pid` FROM `prefix_blogs_bt` WHERE `tid`'.$Mainclass->Db->In($tarr).') AND `status`=1',__file__,__line__);
		list($cnt)=$Mainclass->Db->Fetch_row();
		$Mainclass->Cache->Put('blogs_tag_cnt_'.$tid.'_'.$bid,$cnt,3600,false);
	}
	$content=$Tpl->ShowTag($barr,$tag);
	if($cnt>0)
	{
		$per_page=$barr ? $barr['per_page'] : $Mainclass->vars['m_blogs_per_page'];
		$pages=ceil($cnt/$per_page);
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$offset=abs(($page-1)*$per_page);
		$sizes=array();
		$jscripts[]='js/rating.js';
		$jscripts[]='js/module_blogs.js';
		$result=$Mainclass->Db->Query('SELECT `p`.`id`,`p`.`date`,`p`.`url`,`p`.`title`,`p`.`text`,`p`.`author`,`p`.`author_id`,`p`.`comments`,`p`.`reads`,`p`.`allow_comm`,`p`.`total`,`p`.`votes`,`p`.`editdate`,`b`.`id` `bid`,`b`.`url` `burl`,`b`.`title` `btitle`,`b`.`author_id` `baid`,`b`.`categs`,`c`.`id` `cid`,`c`.`url` `curl`,`c`.`title` `ctitle` FROM `prefix_blogs_posts` `p` LEFT JOIN `prefix_blogs` `b` ON `b`.`id`=`p`.`bid` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`p`.`cid` WHERE `p`.`id`IN(SELECT `pid` FROM `prefix_blogs_bt` WHERE `tid`'.$Mainclass->Db->In($tarr).') AND `p`.`status`=1 ORDER BY `p`.`date` DESC LIMIT '.$offset.', '.$per_page,__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc($result))
		{
			$sizes[$arr['id']]=array($arr['total'],$arr['votes']);
			$seppos=strpos($arr['text'],'[separator]');
			if($seppos!==false)
				$arr['text']=mb_substr($arr['text'],0,$seppos,ELEANOR_CHARSET);
			$arr['text']=Strings::ParseOwnBb($arr['text']);
			$content.=$Tpl->PostInList($arr,$Mainclass->vars['m_blogs_rating'] ? '{rating_'.$arr['id'].'}' : '');
		}
		if($Mainclass->vars['m_blogs_rating'])
		{
			if(!$Mainclass->vars['m_blogs_vote_general'])
				$Mainclass->Functions->PrepareVoting(array_keys($sizes));
			foreach($sizes as $k=>$v)
			{
				$steps=(!$Mainclass->vars['m_blogs_vote_general'] and $Mainclass->Functions->CanVoting($k)) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
				$content=str_replace('{rating_'.$k.'}',$Mainclass->Functions->ShowRating($v[0],$v[1],$steps,array('id'=>$k)),$content);
			}
		}
		$pages=Strings::Pages($cnt,$per_page,array(array($barr ? $barr['url'] : '','bid'=>$barr['id']),array('tag'=>$tag)),false,$page);
		$content.=$pages ? $Mainclass->Template->OpenTable().$pages.$Mainclass->Template->CloseTable() : '';
	}
	else
		$content.=$Mainclass->Template->Message(sprintf($Mainclass->lang['blogs']['no_tag'],$tag));
	GenTags($barr ? $barr['id'] : '',$barr ? $barr['url'] : '');
	Head();
	echo MenuBlogs().$content;
}

function SearchBlogs()
{global $Mainclass,$title,$jscripts;
	$error='';
	if(!$Mainclass->Functions->CanVoting('search'))
		$error=sprintf($Mainclass->lang['blogs']['search_limit'],$Mainclass->vars['m_blogs_search']);
	elseif(isset($_POST['search_word']))
		do
		{
			if(strlen($_POST['search_word'])<3)
			{
				$error=$Mainclass->lang['blogs']['sym_limit'];
				break;
			}
			$word=$Mainclass->Db->EscapeString($Mainclass->POST['search_word']);
			$query='MATCH(`p`.`title`,`p`.`text`) AGAINST(\''.$word.'\' IN BOOLEAN MODE) AND `p`.`status`=1';
			if(isset($_POST['blogs']))
				$query.=' AND `p`.`bid`'.$Mainclass->Db->In($_POST['blogs']);
			$Mainclass->Db->FQuery('SELECT COUNT(`p`.`id`) FROM {"0"} `p` WHERE '.$query,array('blogs_posts'),__file__,__line__);
			list($total)=$Mainclass->Db->Fetch_row();
			if(!$total)
				$error=sprintf($Mainclass->lang['blogs']['nothing_found_w'],$Mainclass->POST['search_word']);
			else
			{
				$md=$Mainclass->Cache->SetSearchCache($total,$query,array($Mainclass->POST['search_word'],'word'));
				$Mainclass->Functions->AddVoting('search',$Mainclass->vars['m_blogs_search'].'s');
				ExitPrefix(array(array('search'=>$md)));
				exit;
			}
		}while(false);
	elseif(isset($_POST['type']))
		do
		{
			$tags=(isset($_POST['tags']) and is_array($_POST['tags'])) ? $_POST['tags'] : array();
			if(!$tags)
			{
				$error=$Mainclass->lang['blogs']['nothing_select'];
				break;
			}
			if($_POST['type']=='or')
			{
				$query='`p`.`id` IN (SELECT `pid` FROM {"1"} WHERE `tid`'.$Mainclass->Db->In($tags).' GROUP BY `pid`) AND `p`.`status`=1';
				$type='or';
			}
			else
			{
				$query='`p`.`id` IN (SELECT `pid` FROM {"1"} WHERE `tid`'.$Mainclass->Db->In($tags).' GROUP BY `pid` HAVING COUNT(DISTINCT `tid`)='.count($tags).') AND `p`.`status`=1';
				$type='and';
			}
			$Mainclass->Db->FQuery('SELECT COUNT(`id`) FROM {"0"} `p` WHERE '.$query,array('blogs_posts','blogs_bt'),__file__,__line__);
			list($total)=$Mainclass->Db->Fetch_row();
			if($total==0)
			{
				$error=$Mainclass->lang['blogs']['nothing_found'];
				break;
			}
			$md=$Mainclass->Cache->SetSearchCache($total,$query,array('',$type));
			$Mainclass->Functions->AddVoting('search',$Mainclass->vars['m_blogs_search'].'s');
			return ExitPrefix(array(array('search'=>$md)));
		}while(false);
	$content=$Mainclass->Template->OpenTable();
	$title[]=$Mainclass->lang['blogs']['blogs'];
	$title[]=$Mainclass->lang['main']['search'];
	$Mainclass->Db->Query('SELECT `t`.`id`,`t`.`name`,COUNT(`b`.`tid`) `cnt` FROM `prefix_blogs_tags` `t` INNER JOIN `prefix_blogs_bt` `b` ON `b`.`tid`=`t`.`id` GROUP BY `t`.`id` ORDER BY `cnt` DESC LIMIT 50',__file__,__line__);
	$tags='';
	$ptags=(isset($_POST['tags']) and is_array($_POST['tags'])) ? $_POST['tags'] : array();
	while($arr=$Mainclass->Db->Fetch_assoc())
		$tags.=Template::Option($arr['name'],$arr['id'],in_array($arr['id'],$ptags));
	$blogs='';
	$Mainclass->Db->Query('SELECT `id`,`title` FROM `prefix_blogs` WHERE `posts`>0 ORDER BY `title` ASC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
		$blogs.=Template::Option($arr['title'],$arr['id']);
	$content.='<form action="" method="post">
		<table class="formeditor" cellspacing="0" width="100%">
		<tr class="infolabel"><td colspan="2"><h4>'.$Mainclass->lang['blogs']['search_tags'].'</h4></td></tr>
		<tr><td class="label">'.$Mainclass->lang['blogs']['select_tags'].'</td><td>'.Template::Items('tags',$tags,20).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['blogs']['search_type'].'</td><td>'.Template::Radio('type','or',true).$Mainclass->lang['blogs']['or'].'<br />'.Template::Radio('type','and').$Mainclass->lang['blogs']['and'].'</td></tr>
		<tr><td class="label"></td><td>'.Template::Button($Mainclass->lang['blogs']['find']).'</td></tr>
		</table>
		</form>
		<form action="" method="post">
		<table class="formeditor" cellspacing="0" width="100%">
		<tr class="infolabel"><td colspan="2"><h4>'.$Mainclass->lang['blogs']['search_words'].'</h4></td></tr>
		<tr><td class="label">'.$Mainclass->lang['blogs']['enter_part'].'</td><td>'.Template::Edit('search_word',isset($_POST['search_word']) ? $_POST['search_word'] : '').'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['blogs']['blogs'].':</td><td>'.Template::Items('posts',$blogs).'</td></tr>
		<tr><td class="label"></td><td>'.Template::Button($Mainclass->lang['blogs']['find']).'</td></tr>
		</table>
		</form>';
	$content.=$Mainclass->Template->CloseTable();
	if($error)
		$content.=$Mainclass->Template->Message($error);
	$Mainclass->Url->suffix=array();
	Head();
	echo MenuBlogs().$content;
}

function ResultBlogs($md)
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/rating.js';
	$jscripts[]='js/module_blogs.js';
	$arr=$Mainclass->Cache->GetSearchCache($md);
	if($arr===false)
		ExitPage(false);
	$title[]=$Mainclass->lang['blogs']['blogs'];
	$title[]=$Mainclass->lang['blogs']['search_results'];
	$jscripts[]='js/rating.js';
	extract($arr);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page==0)
		$page=1;
	$offset=abs(($page-1)*$Mainclass->vars['m_blogs_per_page']);
	$pages=Strings::Pages($total,$Mainclass->vars['m_blogs_per_page'],array(array('search'=>$md)));
	$Tpl=$Mainclass->Template->GetClass('Blogs');
	$sizes=array();
	$content='';
	switch($addon[1])
	{
		case 'word':
			$content.=$Tpl->SResultsHead($Mainclass->lang['blogs']['result_phrase'].'<b>'.$addon[0].'</b>');
		break;
		case 'and':
			$content.=$Tpl->SResultsHead($Mainclass->lang['blogs']['results_and']);
		break;
		case 'or':
			$content.=$Tpl->SResultsHead($Mainclass->lang['blogs']['results_or']);
		break;
	}
	$result=$Mainclass->Db->FQuery('SELECT `p`.`id`,`p`.`date`,`p`.`url`,`p`.`title`,`p`.`text`,`p`.`author`,`p`.`author_id`,`p`.`comments`,`p`.`reads`,`p`.`allow_comm`,`p`.`total`,`p`.`votes`,`p`.`editdate`,`b`.`id` `bid`,`b`.`url` `burl`,`b`.`title` `btitle`,`b`.`author_id` `baid`,`b`.`categs`,`c`.`id` `cid`,`c`.`url` `curl`,`c`.`title` `ctitle` FROM {"0"} `p` LEFT JOIN {"2"} `b` ON `b`.`id`=`p`.`bid` LEFT JOIN {"3"} `c` ON `c`.`id`=`p`.`cid` WHERE '.$query.' ORDER BY `p`.`date` DESC LIMIT '.$offset.', '.$Mainclass->vars['m_blogs_per_page'],array('blogs_posts','blogs_bt','blogs','blogs_categories'),__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc($result))
	{
		$sizes[$arr['id']]=array($arr['total'],$arr['votes']);
		$seppos=strpos($arr['text'],'[separator]');
		if($seppos!==false)
			$arr['text']=mb_substr($arr['text'],0,$seppos,ELEANOR_CHARSET);
		$arr['text']=Strings::ParseOwnBb($arr['text']);
		if($addon[1]=='word')
		{
			$arr['title']=Strings::MarkWords($addon[0],$arr['title']);
			$arr['text']=Strings::MarkWords($addon[0],$arr['text']);
			$Mainclass->Url->suffix=array(array('hl'=>$addon[0]));
		}
		$content.=$Tpl->PostInList($arr,$Mainclass->vars['m_blogs_rating'] ? '{rating_'.$arr['id'].'}' : '','search');
	}
	if($Mainclass->vars['m_blogs_rating'])
	{
		if(!$Mainclass->vars['m_blogs_vote_general'])
			$Mainclass->Functions->PrepareVoting(array_keys($sizes));
		foreach($sizes as $k=>$v)
		{
			$steps=(!$Mainclass->vars['m_blogs_vote_general'] and $Mainclass->Functions->CanVoting($k)) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
			$content=str_replace('{rating_'.$k.'}',$Mainclass->Functions->ShowRating($v[0],$v[1],$steps,array('id'=>$k)),$content);
		}
	}
	$content.=$pages ? $Mainclass->Template->OpenTable().$pages.$Mainclass->Template->CloseTable() : '';
	Head();
	echo MenuBlogs().$content;
}

function ShowPost($pid,$post,$bid,$blog)
{global $Mainclass,$title,$jscripts,$head_addon;
	if($pid)
	{
		$Mainclass->Db->Query('SELECT * FROM `prefix_blogs_posts` WHERE `id`='.$pid.' AND `status`=1 LIMIT 1',__file__,__line__);
		if(!$parr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`categs` FROM `prefix_blogs` WHERE `id`='.$parr['bid'].' AND `status`=1 LIMIT 1',__file__,__line__);
		if(!$barr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
	}
	elseif($post)
	{
		if($bid)
			$where='`id`='.(int)$bid;
		elseif($blog)
			$where='`url`=\''.$Mainclass->Db->EscapeString($blog).'\'';
		else
			return ExitPage(false);
		$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`categs` FROM `prefix_blogs` WHERE '.$where.' AND `status`=1 LIMIT 1',__file__,__line__);
		if(!$barr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
		$Mainclass->Db->Query('SELECT * FROM `prefix_blogs_posts` WHERE `bid`='.$barr['id'].' AND `url`=\''.$Mainclass->Db->EscapeString($post).'\' LIMIT 1',__file__,__line__);
		if(!$parr=$Mainclass->Db->Fetch_assoc())
			return ExitPrefix();
	}
	else
		return ExitPage(false);
	if($barr['categs'])
	{
		$Mainclass->Db->Query('SELECT `id`,`url`,`title` FROM `prefix_blogs_categories` WHERE `id`='.$parr['cid'].' LIMIT 1',__file__,__line__);
		$carr=$Mainclass->Db->Fetch_assoc();
	}
	else
		$carr=false;
	$jscripts[]='js/rating.js';
	$jscripts[]='js/bookmarks.js';
	$jscripts[]='js/module_blogs.js';
	if(!$Mainclass->Account->is_bot)
		$Mainclass->Db->Update('blogs_posts',array('!reads'=>'`reads`+1'),'`id`='.$parr['id'].' LIMIT 1',__file__,__line__);
	$title=$parr['title'];
	if($Mainclass->vars['m_blogs_rating'])
	{
		$Mainclass->Functions->PrepareVoting($parr['id']);
		$steps=$Mainclass->Functions->CanVoting($parr['id']) ? $Mainclass->vars['m_blogs_rating_steps'] : -1*$Mainclass->vars['m_blogs_rating_steps'];
		$rating=$Mainclass->Functions->ShowRating($parr['total'],$parr['votes'],$steps,array('id'=>$parr['id']));
	}
	else
		$rating='';
	$tags=array();
	$head_addon.=$Mainclass->Functions->RssLink(array('bid'=>$barr['id']),sprintf($Mainclass->lang['blogs']['posts_fb'],$barr['title'])).($carr ? $Mainclass->Functions->RssLink(array('cid'=>$carr['id']),sprintf($Mainclass->lang['blogs']['posts_fc'],$carr['title'])) : '');
	$Mainclass->Db->Query('SELECT `t`.`name` FROM `prefix_blogs_bt` `b` INNER JOIN `prefix_blogs_tags` `t` ON `b`.`tid`=`t`.`id` WHERE `b`.`pid`='.$parr['id'].' ORDER BY `t`.`name`',__file__,__line__);
	while(list($tag)=$Mainclass->Db->Fetch_row())
		$tags[]='<a href="'.$Mainclass->Url->ConstructUrl(array(array('tag'=>$tag))).'">'.$tag.'</a>';
	if(strpos($parr['text'],'[separator]')!==false)
		$parr['text']=$parr['show_sokr'] ? str_replace('[separator]','<a name="more"></a>',$parr['text']) : substr_replace($parr['text'],'',0,$seppos+11);
	$prefix=$Mainclass->Url->Prefix(false,false);
	if($Mainclass->Url->furl)
	{
		$url=$Mainclass->Url->ConstructUrl(array(array($parr['url'] ? $barr['url'] : '',true),array(($parr['url'] and $carr) ? $carr['url'] : '',true),array($parr['url'],'pid'=>$parr['id'])),true,false).$Mainclass->Url->GetDel();
		$Mainclass->Url->SetPrefix($url);
		$Mainclass->Url->ending=$Mainclass->vars['m_blogs_ending'];
	}
	else
		$Mainclass->Url->SetPrefix(array('pid'=>$parr['id']),true);
	$parr['text']=Strings::ParseOwnBB($parr['text']);
	$comments='';
	if($parr['allow_comm']!=0)
	{
		$Mainclass->LoadClass('classes/others/class_comments.php');
		$Mainclass->Comments->new_status=$parr['allow_comm'];
		$comments=$Mainclass->Comments->Show($parr['id']);
	}
	$Mainclass->Url->SetPrefix($prefix);
	if(isset($_GET['hl']) and is_string($_GET['hl']) and preg_match('#^['.Strings::ALL.' ]+$#',$_GET['hl'])>0)
	{
		$parr['title']=Strings::MarkWords($_GET['hl'],$parr['title']);
		$parr['text']=Strings::MarkWords($_GET['hl'],$parr['text']);
	}
	if(!empty($Mainclass->vars['allow_bookmarks']) and $Mainclass->Login->IsUser())
	{
		$uid=(int)$Mainclass->Account->GetValue('id');
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_bookmarks` WHERE `uid`='.$uid.' AND `mid`='.$Mainclass->GetModVal('id').' AND `value`='.$parr['id'].' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			$bookmark='<a href="#" onclick="return ShowAddBookMarkForm('.$parr['id'].')">'.$Mainclass->lang['blogs']['add_to_b'].'</a>';
		else
		{
			list($bookmark)=$Mainclass->Db->Fetch_row();
			$bookmark='<a href="#" onclick="return DeleteBookMark('.$bookmark.',\'\',\'$(\\\'#bookmark\\\').html(bookmark_add)\')">'.$Mainclass->lang['blogs']['del_fr_b'].'</a>';
		}
		$bookmark.=Strings::JsVars(array(
											'module_id'=>$Mainclass->GetModVal('id'),
											'bookmark_add'=>'<a href="#" onclick="return ShowAddBookMarkForm('.$parr['id'].')">'.$Mainclass->lang['blogs']['add_to_b'].'</a>',
											'bookmark_delete'=>'<a href="#" onclick="return DeleteBookMark({value},\'\',\'$(\\\'#bookmark\\\').html(bookmark_add)\')">'.$Mainclass->lang['blogs']['del_fr_b'].'</a>',
		));
	}
	else
		$bookmark=false;
	$Mainclass->SetModVal('description',Strings::CutStr(str_replace("\r\n",'',strip_tags($parr['text'])),250,''));
	$Mainclass->SetModVal('keywords',Strings::MakeKeywords($parr['text']));
	$content=$Mainclass->Template->GetClass('Blogs')->ShowPost($parr,$barr,$carr,$tags,$rating,$bookmark);
	Head();
	echo MenuBlogs().$content.$comments;
}

function CleanCache()
{global $Mainclass;
	$Mainclass->Cache->CleanCacheByTag('blogs_mainpage');
}
?>