<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'mp','lang_admin-%');
$Mainclass->navigation=array(
								array($Mainclass->Url->Prefix(false),$Mainclass->lang['mp']['m_list']),
								array($Mainclass->Url->ConstructUrl(array('do'=>'add')),((isset($_GET['do']) and $_GET['do']=='add') ? '!' : '').$Mainclass->lang['mp']['add_module']),
								array($Mainclass->Url->ConstructUrl(array('do'=>'resort')),$Mainclass->lang['main']['resort']),
);
global $mainpage;
$mainpage=false;
if(isset($_GET['do']))
	DoIt($_GET['do']);
elseif(isset($_GET['edit']))
	AddEditModule((int)$_GET['edit']);
elseif(isset($_GET['save']))
	SaveModule($_GET['save']=='new' ? true : (int)$_GET['save']);
elseif(isset($_GET['delete']))
	DeleteModule((int)$_GET['delete']);
elseif(isset($_GET['up']))
	MoveModuleUp((int)$_GET['up']);
elseif(isset($_GET['down']))
	MoveModuleDown((int)$_GET['down']);
else
{
	ShowModules();
	$mainpage=true;
}

if($mainpage and isset($Mainclass->navigation[0]))
	$Mainclass->navigation[0][1]='!'.$Mainclass->navigation[0][1];

function DoIt($task)
{global $mainpage;
	switch (strtolower($task))
	{
		case 'add':
			AddEditModule(true);
		break;
		case 'resort':
			Resort(true);
		break;
		default:
			ShowModules();
			$mainpage=true;
		break;
	}
}

function ShowModules()
{global $Mainclass,$title;
	$title=$Mainclass->lang['mp']['mpo'];
	$content='';
	$n=0;
	$uses_groups=array();
	$Mainclass->Db->Query('SELECT `g`.`id`,`g`.`pos`,`m`.`name`,`m`.`title`,`m`.`descr`,`m`.`path`,`m`.`image`,`m`.`active`,`m`.`user_groups` FROM `prefix_mainpage` `g` INNER JOIN `prefix_modules` `m` ON `g`.`mid`=`m`.`id` ORDER BY `g`.`pos` ASC',__file__,__line__);
	$nums=$Mainclass->Db->Num_rows()-1;
	while($arr=$Mainclass->Db->Fetch_assoc())
	{
		$arr['title']=$arr['title'].' ('.$arr['name'].')';
		$arr['path']=$Mainclass->CheckSlash($arr['path']);
		$position=(int)$arr['pos'];
		$buttons=($position>0 ? '<a href="'.$Mainclass->Url->ConstructUrl(array('up'=>$arr['id'])).'" title="'.$Mainclass->lang['mp']['up'].'"><img src="'.$Mainclass->Template->GetImage('up.png').'" alt="'.$Mainclass->lang['mp']['up'].'" style="margin: 0 1px;" /></a>' : '')
				.($position<$nums ? '<a href="'.$Mainclass->Url->ConstructUrl(array('down'=>$arr['id'])).'" title="'.$Mainclass->lang['mp']['down'].'"><img src="'.$Mainclass->Template->GetImage('down.png').'" alt="'.$Mainclass->lang['mp']['down'].'" style="margin: 0 1px;" /></a>' : '');
		$arr['user_groups']=Strings::CleanForExplode($arr['user_groups']);
		if($arr['user_groups'])
		{
			$user_groups=explode(',',$arr['user_groups']);
			$uses_groups=array_merge($uses_groups,$user_groups);
			foreach($user_groups as $k=>&$v)
				$user_groups[$k]='gr_'.$v.'_';
		}
		$arr['image']=$Mainclass->Template->GetImage('modules/'.str_replace('%','small',$arr['image']));
		if(!$arr['image'])
			$arr['image']=$Mainclass->Template->GetImage('modules/default-small.png');
		$content.='<tr align="center" class="'.($nums==$n ? 'last ' : '').($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td><img src="'.$arr['image'].'" alt="" /></td><td><a href="'.($edit=$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id']))).'" title="'.$arr['descr'].'">'.$arr['title'].'</a></td><td>'.($arr['user_groups'] ? implode(', ',$user_groups) : '<i>'.$Mainclass->lang['main']['all'].'</i>').'</td><td>'.($arr['active']==1 ? $Mainclass->lang['mp']['yes'] : $Mainclass->lang['mp']['no']).'</td><td class="function">'.$buttons.'<a href="'.$edit.'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a></td></tr>';
	}
	$uses_groups=array_unique($uses_groups);
	if(count($uses_groups)>0)
	{
		$Mainclass->Db->Query('SELECT `id`,`title`,`html_pref`,`html_end` FROM `prefix_groups` WHERE `id`'.$Mainclass->Db->In($uses_groups),__file__,__line__);
		while($temp=$Mainclass->Db->Fetch_assoc())
			$content=str_replace('gr_'.$temp['id'],$temp['html_pref'].$temp['title'].$temp['html_end'],$content);
	}
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($title).$Mainclass->Template->OpenTable().'<table class="tabstyle"><tr class="first tablethhead"><th colspan="2">'.$Mainclass->lang['main']['name'].'</th><th>'.$Mainclass->lang['mp']['groups'].'</th><th>'.$Mainclass->lang['main']['active'].'</th><th width="80">'.$Mainclass->lang['main']['functs'].'</th></tr>'
		.$content
		.'</table>'.$Mainclass->Template->CloseTable();
}

function AddEditModule($id,$error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	if($id===true)
	{
		$title=$Mainclass->lang['mp']['m_add'];
		$id='new';
		$module=$pos='';
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT `mid`,`pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPrefix();
			list($module,$pos)=$Mainclass->Db->Fetch_row();
		}
		$title=$Mainclass->lang['mp']['m_edit'];
	}
	if($error)
	{
		$module=isset($_POST['mid']) ? (int)$_POST['mid'] : 0;
		$pos=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
	}
	$Mainclass->ShowDecoration();
	$Mainclass->Db->Query('SELECT `id`,`title`,`name` FROM `prefix_modules` WHERE `active`>0 AND `services` LIKE \'%,2,%\' AND `id` NOT IN (SELECT `mid` FROM `prefix_mainpage`'.(is_int($id) ? ' WHERE `id`!='.$id : '').') AND `id`!=\''.$Mainclass->GetModVal('id').'\' ORDER BY `title` ASC',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0 and !is_int($id))
	{
		echo $Mainclass->Template->Message($Mainclass->lang['mp']['no_modules']);
		return;
	}
	$modules='';
	while($arr=$Mainclass->Db->Fetch_assoc())
		$modules.=Template::Option($arr['title'].' ('.$arr['name'].')',$arr['id'],$arr['id']==$module);
	echo $Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '')
		.$Mainclass->Template->OpenTable()
		.'<form action="'.$Mainclass->Url->ConstructUrl(array('save'=>$id)).'" method="post"><table class="tabstyle tabform"><tr><td class="label">'.$Mainclass->lang['mp']['module'].'</td><td>'.Template::Select('mid',$modules).'</td></tr><tr><td class="label">'.$Mainclass->lang['mp']['pos'].'</td><td>'.Template::Edit('pos',$pos).'</td></tr></table><div class="submitline">'.Template::Button().'</div></form>'.$Mainclass->Template->CloseTable();

}

function SaveModule($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditModule($id);
	if(!CheckKey())
		return ExitPrefix();
	$arr=array(
				'mid'=>isset($_POST['mid']) ? (int)$_POST['mid'] : 0,
	);
	if(is_int($id))
	{
		$arr['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		$Mainclass->Db->Query('SELECT `pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($position)=$Mainclass->Db->Fetch_row();
		if($position!=$arr['pos'])
		{
			$Mainclass->Db->Update('mainpage',array('!pos'=>'`pos`-1'),'`pos`>'.$position,__file__,__line__);
			$Mainclass->Db->Update('mainpage',array('!pos'=>'`pos`+1'),'`pos`>='.$arr['pos'],__file__,__line__);
		}
		$Mainclass->Db->Update('mainpage',$arr,'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	else
	{
		$arr['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		if($_POST['pos']=='')
		{
			$Mainclass->Db->Query('SELECT MAX(`pos`) FROM `prefix_mainpage`',__file__,__line__);
			list($position)=$Mainclass->Db->Fetch_row();
			$arr['pos']=$position===null ? 0 : $position+1;
		}
		else
			$Mainclass->Db->Update('mainpage',array('!pos'=>'`pos`+1'),'`pos`>='.(int)$arr['pos'],__file__,__line__);
		$Mainclass->Db->Insert('mainpage',$arr,__file__,__line__);
	}
	ExitPrefix();
}

function DeleteModule($id)
{global $Mainclass, $title;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()>0)
	{
		list($position)=$Mainclass->Db->Fetch_row();
		$Mainclass->Db->Update('mainpage',array('!pos'=>'`pos`-1'),'`pos`>'.$position.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Delete('mainpage','`id`='.$id,__file__,__line__);
	}
	ExitPrefix();
}

function MoveModuleUp($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($posit)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_mainpage` WHERE `pos`=(SELECT MAX(`pos`) FROM `prefix_mainpage` WHERE `pos`<'.$posit.')',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if($cnt>0)
	{
		if($cnt>1)
		{
			Resort(false);
			$Mainclass->Db->Query('SELECT `pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$Mainclass->Db->Fetch_row();
		}
		$posit--;
		$Mainclass->Db->Update('mainpage', array('!pos'=>'`pos`+1'),'`pos`='.$posit.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Update('mainpage', array('!pos'=>'`pos`-1'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	ExitPrefix();
}

function MoveModuleDown($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($posit)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_mainpage` WHERE `pos`=(SELECT MIN(`pos`) FROM `prefix_mainpage` WHERE `pos`>'.$posit.')',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if($cnt>0)
	{
		if($cnt>1)
		{
			Resort(false);
			$Mainclass->Db->Query('SELECT `pos` FROM `prefix_mainpage` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$Mainclass->Db->Fetch_row();
		}
		$posit++;
		$Mainclass->Db->Update('mainpage', array('!pos'=>'`pos`-1'),'`pos`='.$posit.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Update('mainpage', array('!pos'=>'`pos`+1'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	}
	ExitPrefix();
}

function Resort($redirect=true)
{global $Mainclass;
	$Mainclass->Db->Query('DELETE FROM `prefix_mainpage` WHERE `mid` NOT IN (SELECT `id` FROM `prefix_modules`)',__file__,__line__);
	$result=$Mainclass->Db->Query('SELECT `id` FROM `prefix_mainpage` ORDER BY `pos`',__file__,__line__);
	$cnt=0;
	while($arr=$Mainclass->Db->Fetch_row($result))
		$Mainclass->Db->Update('mainpage',array('pos'=>$cnt++),'`id`='.$arr[0].' LIMIT 1',__file__,__line__);
	if($redirect)
		ExitPrefix();
}
?>