<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'static','lang_admin-%');
$Mainclass->LoadOptions('module_static',false);
$Mainclass->navigation=array(
								array($Mainclass->Url->Prefix(false),$Mainclass->lang['static']['static_list']),
								array($Mainclass->Url->ConstructUrl(array('do'=>'add')),((isset($_GET['do']) and $_GET['do']=='add') ? '!' : '').$Mainclass->lang['static']['add_page']),
								array($Mainclass->Url->ConstructUrl(array('do'=>'options')),((isset($_GET['do']) and $_GET['do']=='options' and !isset($_GET['event'])) ? '!' : '').$Mainclass->lang['main']['options']),
								array($Mainclass->Url->ConstructUrl(array('do'=>'resort')),$Mainclass->lang['main']['resort']),
);
global $mainpage;
$mainpage=false;
if(isset($_GET['do']))
	DoIt($_GET['do']);
elseif(isset($_GET['edit']))
	AddEditStatic((int)$_GET['edit']);
elseif(isset($_GET['save']))
	SaveStatic($_GET['save']=='new' ? true : (int)$_GET['save']);
elseif(isset($_GET['delete']))
	DeleteStatic((int)$_GET['delete']);
elseif(isset($_GET['swap']))
	Swap((int)$_GET['swap']);
elseif(isset($_GET['moveup']))
	MoveUp((int)$_GET['moveup']);
elseif(isset($_GET['movedown']))
	MoveDown((int)$_GET['movedown']);
else
{
	Statics();
	$mainpage=true;
}

if($mainpage and isset($Mainclass->navigation[0]))
	$Mainclass->navigation[0][1]='!'.$Mainclass->navigation[0][1];

function DoIt($task)
{global $mainpage;
	switch ($task)
	{
		case 'add':
			AddEditStatic(true);
		break;
		case 'options':
			StaticOptions();
		break;
		case 'resort':
			Resort();
		break;
		default:
			Statics();
			$mainpage=true;
		break;
	}
}

function StaticOptions()
{global $Mainclass,$title,$jscripts;
	$Mainclass->Url->SetPrefix(array(array('do'=>'options')),true);
	$Mainclass->LoadClass('classes/others/class_settings.php');
	$content=$Mainclass->Settings->ShowGroup('module_static',false);
	$title=$Mainclass->Settings->title;
	$jscripts=array_merge($jscripts,$Mainclass->Settings->jscripts);
	$Mainclass->navigation=array_merge($Mainclass->navigation,$Mainclass->Settings->navigation);
	$Mainclass->ShowDecoration();
	echo $content;
}

function Statics()
{global $Mainclass,$title;
	$title=$Mainclass->lang['static']['static_list'];
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$per_page=30;
	$offset=($page-1)*$per_page;
	$n=0;
	$where=$fititle='';
	$pages_arr=array();
	if(!empty($_REQUEST['filter']))
	{
		$pages_arr['filter']=1;
		if(!empty($_REQUEST['fititle']))
		{
			$pages_arr['fititle']=$fititle=$_REQUEST['fititle'];
			$where=' AND `title` LIKE \'%'.$Mainclass->Db->EscapeString($fititle).'%\'';
		}
	}
	if(count($pages_arr)<=1)
		unset($pages_arr['filter']);
	$content=$Mainclass->Template->Title($title)
	.$Mainclass->Template->OpenTable()
	.'<form action="" method="post"><table class="filtertable"><tr><td><b>'.$Mainclass->lang['main']['filter'].':</b> '.Template::Edit('fititle',$fititle).' '.Template::Button($Mainclass->lang['main']['apply'],'submit').Template::Control('filter','hidden',1).'</td></tr></table></form>
	<table class="tabstyle">
	<tr class="tablethhead"><th width="15">'.$Mainclass->lang['main']['id'].'</th><th>'.$Mainclass->lang['main']['title'].'</th><th width="180">'.$Mainclass->lang['main']['url'].'</th><th width="180">'.$Mainclass->lang['static']['link'].'</th><th width="80">'.$Mainclass->lang['main']['functs'].'</th></tr>';
	$Mainclass->Db->Query('SELECT `id`,`url`,`title`,`pos`,`status`,`parent` FROM `prefix_static` LEFT JOIN `prefix_static_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\')'.$where.' ORDER BY `parent` DESC, `pos` DESC'.(isset($pages_arr['filter']) ? ' LIMIT '.$offset.', '.$per_page : ''),__file__,__line__);
	$max_pos=$Mainclass->Db->Num_rows()-1;
	$n=0;
	if($max_pos==-1)
	{
		$content.='<tr><td colspan="5" align="center"><b>'.$Mainclass->lang['static']['static_not_found'].'</b></td></tr>';
		$pages=0;
	}
	elseif(isset($pages_arr['filter']))
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			$status=$arr['status']
				? '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['deactivate'].'"><img src="'.$Mainclass->Template->GetImage('active.png').'" alt="'.$Mainclass->lang['main']['deactivate'].'" style="margin: 0 1px;" /></a>'
				: '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['activate'].'"><img src="'.$Mainclass->Template->GetImage('inactive.png').'" alt="'.$Mainclass->lang['main']['activate'].'" style="margin: 0 1px;" /></a>';
			$content.='<tr class="'.($n % 2 ? 'tabletrline2' : 'tabletrline1').'">
			<td align="center">'.$arr['id'].'</td>
			<td><a href="'.($edit=$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id']))).'">'.$arr['title'].'</a></td>
			<td align="center">'.$arr['url'].'</td>
			<td align="center">'.Template::Edit('temp',$Mainclass->Url->ConstructUrl(array('module'=>$Mainclass->GetModVal('name'),'doc'=>$arr['url']),false,true,$Mainclass->vars['furl']),'style="width:100%;cursor:pointer" onclick="this.select()" readonly="readonly"','').'</td>
			<td class="function">'.$status.'<a href="'.$edit.'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'"  /></a></td>
			</tr>';
			$n++;
		}
	else
	{
		$last=true;
		$arr=$values=$tosort=array();
		while($temp=$Mainclass->Db->Fetch_assoc())
		{
			$values[$temp['id']]=$temp;
			if($temp['parent']==0)
			{
				if($last)
				{
					$values[$temp['id']]+=array('last'=>true);
					$last=false;
				}
				$tosort[$temp['id']]=$temp['pos'];
			}
			else
				$arr[]=array('id'=>$temp['id'],'parent'=>$temp['parent']);
		}
		asort($tosort,SORT_NUMERIC);
		$keys=array_keys($tosort);
		unset($tosort);
		$len=0;
		$last=array();
		while(count($arr)!=$len)
		{
			$len=count($arr);
			foreach ($arr as $k=>$v)
				if(false!==$id=array_search($v['parent'],$keys))
				{
					$values[$v['id']]['title']=$values[$v['parent']]['title'].' / '.$values[$v['id']]['title'];
					if(!in_array($v['parent'],$last))
					{
						$values[$v['id']]['last']=true;
						$last[]=$v['parent'];
					}
					array_splice($keys,$id+1,0,array((int)$v['id']));
					unset($arr[$k]);
				}
		}
		$pages=count($keys);
		$keys=array_slice($keys,$offset,$per_page);
		foreach($keys as &$v)
		{
			$status=$values[$v]['status']
				? '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$values[$v]['id'])).'" title="'.$Mainclass->lang['main']['deactivate'].'"><img src="'.$Mainclass->Template->GetImage('active.png').'" alt="'.$Mainclass->lang['main']['deactivate'].'" /></a>'
				: '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$values[$v]['id'])).'" title="'.$Mainclass->lang['main']['activate'].'"><img src="'.$Mainclass->Template->GetImage('inactive.png').'" alt="'.$Mainclass->lang['main']['activate'].'" /></a>';
			$updown=((int)$values[$v]['pos']>0 ? '<a href="'.$Mainclass->Url->ConstructUrl(array('MoveUp'=>$values[$v]['id'])).'" title="'.$Mainclass->lang['static']['up'].'"><img src="'.$Mainclass->Template->GetImage('up.png').'" alt="'.$Mainclass->lang['static']['up'].'" /></a>' : '')
					.(empty($values[$v]['last']) ? '<a href="'.$Mainclass->Url->ConstructUrl(array('MoveDown'=>$values[$v]['id'])).'" title="'.$Mainclass->lang['static']['down'].'"><img src="'.$Mainclass->Template->GetImage('down.png').'" alt="'.$Mainclass->lang['static']['down'].'" /></a>' : '');
			$content.='<tr class="'.($n++ % 2 ? 'tabletrline2' : 'tabletrline1').'">
			<td>'.$values[$v]['id'].'</td>
			<td><a href="'.($edit=$Mainclass->Url->ConstructUrl(array('edit'=>$values[$v]['id']))).'">'.$values[$v]['title'].'</a></td>
			<td align="center">'.$values[$v]['url'].'</td>
			<td>'.Template::Edit('temp',$Mainclass->Url->ConstructUrl(array('module'=>$Mainclass->GetModVal('name'),'doc'=>$values[$v]['url']),false,true,$Mainclass->vars['furl']),'style="width:100%;cursor:pointer" onclick="this.select()" readonly="readonly"','').'</td>
			<td class="fuction">'.$updown.$status.'<a href="'.$edit.'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$values[$v]['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a></td>
			</tr>';
		}
	}
	$content.='</table>'.$Mainclass->Template->CloseTable();
	$Mainclass->Db->Query('SELECT COUNT(DISTINCT `id`) FROM `prefix_static` LEFT JOIN `prefix_static_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\')'.$where,__file__,__line__);
	$temp=$Mainclass->Db->Fetch_row();
	$Mainclass->ShowDecoration(false);
	echo $content.Strings::Pages($temp[0],$per_page);
}

function Swap($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Update('static',array('!status'=>'NOT `status`'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	$Mainclass->Cache->CleanCacheByTag('static');
	ExitBack();
}

function AddEditStatic($id,$error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/tabcontent.js';
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->Loadclass('classes/others/class_uploader.php');
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$values=array();
	$multilang=array_combine(array_keys($Mainclass->langs),array_fill(0,count($Mainclass->langs),array('title'=>'','text'=>'')));
	if($id===true)
	{
		$title=$Mainclass->lang['static']['adding_page'];
		$values['id']='new';
		$values['pos']=$values['parent']=$values['url']='';
		$values['show_title']=false;
		$values['status']=true;
		$values['one_lang']=empty($Mainclass->vars['multilang']);
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT * FROM `prefix_static` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPrefix();
			$values=$Mainclass->Db->Fetch_assoc();
			$values['one_lang']=false;
			$Mainclass->Db->Query('SELECT `language`,`title`,`text` FROM `prefix_static_l` WHERE `id`='.$id,__file__,__line__);
			while($temp=$Mainclass->Db->Fetch_assoc())
				if(isset($multilang[$temp['language']]))
				{
					$multilang[$temp['language']]['title']=$temp['title'];
					$multilang[$temp['language']]['text']=$temp['text'];
				}
				elseif(!$temp['language'])
				{
					$multilang[$Mainclass->lang_name]['title']=$temp['title'];
					$multilang[$Mainclass->lang_name]['text']=$temp['text'];
					$values['one_lang']=true;
					break;
				}
			$values['id']=(int)$values['id'];
		}
		else
			$values['id']=(int)$id;
		$title=$Mainclass->lang['static']['editing_page'];
	}
	if($error)
	{
		$values['title']=isset($_POST['title']) ? $_POST['title'] : '';
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['show_title']=isset($_POST['show_title']);
		$values['one_lang']=isset($_POST['one_lang']);
		$values['status']=isset($_POST['status']);
		$values['parent']=isset($_POST['parent']) ? (int)$_POST['parent'] : 0;
		$values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		foreach($multilang as $k=>$v)
			if($Mainclass->lang_name==$k)
			{
				if(isset($_POST['title']))
					$multilang[$k]['title']=$_POST['title'];
				if(isset($_POST['text']))
					$multilang[$k]['text']=$Mainclass->Editor->GetHTML('text');
			}
			else
			{
				if(isset($_POST['title_'.$k]))
					$multilang[$k]['title']=$_POST['title_'.$k];
				if(isset($_POST['text_'.$k]))
					$multilang[$k]['text']=$Mainclass->Editor->GetHTML('text_'.$k);
			}
	}
	$parents=Template::Option($Mainclass->lang['main']['no'],0);
	$nested=$arr=$titles=$poses=array();
	$Mainclass->Db->Query('SELECT `id`,`title`,`parent`,`pos`,`status` FROM `prefix_static` INNER JOIN `prefix_static_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\')'.($id===true ? '' : ' AND `id`!='.$id).' ORDER BY `pos` DESC',__file__,__line__);
	while($temp=$Mainclass->Db->Fetch_assoc())
	{
		if($temp['parent']==0)
		{
			$poses[$temp['id']]=$temp['pos'];
			$titles[$temp['id']]=$temp['title'];
			$nested[$temp['id']]=0;
		}
		else
			$arr[]=$temp;
	}
	asort($poses,SORT_NUMERIC);
	$keys=array_keys($poses);
	unset($poses);
	$len=0;
	while(count($arr)!=$len)
	{
		$len=count($arr);
		foreach($arr as $k=>$v)
			if(false!==$id=array_search($v['parent'],$keys))
			{
				$nested[$v['id']]=$nested[$v['parent']]+1;
				$titles[$v['id']]=str_repeat('&nbsp;&nbsp;&nbsp;',$nested[$v['id']]).'›&nbsp;'.$v['title'];
				array_splice($keys,$id+1,0,array((int)$v['id']));
				unset($arr[$k]);
			}
	}
	foreach($keys as &$v)
		$parents.=Template::Option($titles[$v],$v,$v==$values['parent']);
	$Mainclass->Editor->bb_addon.='<a class="bbe_next" href="#" title="'.$Mainclass->lang['static']['next_page'].'" onclick="{k}.SetSelectedText(\'[next page]\'); return false;"><img src="images/spacer.png" alt="'.$Mainclass->lang['static']['next_page'].'" /></a>';
	$multil_text=$multil_check='';
	$text=$Mainclass->Editor->Area('text',$multilang[$Mainclass->lang_name]['text'],30);
	if($Mainclass->vars['multilang'])
	{
		$multil_check=array();
		$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
		foreach($multilang as $k=>$v)
		{
			$lang_title=ucfirst($k).' / '.ucfirst($Mainclass->langs[$k]);
			$multil_check[]=Template::Check('lang[]',$visible=!(empty($v['title']) and empty($v['text']) and is_int($id)),'value="'.$k.'"').' '.$lang_title;
			if($k==$Mainclass->lang_name)
				continue;
			$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').slideToggle(\'slow\');return false" class="ol_heading">
			'.(file_exists($Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
			<div id="table_'.$k.'">
				<table class="tabstyle tabform">
				<tr><td class="label">'.$Mainclass->lang['main']['title'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
				<tr><td class="label">'.$Mainclass->lang['static']['text'].'</td><td>'.$Mainclass->Editor->Area('text_'.$k,$v['text'],5).'</td></tr>
				</table>
			</div>
			</li>';
		}
		$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
		$multil_check='<tr><td class="label">'.$Mainclass->lang['main']['set_for_langs'].'</td><td>'
		.Template::Check('one_lang',$values['one_lang'])
		.' <b>'.$Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
		.join('<br />',$multil_check).'</div></td></tr>';
	}
	$content=$Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '')
	.$Mainclass->Template->OpenTable()
	.'<form action="'.$Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post"><table class="tabstyle tabform">
	<tr><td class="label">'.$Mainclass->lang['main']['title'].':<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$Mainclass->lang_name]['title']).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['main']['url_l'].'</td><td>'.Template::Edit('url',$values['url']).'</td></tr></table>
	<ul id="blockstabs" class="linetabs">
	<li><a href="#" rel="tab1" class="selected"><b>'.$Mainclass->lang['main']['general'].'</b></a></li>
	'.($Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2"><b>'.$Mainclass->lang['main']['other_langs'].'</b></a></li>' : '').'
	</ul>
	<div id="tab1" class="tabcontent">
		<table class="tabstyle tabform">
		<tr><td class="label">'.$Mainclass->lang['static']['parent'].'</td><td>'.Template::Select('parent',$parents).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['static']['pos'].'</td><td>'.Template::Edit('pos',$values['pos']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['static']['text'].'</td><td>'.$text.'</td></tr>
		<tr><td colspan="2">'.$Mainclass->Uploader->Show($id===true ? 'temp_static' : 'static'.'/'.$id,$id===true).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['static']['show_title'].'<span class="imp">*</span></td><td>'.Template::Check('show_title',$values['show_title']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['main']['status'].'</td><td>'.Template::Check('status',$values['status']).'</td></tr>
		'.$multil_check.'
		</table>
	</div>'.$multil_text;
	$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	if($ref)
		$content.=Template::Control('back','hidden',base64_encode($ref));
	$content.='<div class="submitline">'.Template::Button().' '.(is_int($id) ? Template::Button($Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$Mainclass->Url->ConstructUrl(array('delete'=>$id)).'\'"') : '').'</div>
</form>
<script type="text/javascript">
var countries=new ddtabcontent("blockstabs");
countries.setpersist(true);
countries.setselectedClassTarget("link");
countries.init();
</script>'.$Mainclass->Template->CloseTable();
	$Mainclass->ShowDecoration();
	echo $content;
}

function SaveStatic($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditStatic($id);
	if(!CheckKey())
		return ExitPrefix();
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=isset($_POST['title']) ? $Mainclass->Url->UrlString($_POST['title']) : '';
	if(!$title)
		return AddEditStatic($id,$Mainclass->lang['static']['empty_title']);
	if(!$url)
		return AddEditStatic($id,$Mainclass->lang['static']['empty_url']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and,array('static','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$Mainclass->Loadclass('classes/others/class_editor.php');
	if($Mainclass->vars['multilang'] and !isset($_POST['one_lang']))
	{
		$langs=(empty($_POST['lang']) or !is_array($_POST['lang'])) ? array() : $_POST['lang'];
		$langs=array_intersect(array_keys($Mainclass->langs),$langs);
		if(!$langs)
			$langs=array($Mainclass->lang_name);
	}
	else
		$langs=array('');
	$arr_values=array(
						'url'=>$url,
						'show_title'=>isset($_POST['show_title']),
						'parent'=>isset($_POST['parent']) ? (int)$_POST['parent'] : 0,
						'pos'=>'',
						'status'=>isset($_POST['status']),
	);
	$Mainclass->Db->Transaction('BEGIN');
	if(is_int($id))
	{
		$arr_values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		$Mainclass->Db->Query('SELECT `l`,`r`,`pos`,`parent` FROM `prefix_static` WHERE `id`='.$id,__file__,__line__);
		list($l,$r,$old_pos,$parent)=$Mainclass->Db->Fetch_row();
		if($old_pos!=$arr_values['pos'])
		{
			$Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_static` WHERE `pos`='.$arr_values['pos'].' AND `parent`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
			if($old=$Mainclass->Db->Fetch_assoc())
			{
				#Смещение категории, на место которой мы ставим текущую
				$offset_a=$old['r']-$old['l']+1;
				#Смещение текущей категории на новое место
				$offset_b=$r-$l+1;
				if($r>$old['r'])
				{
					$Mainclass->Db->Update('static',array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
					$Mainclass->Db->Update('static',array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
				}
				else
				{
					$Mainclass->Db->Update('static',array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
					$Mainclass->Db->Update('static',array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
				}
				$Mainclass->Db->Update('static',array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
			}
			$Mainclass->Db->Update('static',array('!pos'=>'`pos`-1'),'`parent`='.$parent.' AND `pos`>'.$old_pos,__file__,__line__);
			$Mainclass->Db->Update('static',array('!pos'=>'`pos`+1'),'`parent`='.$parent.' AND `pos`>='.$arr_values['pos'],__file__,__line__);
		}
		if($parent!=$arr_values['parent'])
		{
			$r=(int)$r;
			$l=(int)$l;
			$Mainclass->Db->Query('SELECT `r` FROM `prefix_static` WHERE `id`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
			{
				#$rp=0;
				$Mainclass->Db->Query('SELECT MAX(`r`)+1 FROM `prefix_static` WHERE `parent`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
				list($rp)=$Mainclass->Db->Fetch_row();
			}
			else
				list($rp)=$Mainclass->Db->Fetch_row();
			if($rp>$l and $rp<$r)
				$arr_values['parent']=$parent;
			else
			{
				$rp=(int)$rp;
				$cnt=$r-$l+1;
				$Mainclass->Db->Update('static',array('!l'=>'-1*`l`','!r'=>'-1*`r`'),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
				$Mainclass->Db->Update('static',array('!r'=>'`r`-'.$cnt),'`r`>'.$r,__file__,__line__);
				$Mainclass->Db->Update('static',array('!l'=>'`l`-'.$cnt),'`l`>'.$r,__file__,__line__);
				if($rp>$r)
					$rp-=$cnt;
				$Mainclass->Db->Update('static',array('!r'=>'`r`+'.$cnt),'`r`>='.$rp,__file__,__line__);
				$Mainclass->Db->Update('static',array('!l'=>'`l`+'.$cnt),'`l`>'.$rp,__file__,__line__);
				if($rp==0)
					$rp=1;
				$Mainclass->Db->Update('static',array('!l'=>'`l`*-1-'.$l.'+'.$rp,'!r'=>'`r`*-1-'.$l.'+'.$rp),'`l`<0',__file__,__line__);
				unset($arr_values['l'],$arr_values['r']);
			}
		}

		$files=glob($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/static/'.$id.'/*');
		if(!$files and is_dir($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/static/'.$id))
			Functions::RmDir($Mainclass->root_path.Mainclass::UPLOADS_DIR.'/static/'.$id);
		$Mainclass->Db->Update('static',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Delete('static_l','`id`='.$id.' AND `language`'.$Mainclass->Db->In($langs,true),__file__,__line__);
		foreach($langs as &$v)
		{
			if(!$v or $Mainclass->lang_name==$v)
				$values=array(
								'title'=>$title,
								'text'=>$Mainclass->Editor->GetHTML('text'),
				);
			else
				$values=array(
								'title'=>$_POST['title_'.$v],
								'text'=>$Mainclass->Editor->GetHTML('text_'.$v),
				);
			$cnt=$Mainclass->Db->Update('static_l',$values,'`id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
			if($cnt==0)
			{
				$Mainclass->Db->Query('SELECT `id` FROM `prefix_static_l` WHERE `id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
				if($Mainclass->Db->Num_rows()==0)
					$Mainclass->Db->Insert('static_l',$values+array('id'=>$id,'language'=>$v),__file__,__line__);
			}
		}
	}
	else
	{
		$arr_values['pos']=isset($_POST['pos']) ? $_POST['pos'] : 0;
		if($arr_values['pos']==='')
		{
			$Mainclass->Db->Query('SELECT MAX(`pos`) FROM `prefix_static` WHERE `parent`='.$arr_values['parent'].'',__file__,__line__);
			$temp=$Mainclass->Db->Fetch_row();
			$arr_values['pos'] = $temp[0]==null ? 0 : (int)$temp[0]+1;
		}
		else
			$Mainclass->Db->Update('static',array('!pos'=>'`pos`+1'),'`pos`>='.$arr_values['pos'].' AND `parent`='.$arr_values['parent'],__file__,__line__);

		if($arr_values['parent']==0)
			$Mainclass->Db->Query('SELECT MAX(`r`)+1 FROM `prefix_static`',__file__,__line__);
		else
			$Mainclass->Db->Query('SELECT `r` FROM `prefix_static` WHERE `id`='.$arr_values['parent'],__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			return ExitPrefix();
		list($r)=$Mainclass->Db->Fetch_row();
		$Mainclass->Db->Update('static',array('!l'=>'`l`+2'),'`l`>'.(int)$r,__file__,__line__);
		$Mainclass->Db->Update('static',array('!r'=>'`r`+2'),'`r`>='.(int)$r,__file__,__line__);
		$arr_values['l']=$r++;
		$arr_values['r']=$r;

		$id=$Mainclass->Db->Insert('static',$arr_values,__file__,__line__);
		$Mainclass->Loadclass('classes/others/class_uploader.php');
		$Mainclass->Uploader->RenameNew('temp_static','/'.Mainclass::UPLOADS_DIR.'/static/'.$id);
		$values=array('id'=>array(),'language'=>array(),'title'=>array(),'text'=>array());
		foreach($langs as &$v)
		{
			$values['id'][]=$id;
			$values['language'][]=$v;
			if(!$v or $Mainclass->lang_name==$v)
			{
				$values['title'][]=$title;
				$text_l=$Mainclass->Editor->GetHTML('text');
			}
			else
			{
				$values['title'][]=$_POST['title_'.$v];
				$text_l=$Mainclass->Editor->GetHTML('text_'.$v);
			}
			$text_l=str_replace(Mainclass::UPLOADS_DIR.'/temp_static/new/',Mainclass::UPLOADS_DIR.'/static/'.$id.'/',$text_l);
			$values['text'][]=$text_l;
		}
		$Mainclass->Db->Insert('static_l',$values,__file__,__line__);
	}
	$Mainclass->Db->Transaction('COMMIT');
	$Mainclass->Cache->CleanCacheByTag('static');
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteStatic($id)
{global $Mainclass, $title;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `title`,`l`,`r`,`pos` FROM `prefix_static` LEFT JOIN `prefix_static_l` USING(`id`) WHERE `id`='.$id.' AND `language` IN (\'\',\''.$Mainclass->lang_name.'\') LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitPrefix();
	list($stitle,$l,$r,$pos)=$Mainclass->Db->Fetch_row();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		$Mainclass->Loadclass('classes/others/class_uploader.php');
		$Mainclass->Db->Transaction('BEGIN');
		$to_kill=array($id);
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_static` WHERE `l`>'.$l.' AND `r`<'.$r,__file__,__line__);
		while($t=$Mainclass->Db->Fetch_row())
		{
			$to_kill[]=$t[0];
			$Mainclass->Uploader->DeleteFile('static',$t[0]);
		}
		$cnt=$Mainclass->Db->Delete('static','`id`'.$Mainclass->Db->In($to_kill),__file__,__line__);
		$Mainclass->Db->Delete('static_l','`id`'.$Mainclass->Db->In($to_kill),__file__,__line__);
		$Mainclass->Db->Update('static',array('!r'=>'`r`-'.$cnt),'`r`>'.$l,__file__,__line__);
		$Mainclass->Db->Update('static',array('!r'=>'`r`-'.$cnt,'!l'=>'`l`-'.$cnt),'`l`>'.$l,__file__,__line__);
		$Mainclass->Db->Update('static',array('!pos'=>'`pos`-1'),'`pos`>'.$pos.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Transaction('COMMIT');
		$Mainclass->Cache->CleanCacheByTag('static');
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	else
	{
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		$title=$Mainclass->lang['static']['confirm_del'];
		$Mainclass->ShowDecoration();
		echo $Mainclass->Template->GetThemeFile(
													'Confirm',
													array(
															'message'=>sprintf($Mainclass->lang['static']['deleting'],$stitle).($back ? Template::Control('back','hidden',base64_encode($back)) : ''),
													)
		);
	}
}

function MoveUp($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `parent`,`l`,`r`,`pos` FROM `prefix_static` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($parent,$l,$r,$posit)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_static` WHERE `pos`=(SELECT MAX(`pos`) FROM `prefix_static` WHERE `pos`<'.$posit.' AND `parent`='.$parent.') AND `parent`='.$parent,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if($cnt>0)
	{
		if($cnt>1)
		{
			Resort(false);
			$Mainclass->Db->Query('SELECT `pos` FROM `prefix_static` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$Mainclass->Db->Fetch_row();
		}
		$Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_static` WHERE `pos`='.--$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		if($old=$Mainclass->Db->Fetch_assoc())
		{
			#Смещение категории, на место которой мы ставим текущую
			$offset_a=$old['r']-$old['l']+1;
			#Смещение текущей категории на новое место
			$offset_b=$r-$l+1;
			if($r>$old['r'])
			{
				$Mainclass->Db->Update('static',array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
				$Mainclass->Db->Update('static',array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
			}
			else
			{
				$Mainclass->Db->Update('static',array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
				$Mainclass->Db->Update('static',array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
			}
			$Mainclass->Db->Update('static',array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
			$Mainclass->Cache->CleanCacheByTag('static');
		}
		$Mainclass->Db->Update('static', array('!pos'=>'`pos`+1'),'`pos`='.$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Update('static', array('!pos'=>'`pos`-1'),'`id`='.$id.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
	}
	ExitPrefix();
}

function MoveDown($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `parent`,`l`,`r`,`pos` FROM `prefix_static` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($parent,$l,$r,$posit)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_static` WHERE `pos`=(SELECT MIN(`pos`) FROM `prefix_static` WHERE `pos`>'.$posit.' AND `parent`='.$parent.') AND `parent`='.$parent,__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if($cnt>0)
	{
		if($cnt>1)
		{
			Resort(false);
			$Mainclass->Db->Query('SELECT `pos` FROM `prefix_static` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			list($posit)=$Mainclass->Db->Fetch_row();
		}
		$Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_static` WHERE `pos`='.++$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		if($old=$Mainclass->Db->Fetch_assoc())
		{
			#Смещение категории, на место которой мы ставим текущую
			$offset_a=$old['r']-$old['l']+1;
			#Смещение текущей категории на новое место
			$offset_b=$r-$l+1;
			if($r>$old['r'])
			{
				$Mainclass->Db->Update('static',array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
				$Mainclass->Db->Update('static',array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
			}
			else
			{
				$Mainclass->Db->Update('static',array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
				$Mainclass->Db->Update('static',array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
			}
			$Mainclass->Db->Update('static',array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
			$Mainclass->Cache->CleanCacheByTag('static');
		}
		$Mainclass->Db->Update('static', array('!pos'=>'`pos`-1'),'`pos`='.$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Update('static', array('!pos'=>'`pos`+1'),'`id`='.$id.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
	}
	ExitPrefix();
}

function Resort($redirect=true)
{global $Mainclass;
	$result=$Mainclass->Db->Query('SELECT `id`,`parent`,`pos` FROM `prefix_static` ORDER BY `parent` ASC, `pos` ASC',__file__,__line__);
	$cnt=0;
	$parent=-1;
	while ($arr=$Mainclass->Db->Fetch_assoc($result))
	{
		if($parent!=$arr['parent'])
		{
			$parent=$arr['parent'];
			$cnt=0;
		}
		if($arr['pos']!=$cnt)
			$Mainclass->Db->Update('static',array('pos'=>$cnt),'`id`='.$arr['id'].' LIMIT 1',__file__,__line__);
		++$cnt;
	}
	RestoreRLByParent();
	if($redirect)
		ExitPrefix();
}

function RestoreRLByParent()
{global $Mainclass;
	$tree_=$tree=$tosort=$dump=array();
	$Mainclass->Db->Query('SELECT `id`,`parent`,`pos` FROM `prefix_static` ORDER BY `pos` DESC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
	if($arr['parent']==0)
	{
		$tree_[$arr['id']]=array('id'=>$arr['id'],'parent'=>0,'nest'=>0);
		$tosort[$arr['id']]=$arr['pos'];
	}
	else
		$dump[]=array('id'=>$arr['id'],'parent'=>$arr['parent']);
	asort($tosort,SORT_NUMERIC);
	$tosort=array_keys($tosort);
	foreach($tosort as &$v)
		$tree[]=$tree_[$v];
	unset($tree_);
	$len=0;
	while(count($dump)!=$len)
	{
		$len=count($dump);
		foreach($dump as $k=>&$v)
			if(false!==$id=array_search($v['parent'],$tosort))
			{
				array_splice($tree,$id+1,0,array(array('id'=>(int)$v['id'],'parent'=>(int)$v['parent'],'nest'=>$tree[$id]['nest']+1)));
				array_splice($tosort,$id+1,0,array($v['id']));
				unset($dump[$k]);
			}
	}
	unset($tosort);
	$onest=-1;
	$ids=array();
	$n=1;
	foreach($tree as $k=>&$v)
	{
		if($v['nest']>$onest)
			$tree[$k]['l']=$n;
		else
		{
			$id=array_pop($ids);
			$tree[$id]['r']=$n;
			$q=$tree[$id]['nest']-$v['nest'];
			for(;$q>0;--$q)
				if(null!==$id=array_pop($ids))
					$tree[$id]['r']=++$n;
			$tree[$k]['l']=++$n;
		}
		$ids[]=$k;
		$onest=$v['nest'];
		++$n;
	}
	while(null!==$id=array_pop($ids))
		$tree[$id]['r']=$n++;
	foreach($tree as &$v)
		$Mainclass->Db->Update('static',array('r'=>$v['r'],'l'=>$v['l']),'`id`='.(int)$v['id'].' LIMIT 1',__file__,__line__);
	$Mainclass->Cache->CleanCacheByTag('static');
}
?>