<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if (!defined('CMS'))
	die('Попытка взлома?');
$class_name='Module_static_plugins_v1';
if (!class_exists($class_name,false))
{
	class Module_static_plugins_v1 extends BaseClass
	{
		static $abilities=array(
									'splinter',
									'sitemap',
									'blocks'
		);

		public function GetSplinter()
		{
			return array(
							'user'=>array(
											'page'=>array('Страница','l'),
											'id'=>array('ID страницы','i')
							)
			);
		}

		public function GetBlocksOptions(array $params=array(),array $values=array())
		{
			return array(
							'arr'=>array(
											'type'=>array('Блок:','Select',isset($values['type']) ? $values['type'] : '',array('all'=>'Все активные страницы'),'',''),
							)
			);
		}

		public function GetBlocksContent($options)
		{
			$this->Mainclass->LoadOptions('module_static',false);
			$this->Mainclass->Url->s_delimeter=$this->Mainclass->vars['m_static_delimeter'];
			$this->Mainclass->Url->ending=$this->Mainclass->vars['m_static_ending'];
			$prefix=$this->Mainclass->Url->Prefix(false,false,false);
			$this->Mainclass->Url->SetPrefix(array('module'=>'page'));
			$content='<ul class="blockcategories">';
			$temp_parent=0;
			$temp_text='';
			$div='<ul id="sb-{id}" style="display: {disp}; padding-left: 20px;"><!-- static_{id} --></ul>';
			$image='<img src="images/icons/{type}.gif" border="0" id="image-{id}" onclick="SwitchBlockStatic(\'{id}\');" style="cursor: pointer;" alt="{cnt} -&gt;" title="{cnt} -&gt;" />';

			$dump=$this->Mainclass->Cache->Get('blockstatic_'.$this->Mainclass->lang_name,false);
			if($dump===false)
			{
				$this->Mainclass->Db->Query('SELECT `id`,`url`,`title`,`parent`,`l`,`r` FROM `prefix_static` INNER JOIN `prefix_static_l` USING(`id`) WHERE `language` IN (\'\',\''.$this->Mainclass->lang_name.'\') AND `status`=1 ORDER BY `l` ASC',__file__,__line__);
				while($arr=$this->Mainclass->Db->Fetch_assoc())
					$dump[]=$arr;
				$this->Mainclass->Cache->Put('blockstatic_'.$this->Mainclass->lang_name,$dump,3600,false);
			}
			foreach($dump as &$v)
			{
				$cnt=floor(($v['r']-$v['l'])/2);
				if($v['parent']!=$temp_parent)
				{
					if(strpos($content,'<!-- static_'.$temp_parent.' -->')!==false)
						$content=str_replace('<!-- static_'.$temp_parent.' -->',$temp_text.'<!-- static_'.$temp_parent.' -->',$content);
					else
						$content.=$temp_text;
					$temp_text='';
					$temp_parent=$v['parent'];
				}
				if($cnt>0)
				{
					if($this->Mainclass->GCookie('sb-'.$v['id'])=='true')
					{
						$disp='block';
						$type='minus';
					}
					else
					{
						$disp='none';
						$type='plus';
					}
					$begin='<li class="subcat">'.str_replace(
												array(
														'{id}',
														'{cnt}',
														'{type}'
												),
												array(
														$v['id'],
														$cnt,
														$type
												),
												$image
					).' ';
					$this_div=str_replace(
											array(
													'{id}',
													'{disp}'
											),
											array(
													$v['id'],
													$disp
											),
											$div
					);
				}
				else
				{
					$this_div='';
					$begin='<li>';
				}
				$temp_text.=$begin.'<a href="'.$this->Mainclass->Url->ConstructUrl(array('url'=>$v['url'])).'">'.$v['title'].'</a>'.$this_div.'</li>';
			}
			if($temp_text)
			{
				if(strpos($content,'<!-- static_'.$temp_parent.' -->')!=false)
					$content=str_replace('<!-- static_'.$temp_parent.' -->',$temp_text,$content);
				else
					$content.=$temp_text;
			}
			$content.='</ul>
			<script type="text/javascript">//<![CDATA[
			function SwitchBlockStatic(id)
			{
				var el=Id("sb-"+id);
				var image=Id("image-"+id);
				if(el.style.display=="none")
				{
					image.src="images/icons/minus.gif";
					SetCookie("sb-"+id,"true");
				}
				else
				{
					image.src="images/icons/plus.gif";
					SetCookie("sb-"+id,"false");
				}
				$(el).toggle(200);
			}
			//]]></script>';
			$this->Mainclass->Url->SetPrefix($prefix);
			return $content;
		}

		public function DoSitemap($per_time,$sdata)
		{
			if(!$sdata)
				$sdata=array('offset'=>0);
			$this->Mainclass->LoadOptions('module_static',false);
			$result=$this->Mainclass->Db->Query('SELECT `url` FROM `prefix_static` LIMIT '.$sdata['offset'].','.$per_time,__file__,__line__);
			$sdata['offset']+=$this->Mainclass->Db->Num_rows();
			while($arr=$this->Mainclass->Db->Fetch_assoc($result))
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('doc'=>$arr['url'])),'','monthly',0.5);
			return $sdata;
		}

		public function GetPage($page)
		{
			$page=preg_replace('#([^'.Strings::ALL.'\.\-]|\.\.)+#','',$page);#Обезопасим от возможного выхода из каталога и проверку других файлов.
			if(!$page)
				return false;
			if($arr=glob(dirname(__file__).'/DIRECT/{'.$page.'.php,'.$page.'.*htm*}',GLOB_BRACE))
			{
				if(substr($arr[0],-3)=='php')
				{
					ob_start();
					include $arr[0];
					$text=ob_get_contents();
					ob_end_clean();
				}
				else
				{
					$text=file_get_contents($arr[0]);
					$text=preg_replace('#^\[title\](.+?)\[/title\]#i','',$text);
				}
			}
			else
			{
				$text='';
				$this->Mainclass->Db->FQuery('SELECT `id`,`title`,`text`,`show_title`,`l`,`parent` FROM {"0"} INNER JOIN {"1"} USING(`id`) WHERE `language` IN (\'\',\''.$this->Mainclass->lang_name.'\') AND `status`=1 AND `url`={"2"} LIMIT 1',array('static','static_l','s_'.$page),__file__,__line__);
				if($this->Mainclass->Db->Num_rows()==0)
					return false;
				list($id,$ttitle,$ttext,$st,$l,$parent)=$this->Mainclass->Db->Fetch_row();
				if($parent>0)
				{
					$navig='';
					$this->Mainclass->Db->Query('SELECT `url`,`title` FROM `prefix_static` INNER JOIN `prefix_static_l` USING(`id`) WHERE `language` IN (\'\',\''.$this->Mainclass->lang_name.'\') AND `l`<='.$l.' ORDER BY `l` ASC',__file__,__line__);
					$n=$this->Mainclass->Db->Num_rows();
					while($arr=$this->Mainclass->Db->Fetch_assoc())
						$navig.=--$n ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array($arr['url'])).'">'.$arr['title'].'</a> <code>&gt;</code> ' : $arr['title'];
					if($navig)
						$text.=$this->Mainclass->Template->OpenTable().$navig.$this->Mainclass->Template->CloseTable();
				}
				$title=$ttitle;
				$text.=($st ? '<h3 class="stitle">'.$ttitle.'</h3>' : '').$ttext;
				unset($ttext);
			}
			$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
			if($page<1)
				$page=1;
			$text=explode('[next page]',$text);
			$this->Mainclass->Url->SetPrefix(array('doc'=>$url),true);
			return $this->Mainclass->Template->OpenTable()
				.Strings::ParseOwnBb(isset($text[$page-1]) ? $text[$page-1] : reset($text))
				.Strings::Pages(count($text),1)
				.$this->Mainclass->Template->CloseTable();
		}
	}
}
?>