<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
#Спецификацию RSS читать тут: http://cyber.law.harvard.edu/rss/rss.html
$start=microtime();#Начало отсчета времени движка.
define('CMS',true);
require dirname(__file__).'/classes/mainclass.php';
$Mainclass=MainClass::getInstance();
$Mainclass->start_time=$start;
$Mainclass->service_id='6';#ID сервиса
$Mainclass->file_name=basename(__file__);
if(0<$t=strpos($Mainclass->site_path,$Mainclass->file_name))
	$Mainclass->site_path=$t==1 ? '' : substr($Mainclass->site_path,0,$t-1);
$Mainclass->LoadOptions(array('system','blocker','login','public','rss'));
if($Mainclass->vars['multilang'])
	$Mainclass->Functions->GetLangCookie();
$Mainclass->LoadService();
if(isset($Mainclass->Login))
{
	if($Mainclass->services[$Mainclass->service_id]['login']==$Mainclass->services[1]['login'])
	{
		$old_service=$Mainclass->service;
		$old_id=$Mainclass->service_id;
		$Mainclass->service='admin';
		$Mainclass->service_id='1';
	}
	$Mainclass->Login->IsUser();
	if(!empty($Mainclass->vars['site_closed']) and !$Mainclass->Permission->IsAdmin())
		ExitPage();
	if(isset($old_service))
	{
		$Mainclass->service=$old_service;
		$Mainclass->service_id=$old_id;
	}
	if($Mainclass->Permission->IsBanned())
		throw new EE(null,EE::BAN);
}
$Mainclass->Cache->FilterLangVars();
$rss=$title=$description='';
if(isset($_REQUEST['module']))
{
	$module_name=$_REQUEST['module'];
	$Mainclass->Db->FQuery('SELECT `id`,`services`,`name`,`title`,`path`,`multiservice`,`file`,`is_class`,`resources`,`image`,`user_groups` FROM {"0"} WHERE `name`={"1"} AND `active` LIMIT 1',array('modules','s_'.$module_name),__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitPage();
	$arr=$Mainclass->Db->Fetch_Assoc();
	$arr['user_groups']=Strings::CleanForExplode($arr['user_groups']);
	if($arr['user_groups'])
	{
		$groups=explode(',',$arr['user_groups']);
		$user_groups=$Mainclass->Account->GetUserGroups();
		if(count(array_intersect($groups,$user_groups))==0)
			ExitPage();
	}
	if(strpos($arr['services'],','.$Mainclass->service_id.',')===false and $arr['resources'])
	{
		$resources=explode('·',Strings::CleanForExplode($arr['resources']));
		foreach($resources as &$v)
		{
			$temp=explode('=',$v,2);
			if($Mainclass->service==$temp[0])
			{
				$arr['file']=$temp[1];
				break;
			}
		}
	}
	if(!$arr['file'])
		ExitPage();
	$Mainclass->module['name']=$arr['name'];
	$Mainclass->module['title']=$arr['title'];
	$Mainclass->module['image']=$arr['image'];
	$Mainclass->module['path']=$arr['path'];
	$Mainclass->module['general']=false;
	$Mainclass->module['id']=$arr['id'];
	$Mainclass->Url->SetPrefix(array('module'=>$Mainclass->module['name']));
	if(!$Mainclass->LoadModule($arr['path'],$arr['multiservice'],$arr['file'] ? $arr['file'] : 'index',$arr['is_class']))
		ExitPage();
}
elseif(isset($_REQUEST['direct']) and is_string($_REQUEST['direct']) and is_file($f=$Mainclass->root_path.'addons/direct/'.preg_replace('#[^a-z0-9]+#i','',$_REQUEST['direct']).'.php'))
	include $f;
else
	ExitPage();

function Rss($arr=array())
{global $rss, $Mainclass;
	if(!isset($arr['guid']))
		$arr['guid']=ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.$arr['link'];
	if(isset($arr['descr']))
		$arr['descr']=preg_replace('#<script[^>]*>(.*?)</script>#is','',$arr['descr']);
	$rss.='
		<item>
			'.(isset($arr['title']) ? '<title><![CDATA['.html_entity_decode($arr['title']).']]></title>'."\r\n" : '')
.(isset($arr['link'])		? '			<link>'.ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.$arr['link'].'</link>'."\r\n" : '')
.(isset($arr['descr'])		? '			<description><![CDATA['.$arr['descr'].']]></description>'."\r\n" : '')
.(isset($arr['category'])	? '			<category>'.htmlspecialchars($arr['category'],ENT_QUOTES).'</category>'."\r\n" : '')
.(isset($arr['date'])		? '			<pubDate>'.$arr['date'].'</pubDate>'."\r\n" : '')
.(isset($arr['author'])		? '			<author>'.htmlspecialchars($arr['author'],ENT_QUOTES).'&lt;spam@'.$Mainclass->domain.'&gt;</author>'."\r\n" : '')
.(isset($arr['comments'])	? '			<comments>'.ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.$arr['comments'].'</comments>'."\r\n" : '')
.(isset($arr['guid']) 		? '			<guid>'.$arr['guid'].'</guid>'."\r\n" : '')
.(isset($arr['enclosure'])	? '			<enclosure>'.$arr['enclosure'].'</enclosure>'."\r\n" : '')
.(isset($arr['source'])		? '			<source>'.$arr['source'].'</source>'."\r\n" : '').'		</item>';
}

function ExitPage($redirect=true)
{global $Mainclass;
	if($redirect)
		Functions::Redirect(ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.htmlspecialchars_decode($Mainclass->Url->DynamicBegin().$Mainclass->Url->ConstructUrl(array('module'=>'errors','url'=>'404'),false,false,false)));
	else
	{
		#Страница с Error
		$Mainclass->module['name']='errors';
		$Mainclass->Url->string='';
		$_GET['url']=404;
		$Mainclass->module['path']='modules/errors';
		$Mainclass->Url->SetPrefix($Mainclass->vars['multilang'] ? array('lang'=>$Mainclass->get_lang,'module'=>'errors') : array('module'=>'errors'),false);
		if(!include $Mainclass->root_path.'modules/errors/user/index.php')
			ExitPage(true);
		die;
	}
}

#Функция "Будь как", делает сервис AJAX похожим на другой сервис
function BeAs($idname='')
{global $Mainclass;
	if($Mainclass->service==$idname or $Mainclass->service_id==$idname)
		return;
	if(!$idname)
		$idname=2;
	foreach($Mainclass->services as &$arr)
		if($arr['id']==$idname or $arr['id']==$idname)
			break;
	$Mainclass->Permission->CleanAll();
	$id=$Mainclass->service_id;
	$name=$Mainclass->service;
	$Mainclass->service_id=$arr['id'];
	$Mainclass->service=$arr['name'];
	$Mainclass->Functions->GetLangCookie(true,$Mainclass->service.'_lang');
	$Mainclass->LoadLanguage('langs','main',$arr['name'].'-%');
	$Mainclass->file_name=$arr['file'];
	if(!empty($arr['login']) and $Mainclass->services[$id]['login']!=$arr['login'])
	{
		$Mainclass->Account->LogOut(false);
		if(isset($Mainclass->Login) and ($Mainclass->Login instanceof LoginClass))
			unset($Mainclass->Login);
		$Mainclass->LoadLogin($arr['login']);
	}
	$Mainclass->Login->IsUser();
	$Mainclass->service_id=$id;
	$Mainclass->service=$name;
	$Mainclass->Template->theme=$arr['theme'];
	$Mainclass->Url->furl=$arr['id']==2 ? $Mainclass->vars['furl'] : false;
	$Mainclass->service=$arr['name'];
}
$Mainclass->content_type='application/xml';
$Mainclass->do_gzip_compress=false;
$Mainclass->ShowDecoration(true,'');
$site_title=$Mainclass->vars['site_name'];
if($title)
	$site_title.=$Mainclass->vars['site_defis'].(is_array($title) ? implode($Mainclass->vars['site_defis'],$title) : $title);
if(!$description)
	$description=$Mainclass->vars['site_description'];
if(!empty($Mainclass->vars['rss_image']) and is_file($Mainclass->FormatPath($Mainclass->vars['rss_image'])))
	$image='<image>
			<url>'.ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'/'.$Mainclass->vars['rss_image'].'</url>
			<title>'.$Mainclass->vars['site_name'].'</title>
			<link>'.ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'</link>
			<description>'.$description.'</description>
		</image>';
else
	$image='';
echo '<?xml version="1.0" encoding="'.ELEANOR_DISPLAYCHARSET.'"?>
<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">
	<channel>
		<title>'.$site_title.'</title>
		<description>'.$description.'</description>
		<link>'.ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path.'</link>
		<lastBuildDate>'.date('r',$Mainclass->MyTime()).'</lastBuildDate>
		<language>ru</language>
		<generator>Eleanor RSS Generator</generator>
		'.$image.$rss.'
		<atom:link href="'.ELEANOR_PROTOCOL.$Mainclass->MyGetEnv('HTTP_HOST').htmlspecialchars($Mainclass->MyGetEnv('REQUEST_URI')).'" rel="self" type="application/rss+xml" />
	</channel>
</rss>';
?>