<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='ABlogs';
class ABlogs extends BaseClass
{
	#Шапки таблицы списка блогов
	public function BlogsListBegin($title,$fititle,$pages_arr,$page)
	{
		return $this->Mainclass->Template->Title($title)
			.$this->Mainclass->Template->OpenTable()
			.'<form action="" method="post"><table class="filtertable"><tr><td style="width: 100%; white-space: nowrap;"><b>'.$this->Mainclass->lang['main']['filter'].':</b> '.Template::Edit('fititle',$fititle).Template::Button($this->Mainclass->lang['main']['apply'],'submit').Template::Control('filter','hidden',1).'</td></tr></table></form>
			<form id="blogs_form" action="'.$this->Mainclass->Url->ConstructUrl($pages_arr+array('page'=>$page)).'" method="post" onsubmit="return (CheckGroup(this) && confirm(\''.$this->Mainclass->lang['main']['are_you_sure'].'\'))"><table width="100%" class="tabstyle">
			<tr class="first tablethhead"><th width="1">'.$this->Mainclass->lang['main']['id'].'</th><th colspan="2">'.$this->Mainclass->lang['blogs']['title'].'</th><th>'.$this->Mainclass->lang['blogs']['datecr'].'</th><th>'.$this->Mainclass->lang['blogs']['type'].'</th><th>'.$this->Mainclass->lang['blogs']['user'].'</th><th width="70">'.$this->Mainclass->lang['main']['functs'].'</th><th width="1">'.Template::Check('mass',false,'id="blogs_mass_check"').'</th></tr>';;
	}

	#Показ сообщения о том, что блогов нет
	public function BlogsListEmpty()
	{
		return '<tr><td colspan="8" align="center"><b>'.$this->Mainclass->lang['blogs']['no_blogs'].'</b></td></tr>';
	}

	#Строка таблицы списка блогов
	public function BlogsListLine($arr,$cnt)
	{static $n=1;
		$status=(int)$arr['status'];
		if($status>=0)
			$status=$status
				? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('swapblog'=>$arr['id'])).'" title="'.$this->Mainclass->lang['blogs']['block'].'"><img src="'.$this->Mainclass->Template->GetImage('active.png').'" alt="'.$this->Mainclass->lang['blogs']['block'].'" /></a>'
				: '<a href="'.$this->Mainclass->Url->ConstructUrl(array('swapblog'=>$arr['id'])).'" title="'.$this->Mainclass->lang['main']['activate'].'"><img src="'.$this->Mainclass->Template->GetImage('inactive.png').'" alt="'.$this->Mainclass->lang['main']['activate'].'" /></a>';
		else
			$status='';
		$edit=$this->Mainclass->Url->ConstructUrl(array('editblog'=>$arr['id']));
		return '<tr class="'.($n++ % 2 ? 'tabletrline2' : 'tabletrline1').($n==$cnt ? ' last' : '').'"><td align="right">'.$arr['id'].'</td>'
				.($arr['logo'] ? '<td width="1"><a href="'.$edit.'"><img src="'.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$arr['logo'].'" alt="'.$arr['title'].'" title="'.$arr['title'].'" /></a></td><td>' : '<td colspan="2">')
				.'<a href="'.$edit.'">'.$arr['title'].'</a>'.($arr['descr'] ? '<br /><i>'.$arr['descr'].'</i>' : '').'</td>
				<td align="center">'.substr($arr['crdate'],0,10).'</td>
				<td align="center">'.($arr['type']=='public' ? $this->Mainclass->lang['blogs']['public'] : $this->Mainclass->lang['blogs']['private']).'</td>
				<td align="center"><a href="'.$this->Mainclass->Login->UserLink($arr['author'],$arr['author_id']).'">'.$arr['author'].'</a></td>
				<td class="function"><a href="'.$this->Mainclass->Url->ConstructUrl(array('tags'=>$arr['id'])).'"><img src="'.$this->Mainclass->Template->GetImage('tagsmanag.png').'" alt="'.$this->Mainclass->lang['blogs']['tags'].'" /></a><br />'.($arr['categs'] ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array('categs'=>$arr['id'])).'"><img src="'.$this->Mainclass->Template->GetImage('catmanag.png').'" alt="'.$this->Mainclass->lang['blogs']['categs'].'" /></a><br />' : '').$status.'<a href="'.$edit.'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array('deleteblog'=>$arr['id'])).'" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></td><td align="center">'.Template::Check('mass[]',false,'value="'.$arr['id'].'"').'</td></tr>';
	}

	#Конец таблицы списка блогов
	public function BlogsListEnd($op_list,$pcnt,$per_page,$pages_arr)
	{
		return '</table><div class="submitline" style="text-align: right;">'.$this->Mainclass->lang['main']['with_selected'].Template::Select('op',$op_list).Template::Button($this->Mainclass->lang['main']['ok']).'</div></form>
		<script type="text/javascript">
		One2AllCheckboxes("blogs_form","blogs_mass_check","mass[]");
		</script>'.Strings::Pages($pcnt,$per_page,$pages_arr).$this->Mainclass->Template->CloseTable();
	}

	#Интерфейс добавления/правки блога
	public function AddEditBlog($error,$title,$bvalue,$values,$dis,$image)
	{
		$values['crdate']=Calendar('crdate',$values['crdate'],true);
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		$ref=$ref ? Template::Control('back','hidden',base64_encode($ref)) : '';
		return ($error ? $this->Mainclass->Template->Message($error) : '').$this->Mainclass->Template->OpenTable()
		.'<form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('saveblog'=>$values['id']))).'">
		<table class="tabstyle tabform">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_name'].'</td><td>'.Template::Edit('title',$values['title']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_url'].'</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_descr'].'</td><td>'.$this->Mainclass->Editor->Area('descr',$values['descr'],5).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_pp'].'</td><td>'.Template::Edit('per_page',$values['per_page']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_bcat'].'</td><td>'.Template::Check('categs',$values['categs']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_type'].'</td><td>'.Template::Select('type',Template::Option($this->Mainclass->lang['blogs']['public'],'personal',$values['type']=='personal').Template::Option($this->Mainclass->lang['blogs']['private'],'public',$values['type']=='public')).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['datecr_'].'</td><td>'.$values['crdate'].'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['main']['author'].'</td><td>'.Author($values['author'],$values['author_id']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_stat'].'</td><td>'.Template::Select('status',Template::Option($this->Mainclass->lang['main']['waiting_act'],'-1',$values['status']==-1).Template::Option($this->Mainclass->lang['main']['inactive'],'0',$values['status']==0).Template::Option($this->Mainclass->lang['main']['active'],'1',$values['status']>0)).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_logo'].'</td><td><span id="img_upload"></span>
			<div style="padding: 5px 0;"><img style="border: 1px solid #c9c7c3;" id="blog_image" src="'.$image.'" alt="" /></div>'
			.Template::Button($this->Mainclass->lang['blogs']['bl_canc'],'button','id="cancel_upload" disabled="disabled" onclick="swfu.cancelUpload()"').Template::Button($this->Mainclass->lang['blogs']['bl_del'],'button','id="del_button" onclick="DeleteBlockLogoImg('.(int)$values['id'].',1)"'.$dis)
		.'</td></tr>
		</table><div class="submitline">'.$ref.Template::Button($bvalue,'submit','id="reg"').($values['id']==0 ? '' : ' '.Template::Button($this->Mainclass->lang['blogs']['bl_del'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('deleteblog'=>$values['id'])).'\'"')).'</div></form>
		<script type="text/javascript">//<![CDATA[
		var swfu = new SWFUpload({
			flash_url : "addons/swfupload/swfupload.swf",
			upload_url: "'.ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/upload.php",
			file_post_name:"image",
			post_params: {"module": "'.$this->Mainclass->GetModVal('name').'","session":"'.session_id().'"},
			file_size_limit : "2 MB",
			file_types : "*.jpg;*.png;*.gif;",
			file_types_description : "Images",
			file_upload_limit : "0",
			file_queue_limit : "1",

			file_queue_error_handler : fileQueueError,
			file_dialog_complete_handler : fileDialogComplete,
			upload_progress_handler : uploadProgress,
			upload_error_handler : uploadError,
			upload_success_handler : uploadSuccess,
			upload_complete_handler : uploadComplete,

			button_placeholder_id: "img_upload",
			button_image_url: "'.ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/images/uploader/uploadbtn.png",
			button_text: \'<span class="upbtntext">'.$this->Mainclass->lang['blogs']['bl_upllog'].'</span>\',
			button_text_style: ".upbtntext { font-size: 11px; color: #6D6A65; font-family: Tahoma, Arial, sans-serif; font-weight: bold; }",
			button_text_left_padding: 16,
			button_text_top_padding: 4,
			button_width: 129,
			button_height: 27,
			button_action : SWFUpload.BUTTON_ACTION.SELECT_FILE,
			button_cursor: SWFUpload.CURSOR.HAND,
			debug: false
		});
		//]]></script>'.$this->Mainclass->Template->CloseTable();
	}

	#Шапка таблицы списка категорий
	public function CategsListBegin($title,$bid,$page)
	{
		return $this->Mainclass->Template->Title($title)
			.$this->Mainclass->Template->OpenTable()
			.'<form id="blogsc_form" action="'.$this->Mainclass->Url->ConstructUrl(array('categs'=>$bid,'page'=>$page)).'" method="post" onsubmit="return (CheckGroup(this) && confirm(\''.$this->Mainclass->lang['main']['are_you_sure'].'\'))"><table width="100%" class="tabstyle">
			<tr class="first tablethhead"><th width="1">'.$this->Mainclass->lang['main']['id'].'</th><th colspan="2">'.$this->Mainclass->lang['blogs']['title'].'</th><th>URL</th><th>'.$this->Mainclass->lang['blogs']['posts'].'</th><th width="70">'.$this->Mainclass->lang['main']['functs'].'</th><th width="1">'.Template::Check('mass',false,'id="blogs_mass_check"').'</th></tr>';;
	}

	#Показ сообщения о том, что категорий нет
	public function CategsListEmpty()
	{
		return '<tr><td colspan="6" align="center"><b>'.$this->Mainclass->lang['blogs']['no_cats'].'</b></td></tr>';
	}

	#Строка таблицы списка категорий
	public function CategsListLine($arr,$cnt)
	{static $n=1;
		$edit=$this->Mainclass->Url->ConstructUrl(array('editcat'=>$arr['id']));
		return '<tr class="'.($n++ % 2 ? 'tabletrline2' : 'tabletrline1').($n==$cnt ? ' last' : '').'"><td align="right">'.$arr['id'].'</td>'
				.($arr['logo'] ? '<td width="1"><a href="'.$edit.'"><img src="images/categories/'.$arr['logo'].'" alt="'.$arr['title'].'" title="'.$arr['title'].'" /></a></td><td>' : '<td colspan="2">')
				.'<a href="'.$edit.'">'.$arr['title'].'</a>'.($arr['descr'] ? '<br /><i>'.$arr['descr'].'</i>' : '').'</td>
				<td align="center">'.$arr['url'].'</td>
				<td align="center">'.$arr['posts'].'</td>
				<td class="function"><a href="'.$edit.'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array('deletecat'=>$arr['id'])).'" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></td><td align="center">'.Template::Check('mass[]',false,'value="'.$arr['id'].'"').'</td></tr>';
	}

	#Конец таблицы списка категорий
	public function CategsListEnd($op_list,$pcnt,$per_page,$bid)
	{
		return '</table><div class="submitline" style="text-align: right;">'.$this->Mainclass->lang['main']['with_selected'].Template::Select('op',$op_list).Template::Button($this->Mainclass->lang['main']['ok']).'</div></form>
		<script type="text/javascript">
		One2AllCheckboxes("blogsc_form","blogs_mass_check","mass[]");
		</script>'.Strings::Pages($pcnt,$per_page,array('categs'=>$bid)).$this->Mainclass->Template->CloseTable();
	}

	#Интерфейс добавления/правки категории
	public function AddEditCategory($error,$title,$values,$cimgs)
	{
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		$ref=$ref ? Template::Control('back','hidden',base64_encode($ref)) : '';
		return ($error ? $this->Mainclass->Template->Message($error) : '').$this->Mainclass->Template->OpenTable()
		.'<form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('savecat'=>$values['id']))).'">
		<table class="tabstyle tabform">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_tit_'].'</td><td>'.Template::Edit('title',$values['title']).'</td></tr>
		<tr><td class="label">URL:</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_descr'].'</td><td>'.$this->Mainclass->Editor->Area('descr',$values['descr'],5).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_pos'].'</td><td>'.Template::Edit('pos',$values['pos']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_logo'].'</td><td>'.Template::Select('image',Template::Option($this->Mainclass->lang['main']['no'],0,empty($values['logo'])).$cimgs,'onchange="document.images.preview.src=this.value==\'0\' ? \'images/categories/none.png\' : this.value"').'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['prev'].'</td><td><img src="'.((!$values['image'] or !is_file($this->Mainclass->FormatPath($values['image']))) ? 'images/categories/none.png' : $values['image']).'" id="preview" alt="" title="" /></td></tr>
		</table><div class="submitline">'.Template::Button().$ref.Template::Control('bid','hidden',$values['bid']).'</div></form>'.$this->Mainclass->Template->CloseTable();
	}

	#Шапка таблицы тегов
	public function TagsListBegin($title,$bid,$page)
	{
		return $this->Mainclass->Template->Title($title)
			.$this->Mainclass->Template->OpenTable()
			.'<form id="blogst_form" action="'.$this->Mainclass->Url->ConstructUrl(array('tags'=>$bid,'page'=>$page)).'" method="post" onsubmit="return (CheckGroup(this) && confirm(\''.$this->Mainclass->lang['main']['are_you_sure'].'\'))"><table width="100%" class="tabstyle">
			<tr class="first tablethhead"><th width="1">'.$this->Mainclass->lang['main']['id'].'</th><th>'.$this->Mainclass->lang['blogs']['title'].'</th><th>'.$this->Mainclass->lang['blogs']['posts'].'</th><th width="70">'.$this->Mainclass->lang['main']['functs'].'</th><th width="1">'.Template::Check('mass',false,'id="blogs_mass_check"').'</th></tr>';;
	}

	#Показ сообщения о том, что тегов нет
	public function TagsListEmpty()
	{
		return '<tr><td colspan="4" align="center"><b>'.$this->Mainclass->lang['blogs']['no_tags'].'</b></td></tr>';
	}

	#Строка таблицы тегов
	public function TagsListLine($arr,$cnt)
	{static $n=1;
		$edit=$this->Mainclass->Url->ConstructUrl(array('edittag'=>$arr['id']));
		return '<tr class="'.($n++ % 2 ? 'tabletrline2' : 'tabletrline1').($n==$cnt ? ' last' : '').'"><td align="right">'.$arr['id'].'</td>
				<td><a href="'.$edit.'">'.$arr['name'].'</a></td>
				<td align="center">'.$arr['posts'].'</td>
				<td class="function"><a href="'.$edit.'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array('deletetag'=>$arr['id'])).'" onclick="return confirm(\''.$this->Mainclass->lang['main']['are_you_sure'].'\')" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></td><td align="center">'.Template::Check('mass[]',false,'value="'.$arr['id'].'"').'</td></tr>';
	}

	#Низ таблицы тегов
	public function TagsListEnd($op_list,$pcnt,$per_page,$bid)
	{
		return '</table><div class="submitline" style="text-align: right;">'.$this->Mainclass->lang['main']['with_selected'].Template::Select('op',$op_list).Template::Button($this->Mainclass->lang['main']['ok']).'</div></form>
		<script type="text/javascript">
		One2AllCheckboxes("blogst_form","blogs_mass_check","mass[]");
		</script>'.Strings::Pages($pcnt,$per_page,array('tags'=>$bid)).$this->Mainclass->Template->CloseTable();
	}

	#Интерфейс редактирования тега
	public function EditTag($error,$title,$values)
	{
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		$ref=$ref ? Template::Control('back','hidden',base64_encode($ref)) : '';
		return ($error ? $this->Mainclass->Template->Message($error) : '').$this->Mainclass->Template->OpenTable()
		.'<form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('savetag'=>$values['id']))).'">
		<table class="tabstyle tabform">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['bl_tit_'].'</td><td>'.Template::Edit('name',$values['name']).'</td></tr>
		</table><div class="submitline">'.Template::Button().$ref.'</div></form>'.$this->Mainclass->Template->CloseTable();
	}
}
?>