<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='AfTPL';
class AfTPL extends BaseClass
{
	public function AfListHead($title,$post_name,$lang,$page)
	{
		return $this->Mainclass->Template->Title($title)
			.$this->Mainclass->Template->OpenTable()
			.'<form id="'.$post_name.'_form" action="'.$this->Mainclass->Url->ConstructUrl(array('page'=>$page)).'" method="post" onsubmit="return (CheckGroup(this) && confirm(\''.$this->Mainclass->lang['main']['are_you_sure'].'\'))"><table class="tabstyle">
			<tr class="tablethhead"><th>'.$this->Mainclass->lang['main']['name'].'</th><th>'.$this->Mainclass->lang['main']['descr'].'</th><th>'.$lang['type'].'</th><th>'.$lang['tags'].'</th><th>'.$this->Mainclass->lang['main']['functs'].'</th><th width="15">'.Template::Check('mass',false,'id="'.$post_name.'_mass_check"').'</th></tr>';
	}

	public function AfListRow($n,$arr,$type,$buttons)
	{
		return'<tr class="'.($n % 2 ? 'tabletrline1' : 'tabletrline2').'"><td>'.($arr['req'] ? '<span class="imp">*</span> ' : '').'<a href="'.($edit=$this->Mainclass->Url->ConstructUrl(array('edit'=>$arr['id']))).'">'.$arr['title'].'</a></td><td>'.$arr['descr'].'</td><td align="center">'.$type.'</td><td align="center">'.($arr['tags'] ? $arr['tags'] : '--').'</td><td class="function">'.$buttons.' <a href="'.$edit.'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a> <a href="'.$this->Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></td><td align="center">'.Template::Check('mass[]',false,'value="'.$arr['id'].'"').'</td></tr>';
	}

	public function AfListEmpty($lang)
	{
		return'<tr><td colspan="6" align="center"><b>'.$lang['noaddonf'].'</b></td></tr>';
	}

	public function AfListFoot($post_name,$op_list)
	{
		return'</table><div class="submitline" style="text-align: right;">'.$this->Mainclass->lang['main']['with_selected'].Template::Select('op',$op_list).' '.Template::Button($this->Mainclass->lang['main']['ok']).'</div></form><script type="text/javascript">One2AllCheckboxes("'.$post_name.'_form","'.$post_name.'_mass_check","mass[]");</script>'.$this->Mainclass->Template->CloseTable();
	}

	public function AddEdit($error,$title,$lang,$values,$multilang,$types)
	{
		$multil_text=$multil_check='';
		if($this->Mainclass->vars['multilang'])
		{
			$multil_check=array();
			$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
			foreach($multilang as $k=>$v)
			{
				$lang_title=ucfirst($k).' / '.ucfirst($this->Mainclass->langs[$k]);
				$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['descr'] or !is_int($id)),'value="'.$k.'"').' '.$lang_title;
				if($k==$this->Mainclass->lang_name)
					continue;
				$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').toggle(200);return false" class="ol_heading">
				'.(file_exists($this->Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
				<div id="table_'.$k.'">
					<table class="tabstyle tabform">
					<tr><td class="label">'.$this->Mainclass->lang['main']['name'].'</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
					<tr><td class="label">'.$this->Mainclass->lang['main']['descr'].':</td><td>'.$this->Mainclass->Editor->Area('descr_'.$k,$v['descr'],5).'</td></tr>
					</table>
				</div>
				</li>';
			}
			$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
			$multil_check='<tr><td class="label">'.$this->Mainclass->lang['main']['set_for_langs'].'</td><td>'
			.Template::Check('one_lang',$values['one_lang'])
			.' <b>'.$this->Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
			.join('<br />',$multil_check).'</div></td></tr>';
		}
		$content=$this->Mainclass->Template->Title($title).($error ? $this->Mainclass->Template->Message($error) : '')
		.$this->Mainclass->Template->OpenTable()
		.'<ul id="blockstabs" class="linetabs">
		<li><a href="#" rel="tab1" class="selected"><b>'.$this->Mainclass->lang['main']['general'].'</b></a></li>
		'.($this->Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2"><b>'.$this->Mainclass->lang['main']['other_langs'].'</b></a></li>' : '').'
		</ul>
		<form action="'.$this->Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post">
		<div id="tab1" class="tabcontent">
			<table class="tabstyle tabform">
			<tr><td class="label">'.$this->Mainclass->lang['main']['name'].'<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$this->Mainclass->lang_name]['title']).'</td></tr>
			<tr><td class="label">'.$this->Mainclass->lang['main']['descr'].':</td><td>'.$this->Mainclass->Editor->Area('descr',$multilang[$this->Mainclass->lang_name]['descr'],5).'</td></tr>
			<tr><td class="label">'.$lang['pos'].'</td><td>'.Template::Edit('position',$values['position']).'</td></tr>
			<tr><td class="label">'.$lang['type'].':<span class="imp">*</span></td><td>'.Template::Select('type',$types).'</td></tr>
			<tr><td class="label">'.$lang['name'].':<span class="imp">*</span></td><td>'.Template::Edit('name',$values['name']).'</td></tr>
			<tr><td class="label">'.$lang['tags'].'</td><td>'.Template::Edit('tags',$values['tags']).'</td></tr>
			<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,$(\'#hint_def\').html())">(?)</span>'.$lang['def_opt'].'</td><td>'.Template::Text('default',$values['default']).'</td></tr>
			<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,$(\'#hint_add\').html())">(?)</span>'.$lang['addon_'].'</td><td>'.Template::Text('extra',$values['extra']).'</td></tr>
			<tr><td class="label">'.$lang['php_code'].'</td><td>'.Template::Text('eval',$values['eval']).'</td></tr>
			<tr><td class="label">'.$lang['req_field'].'</td><td>'.Template::Check('req',$values['req']).'</td></tr>
			<tr><td class="label"><span style="color: #'.($values['status'] ? '71ad08' : 'd23100').'">'.$this->Mainclass->lang['main']['status'].'</span></td><td>'.Template::Check('status',$values['status']).'</td></tr>
			'.$multil_check.'
			</table>
		</div>'.$multil_text;
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		if($ref)
			$content.=Template::Control('back','hidden',base64_encode($ref));
		$content.='<div class="submitline">'.Template::Button().' '.(is_int($values['id']) ? Template::Button($this->Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('delete'=>$values['id'])).'\'"') : '').'</div>
		</form>
		<script type="text/javascript">//<![CDATA[
		var countries=new ddtabcontent("blockstabs");
		countries.setpersist(true);
		countries.setselectedClassTarget("link");
		countries.init();
		//]]></script>'.$this->Mainclass->Template->CloseTable()
		.'<div id="hint_def" style="display:none">'.$lang['hint_def'].'</div><div id="hint_add" style="display:none">'.$lang['hint_add'].'</div>';
		return $content;
	}
}
?>