<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class Blogs extends BaseClass
{
	#Шапка списка блогов
	public function BlogsBeginTable($canadd=false)
	{
		return '<ul class="reset listing">';
	}

	#Сообщение, что блогов нет
	public function BlogsEmptyTable($canadd=false)
	{
		return '<li class="listing"><div align="center"><b>'.$this->Mainclass->lang['blogs']['tplnobl'].'</b></div></li>';
	}

	#Строка списка  моих блогов - когда пользователь просматривает свои блоги и может их править.
	public function MyBlogsTableList($arr)
	{
		$status='';
		switch($arr['status'])
		{
			case 0:
				$status=' <span style="color:red;font-weight:bold">'.$this->Mainclass->lang['blogs']['tplbloc'].'</span>';
			break;
			case -1:
				$status=' <span style="color:orange;font-weight:bold">'.$this->Mainclass->lang['blogs']['tplwait'].'</span>';
			break;
		}
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		if($arr['last_id'])
			$last='<a href="'.$this->Mainclass->Url->ConstructUrl(array(array($arr['last_url'] ? $arr['url'] : '',true),array($arr['last_url'] ? $arr['curl'] : '',true),array($arr['last_url'],'pid'=>$arr['last_id']))).'">'.$arr['last_title'].'</a><br /><span class="small">'.$this->Mainclass->lang['blogs']['tplaut_'].' '.$this->Author($arr['last_author_id'],$arr['last_author']).' '.$this->Mainclass->lang['blogs']['tpldat_'].' '.substr($arr['last_date'],0,10).'</span>';
		else
			$last='--<b>'.$this->Mainclass->lang['blogs']['tplaut_'].'</b> --<b>'.$this->Mainclass->lang['blogs']['tpldat_'].'</b> --';
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
		$url=$this->Mainclass->Url->ConstructUrl(array(array($arr['url'],'bid'=>$arr['id'])));
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		return '<li class="listing">
				<div class="blog avatarcol">
					<div class="rcolomn">
						<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('newpost'=>$arr['id']))).'"><b>'.$this->Mainclass->lang['blogs']['tplnewp'].'</b></a><br /><hr />
						<b>'.$this->Mainclass->lang['blogs']['tptagna'].'</b> <a href="'.$url.'"><b>'.$arr['title'].'</b></a><br />
						<b>'.$this->Mainclass->lang['blogs']['tddcrea'].'</b> '.substr($arr['crdate'],0,10).'<br />
						<b>'.$this->Mainclass->lang['blogs']['tpnumpo'].'</b> '.$arr['posts'].'<br />
						<b>'.$this->Mainclass->lang['blogs']['tplttyp'].'</b> '.($arr['type']=='public' ? $this->Mainclass->lang['blogs']['tplpubl'] : $this->Mainclass->lang['blogs']['tplpriv']).'<br />
						<b>'.$this->Mainclass->lang['blogs']['tdescrb'].'</b> '.$status.($arr['descr'] ? $arr['descr'] : '').($arr['categs'] ? '<!-- CAT'.$arr['id'].' -->' : '').'<br />
						<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('tags'=>$arr['id']))).'"><img src="'.$this->Mainclass->Template->GetImage('tagsmanag.png').'" alt="'.$this->Mainclass->lang['main']['tags'].'" /></a><br />'
						.($arr['categs'] ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('categories'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tplcatm'].'"><img src="'.$this->Mainclass->Template->GetImage('catmanag.png').'" alt="'.$this->Mainclass->lang['blogs']['tplcatm'].'" /></a> ' : '')
						.'<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('editblog'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tpledit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['blogs']['tpledit'].'" /></a>
						<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('deleteblog'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tpldele'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['blogs']['tpldele'].'" /></a>
					</div>
					<div class="lcolomn">'.($arr['logo'] ? '<a href="'.$url.'"><img width="80" src="'.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$arr['logo'].'" alt="'.$arr['title'].'" title="'.$arr['title'].'" /></a>' : '').'</div>
					<div class="clr"></div>
				</div></li>';
	}

	#Строка списка блогов
	public function BlogsTableList($arr)
	{
		$status='';
		if($arr['last_id'])
			$last='<a href="'.$this->Mainclass->Url->ConstructUrl(array(array($arr['url'],true),array($arr['curl'],true),array($arr['last_url'],'pid'=>$arr['last_id']))).'">'.$arr['last_title'].'</a><br /><span class="small">'.$this->Mainclass->lang['blogs']['tplaut_'].' <a href="'.$this->Mainclass->Login->UserLink($arr['last_author'],$arr['last_author_id']).'">'.$arr['last_author'].'</a> '.$this->Mainclass->lang['blogs']['tpldat_'].' '.substr($arr['last_date'],0,10).'</span>';
		else
			$last='--<b>'.$this->Mainclass->lang['blogs']['tplaut_'].'</b> --<b>'.$this->Mainclass->lang['blogs']['tpldat_'].'</b> --';
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
		$url=$this->Mainclass->Url->ConstructUrl(array(array($arr['url'],'bid'=>$arr['id'])));
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		return '<li class="listing">
				<div class="blog avatarcol">
					<div class="rcolomn">
						'.($arr['type']=='public' ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('newpost'=>$arr['id']))).'"><b>'.$this->Mainclass->lang['blogs']['tplnewp'].'</b></a>' : '<i>'.$this->Mainclass->lang['blogs']['tpldisa'].'</i>').'<br /><hr />
						<b>'.$this->Mainclass->lang['blogs']['tptagna'].'</b> <a href="'.$url.'"><b>'.$arr['title'].'</b></a><br />
						<b>'.$this->Mainclass->lang['blogs']['tplaut_'].'</b> '.(isset($arr['author_id']) ? $this->Mainclass->lang['blogs']['tplaut_'].' '.$this->Author($arr['author_id'],$arr['author']) : '').'<br />
						<b>'.$this->Mainclass->lang['blogs']['tddcrea'].'</b> '.substr($arr['crdate'],0,10).'<br />
						<b>'.$this->Mainclass->lang['blogs']['tpnumpo'].'</b> '.$arr['posts'].'<br />
						<b>'.$this->Mainclass->lang['blogs']['tplttyp'].'</b> '.($arr['type']=='public' ? $this->Mainclass->lang['blogs']['tplpubl'] : $this->Mainclass->lang['blogs']['tplpriv']).'<br />
						<b>'.$this->Mainclass->lang['blogs']['tdescrb'].'</b> '.$status.($arr['descr'] ? $arr['descr'] : '').($arr['categs'] ? '<!-- CAT'.$arr['id'].' -->' : '').'<br />
						<hr />
						<b>'.$this->Mainclass->lang['blogs']['tpllast'].':</b> '.$last.'<br />
					</div>
					<div class="lcolomn">'.($arr['logo'] ? '<a href="'.$url.'"><img width="80" src="'.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$arr['logo'].'" alt="'.$arr['title'].'" title="'.$arr['title'].'" /></a>' : '').'</div>
					<div class="clr"></div>
				</div></li>';
	}

	#Конец списка блогов
	public function BlogsEndTable($canadd=false)
	{
		$content='</ul>';
		if($canadd)
			$content.='<div class="submitline"><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('do'=>'newblog'))).'" class="link-button" style="width:150px"><b>'.$this->Mainclass->lang['blogs']['creblog'].'</b></a></div>';
		return $content;
	}

	#Интерфейс редактирования блога
	public function AddEditBlog($error,$title,$bvalue,$values,$dis,$image)
	{
		return ($error ? $this->Mainclass->Template->Message($error) : '')
		.'<form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('saveblog'=>$values['id']))).'">
		<table class="tabstyle tabform" align="center">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpblnam'].'</td><td>'.Template::Edit('title',$values['title']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplurl_'].'</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplangd'].'</td><td>'.$this->Mainclass->Editor->Area('descr',$values['descr'],5).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tperpag'].'</td><td>'.Template::Edit('per_page',$values['per_page']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpblwca'].'</td><td>'.Template::Check('categs',$values['categs']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tptype_'].'</td><td>'.Template::Select('type',Template::Option($this->Mainclass->lang['blogs']['tplpriv'],'personal',$values['type']=='personal').Template::Option($this->Mainclass->lang['blogs']['tplpubl'],'public',$values['type']=='public')).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpllogo'].'</td><td><span id="img_upload"></span>
			<div style="padding: 5px 0;"><img style="border: 1px solid #c9c7c3;" id="blog_image" src="'.$image.'" alt="" /></div>
			'.Template::Button($this->Mainclass->lang['blogs']['tplcanc'],'button','id="cancel_upload" disabled="disabled" onclick="swfu.cancelUpload()"').Template::Button($this->Mainclass->lang['blogs']['tpldele'],'button','id="del_button" onclick="DeleteBlockLogoImg('.(int)$values['id'].')"'.$dis).'</td></tr>
		<tr><td class="label"></td><td>'.Template::Button($bvalue,'submit','id="reg"').($values['id']==0 ? '' : ' '.Template::Button($this->Mainclass->lang['blogs']['tpldele'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('deleteblog'=>$values['id'])).'\'"')).'</td></tr></table></form>
		<script type="text/javascript">//<![CDATA[
		var swfu = new SWFUpload({
			flash_url : "addons/swfupload/swfupload.swf",
			upload_url: "'.ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/upload.php",
			file_post_name:"image",
			post_params: {"module": "'.$this->Mainclass->GetModVal('name').'","session":"'.session_id().'"},
			file_size_limit : "2 MB",
			file_types : "*.jpg;*.png;*.gif;",
			file_types_description : "Images",
			file_upload_limit : "0",
			file_queue_limit : "1",

			file_queue_error_handler : fileQueueError,
			file_dialog_complete_handler : fileDialogComplete,
			upload_progress_handler : uploadProgress,
			upload_error_handler : uploadError,
			upload_success_handler : uploadSuccess,
			upload_complete_handler : uploadComplete,

			button_placeholder_id: "img_upload",
			button_image_url: "'.ELEANOR_PROTOCOL.$this->Mainclass->domain.$this->Mainclass->site_path.'/images/uploader/uploadbtn.png",
			button_text: \'<span class="upbtntext">'.$this->Mainclass->lang['blogs']['tploadl'].'</span>\',
			button_text_style: ".upbtntext { font-size: 11px; color: #6D6A65; font-family: Tahoma, Arial, sans-serif; font-weight: bold; }",
			button_text_left_padding: 16,
			button_text_top_padding: 4,
			button_width: 129,
			button_height: 27,
			button_action : SWFUpload.BUTTON_ACTION.SELECT_FILE,
			button_cursor: SWFUpload.CURSOR.HAND,
			debug: false
		});
		//]]></script>';
	}

	#Шаблон списка подкатегорий блога
	public function CatsSubLine($arr,$categs)
	{
		return '<a href="'.$this->Mainclass->Url->ConstructUrl(array(array($categs[$arr['bid']],true),array($arr['url'],'cid'=>$arr['id']))).'">'.$arr['title'].'</a>';
	}

	#Интерфейс удаления блога
	public function DeleteBlog($arr)
	{
		return '<form action="" method="post">'
			.Template::Control('ok','hidden','ok').$this->Mainclass->Template->Message(sprintf($this->Mainclass->lang['blogs']['tpaysdb'],$arr['title'],$arr['crdate']).'<div class="submitline">'.Template::Button($this->Mainclass->lang['blogs']['tpl_yes']).' '.Template::Button($this->Mainclass->lang['blogs']['tpl_no'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array(array('do'=>'my'))).'\'"').'</div>','confirm')
			.'</form>';
	}

	#Шапка списка авторов
	public function AuthorsListBegin()
	{
		return '<div class="base"><div class="binner"><ul class="reset listing">';
	}

	#Строка списка авторов
	public function AuthorsList($arr)
	{
		return '<li><a href="'.$this->Mainclass->Login->UserLink($arr['author'],$arr['author_id']).'"><b>'.$arr['author'].'</b></a> - <a href="'.$this->Mainclass->Url->ConstructUrl(array(array('userblogs'=>$arr['author_id']))).'">'.sprintf($this->Mainclass->lang['blogs']['tpl%sbl'],$arr['cntb']).'</a>, <a href="'.$this->Mainclass->Url->ConstructUrl(array(array('userposts'=>$arr['author_id']))).'">'.sprintf($this->Mainclass->lang['blogs']['tpl%spo'],$arr['cntp']).'</a>.</li>';
	}

	#Конец списка авторов
	public function AuthorsListEnd()
	{
		return '</ul></div></div>';
	}

	#Начало списка моих категорий - когда пользователь просматриват список своих категорий и может их править.
	public function MyCatsListBegin()
	{
		return '<table class="tabstyle"><tr align="center"><th colspan="2">'.$this->Mainclass->lang['blogs']['tpltitl'].'</th><th width="50">'.$this->Mainclass->lang['blogs']['tpostst'].'</th><th width="100">'.$this->Mainclass->lang['blogs']['tplfunc'].'</th></tr>';
	}

	#Сообщение, что категорий нет.
	public function MyCatsListEmpty()
	{
		return '<tr><td align="center" colspan="4" style="font-weight:bold">'.$this->Mainclass->lang['blogs']['tpnocat'].'</td></tr>';
	}

	#Строка списка моих категорий - когда пользователь просматриват список своих категорий и может их править.
	public function MyCatsList($arr,$barr,$cnt)
	{
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
		$url=$this->Mainclass->Url->ConstructUrl(array(array($arr['url'] ? $barr['url'] : '','bid'=>$barr['id'],true),array($arr['url'],'cid'=>$arr['id'])));
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		$updown=($arr['pos']>0 ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('movecatup'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tplmoup'].'"><img src="'.$this->Mainclass->Template->GetImage('up.png').'" alt="'.$this->Mainclass->lang['blogs']['tplmoup'].'" /></a>' : '').(($arr['pos']+1)>=$cnt ? '' : '<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('movecatdown'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tpldown'].'"><img src="'.$this->Mainclass->Template->GetImage('down.png').'" alt="'.$this->Mainclass->lang['blogs']['tpldown'].'" /></a>');
		return '<tr>'.($arr['logo'] ? '<td width="2%"><a href="'.$url.'"><img src="images/categories/'.$arr['logo'].'" alt="'.$arr['title'].'" title="'.$arr['title'].'" /></a></td><td>' : '<td colspan="2">').'
				<a href="'.$url.'"><b>'.$arr['title'].'</b></a>'.($arr['descr'] ? '<br /><i>'.$arr['descr'].'</i>' : '').'</td>
				<td align="center">'.$arr['posts'].'</td>
				<td class="function"><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('newpost'=>$barr['id']),array('cid'=>$arr['id']))).'">'.$this->Mainclass->lang['blogs']['tplnewp'].'</a><br /><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('editcat'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tpledit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['blogs']['tpledit'].'" /></a>'.
				$updown.'<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('deletecat'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tpldele'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['blogs']['tpldele'].'" /></a></td>
		</tr>';
	}

	#Конец списка категорий
	public function MyCatsListEnd($barr)
	{
		return '</table><div align="center" style="margin:10px"><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('newcat'=>$barr['id']))).'" class="link-button" style="width:150px"><b>'.$this->Mainclass->lang['blogs']['crcateg'].'</b></a></div>';
	}

	#Интерфейс добавления категории
	public function AddEditCat($error,$title,$bvalue,$values,$cimgs,$blogs)
	{
		return ($error ? $this->Mainclass->Template->Message($error) : '')
		.'<form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('savecat'=>$values['id']))).'">
		<table class="tabstyle tabform" align="center">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplcana'].'</td><td>'.Template::Edit('title',$values['title']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpcaurl'].'</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplangd'].'</td><td>'.$this->Mainclass->Editor->Area('descr',$values['descr'],5).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpcapos'].'</td><td>'.Template::Edit('pos',$values['pos']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpblog_'].'</td><td>'.Template::Select('bid',$blogs).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpllogo'].'</td><td>'.Template::Select('image',Template::Option($this->Mainclass->lang['main']['no'],0,empty($values['logo'])).$cimgs,'onchange="document.images.preview.src=this.value==\'0\' ? \'images/categories/none.png\' : this.value"').'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplprev'].'</td><td><img src="'.((!$values['image'] or !is_file($this->Mainclass->FormatPath($values['image']))) ? 'images/categories/none.png' : $values['image']).'" id="preview" alt="'.$this->Mainclass->lang['blogs']['tplprev'].'" title="'.$this->Mainclass->lang['blogs']['tplprev'].'" /></td></tr>
		<tr><td class="label"></td><td>'.Template::Button($bvalue).($values['id']==0 ? '' : ' '.Template::Button($this->Mainclass->lang['blogs']['tpldele'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('deletecat'=>$values['id'])).'\'"')).'</td></tr></table></form>';
	}

	#Интерфейс удаления категориии
	public function DeleteCat($arr)
	{
		return '<form action="" method="post">'
			.Template::Control('ok','hidden','ok').$this->Mainclass->Template->Message(sprintf($this->Mainclass->lang['blogs']['tpdelca'],$arr['title'],Template::Check('deleteposts')).'<div align="center" style="margin:10px">'.Template::Button($this->Mainclass->lang['blogs']['tpl_yes']).' '.Template::Button($this->Mainclass->lang['blogs']['tpl_no'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array(array('categories'=>$arr['bid']))).'\'"').'</div>','confirm')
			.'</form>';
	}

	#Список моих тегов
	public function MyTagsListBegin()
	{
		return '<table class="tabstyle"><tr class="tablethhead"><th>'.$this->Mainclass->lang['blogs']['tpltitl'].'</th><th width="50">'.$this->Mainclass->lang['blogs']['tpostst'].'</th><th width="100">'.$this->Mainclass->lang['blogs']['tplfunc'].'</th></tr>';
	}

	#Сообщение, что тегов нет
	public function MyTagsListEmpty()
	{
		return '<tr><td colspan="4">'.$this->Mainclass->lang['blogs']['tpntags'].'</td></tr>';
	}

	#Строка списка моих тегов
	public function MyTagsList($arr,$barr)
	{
		$url=$this->Mainclass->Url->ConstructUrl(array(array($barr['url'],'bid'=>$barr['id'],true),array('tag'=>$arr['name'],true),array('tid'=>$arr['id'],false)));
		return '<tr><td><a href="'.$url.'"><b>'.$arr['title'].'</b></a></td>
				<td align="center">'.$arr['posts'].'</td>
				<td class="function"><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('edittag'=>$arr['id']))).'" title="'.$this->Mainclass->lang['blogs']['tpledit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['blogs']['tpledit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('deletetag'=>$arr['id']))).'" onclick="return confirm(\''.$this->Mainclass->lang['blogs']['tpdelta'].'\')" title="'.$this->Mainclass->lang['blogs']['tpldele'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['blogs']['tpldele'].'" /></a></td>
		</tr>';
	}

	#Конец списка моих тегов
	public function MyTagsListEnd($barr)
	{
		return '</table>';
	}

	#Интерфейс редактирования тега
	public function EditTag($error,$title,$values)
	{
		return ($error ? $this->Mainclass->Template->Message($error) : '')
		.'<div class="base"><div class="binner"><form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('savetag'=>$values['id']))).'">
		<table class="tabstyle tabform">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tptagna'].'</td><td>'.Template::Edit('name',$values['name']).'</td></tr>
		<tr><td class="label"></td><td>'.Template::Button().'</td></tr></table></form></div></div>';
	}

	#Интерфейс добавления/правки записи в блоге
	public function AddEditPost($barr,$error,$title,$values,$cats,$other_cats,$upload,$back)
	{
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
		$burl=$this->Mainclass->Url->ConstructUrl(array(array($barr['url'],'bid'=>$barr['id'])));
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		return ($error ? $this->Mainclass->Template->Message($error) : '')
		.'<div class="base"><div class="binner"><form method="post" action="'.$this->Mainclass->Url->ConstructUrl(array(array('bid'=>$barr['id']),array('savepost'=>$values['id']))).'">
		<table class="tabstyle tabform">
		<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpblog_'].'</td><td><a href="'.$burl.'">'.$barr['title'].'</a></td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tptagna'].'</td><td>'.Template::Edit('title',$values['title']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpcaurl'].'</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
		'.(($barr['categs'] and $cats) ? '<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpgenca'].'</td><td>'.Template::Select('cid',$cats).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpaddca'].'</td><td>'.Template::Items('cats',$other_cats).'</td></tr>' : '').'
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tags'].'</td><td>'.Template::Edit('tags',$values['tags']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpltext'].'</td><td>'.$this->Mainclass->Editor->Area('text',$values['text'],10).'</td></tr>
		<tr><td colspan="2">'.$upload.'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplssto'].'</td><td>'.Template::Check('show_sokr',$values['show_sokr']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tpalloc'].'</td><td>'.Template::Check('allow_comm',$values['allow_comm']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['blogs']['tplstat'].'</td><td>'.Template::Check('status',$values['status']).'</td></tr></table>
		<div class="submitline">'.($back ? Template::Control('back','hidden',base64_encode($back)) : '').Template::Button().($values['id']==0 ? '' : ' '.Template::Button($this->Mainclass->lang['blogs']['tpldele'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('deletepost'=>$values['id'])).'\'"')).'</div></form></div></div>';
	}

	#Интерфейс удаления сообщения
	public function DeletePost($arr,$back)
	{
		return '<form action="" method="post">'
			.Template::Control('ok','hidden','ok').$this->Mainclass->Template->Message(sprintf($this->Mainclass->lang['blogs']['tpldelp'],$arr['title']).'<div class="submitline">'.Template::Button($this->Mainclass->lang['blogs']['tpl_yes']).' '.Template::Button($this->Mainclass->lang['blogs']['tpl_no'],'button','onclick="window.location=\''.($back ? $back : $this->Mainclass->Url->ConstructUrl()).'\'"').'</div>','confirm')
			.'</form>';
	}

	#Интерфейс кнопок "Удалить и править"
	public function DeleteEdit($arr)
	{
		$uid=$this->Mainclass->Account->GetValue('id');
		if(!$uid)
			return '';
		if($arr['author_id']==$uid or $arr['bid']==$uid or $this->Mainclass->Permission->IsAdmin())
			return '<div class="function"><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('editpost'=>$arr['id']))).'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('deletepost'=>$arr['id']))).'" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></div>';
	}

	#Интерфейс записи блога в общем списке: при просмотре категории или блога, например.
	public function PostInList($arr,$rating,$type='')
	{
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
		$burl='<a href="'.$this->Mainclass->Url->ConstructUrl(array(array($arr['burl'],'bid'=>$arr['bid']))).'" style="color:darkgray">'.$arr['btitle'].'</a>';
		$curl=($arr['categs'] and $arr['cid']) ? '<span class="arg">'.$this->Mainclass->lang['blogs']['tplccat'].' <a href="'.$this->Mainclass->Url->ConstructUrl(array(array($arr['curl'] ? $arr['burl'] : '',true),array($arr['curl'],'cid'=>$arr['cid']))).'">'.$arr['ctitle'].'</a></span>' : $arr['curl']='';
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		$url=$this->Mainclass->Url->ConstructUrl(array(array($arr['url'] ? $arr['burl'] : '',true),array($arr['url'] ? $arr['curl'] : '',true),array($arr['url'],'pid'=>$arr['id'])));
		$more='<span class="argmore"><a href="'.$url.'#more">'.$this->Mainclass->lang['blogs']['tprmore'].'</a></span>';
		$comments=$arr['allow_comm'] ? '<span class="arg"><a href="'.$url.'#comments">'.$this->Mainclass->lang['blogs']['tplcomm'].' '.$arr['comments'].'</a></span>' : '';
		$url='<a href="'.$url.'">'.$arr['title'].'</a>';
		return '<div class="base"><div class="heading"><div class="binner">
		<h1>'.$burl.' <code style="color:black">&gt;</code> '.$url.'</h1>
		<div class="moreinfo"><span class="arg">'.$this->Mainclass->lang['blogs']['tpcring'].' '.substr($arr['date'],0,-3).'</span>'.((int)$arr['editdate'] ? '<span class="arg">'.$this->Mainclass->lang['blogs']['tpediti'].' '.substr($arr['editdate'],0,-3).'</span>' : '').$curl.' <div class="arg">'.$this->Mainclass->lang['blogs']['tposted'].$this->Author($arr['author_id'],$arr['author']).'</div>'.$comments.'<span class="arg">'.$this->Mainclass->lang['blogs']['tpviews'].$arr['reads'].'</span><div class="clr"></div></div>
		<div class="clr"></div>
	</div></div>
	<div class="maincont"><div class="binner">'.$arr['text'].$this->DeleteEdit($arr).'<div class="clr"></div>
	</div></div>
	<div class="morelink"><div class="binner">
		<div class="ratebase">'.$rating.'</div>
		'.$more.'
		<div class="clr"></div>
	</div></div>
</div>';
	}

	#Шапка при просмотре записей пользователя
	public function UserPostsBegin($uname,$id,$cnt)
	{
		if($cnt==0)
			return $this->Mainclass->Template->Message(sprintf($this->Mainclass->lang['blogs']['tpnousp'],$this->Author($id,$uname)));
		else
			return '<div align="center"><b>'.$this->Mainclass->lang['blogs']['tpostu_'].' '.$this->Author($id,$uname).'</b></div><hr />';
	}

	#Показ ссылки на автора
	public function Author($id,$name)
	{
		return '<div class="bwhoposted" style="display: inline;"><a href="'.$this->Mainclass->Login->UserLink($name,$id).'">'.$name.'</a>
	<div class="in mmenusub" style="display:none;">
	<ul>
	<li><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('userposts'=>$id))).'">'.$this->Mainclass->lang['blogs']['tpostu_'].'</a></li>
	<li><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('userblogs'=>$id))).'">'.$this->Mainclass->lang['blogs']['tpblous'].'</a></li>
	</ul>
	</div></div>';
	}

	#Показ шапки блога, при просмотре блога
	public function ShowBlog($barr,$carr)
	{
		$logo=$barr['logo'] ? '<img src="'.Mainclass::UPLOADS_DIR.'/blogs/blogs_logo/'.$barr['logo'].'" alt="'.$barr['title'].'" title="'.$barr['title'].'" />' : $this->Mainclass->lang['blogs']['tpnolog'];
		$head='
	<div class="base"><div class="binner">
	<ul class="reset listing">
	<li class="listing">
	<div class="avatarcol">
		<div class="rcolomn">
			'.(($barr['type']=='public' or $barr['author_id']==$this->Mainclass->Account->GetValue('id')) ? '<a href="'.$this->Mainclass->Url->ConstructUrl(array(array('newpost'=>$barr['id']))).'"><b>'.$this->Mainclass->lang['blogs']['tplnewp'].'</b></a><br /><hr />' : '').'
			<b>'.$this->Mainclass->lang['blogs']['tptagna'].'</b> '.$barr['title'].'<br />
			<b>'.$this->Mainclass->lang['blogs']['tdcreat'].'</b> '.$this->Author($barr['author_id'],$barr['author']).'<br />
			<b>'.$this->Mainclass->lang['blogs']['tddcrea'].'</b> '.$barr['crdate'].'<br />
			<b>'.$this->Mainclass->lang['blogs']['tperpag'].'</b> '.$barr['per_page'].'<br />
			<b>'.$this->Mainclass->lang['blogs']['tpnumpo'].'</b> '.$barr['posts'].'<br />
			<b>'.$this->Mainclass->lang['blogs']['tplttyp'].'</b> '.($barr['type']=='public' ? $this->Mainclass->lang['blogs']['tplpubl'] : $this->Mainclass->lang['blogs']['tplpriv']).'<br />
			<b>'.$this->Mainclass->lang['blogs']['tdescrb'].'</b> '.$barr['descr'].'<br />
		</div>
		<div class="lcolomn"><div class="avatarbox">'.$logo.'</div></div>
		<div class="clr"></div>
	</div>
	</li>
	</ul>
</div></div>';
		if($barr['categs'] and $carr)
		{
			$head.='<div class="base"><div class="binner"><b>'.$this->Mainclass->lang['blogs']['tp_cats'].'</b><br /><ul class="reset listing">';
				$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
			foreach($carr as &$v)
			{
				$url=$this->Mainclass->Url->ConstructUrl(array(array($v['url'] ? $barr['url'] : '',true),array($v['url'],'cid'=>$v['id'])));
				$logo=$v['logo'] ? '<a href="'.$url.'"><img width="16" style="vertical-align: middle; margin-right: 4px;" src="images/categories/'.$v['logo'].'" alt="'.$v['title'].'" title="'.$v['title'].'" /></a>' : '';
				$head.='<li class="listing">'.$logo.'<a href="'.$url.'">'.$v['title'].'</a></li>';
			}
			$head.='</ul></div></div>';
		}
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		return $head;
	}

	#Показ постов внутри блога. Когда мы просматриваем блог - выводится список постов.
	public function PostsInBlog($arr,$barr,$carr,$rating)
	{
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
		$burl='<a href="'.$this->Mainclass->Url->ConstructUrl(array(array($barr['url'],'bid'=>$barr['id']))).'" style="color:darkgray">'.$barr['title'].'</a>';
		$curl=($barr['categs'] and $carr) ? '<span class="arg">'.$this->Mainclass->lang['blogs']['tplccat'].' <a href="'.$this->Mainclass->Url->ConstructUrl(array(array($carr['url'] ? $barr['url'] : '',true),array($carr['url'],'cid'=>$carr['id']))).'">'.$carr['title'].'</a></span>' : $carr['url']='';
		$this->Mainclass->Url->ending=$this->Mainclass->vars['m_blogs_ending'];
		$url=$this->Mainclass->Url->ConstructUrl(array(array($arr['url'] ? $barr['url'] : '',true),array(($arr['url'] and $carr) ? $carr['url'] : '',true),array($arr['url'],'pid'=>$arr['id'])));
		$more='<span class="argmore"><a href="'.$url.'#more">'.$this->Mainclass->lang['blogs']['tprmore'].'</a></span>';
		$comments=$arr['allow_comm'] ? '<span class="arg"><a href="'.$url.'#comments">'.$this->Mainclass->lang['blogs']['tplcomm'].$arr['comments'].'</a></span>' : '';
		$url='<a href="'.$url.'">'.$arr['title'].'</a>';
		return '<div class="base"><div class="heading"><div class="binner">
		<h1>'.$burl.' <code style="color:black">&gt;</code> '.$url.'</h1>
		<div class="moreinfo">
		<span class="arg">'.$this->Mainclass->lang['blogs']['tpcring'].substr($arr['date'],0,-3).'</span>'.((int)$arr['editdate'] ? '<span class="arg">'.$this->Mainclass->lang['blogs']['tpediti'].substr($arr['editdate'],0,-3).'</span>' : '')
		.$curl.' <div class="arg">'.$this->Mainclass->lang['blogs']['tposted'].$this->Author($arr['author_id'],$arr['author']).'</div>'.$comments.'<span class="arg">'.$this->Mainclass->lang['blogs']['tpviews'].$arr['reads'].'</span><div class="clr"></div></div>
		<div class="clr"></div>
	</div></div>
	<div class="maincont"><div class="binner">'.$arr['text'].$this->DeleteEdit($arr).'<div class="clr"></div>
	</div></div>
	<div class="morelink"><div class="binner">
		<div class="ratebase">'.$rating.'</div>
		'.$more.'
		<div class="clr"></div>
	</div></div>
</div>';
	}

	#Показ шапки категории
	public function ShowCategory($barr,$carr)
	{
		$logo=$carr['logo'] ? '<img src="images/categories/'.$carr['logo'].'" alt="'.$carr['title'].'" title="'.$carr['title'].'" />' : '--';
		return '<div class="base"><div class="binner"><div class="avatarcol">
	<div class="rcolomn">
		<b>'.$this->Mainclass->lang['blogs']['tptagna'].'</b> '.$carr['title'].'<br />
		<b>'.$this->Mainclass->lang['blogs']['tdescrb'].'</b> '.$carr['descr'].'<br />
		<b>'.$this->Mainclass->lang['blogs']['tpblog_'].'</b> <a href="'.$this->Mainclass->Url->ConstructUrl(array(array($barr['url'],'bid'=>$barr['id']))).'">'.$barr['title'].'</a><br />
		<b>'.$this->Mainclass->lang['blogs']['tpnumpo'].'</b> '.$carr['posts'].'<br />
		'.(($barr['type']=='public' or $barr['author_id']==$this->Mainclass->Account->GetValue('id')) ? '<hr /><a href="'.$this->Mainclass->Url->ConstructUrl(array(array('newpost'=>$barr['id']),array('cid'=>$carr['id']))).'">'.$this->Mainclass->lang['blogs']['tplnewp'].'</a>' : '').'
	</div>
	<div class="lcolomn" style="text-align: center;">
		'.$logo.'
	</div>
	<div class="clr"></div>
</div></div></div>';
	}

	#Показ шапки при просмотре списка записей тега
	public function ShowTag($barr,$tarr)
	{
		return $this->Mainclass->Template->Title(sprintf($this->Mainclass->lang['blogs']['tpltagp'],$tarr['name']));
	}

	#Пока шапки результатов поиска
	public function SResultsHead($title)
	{
		return $this->Mainclass->Template->Message($title,'info');
	}

	#Показ поста при подробном просмотре.
	public function ShowPost($arr,$barr,$carr,$tags,$rating,$bookmark)
	{
		$curl=($barr['categs'] and $carr) ? '<span class="arg">'.$this->Mainclass->lang['blogs']['tplccat'].' <a href="'.$this->Mainclass->Url->ConstructUrl(array(array($carr['url'] ? $barr['url'] : '',true),array($carr['url'],'cid'=>$carr['id']))).'">'.$carr['title'].'</a></span>' : $carr['url']='';
		return '<div class="base">
	<div class="heading"><div class="binner">
		<h1>'.$arr['title'].'</h1>
		<div class="moreinfo">
			<div class="arg">'.$this->Mainclass->lang['blogs']['tposted'].$this->Author($arr['author_id'],$arr['author']).'</div>
			<span class="arg">'.$this->Mainclass->lang['blogs']['tpcring'].substr($arr['date'],0,-3).'</span>'.((int)$arr['editdate'] ? '<span class="arg">'.$this->Mainclass->lang['blogs']['tpediti'].substr($arr['editdate'],0,-3).'</span>' : '')
			.'<span class="arg">'.$curl.'</span>
			<span class="arg">'.$this->Mainclass->lang['blogs']['tpviews'].$arr['reads'].'</span>
			<div class="clr"></div>
		</div>
		<div class="clr"></div>
	</div></div>
	<div class="maincont"><div class="binner">'.$arr['text']
	.'<br /><br />'.$this->Mainclass->lang['main']['tags'].': '.($tags ? join(', ',$tags) : '<i>'.$this->Mainclass->lang['blogs']['tplnono'].'</i>')
	.$this->DeleteEdit($arr).'<div class="clr"></div>
		<div class="clr"></div>
	</div></div>
	<div class="morelink"><div class="binner">
		<div class="ratebase">'.$rating.'</div>
		<span class="arg"><a href="#" onclick="history.go(-1); return false;"><b>'.$this->Mainclass->lang['main']['back'].'</b></a></span>
		<span class="arg" id="bookmark">'.$bookmark.'</span>
		<div class="clr"></div>
	</div></div>
	<div id="bookmark_params" style="display:none"></div>
</div>';
	}
}
?>