<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
$start=microtime();#Начало отсчета времени движка.
define('CMS',true);
require dirname(__file__).'/classes/mainclass.php';
$Mainclass=MainClass::getInstance();
$Mainclass->start_time=$start;
$Mainclass->service_id='4';#ID сервиса
$Mainclass->file_name=basename(__file__);
if(0<$t=strpos($Mainclass->site_path,$Mainclass->file_name))
	$Mainclass->site_path=$t==1 ? '' : substr($Mainclass->site_path,0,$t-1);
$Mainclass->LoadOptions(array('system','public','blocker','login'));
$Mainclass->LoadService();
include $Mainclass->root_path.'classes/others/class_uploader.php';
if(!empty($_REQUEST['module']))
{
	$where=ctype_digit($_REQUEST['module']) ? '`id`='.(int)$_REQUEST['module'] : '(`name`=\''.($mid=$Mainclass->Db->EscapeString($_REQUEST['module'])).'\' OR `path` LIKE \'%'.$_REQUEST['module'].'\')';
	$Mainclass->Db->Query('SELECT `id`,`services`,`name`,`title`,`path`,`multiservice`,`file`,`is_class`,`resources`,`image`,`user_groups` FROM `prefix_modules` WHERE '.$where.' AND `active` LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitPage();
	$arr=$Mainclass->Db->Fetch_Assoc();
	$arr['user_groups']=Strings::CleanForExplode($arr['user_groups']);
	if($arr['user_groups'])
	{
		$groups=explode(',',$arr['user_groups']);
		$user_groups=$Mainclass->Account->GetUserGroups();
		if(count(array_intersect($groups,$user_groups))==0)
			ExitPage();
	}
	if(strpos($arr['services'],','.$Mainclass->service_id.',')===false and $arr['resources'])
	{
		$resources=explode('·',Strings::CleanForExplode($arr['resources']));
		foreach($resources as &$v)
		{
			$temp=explode('=',$v,2);
			if($Mainclass->service==$temp[0])
			{
				$arr['file']=$temp[1];
				break;
			}
		}
	}
	if(!$arr['file'])
		ExitPage();
	$Mainclass->module['name']=$arr['name'];
	$Mainclass->module['title']=$arr['title'];
	$Mainclass->module['image']=$arr['image'];
	$Mainclass->module['path']=$arr['path'];
	$Mainclass->module['general']=false;
	$Mainclass->module['id']=$arr['id'];
	if(!$Mainclass->LoadModule($arr['path'],$arr['multiservice'],$arr['file'] ? $arr['file'] : 'index',$arr['is_class']))
		ExitPage('Невозможно загрузить файл');
}
elseif(isset($_FILES[Uploader::FILENAME]) and is_uploaded_file($_FILES[Uploader::FILENAME]['tmp_name']))
	SWFUpload();
elseif(isset($_REQUEST['direct']) and is_string($_REQUEST['direct']) and is_file($f=$Mainclass->root_path.'addons/direct/'.preg_replace('#[^a-z0-9]+#i','',$_REQUEST['direct']).'.php'))
	include $f;
else
	ExitPage();
function SWFUpload()
{global $Mainclass;
	$Mainclass->Loadclass('classes/others/class_uploader.php');
	if(!$Mainclass->Uploader->DoUpload())
		ExitPage(true);
}

function ExitPage($error=false)
{global $Mainclass;
	if($error)
		header('HTTP/1.0 500 Internal Server Error');
	else
		Functions::Redirect(ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path);
}

#Функция "Будь как", делает сервис AJAX похожим на другой сервис
function BeAs($idname='')
{global $Mainclass;
	if($Mainclass->service==$idname or $Mainclass->service_id==$idname)
		return;
	if(!$idname)
		$idname=2;
	foreach($Mainclass->services as &$arr)
		if($arr['id']==$idname or $arr['id']==$idname)
			break;
	$Mainclass->Permission->CleanAll();
	$id=$Mainclass->service_id;
	$name=$Mainclass->service;
	$Mainclass->service_id=$arr['id'];
	$Mainclass->service=$arr['name'];
	$Mainclass->file_name=$arr['file'];
	$Mainclass->Functions->GetLangCookie(true,$Mainclass->service.'_lang');
	$Mainclass->LoadLanguage('langs','main',$arr['name'].'-%');
	if(!empty($arr['login']) and $Mainclass->services[$id]['login']!=$arr['login'])
	{
		$Mainclass->Account->LogOut(false);
		if(isset($Mainclass->Login) and ($Mainclass->Login instanceof LoginClass))
			unset($Mainclass->Login);
		$Mainclass->LoadLogin($arr['login']);
	}
	$Mainclass->Login->IsUser();
	$Mainclass->service_id=$id;
	$Mainclass->service=$name;
	$Mainclass->Template->theme=$arr['theme'];
	$Mainclass->Url->furl=$arr['id']==2 ? $Mainclass->vars['furl'] : false;
	$Mainclass->service=$arr['name'];
}
?>