<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->lang['th_edit']=$lang=$Mainclass->LoadLanguage('addons/adminka/langs','','theme_editor-%');
$event=strtolower($Mainclass->AJAX['event']);
switch ($event)
{
	case 'copy':
		$name=empty($_REQUEST['copy_name']) ? '' : $_REQUEST['copy_name'];
		$theme=empty($_REQUEST['theme']) ? '' : $_REQUEST['theme'];
		if(empty($name) or preg_match('#^[a-z0-9\-_\.]+$#i',$name)==0 or empty($theme) or preg_match('#^[a-z0-9\-_\.]+$#i',$theme)==0)
		{
			Error($lang['incorr_symb']);
			break;
		}
		if(file_exists($Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$name))
		{
			Error(sprintf($lang['theme_exists'],$name));
			break;
		}
		if(!file_exists($Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$theme))
		{
			Error(sprintf($lang['no_ish_thm'],$name));
			break;
		}
		$res=Functions::Copy($Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$theme,$Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$name);
		if(file_exists($Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$theme.'.php'))
		Functions::Copy($Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$theme.'.php',$Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.$name.'.php');
		if($res)
			Result('ok');
		else
			Error();
	break;
	case 'get_files':
		$start_folder=isset($_REQUEST['start_folder']) ? $_REQUEST['start_folder'] : Error();
		$destination=isset($_REQUEST['destination']) ? $_REQUEST['destination'] : '';
		$page=isset($_REQUEST['page']) ? (int)$_REQUEST['page'] : 1;
		if($page<1)
			$page=1;
		Result(GetFiles($start_folder,$destination,$page));
	break;
	case 'new_folder':
		$start_folder=isset($_REQUEST['start_folder']) ? $_REQUEST['start_folder'] : Error();
		$folder=isset($_REQUEST['folder']) ? $_REQUEST['folder'] : Error();
		if($folder=='')
		{
			Error($lang['no_title']);
			break;
		}
		if(preg_match('%[\s#"\'\\/:*\?<>|]+%',$folder)>0)
		{
			Error($lang['incorr_symb']);
			break;
		}
		$path=DirPath($start_folder);
		$path.='/'.$Mainclass->Functions->FixWinFileS($folder);
		if(!is_dir($path))
			@mkdir($path);
		if(is_dir($path))
			Result('ok');
		else
			Error($lang['folder_ncr']);
	break;
	case 'rename':
		$start_folder=isset($_REQUEST['start_folder']) ? $_REQUEST['start_folder'] : Error();
		$name=isset($_REQUEST['filename']) ? $_REQUEST['filename'] : Error();
		$newname=isset($_REQUEST['newname']) ? $_REQUEST['newname'] : Error();
		if($newname=='')
		{
			Error($lang['no_title']);
			break;
		}
		if($name==$newname)
			Result('');
		$path=$Mainclass->Functions->FixWinFileS(DirPath($start_folder));
		$name=$Mainclass->Functions->FixWinFileS($name);
		$newname=$Mainclass->Functions->FixWinFileS($newname);
		if(!file_exists($path.'/'.$name))
		{
			Error($lang['no_file']);
			break;
		}
		if(preg_match('%[\s#"\'\\/:*\?<>|]+%',$newname)>0)
		{
			Error($lang['incorr_symb']);
			break;
		}
		if(file_exists($path.'/'.$newname))
		{
			Error($lang['file_exists']);
			break;
		}
		if(rename($path.'/'.$name,$path.'/'.$newname))
			Result('ok');
		else
			Error($lang['not_renamed']);
	break;
	case 'delete':
		$start_folder=isset($_REQUEST['start_folder']) ? $_REQUEST['start_folder'] : Error();
		$name=isset($_REQUEST['filename']) ? $_REQUEST['filename'] : Error();
		$path=DirPath($start_folder,$name,true);
		if(!$path)
		{
			Error($lang['no_file']);
			break;
		}
		if(is_dir($path) ? Functions::RmDir($path) : unlink($path))
			Result('ok');
		else
			Error($lang['not_del']);
	break;
	default:
		Error($Mainclass->lang['main']['unknown_event']);
	break;
}

function GetFiles($start_folder,$move='',$page=1)
{global $Mainclass;
	$per_page=30;
	$files_to_edit=array('php','html','css','txt','js');
	$path=DirPath($start_folder,$move);
	$short_path=substr($path,strlen($Mainclass->root_path.$Mainclass->Template->theme_path)+1);
	if($Mainclass->os=='w')
		$short_path=$Mainclass->Functions->FixWinFileS(str_replace(DIRECTORY_SEPARATOR,'/',$short_path),true);
	$dirs=array();
	$files=glob($path.'/*',GLOB_MARK);
	$cnt_tot=count($files);
	foreach($files as $k=>&$v)
	{
		$fv=$Mainclass->Functions->FixWinFileS($v,true);
		if(substr($fv,-1)==DIRECTORY_SEPARATOR)
		{
			$dirs[]=basename($fv);
			unset($files[$k]);
		}
		else
			$files[$k]=basename($v);
	}
	natsort($dirs);
	natsort($files);
	if($page<1)
		$page=1;
	if($per_page<$cnt_tot and $page<=ceil($cnt_tot/$per_page))
	{
		$cnt_dir=count($dirs);
		$offset=($page-1)*$per_page;
		if(($offset+$per_page)<=$cnt_dir)
		{
			$dirs=array_slice($dirs,$offset,$per_page);
			$files=array();
		}
		elseif($offset<$cnt_dir)
		{
			$dirs=array_slice($dirs,$offset,$per_page);
			$files=array_slice($files,0,$per_page-count($dirs));
		}
		else
		{
			$dirs=array();
			$files=array_slice($files,$offset-$cnt_dir,$per_page);
		}
		$result['pages']=Strings::Pages($cnt_tot,$per_page,'#',false,$page,'et_flist.Go(\'\',\'{page}\')');
		$result['page']=$page;
	}
	else
	{
		$result['pages']='';
		$result['page']=1;
	}
	if(!empty($short_path))
	{
		$arr=explode('/',$short_path);
		$temp=array();
		$cnt=count($arr)-1;
		for($i=0;$i<$cnt;$i++)
			$temp[]='<a href="#" onclick="return et_flist.Go(\''.rtrim(str_repeat('../',$cnt-$i),'/').'\')">'.$arr[$i].'</a>';
		$temp[]=end($arr);
		$walk='<li><a href="#" onclick="return et_flist.Go(\'..\');" title="'.$Mainclass->lang['th_edit']['goup'].'"><img class="typeicon" src="images/uploader/folder_up.gif" alt="'.$Mainclass->lang['th_edit']['goup'].'" style="width: 25px; height: 16px;" /></a><b>/'.implode('/',$temp).'</b></li>';
	}
	foreach($files as &$entry)
	{
		$mtime=date('Y-m-d H:i:s',filemtime($path.'/'.$entry));
		$size=filesize($path.'/'.$entry);
		$type=strtolower(substr($entry,strrpos($entry,'.')+1));
		$tip='';
		if(in_array($type,array('jpeg','jpg','png','bmp','gif','tiff','ico','psd')))
		{
			if(!file_exists($Mainclass->root_path.'images/uploader/file_types/'.$type.'.png'))
				$type='type_image';
			$tip=' onmouseover="Tip(\'&lt;img src=&quot;'.$Mainclass->Template->theme_path.'/'.$short_path.'/'.$entry.'&quot; alt=&quot;&quot; /&gt;\',BGCOLOR,\'#ffffff\')" onmouseout="UnTip()"';
		}
		$entry='<li>
		<span class="buttons">
			'.(in_array($type,$files_to_edit) ? '<a href="'.$Mainclass->services[1]['file'].'?'.$Mainclass->Url->ConstructUrl(array('section'=>'management','module'=>$Mainclass->GetModVal('name'),'edit'=>$short_path.'/'.$entry),false).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="images/uploader/edit.png" alt="'.$Mainclass->lang['main']['edit'].'" style="width: 16px; height: 16px;" /></a>' : '').'
			<a href="#" onclick="return et_flist.Rename(\''.$entry.'\');" title="'.$Mainclass->lang['th_edit']['rename'].'"><img src="images/uploader/rename.png" alt="'.$Mainclass->lang['th_edit']['rename'].'" style="width: 16px; height: 16px;" /></a>
			<a href="#" onclick="return et_flist.DeleteFile(\''.$entry.'\');" title="'.$Mainclass->lang['main']['delete'].'"><img src="images/uploader/delete.png" alt="'.$Mainclass->lang['main']['delete'].'" style="width: 16px; height: 16px;" /></a>
		</span>
		<span class="frdatethm">'.$mtime.'</span>
		<span class="frsizethm">'.round($size/1024,2).' KB</span><img'.$tip.' onclick="window.open(\''.$Mainclass->services[5]['file'].'?'.$Mainclass->Url->ConstructUrl(array('direct'=>'admin','file'=>'themes_editor','filename'=>$short_path.'/'.$entry),false).'\');" class="typeicon" src="'.(file_exists($Mainclass->root_path.'images/uploader/file_types/'.$type.'.png') ? 'images/uploader/file_types/'.$type.'.png' : 'images/uploader/type_file.png').'" title="'.$Mainclass->lang['th_edit']['download'].'" alt="'.$Mainclass->lang['th_edit']['download'].'" style="width:16px;height:16px;cursor:pointer" />'.$entry
		.'</li>';

	}
	foreach($dirs as &$entry)
		$entry='<li>
		<span>
			<a href="#" onclick="return et_flist.Rename(\''.$entry.'\',this.parentNode.parentNode);" title="'.$Mainclass->lang['th_edit']['rename'].'"><img src="images/uploader/rename.png" alt="'.$Mainclass->lang['th_edit']['rename'].'" style="width: 16px; height: 16px;" /></a>
			<a href="#" onclick="return et_flist.DeleteFile(\''.$entry.'\');" title="'.$Mainclass->lang['main']['delete'].'"><img src="images/uploader/delete.png" alt="'.$Mainclass->lang['main']['delete'].'" style="width: 16px; height: 16px;" /></a>
		</span>
		<a href="#" onclick="return et_flist.Go(\''.$entry.'\');"><img class="typeicon" src="images/uploader/type_folder.png" alt="" style="width: 16px; height: 16px;" /><b>'.$entry.'</b></a></li>';
	$files=array_merge($dirs,$files);
	unset($dirs);
	if(!empty($walk))
		array_unshift($files,$walk);
	$result['icons']='';
	$result['files']=implode('',$files);
	$result['folder']=empty($short_path) ? '' : $short_path;
	if(!empty($error))
		$result['error']=implode("\r\n",$error);
	return $result;
}

function DirPath($start_folder,$move='',$retfal=false)
{global $Mainclass;
	$start_folder=str_replace(array('..','/.'),'',$start_folder);
	$start_folder=$Mainclass->Functions->FixWinFileS($Mainclass->root_path.$Mainclass->Template->theme_path.DIRECTORY_SEPARATOR.Strings::CleanForExplode($start_folder,'/'));
	if(!is_dir($start_folder))
		return $retfal ? false : $Mainclass->root_path.$Mainclass->Template->theme_path;
	if($move!='')
		$move='/'.$Mainclass->Functions->FixWinFileS($move);
	$destination=realpath($m=$start_folder.$move);
	if($destination===false)
		return $retfal ? false : $start_folder;
	if(strncmp($destination,$Mainclass->root_path.$Mainclass->Template->theme_path,strlen($Mainclass->root_path.$Mainclass->Template->theme_path))!=0)
		return $retfal ? false : $start_folder;
	return $destination;
}
?>