<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadOptions(array('reg'),false);
$Mainclass->LoadLanguage('addons/adminka/langs','users','users-%');
/*
	Название; Массив (Заголовок, тип, значение по-умолчанию, extra, Описание, addon
	Для раздела, напишите просто ключевой текст
	Пользовательское:
		тип - user
		extra - ссылка на вызываемую функцию
	Формат функции:
	Func($type,$value,$addon='')
	Где $type одно из:
		load - загрузка значения для правки в пользовательском интерфейсе
		loadpost - загрузка значения для правки в пользовательском интерфейсе из значений в POST запросе.. (в случае ошибки)
		save - сохранение
	Функция может выбросить исключение EExceptionNonFatal с типом ошибки
*/
global $users_extra, $mainpage;
$users_extra=array(
'jabber'=>array($Mainclass->lang['users']['jabber'],'edit','','','',''),
'bio'=>array($Mainclass->lang['users']['bio'],'Editor','','','',''),
'icq'=>array($Mainclass->lang['users']['icq'],'edit','','','',''),
'aim'=>array($Mainclass->lang['users']['aim'],'edit','','','',''),
'website'=>array($Mainclass->lang['users']['wsite'],'edit','','','',''),
'yahoo'=>array($Mainclass->lang['users']['yahoo'],'edit','','','',''),
'msn'=>array($Mainclass->lang['users']['msn'],'edit','','','',''),
'skype'=>array('Skype:','edit','','','',''),
'interests'=>array($Mainclass->lang['users']['interes'],'edit','','','',''),
'location'=>array($Mainclass->lang['users']['wherefrom'],'edit','','','',''),
'signature'=>array($Mainclass->lang['users']['signat'],'Editor','','','',''),
);

$mainpage=false;
if(isset($_GET['do']))
	DoIt($_GET['do']);
elseif(isset($_GET['change_pass']))
	ChangePassword((int)$_GET['change_pass']);
elseif(isset($_GET['save_pass']))
	SavePassword((int)$_GET['save_pass']);
elseif(isset($_GET['change_name']))
	ChangeName((int)$_GET['change_name']);
elseif(isset($_GET['save_name']))
	SaveName((int)$_GET['save_name']);
elseif(isset($_GET['edit']))
	Edit((int)$_GET['edit']);
elseif(isset($_GET['save']))
	Save((int)$_GET['save']);
elseif(isset($_GET['kill']))
	Kill((int)$_GET['kill']);
elseif(isset($_GET['sresult']))
	ResultFindUsers($_GET['sresult']);
else
{
	FindUsers();
	$mainpage=true;
}

function DoIt($task)
{global $Mainclass,$mainpage;
	switch ($task)
	{
		case 'new_user':
			NewUser();
		break;
		case 'submit_new_user':
			SubmitNewUser();
		break;
		case 'pre_fu':
			PrepareFindUsers();
		break;
		case 'userlist':
			UserList();
		break;
		case 'showuserlist':
			$query=' FROM {"0"}';
			$Mainclass->Db->FQuery('SELECT COUNT(`id`)'.$query,array('users'),__file__,__line__);
			list($total)=$Mainclass->Db->Fetch_row();
			$md=$Mainclass->Cache->SetSearchCache($total,$query,$Mainclass->lang['users']['userlist']);
			ExitPrefix(array('sresult'=>$md,'type'=>1));
		break;
		case 'kill_users_mass':
			KillUsersMass();
		break;
		case 'admins':
			Admins();
		break;
		default:
			FindUsers();
			$mainpage=true;
		break;
	}
}

$Mainclass->navigation=array(
	array($Mainclass->Url->Prefix(false),($mainpage ? '!' : '').$Mainclass->GetModVal('title')),
	array($Mainclass->Url->ConstructUrl(array('do'=>'new_user')),((isset($_GET['do']) and $_GET['do']=='new_user') ? '!' : '').$Mainclass->lang['users']['add_user']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'showuserlist')),((isset($_GET['do']) and $_GET['do']=='showuserlist') ? '!' : '').$Mainclass->lang['users']['userlist']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'admins')),((isset($_GET['do']) and $_GET['do']=='admins') ? '!' : '').$Mainclass->lang['users']['users_with_ap']),
);

function Admins()
{global $Mainclass, $title;
	$title=$Mainclass->lang['users']['users_with_ap'];
	$grs=$gr_name=array();
	$Mainclass->Db->Query('SELECT `id`,`title`,`html_pref`,`html_end` FROM `prefix_groups` WHERE `access_cp`=1',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
	{
		$grs[]=$arr['id'];
		$gr_name[]='<a href="'.$Mainclass->Url->DynamicBegin().$Mainclass->Url->ConstructUrl(array('section'=>'management','module'=>'groups','edit'=>$arr['id']),false).'">'.$arr['html_pref'].$arr['title'].$arr['html_end'].'</a>';
	}
	sort($grs,SORT_NUMERIC);
	$content=$Mainclass->Template->Title($title).$Mainclass->Template->OpenTable()
		.'<table class="tabstyle"><tr class="first tablethhead"><th>'.$Mainclass->lang['users']['groups_with_ap'].'</th</tr><tr class="last"><td align="center">'.join(', ',$gr_name).'</td></tr></table><br />';
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_users` WHERE `group`'.$Mainclass->Db->In($grs).' OR `other_group` LIKE "%,'.join(',%,',$grs).',%"');
	list($total)=$Mainclass->Db->Fetch_row();
	$per_page=30;
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$per_page);
	$content.='<table class="tabstyle"><tr class="first tablethhead"><th>'.$Mainclass->lang['users']['name'].'</th><th>'.$Mainclass->lang['users']['groups'].'</th><th>'.$Mainclass->lang['users']['last_visit'].'</th><th>'.$Mainclass->lang['users']['ip'].'</th><th>'.$Mainclass->lang['users']['register'].'</th><th width="80">'.$Mainclass->lang['main']['functs'].'</th></tr>';
	$Mainclass->Db->SetQuery('SELECT `id`,`name`,`group`,`other_group`,`ip`,`register`,`last_visit` FROM `prefix_users` WHERE `group`'.$Mainclass->Db->In($grs).' OR `other_group` LIKE "%,'.join(',%,',$grs).',%" ORDER BY `name` ASC');
	$Mainclass->Db->SetLimit($offset,$per_page);
	$Mainclass->Db->Query('',__file__,__line__);
	$n=1;
	if(0==$cnt=$Mainclass->Db->Num_rows())
		$content.='<tr align="center"><td colspan="6"><b>'.$Mainclass->lang['users']['users_not_found'].'</b></td></tr>';
	else
	{
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			$groups[]=$arr['group'];
			$user_groups=array();
			if($arr['other_group'])
			{
				$user_groups=explode(',',trim($arr['other_group'],','));
				foreach($user_groups as $k=>$v)
					if($v)
						$groups[]=(int)$v;
					else
						unset($user_groups[$k]);
			}
			array_unshift($user_groups,$arr['group']);
			$content.='<tr class="'.($cnt ? 'last ' : '').($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td>'.$arr['name'].'</td><td>'.($user_groups ? 'gr_'.implode('_, gr_',$user_groups).'_' : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td><td align="center">'.($arr['last_visit'] ? date('Y-m-d h:j:s',$arr['last_visit']) : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td><td align="center">'.$arr['ip'].'</td><td align="center">'.$arr['register'].'</td><td class="function"><a href="'.$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('kill'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_pass'=>$arr['id'])).'" title="'.$Mainclass->lang['users']['change_pass'].'"><img src="'.$Mainclass->Template->GetImage('edit_password.png').'" alt="'.$Mainclass->lang['users']['change_pass'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_name'=>$arr['id'])).'" title="'.$Mainclass->lang['users']['change_login'].'"><img src="'.$Mainclass->Template->GetImage('edit_name.png').'" alt="'.$Mainclass->lang['users']['change_login'].'" /></a></td></tr>';
		}
		$groups=array_unique($groups);
		if($groups)
		{
			$Mainclass->Db->Query('SELECT `id`,`title`,`html_pref`,`html_end` FROM `prefix_groups` WHERE `id`'.$Mainclass->Db->In($groups),__file__,__line__);
			while($temp=$Mainclass->Db->Fetch_assoc())
				$content=str_replace('gr_'.$temp['id'].'_',$temp['html_pref'].$temp['title'].$temp['html_end'],$content);
		}
	}
	$Mainclass->ShowDecoration(false);
	echo $content.'</table>'.Strings::Pages($total,$per_page).$Mainclass->Template->CloseTable();
}

function FindUsers($error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	$name=isset($_POST['name']) ? $_POST['name'] : '';
	$name_id=isset($_POST['name_id']) ? $_POST['name_id'] : '';
	$name_type=isset($_POST['name_type']) ? $_POST['name_type'] : '';
	$email_type=isset($_POST['email_type']) ? $_POST['email_type'] : '';
	$email=isset($_POST['email']) ? $_POST['email'] : '';
	$type=isset($_POST['type']) ? $_POST['type'] : '1';
	$icq=isset($_POST['icq']) ? $_POST['icq'] : '';
	$group=isset($_POST['group']) ? $_POST['group'] : '';
	$from=isset($_POST['from']) ? $_POST['from'] : '';
	$to=isset($_POST['to']) ? $_POST['to'] : '';
	$ip=isset($_POST['ip']) ? $_POST['ip'] : '';
	$ogroups=(isset($_POST['ogroups']) and is_array($_POST['ogroups'])) ? $_POST['ogroups'] : array();
	$name_type_arr=array($Mainclass->lang['users']['begins'],$Mainclass->lang['users']['contains'],$Mainclass->lang['users']['match'],$Mainclass->lang['users']['endings']);

	$name_types=$ogroup=$email_types='';
	$groups=Template::Option($Mainclass->lang['users']['not_imp'],'0');
	foreach($name_type_arr as $k=>$v)
		$name_types.=Template::Option($v,$k,strcasecmp($k,$name_type)==0);

	foreach($name_type_arr as $k=>$v)
		$email_types.=Template::Option($v,$k,strcasecmp($k,$email_type)==0);

	$Mainclass->Db->Query('SELECT `id`, `title` FROM `prefix_groups` ORDER BY `title` ASC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
	{
		$groups.=Template::Option($arr['title'],$arr['id'],$arr['id']==$group);
		$ogroup.=Template::Option($arr['title'],$arr['id'],in_array($arr['id'],$ogroups));
	}
	$title=$Mainclass->lang['users']['u_search'];
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($title)
		.($error ? $Mainclass->Template->Message($error) : '')
		.$Mainclass->Template->OpenTable()
		.'<form action="'.$Mainclass->Url->ConstructUrl(array('do'=>'pre_fu')).'" method="post">
<table class="tabstyle tabform">
<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['users']['general'].'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['user_name'].'</td><td>'.Template::Select('name_type',$name_types,'style="width:150px"').' '.Template::Edit('name',$name,'style="width:247px"').'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['or_id'].'</td><td>'.Template::Edit('id',$name_id).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['ip_'].'</td><td>'.Template::Edit('ip',$ip).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['email'].'</td><td>'.Template::Select('email_type',$email_types,'style="width:150px"').' '.Template::Edit('email',$email,'style="width:247px"').'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['gen_gr'].'</td><td>'.Template::Select('group',$groups).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['oth_gr'].'</td><td>'.Template::Items('other_group[]',$ogroup).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['s_type'].'</td><td>'.Template::Select('type',Template::Option($Mainclass->lang['users']['for_del'],1,$type==1).Template::Option($Mainclass->lang['users']['for_mass_del'],2,$type==2)).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['last_act'].'</td><td>'.Template::Edit('from',$from,'style="width:136px"').$Mainclass->lang['users']['and_'].Template::Edit('to',$from,'style="width:136px"').'</td></tr>
<tr class="infolabel"><td colspan="2">'.$Mainclass->lang['users']['addon'].'</td></tr>
<tr><td class="label">ICQ:</td><td>'.Template::Edit('icq',$icq).'</td></tr></table>
<div class="submitline">'.Template::Button($Mainclass->lang['users']['find']).'</div>
</form>'.$Mainclass->Template->CloseTable();
}

function PrepareFindUsers()
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$search=array();
	$extra=false;
	if(!empty($_POST['name']) and empty($_POST['id']))
	{
		$name=strtolower($Mainclass->Db->EscapeString($_POST['name']));
		switch($_POST['name_type'])
		{
			case '0':
				$name=' LIKE \''.$name.'%\'';
			break;

			case '1':
				$name=' LIKE \'%'.$name.'%\'';
			break;

			case '2':
			default:
				$name='=\''.$name.'\'';
			break;

			case '3':
				$name=' LIKE \'%'.$name.'\'';
			break;
		}
		$search[]='`l_name`'.$name;
	}
	elseif(!empty($_POST['id']))
		$search[]='`id`='.(int)$_POST['id'];
	if(!empty($_POST['email']))
	{
		$email=strtolower($Mainclass->Db->EscapeString($_POST['email']));
		switch($_POST['email_type'])
		{
			case '0':
				$email=' LIKE \''.$email.'%\'';
			break;

			case '1':
				$email=' LIKE \'%'.$email.'%\'';
			break;

			case '2':
			default:
				$email='=\''.$email.'\'';
			break;

			case '3':
				$email=' LIKE \'%'.$email.'\'';
			break;
		}
		$search[]='`email`'.$email;
	}
	if(!empty($_POST['group']))
		$search[]='`group`='.(int)$_POST['group'];
	if(!empty($_POST['ip']))
	{
		$ip=$Mainclass->Db->EscapeString($_POST['ip']);
		$search[]='`ip` LIKE \''.str_replace('*','%',$ip).'\'';
	}
	if(!empty($_POST['other_group']))
	{
		$groups=isset($_POST['other_group']) ? $_POST['other_group'] : array();
		if(!is_array($groups))
			$groups=array();
		else
			foreach($groups as $k=>$v)
				if(!ctype_digit((string)$v))
					unset($groups[$k]);
		sort($groups,SORT_NUMERIC);
		if(count($groups)>0)
			$search[]='`other_group` LIKE \'%,'.implode(',%,',$groups).',%\'';
	}
	if(!empty($_POST['from']) or !empty($_POST['to']))
	{
		$can=false;
		if(preg_match('#^(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2})$#',$_POST['from'],$matches)>0)
		{
			$can=true;
			$from=mktime($matches[4],$matches[5],0,$matches[2],$matches[3],$matches[1]);
		}
		else
			$from='0';
		if(preg_match('#^(\d{4})\-(\d{2})\-(\d{2}) (\d{2}):(\d{2})$#',$_POST['to'],$matches)>0)
		{
			$can=true;
			$to=mktime($matches[4],$matches[5],0,$matches[2],$matches[3],$matches[1]);
		}
		else
			$to=9999999999;
		if($can)
			$search[]='`last_visit` BETWEEN \''.$from.'\' AND \''.$to.'\'';
	}
	if(!empty($_POST['icq']) and ctype_digit($_POST['icq']))
	{
		$extra=true;
		$search[]='`icq`=\''.$_POST['icq'].'\'';
	}
	$query=' FROM {"0"}'.($extra ? ' INNER JOIN {"1"} USING (`id`)' : '').($search ? ' WHERE ' : '').join(' AND ',$search);
	$Mainclass->Db->FQuery('SELECT COUNT(`id`)'.$query,array('users','users_extra'),__file__,__line__);
	list($total)=$Mainclass->Db->Fetch_row();
	if(!$total)
		return FindUsers($Mainclass->lang['users']['nothing_found']);
	$md=$Mainclass->Cache->SetSearchCache($total,$query,$Mainclass->lang['users']['sresults']);
	ExitPrefix(array('sresult'=>$md,'type'=>isset($_POST['type']) ? $_POST['type'] : 1));
}

function ResultFindUsers($md)
{global $Mainclass, $title;
	$arr=$Mainclass->Cache->GetSearchCache($md);
	if($arr===false)
		ExitPrefix();
	extract($arr);
	$type=isset($_GET['type']) ? (int)$_GET['type'] : 1;
	$groups=array();
	if($type=='1')
	{
		$per_page=30;
		$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
		if($page<=0)
			$page=1;
		$offset=abs(($page-1)*$per_page);
		$title=$addon;
		$content='<table class="tabstyle"><tr class="first tablethhead"><th>'.$Mainclass->lang['users']['name'].'</th><th>'.$Mainclass->lang['users']['groups'].'</th><th width="115">'.$Mainclass->lang['users']['last_visit'].'</th><th width="90">'.$Mainclass->lang['users']['ip'].'</th><th width="100">'.$Mainclass->lang['users']['register'].'</th><th width="82">'.$Mainclass->lang['main']['functs'].'</th></tr>';
		$Mainclass->Db->SetQuery('SELECT `id`,`name`,`group`,`other_group`,`ip`,`register`,`last_visit`'.$query.' ORDER BY `name` ASC');
		$Mainclass->Db->SetLimit($offset,$per_page);
		$Mainclass->Db->FQuery('',array('users','users_extra'),__file__,__line__);
		$n=1;
		if(0==$cnt=$Mainclass->Db->Num_rows())
			$content.='<tr align="center"><td colspan="6"><b>'.$Mainclass->lang['users']['users_not_found'].'</b></td></tr>';
		else
			while($arr=$Mainclass->Db->Fetch_assoc())
			{
				$groups[]=$arr['group'];
				$user_groups=array();
				if($arr['other_group'])
				{
					$user_groups=explode(',',trim($arr['other_group'],','));
					foreach($user_groups as $k=>$v)
						if($v)
							$groups[]=(int)$v;
						else
							unset($user_groups[$k]);
				}
				array_unshift($user_groups,$arr['group']);
				$content.='<tr class="'.($cnt==$n ? 'last ' : '').($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td><a href="'.($edit=$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id']))).'" title="'.$Mainclass->lang['main']['edit'].'">'.$arr['name'].'</a></td><td>'.($user_groups ? 'gr_'.implode('_, gr_',$user_groups).'_' : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td><td align="center">'.($arr['last_visit'] ? date('Y-m-d h:j:s',$arr['last_visit']) : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td><td align="center">'.$arr['ip'].'</td><td align="center">'.$arr['register'].'</td><td class="function"><a href="'.$edit.'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('kill'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_pass'=>$arr['id'])).'" title="'.$Mainclass->lang['users']['change_pass'].'"><img src="'.$Mainclass->Template->GetImage('edit_password.png').'" alt="'.$Mainclass->lang['users']['change_pass'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_name'=>$arr['id'])).'" title="'.$Mainclass->lang['users']['change_login'].'"><img src="'.$Mainclass->Template->GetImage('edit_name.png').'" alt="'.$Mainclass->lang['users']['change_login'].'" /></a></td></tr>';
			}
		$content.='</table>'.Strings::Pages($total,$per_page,array('sresult'=>$md,'type'=>$type));
	}
	else
	{
		$title=$Mainclass->lang['users']['s_del_results'];
		$Mainclass->ShowDecoration(false);
		$content='<form method="post" action="'.$Mainclass->Url->ConstructUrl(array('do'=>'kill_users_mass')).'"><table class="tabstyle"><tr class="first tablethhead"><th>'.$Mainclass->lang['users']['name'].'</th><th>'.$Mainclass->lang['users']['groups'].'</th><th width="115">'.$Mainclass->lang['users']['last_visit'].'</th><th width="15">'.$Mainclass->lang['users']['del?'].'</th></tr>';
		$Mainclass->Db->FQuery('SELECT `id`,`name`,`group`,`other_group`,`last_visit`'.$query,array('users','users_extra'),__file__,__line__);
		if(0==$cnt=$Mainclass->Db->Num_rows())
			$content.='<tr align="center"><td colspan="4"><b>'.$Mainclass->lang['users']['users_not_found'].'</b></td></tr>';
		else
		{
			$n=1;
			while($arr=$Mainclass->Db->Fetch_assoc())
			{
				$groups[]=$arr['group'];
				$user_groups=array();
				if($arr['other_group'])
				{
					$user_groups=explode(',',trim($arr['other_group'],','));
					foreach($user_groups as $k=>$v)
						if($v)
							$groups[]=(int)$v;
						else
							unset($user_groups[$k]);
				}
				array_unshift($user_groups,$arr['group']);
				$content.='<tr class="'.($n==$cnt ? 'last ' : '').($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td><a href="'.$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['edit'].'">'.$arr['name'].'</a></td><td>'.($user_groups ? 'gr_'.implode('_, gr_',$user_groups).'_' : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td><td align="center">'.date('Y-m-d h:j:s',$arr['last_visit']).'</td><td align="center">'.Template::Check('users[]',true,'value="'.$arr['id'].'"').'</td></tr>';
			}
			$content.='</table><div class="submitline">'.Template::Button($Mainclass->lang['main']['delete']).'</div>';
		}
		$content.='</form>';
	}
	$groups=array_unique($groups);
	if($groups)
	{
		$Mainclass->Db->Query('SELECT `id`,`title`,`html_pref`,`html_end` FROM `prefix_groups` WHERE `id`'.$Mainclass->Db->In($groups),__file__,__line__);
		while($temp=$Mainclass->Db->Fetch_assoc())
			$content=str_replace('gr_'.$temp['id'].'_',$temp['html_pref'].$temp['title'].$temp['html_end'],$content);
	}
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($title).$Mainclass->Template->OpenTable().$content.$Mainclass->Template->CloseTable();
}

function NewUser($error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$name=isset($_POST['name']) ? $_POST['name'] : '';
	$pass=isset($_POST['pass']) ? $_POST['pass'] : '';
	$group=isset($_POST['group']) ? $_POST['group'] : '2';
	$email=isset($_POST['email']) ? $_POST['email'] : '';
	$theme=isset($_POST['theme']) ? $_POST['theme'] : '';
	$lang=isset($_POST['lang']) ? $_POST['lang'] : '';
	$editor=isset($_POST['editor'],$Mainclass->Editor->editors[$_POST['editor']]) ? $_POST['editor'] : -1;
	$themes=$langs=Template::Option($Mainclass->lang['main']['no'],'');
	$func=create_function('','global $Mainclass;$themes=array();$arr=glob($Mainclass->root_path.$Mainclass->Template->theme_path."/*",GLOB_ONLYDIR);
	foreach($arr as &$v)
	{
		$name=false;
		$service=array();
		if(file_exists($v.".php"))
			include $v.".php";
		if($service and is_array($service) and !in_array(2,$service))
			continue;
		$tpl=basename($v);
		if(!$name)
			$name=$tpl;
		$themes[$tpl]=$name;
	}
	return $themes;');
	foreach($func() as $k=>$v)
		$themes.=Template::Option($v,$k,$k==$theme);
	foreach($Mainclass->langs as $k=>&$lng)
		$langs.=Template::Option($lng,$k,$k==$lang);

	$groups='';
	$Mainclass->Db->Query('SELECT `id`, `title` FROM `prefix_groups` ORDER BY `title` ASC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
		$groups.=Template::Option($arr['title'],$arr['id'],$arr['id']==$group);

	$editors=Template::Option($Mainclass->lang['users']['default'],-1,$arr['editor']==-1);
	foreach($Mainclass->Editor->editors as $k=>$v)
		$editors.=Template::Option($v,$k,$k==$arr['editor']);

	$title=$Mainclass->lang['users']['adding_user'];
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($Mainclass->lang['users']['add_user'])
		.($error ? $Mainclass->Template->Message($error) : '')
		.$Mainclass->Template->OpenTable()
	.'<form action="'.$Mainclass->Url->ConstructUrl(array('do'=>'submit_new_user')).'" method="post">
<table class="tabstyle tabform">
<tr><td class="label">'.$Mainclass->lang['users']['user_name'].'<span class="imp">*</span></td><td>'.Template::Edit('name',$name).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['pass_'].'</td><td>'.Template::Control('pass','password',$pass,'class="inputText"').'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['email'].'<span class="imp">*</span></td><td>'.Template::Edit('email',$email).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['gen_gr'].'<span class="imp">*</span></td><td>'.Template::Select('group',$groups).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['template'].'</td><td>'.Template::Select('theme',$themes).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['lang'].'</td><td>'.Template::Select('lang',$langs).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['email_send'].'</td><td>'.Template::Check('send',isset($_POST['send'])).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['editor'].'</td><td>'.Template::Select('editor',$editors).'</td></tr>
</table><div class="submitline">'.Template::Button($Mainclass->lang['users']['add_user']).'</div></form>'.$Mainclass->Template->CloseTable();
}

function SubmitNewUser()
{global $Mainclass, $title;
	if(!CheckKey())
		return ExitPrefix();
	$group=isset($_POST['group']) ? (int)$_POST['group'] : 1;
	if(empty($_POST['name']))
		return NewUser($Mainclass->lang['users']['empty_name']);
	if(empty($_POST['pass']))
		$_POST['pass']=Strings::GenPass(10);
	if(empty($_POST['email']) or !Functions::CheckEmail($_POST['email']))
		return NewUser($Mainclass->lang['users']['empty_email']);
	$tpls=glob($Mainclass->root_path.$Mainclass->Template->theme_path.'/*',GLOB_ONLYDIR);
	foreach($tpls as &$v)
		$v=basename($v);
	$groups='';
	$Mainclass->Db->Query('SELECT `id`, `title` FROM `prefix_groups` ORDER BY `title` ASC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
		$groups.=Template::Option($arr['title'],$arr['id'],$arr['id']==$group);
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$editor=isset($_POST['editor'],$Mainclass->Editor->editors[$_POST['editor']]) ? $_POST['editor'] : -1;
	$func=create_function('','global $Mainclass;$themes=array();$arr=glob($Mainclass->root_path.$Mainclass->Template->theme_path."/*",GLOB_ONLYDIR);
	foreach($arr as &$v)
	{
		$name=false;
		$service=array();
		if(file_exists($v.".php"))
			include $v.".php";
		if($service and is_array($service) and !in_array(2,$service))
			continue;
		$tpl=basename($v);
		if(!$name)
			$name=$tpl;
		$themes[$tpl]=$name;
	}
	return $themes;');
	$arr=$func();
	$id=$Mainclass->Account->Manage->AddUser(
												$_POST['name'],
												$_POST['pass'],
												array(
														'group'=>$group,
														'email'=>$_POST['email'],
														'lang'=>(isset($_POST['lang'],$Mainclass->langs[$_POST['lang']])) ? $_POST['lang'] : '',
														'theme'=>(isset($_POST['theme']) and in_array($_POST['theme'],$arr)) ? $_POST['theme'] : '',
												)
	);
	if($id===false)
		return NewUser($Mainclass->Account->error_exp);
	if(isset($_POST['send']) and file_exists($f=$Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php')))
	{
		include $f;
		$Mainclass->Mail(
							$_POST['email'],
							str_replace(
										array(
												'%title%',
												'%link%',
												'%nick%',
												'%pass%',
										),
										array(
												$Mainclass->vars['site_name'],
												ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
												isset($_POST['name']) ? $_POST['name'] : '',
												isset($_POST['pass']) ? $_POST['pass'] : '',
										),
										$letters['letter_e']
							),
							array(
									'html'=>true,
									'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_e_tit']),
							)
		);
	}
	$title=$Mainclass->lang['users']['user_created'];
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($title).$Mainclass->Template->OpenTable().$Mainclass->Template->Message(sprintf($Mainclass->lang['users']['us_cr_text'],htmlspecialchars($_POST['name']),htmlspecialchars($_POST['pass']),$Mainclass->Url->ConstructUrl(array('edit'=>$id))),'info').$Mainclass->Template->CloseTable();
}

function ChangePassword($id,$error='')
{global $Mainclass, $title;
	$arr=$Mainclass->Account->SelectUserById($id,array('name'));
	$title=$Mainclass->lang['users']['changing_pass'].'&quot;'.$arr['name'].'&quot;';
	if($id==$Mainclass->Account->GetValue('id'))
		$error.=$Mainclass->lang['users']['self_pass_ch'];
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($title)
		.($error ? $Mainclass->Template->Message($error) : '')
		.$Mainclass->Template->OpenTable()
		.'<div class="function"><a href="'.$Mainclass->Url->ConstructUrl(array('edit'=>$id)).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_name'=>$id)).'" title="'.$Mainclass->lang['users']['change_login'].'"><img src="'.$Mainclass->Template->GetImage('edit_name.png').'" alt="'.$Mainclass->lang['users']['change_login'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('kill'=>$id)).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a></div><form action="'.$Mainclass->Url->ConstructUrl(array('save_pass'=>$id)).'" method="post">'
		.($back ? Template::Control('back','hidden',base64_encode($back)) : '')
		.'<table class="tabstyle tabform">
<tr><td class="label">'.$Mainclass->lang['users']['pass'].'<span class="imp">*</span></td><td>'.Template::Control('pass','password','','class="inputText"').'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['pass_rep'].'<span class="imp">*</span></td><td>'.Template::Control('pass2','password','','class="inputText"').'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['cl_keys'].'</td><td>'.Template::Check('clean',isset($_POST['clean'])).'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['email_send'].'</td><td>'.Template::Check('send').'</td></tr>
</table><div class="submitline">'.Template::Button($Mainclass->lang['main']['ok']).'</div></form>'.$Mainclass->Template->CloseTable();
}

function SavePassword($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	if(!isset($_POST['pass']) or !isset($_POST['pass2']) or $_POST['pass']!=$_POST['pass2'])
		return ChangePassword($id,$Mainclass->lang['users']['pass_mismatch']);
	if(!$Mainclass->Account->Manage->ChangePass($_POST['pass'],$id))
		return ChangePassword($id,$Mainclass->Account->error_exp);
	if(isset($_POST['clean']))
		$Mainclass->Account->Manage->UpdateUser(array('login_keys'=>''),$id);
	if(isset($_POST['send']) and file_exists($f=$Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php')))
	{
		include $f;
		$arr=$Mainclass->Account->SelectUserById($id,array('name','email'));
		$Mainclass->Mail(
							$arr['email'],
							str_replace(
										array(
												'%title%',
												'%link%',
												'%nick%',
												'%pass%',
										),
										array(
												$Mainclass->vars['site_name'],
												ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
												$arr['name'],
												$_POST['pass']
										),
										$letters['letter_pls']
							),
							array(
									'html'=>true,
									'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_pls_tit']),
							)
		);
	}
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function ChangeName($id,$error='')
{global $Mainclass, $title;
	$arr=$Mainclass->Account->SelectUserById($id,array('name'));
	$title=$Mainclass->lang['users']['changing_login'].'&quot;'.$arr['name'].'&quot;';
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($title)
		.($error ? $Mainclass->Template->Message($error) : '')
		.$Mainclass->Template->OpenTable()
		.'<div class="function"><a href="'.$Mainclass->Url->ConstructUrl(array('edit'=>$id)).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_pass'=>$id)).'" title="'.$Mainclass->lang['users']['change_pass'].'"><img src="'.$Mainclass->Template->GetImage('edit_password.png').'" alt="'.$Mainclass->lang['users']['change_pass'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('kill'=>$id)).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a></div><form action="'.$Mainclass->Url->ConstructUrl(array('save_name'=>$id)).'" method="post">'
		.($back ? Template::Control('back','hidden',base64_encode($back)) : '')
		.'<table class="tabstyle tabform">
<tr><td class="label">'.$Mainclass->lang['users']['new_name'].'</td><td>'.Template::Edit('name',isset($_POST['name']) ? $_POST['name'] : '').'</td></tr>
<tr><td class="label">'.$Mainclass->lang['users']['email_send'].'</td><td>'.Template::Check('send').'</td></tr>
</table>
<div class="submitline">'.Template::Button($Mainclass->lang['main']['ok']).'</div>
</form>';
}

function SaveName($id)
{global $Mainclass;
	if(!CheckKey() or !isset($_POST['name']))
		return ExitPrefix();
	if(!$Mainclass->Account->Manage->ChangeName($_POST['name'],$id))
		return ChangeName($id,$Mainclass->Account->error_exp);
	if(isset($_POST['send']) and file_exists($f=$Mainclass->FormatPath($Mainclass->GetModVal('path').'/letters-'.$Mainclass->lang_name.'.php')))
	{
		include $f;
		$arr=$Mainclass->Account->SelectUserById($id,array('name','email'));
		$Mainclass->Mail(
							$arr['email'],
							str_replace(
										array(
												'%title%',
												'%link%',
												'%nick%',
												'%pass%',
										),
										array(
												$Mainclass->vars['site_name'],
												ELEANOR_PROTOCOL.$Mainclass->domain.$Mainclass->site_path,
												isset($_POST['name']) ? $_POST['name'] : '',
												'<i>'.$Mainclass->lang['users']['without_ch'].'</i>'
										),
										$letters['letter_pls']
							),
							array(
									'html'=>true,
									'subject'=>str_replace('%site%',$Mainclass->vars['site_name'],$letters['letter_pls_tit']),
							)
		);
	}
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function Edit($id,$error='')
{global $Mainclass,$title,$users_extra,$jscripts;
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$jscripts[]='js/tabcontent.js';
	$jscripts[]='js/eleanor_tooltip.js';
	$arr_params=array();
	$arr=$Mainclass->Account->SelectUserById($id);
	if($error)
	{
		$arr['other_group']=(isset($_POST['other_group']) and is_array($_POST['other_group'])) ? $_POST['other_group'] : array();
		$arr['email']=isset($_POST['email']) ? $_POST['email'] : '';
		$arr['group']=isset($_POST['group']) ? $_POST['group'] : '';
		$arr['avatar_type']=isset($_POST['avatar_type']) ? $_POST['avatar_type'] : '';
		$arr['avatar_location']=isset($_POST['avatar_location']) ? $_POST['avatar_location'] : '';
		$arr['ban_date']=isset($_POST['ban_date']) ? Strings::CheckDate($_POST['ban_date']) : '';
		$arr['ban_explain']=$Mainclass->Editor->GetHtml('ban_explain');
		$arr['theme']=isset($_POST['theme']) ? $_POST['theme'] : '';
		$arr['lang']=isset($_POST['lang']) ? $_POST['lang'] : '';
		$arr['editor']=isset($_POST['editor']) ? (int)$_POST['editor'] : -1;
		if(!isset($Mainclass->Editor->editors[$arr['editor']]))
			$arr['editor']=-1;
		foreach($users_extra as $k=>$v)
			if(is_array($v))
				if(isset($_POST[$k]))
					$arr_params[$k]=strcasecmp($v[1],'editor')==0 ? $Mainclass->Editor->GetHTML($k) : $_POST[$k];
				else
					$arr_params[$k]='';
	}
	else
	{
		$Mainclass->Db->Query('SELECT * FROM `prefix_users_extra` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			ExitPrefix();
		$arr_params=$Mainclass->Db->Fetch_assoc();
		$arr['other_group']=explode(',',Strings::CleanForExplode($arr['other_group']));
		$arr['avatar_type']=$arr_params['avatar_type'];
		$arr['avatar_location']=$arr_params['avatar_location'];
	}
	$themes=$langs=$groups=$o_groups='';
	$Mainclass->Db->Query('SELECT `id`,`title` FROM `prefix_groups` ORDER BY `title` ASC',__file__,__line__);
	while($temp=$Mainclass->Db->Fetch_assoc())
	{
		$groups.=Template::Option($temp['title'],$temp['id'],$temp['id']==$arr['group']);
		$o_groups.=Template::Option($temp['title'],$temp['id'],in_array($temp['id'],$arr['other_group']));
	}
	$failed_logins=array();
	if($arr['failed_logins'])
	{
		$temp=unserialize($arr['failed_logins']);
		foreach($temp as $v)
			$failed_logins[]='<b>'.date('Y-m-d H:i:s',$v[0]).' - '.$v[1].'</b><br />'.$Mainclass->lang['users']['browser'].$v[2].'<br />IP:'.$v[3];
	}
	if(!$failed_logins)
		$failed_logins[]='<i>'.$Mainclass->lang['main']['no'].'</i>';
	$avatars_type=Template::Option($Mainclass->lang['users']['a_sys'],'local',strcasecmp($arr['avatar_type'],'local')==0)
				.Template::Option($Mainclass->lang['users']['a_upl'],'upload',strcasecmp($arr['avatar_type'],'upload')==0)
				.Template::Option($Mainclass->lang['users']['a_lnk'],'url',strcasecmp($arr['avatar_type'],'url')==0);
	$Mainclass->Loadclass('classes/others/class_uploader.php');
	$Mainclass->Uploader->watermark_on=$Mainclass->Uploader->allow_walk=$Mainclass->Uploader->watermark=$Mainclass->Uploader->allow_lock=$Mainclass->Uploader->allow_new=false;
	$Mainclass->Uploader->allowed_types=array('jpg','jpeg','gif','bmp','png');
	$Mainclass->Uploader->preview=false;
	require $Mainclass->root_path.'addons/addons.php';
	$ban_date=Calendar('ban_date',$arr['ban_date']);
	$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$title=$Mainclass->lang['users']['editing_u'].' &quot;'.htmlspecialchars($arr['name']).'&quot;';
	$themes=$langs=Template::Option($Mainclass->lang['main']['no'],'');
	$func=create_function('','global $Mainclass;$themes=array();$arr=glob($Mainclass->root_path.$Mainclass->Template->theme_path."/*",GLOB_ONLYDIR);
	foreach($arr as &$v)
	{
		$name=false;
		$service=array();
		if(file_exists($v.".php"))
			include $v.".php";
		if($service and is_array($service) and !in_array(2,$service))
			continue;
		$tpl=basename($v);
		if(!$name)
			$name=$tpl;
		$themes[$tpl]=$name;
	}
	return $themes;');
	foreach($func() as $k=>$v)
		$themes.=Template::Option($v,$k,$k==$arr['theme']);
	foreach($Mainclass->langs as $k=>&$lng)
		$langs.=Template::Option($lng,$k,$k==$arr['lang']);
	$editors=Template::Option($Mainclass->lang['users']['default'],-1,$arr['editor']==-1);
	foreach($Mainclass->Editor->editors as $k=>$v)
		$editors.=Template::Option($v,$k,$k==$arr['editor']);
	$content=$Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '').$Mainclass->Template->OpenTable()
			.'<div class="function"><a href="'.$Mainclass->Url->ConstructUrl(array('change_pass'=>$arr['id'])).'" title="'.$Mainclass->lang['users']['change_pass'].'"><img src="'.$Mainclass->Template->GetImage('edit_password.png').'" alt="'.$Mainclass->lang['users']['change_pass'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('change_name'=>$arr['id'])).'" title="'.$Mainclass->lang['users']['change_login'].'"><img src="'.$Mainclass->Template->GetImage('edit_name.png').'" alt="'.$Mainclass->lang['users']['change_login'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('kill'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a></div>
	<ul id="usertabs" class="linetabs">
	<li><a href="#" rel="tab1" class="selected"><b>'.$Mainclass->lang['main']['general'].'</b></a></li>
	<li><a href="#" rel="tab2"><b>'.$Mainclass->lang['users']['unsuc_auth'].'</b></a></li>
	<li><a href="#" rel="tab3"><b>'.$Mainclass->lang['users']['addon'].'</b></a></li>
	<li><a href="#" rel="tab4"><b>'.$Mainclass->lang['users']['avatar'].'</b></a></li>
	<li><a href="#" rel="tab5"><b>'.$Mainclass->lang['users']['block'].'</b></a></li>
</ul>
<form name="form" action="'.$Mainclass->Url->ConstructUrl(array('save'=>$id)).'" method="post">'
.($back ? Template::Control('back','hidden',base64_encode($back)) : '')
.'<div id="tab1" class="tabcontent">
<table class="tabstyle tabform">
	<tr><td class="label">'.$Mainclass->lang['users']['name'].':</td><td>'.$arr['name'].'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['register'].':</td><td>'.$arr['register'].'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['last_visit'].':</td><td>'.($arr['last_visit'] ? date('Y-m-d h:j:s',$arr['last_visit']) : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['ip'].':</td><td>'.($arr['ip'] ? $arr['ip'] : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['email'].'</td><td>'.Template::Edit('email',$arr['email']).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['gen_gr'].'</td><td>'.Template::Select('group',$groups).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['oth_gr'].'</td><td>'.Template::Items('other_group[]',$o_groups).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['template'].'</td><td>'.Template::Select('theme',$themes).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['lang'].'</td><td>'.Template::Select('lang',$langs).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['editor'].'</td><td>'.Template::Select('editor',$editors).'</td></tr>
</table>
</div>
<div id="tab2" class="tabcontent">
	<table class="tabstyle tabform">
	<tr><td class="label">'.$Mainclass->lang['users']['del?'].'</td><td>'.Template::Check('clean_failed_logins',isset($_POST['clean_failed_logins'])).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['att_log'].'</td><td>'.implode('<hr />',$failed_logins).'</td></tr>
	</table>
</div>
<div id="tab3" class="tabcontent">
	<table class="tabstyle tabform">';
		foreach($users_extra as $k=>$v)
		{
			if(is_array($v))
			{
				$mn=false;
				switch(strtolower($v[1]))
				{
					case 'user':
						if(!is_callable($v[3]))
							continue 2;
						$value=call_user_func($v[3],$error ? 'loadpost' : 'load',$arr_params[$k],$v[5]);
					break;
					case 'editor':
						$value=$Mainclass->Editor->Area($k,$arr_params[$k],5);
					break;
					case 'radios':
						$value=Template::Radios($k,$v[3],$arr_params[$k],'<br />',$v[5]);
					break;
					case 'edit':
					case 'text':
						$value=Template::$v[1]($k,$arr_params[$k],$v[5],!empty($v[6]));
					break;
					case 'items':
						$arr_params[$k]=explode(',',$arr_params[$k]);
					case 'item':
						$mn=true;
					case 'select':
						$value='';
						foreach($v[3] as $k_=>$v_)
							$value.=Template::Option($v_,$k_,is_array($arr_params[$k]) ? in_array($k_,$arr_params[$k]) : $arr_params[$k]==$k_);
						$arr_params[$k]=$value;
						if($mn)
						{
							$value=Template::$v[1]($k,$arr_params[$k],10,$v[5]);
							break;
						}
					default:
						$value=Template::$v[1]($k,$arr_params[$k],$v[5]);
					break;
				}
				$content.='<tr><td class="label">'.$v[0].'</td><td>'.$value.'</td></tr>';
			}
			else
				$content.='<tr class="infolabel"><td colspan="2">'.$v.'</td></tr>';
		}
		$content.='</table>
</div>
<div id="tab4" class="tabcontent">
	<table class="tabstyle tabform">
	<tr><td class="label">'.$Mainclass->lang['users']['a_del'].'</td><td>'.Template::Check('delete_avatar',isset($_POST['delete_avatar'])).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['a_type'].'</td><td>'.Template::Select('avatar_type',$avatars_type).'</td></tr>
	<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($Mainclass->lang['users']['a_descr'],ENT_QUOTES).'\')">(?)</span>'.$Mainclass->lang['users']['avatar'].':</td><td>'.Template::Edit('avatar_location',$arr['avatar_location'],'onfocus="var e=this;EDITOR.NewEditor(-1,function(t){e.value=t},function(t){e.value=t},function(t){return e.value})"').'</td></tr>
	<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($Mainclass->lang['users']['a_descr2'],ENT_QUOTES).'\')">(?)</span>'.$Mainclass->lang['users']['a_loc'].'</td><td>'.$Mainclass->Uploader->Show('uploaded_avatars',false).'</td></tr>
	</table>
</div>
<div id="tab5" class="tabcontent">
	<table class="tabstyle tabform">
	<tr><td class="label">'.$Mainclass->lang['users']['ban_to'].'</td><td>'.$ban_date.'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['users']['ban_mess'].'</td><td>'.$Mainclass->Editor->Area('ban_explain',$arr['ban_explain']).'</td></tr>
	</table>
</div>
<div class="submitline">'.Template::Button().'</div>
</form>
<script type="text/javascript">//<!CDATA[
var countries=new ddtabcontent("usertabs");
countries.setpersist(true);
countries.setselectedClassTarget("link");
countries.init();
//]]></script>'.$Mainclass->Template->CloseTable();
	$Mainclass->ShowDecoration(false);
	echo $content;
}

function Save($id)
{global $Mainclass, $users_extra;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return Edit($id);
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$update=$extra_update=array();
	if(!Functions::CheckEmail($_POST['email']))
		return Edit($id,$Mainclass->lang['users']['wrong_email']);
	$group=isset($_POST['group']) ? (int)$_POST['group'] : 1;
	$o_groups=isset($_POST['other_group']) ? $_POST['other_group'] : array();
	if(!is_array($o_groups))
		$o_groups=array();
	else
		foreach($o_groups as $k=>$v)
			if(!ctype_digit((string)$v) or $v==$group)
				unset($o_groups[$k]);
	$temp_groups=$o_groups;
	$temp_groups[]=$group;
	$temp_groups=array_unique($temp_groups);
	$Mainclass->Db->Query('SELECT `id` FROM `prefix_groups` WHERE `id`'.$Mainclass->Db->In($temp_groups),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=count($temp_groups))
		return Edit($id,$Mainclass->lang['users']['excess_g']);
	sort($o_groups,SORT_NUMERIC);
	$Mainclass->Db->Query('SELECT `group`,`other_group` FROM `prefix_users` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		return ExitPrefix();
	$arr=$Mainclass->Db->Fetch_assoc();
	if(($arr['group']==1 or strpos($arr['other_group'],',1,')!==false) and $group!=1 and !in_array(1,$o_groups))
	{
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_users` WHERE (`group`=1 OR `other_group` LIKE \'%,1,%\') AND `id`!='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()>0)
			$update['group']=$group;
		elseif($arr['group']!=1)
			$o_groups[]=1;
	}
	else
		$update['group']=$group;
	$update['other_group']=$o_groups ? ','.implode(',,',$o_groups).',' : '';
	$arr=glob($Mainclass->root_path.$Mainclass->Template->theme_path.'/*',GLOB_ONLYDIR);
	foreach($arr as &$v)
		$v=basename($v);
	$update['lang']=(isset($_POST['lang'],$Mainclass->langs[$_POST['lang']])) ? $_POST['lang'] : '';
	$update['theme']=(isset($_POST['theme']) and in_array($_POST['theme'],$arr)) ? $_POST['theme'] : '';
	$update['email']=$_POST['email'];
	if(isset($_POST['clean_failed_logins']))
		$update['failed_logins']='';
	foreach($users_extra as $k=>$v)
		switch(strtolower($v[1]))
			{
				case 'editor':
					$extra_update[$k]=$Mainclass->Editor->GetHTML($k);
				break;
				case 'check':
					$extra_update[$k]=isset($_POST[$k]);
				break;
				case 'user':
					if(!is_callable($v[3]))
						continue 2;
					$extra_update[$k]=call_user_func($v[3],'save',null,$v[5]);
				break;
				default:
					#Заплатка для ICQ
					if($k=='icq' and isset($_POST['icq']))
						$_POST['icq']=preg_replace('#[^0-9]+#','',$_POST['icq']);
					if(empty($_POST[$k]))
						$extra_update[$k]='';
					else
						$extra_update[$k]=is_array($_POST[$k]) ? ','.implode(',',$Mainclass->POST[$k]).',' : (empty($v[6]) ? $Mainclass->POST[$k] : $_POST[$k]);
				break;
			}
	$extra_update['avatar_type']=$extra_update['avatar_size']=$extra_update['avatar_location']='';
	$root=$Mainclass->root_path.Mainclass::UPLOADS_DIR.DIRECTORY_SEPARATOR.'uploaded_avatars'.DIRECTORY_SEPARATOR;
	$Mainclass->Db->Query('SELECT `avatar_location`,`avatar_type` FROM `prefix_users_extra` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($a_loc,$a_type)=$Mainclass->Db->Fetch_row();
	if((isset($_POST['delete_avatar']) or $_POST['avatar_location']!=$a_loc) and $a_type=='upload')
	{
		$avatar=realpath($root.$a_loc);
		if($avatar and strncmp($avatar,$root,strlen($root))==0 and is_file($avatar))
			@unlink($avatar);
	}
	$path='';
	if(!isset($_POST['avatar_location']))
		return ExitPrefix();
	if(!isset($_POST['delete_avatar']))
		switch($_POST['avatar_type'])
		{
			case 'upload':
				if(is_file($root.$_POST['avatar_location']))
				{
					$path=$root.$_POST['avatar_location'];
					$extra_update['avatar_type']='upload';
				}
			break;

			case 'local':
				if(is_file($Mainclass->root_path.'images/avatars/'.$_POST['avatar_location']))
				{
					$path=$Mainclass->root_path.'images/avatars/'.$_POST['avatar_location'];
					$extra_update['avatar_type']='local';
				}
			break;

			case 'url':
				$path=$_POST['avatar_location'];
				$extra_update['avatar_type']='url';
			break;
		}
	elseif($a_type=='local')
		$extra_update['avatar_location']='';
	if($path)
	{
		if($temp=@getimagesize($path))
		{
			list($a_width,$a_height)=$temp;
			$extra_update['avatar_size']=$a_width.'x'.$a_height;
		}
		else
			$extra_update['avatar_size']=str_replace(' ','x',$Mainclass->vars['avatar_size']);
		$extra_update['avatar_location']=$_POST['avatar_location'];
	}
	$ban_date=isset($_POST['ban_date']) ? $_POST['ban_date'] : false;
	$update['ban_date']=$ban_date ? Strings::CheckDate($_POST['ban_date']) : null;
	$update['ban_explain']=$Mainclass->Editor->GetHTML('ban_explain');
	$update['editor']=isset($_POST['editor']) ? (int)$_POST['editor'] : -1;
	if(!isset($Mainclass->Editor->editors[$update['editor']]))
		$update['editor']=-1;
	if(!$Mainclass->Account->Manage->UpdateUser($update,$id))
		return Edit($id,$Mainclass->Account->error_exp);
	if(!$Mainclass->Account->Manage->UpdateUserExtra($extra_update,$id))
		return Edit($id,$Mainclass->Account->error_exp);
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function Kill($id)
{global $Mainclass, $title;
	if(!CheckKey())
		return ExitPrefix();
	if($id==$Mainclass->Account->GetValue('id'))
		return $Mainclass->Template->ErrorScreen($Mainclass->lang['users']['cant_self_kill']);
	$arr=$Mainclass->Account->SelectUserById($id,array('name'));
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		$Mainclass->Account->Manage->DeleteUser($id);
		$title=$Mainclass->lang['users']['user_deld'];
		$goto=empty($_POST['back']) ? $Mainclass->Url->Prefix(false,true,true) : base64_decode($_POST['back']);
		$Mainclass->ShowDecoration(false);
		echo '<div align="center"><b>'.$Mainclass->lang['users']['user_deld'].' <a href="'.$goto.'">'.$Mainclass->lang['main']['goback'].'</a>.</b></div>';
	}
	else
	{
		$title=$Mainclass->lang['users']['confirm_del'].'&quot;'.$arr['name'].'&quot;';
		$Mainclass->ShowDecoration(false);
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'=>sprintf($Mainclass->lang['users']['deleting'],$arr['name']).($back ? Template::Control('back','hidden',base64_encode($back)) : '')
												)
		);
	}
}

function KillUsersMass()
{global $Mainclass;
	if(isset($_POST['users']) and is_array($_POST['users']))
	{
		$_POST['users']=array_diff($_POST['users'],array($Mainclass->Account->GetValue('id')));#Не будем пришибать себя ;)
		$cnt=$Mainclass->Account->Manage->DeleteUser($_POST['users']);
		$Mainclass->ShowDecoration(false);
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		$goto=$back ? $back : $Mainclass->Url->Prefix(false,true,true);
		echo '<div align="center"><b>'.sprintf($Mainclass->lang['users']['mess_delu_cnt'],$cnt).' <a href="'.$goto.'">'.$Mainclass->lang['main']['goback'].'</a>.</b></div>';
	}
	else
		ExitPrefix();
}
function UserList()
{global $Mainclass;
	if(!isset($_GET['unique']))
		return FindUsers();
	if(isset($_POST['name']))
	{
		$query=' WHERE `name` LIKE \'%'.$Mainclass->Db->EscapeString($_POST['name']).'%\'';
		$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_users`'.$query,__file__,__line__);
		list($total)=$Mainclass->Db->Fetch_row();
		$md=$Mainclass->Cache->SetSearchCache($total,$query);
		$links=array('Search'=>$md);
	}
	elseif(isset($_GET['search']))
	{
		$md=$_GET['search'];
		$links=array('Search'=>$md);
		$arr=$Mainclass->Cache->GetSearchCache($md);
		if($arr===false)
			return FindUsers();
		extract($arr);
	}
	else
	{
		$query=' ORDER BY `name` ASC';
		$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_users`',__file__,__line__);
		list($total)=$Mainclass->Db->Fetch_row();
		$links=array();
	}
	$per_page=30;
	$Mainclass->Url->SetPrefix(array('do'=>'userlist','unique'=>isset($_GET['unique']) ? $_GET['unique'] : ''),true);
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$offset=abs(($page-1)*$per_page);
	$result=array();
	$n=$offset+1;
	$Mainclass->Db->Query('SELECT `id`, `name` FROM `prefix_users` '.$query.' LIMIT '.$offset.', '.$per_page,__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
	{
		$arr['name']=$arr['name'];
		$result[]=$n.'. <a href="#" onclick="return SelectUser(\''.$arr['name'].'\',\''.$arr['id'].'\')">'.$arr['name'].'</a>';
		$n++;
	}
	$notfound=$total==0 ? '<tr><td colspan="3" aling="center"><b>'.$Mainclass->lang['users']['users_not_found'].'</b></td></tr>' : '';
	$part1=array_splice($result,0,10);
	$part2=array_splice($result,0,10);
	$part3=array_splice($result,0,10);
	$pages=Strings::Pages($total,$per_page,$links);
	$content='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru" lang="ru">
<head>
<meta http-equiv="content-type" content="text/html; charset='.ELEANOR_DISPLAYCHARSET.'" />
<title>'.$Mainclass->lang['users']['users_list'].'</title>
<style type="text/css">
	:link, :visited { color: #ff5a00; text-decoration: none; }
	:link:hover, :visited:hover { color: #ff9600; text-decoration: none; }
	ul { margin: 2px 0; padding: 0 0 0 5px; }
	ul li { margin: 5px 0; padding: 0px 0 0px 14px; list-style-type: none; background: none; }
	h2 { font-size: 18px; font-weight: normal; line-height: 133%; margin: 0.5em 0 0.2em 0; }
	input, textarea, select { font-size: 11px; font-family: Tahoma, Helvetica, sans-serif; }
	body, td, div, li { color: #6d6a65; font-size: 11px; font-family: Tahoma, Helvetica, sans-serif; }
	body { text-align: left; height: 100%; line-height: 142%; padding: 0; margin: 20px; background-color: #FFFFFF; }
	.clr {clear:both;}
	hr	{ height: 1px; border: solid #d8d8d8 0px; border-top-width: 1px; }
</style>
</head>
<body>
<script type="text/javascript">
var op=window.opener;
var unique="'.$_GET['unique'].'";
function SelectUser(name,id)
{
	op.document.getElementById("a"+unique).value=name;
	op.document.getElementById("u"+unique).value=id;
	window.close();
	return false;
}
</script>
<table border="0" width="100%" cellpadding="0" cellspacing="5"><tr>
	<td colspan="3"><h2>'.$Mainclass->lang['users']['users_list'].'</h2><hr /></td>
	</tr>'.$notfound.'
	<tr>
	<td>
		<ul>
			<li>'.implode('</li><li>',$part1).'</li>
		</ul>
	</td>
	<td>
		<ul>
			<li>'.implode('</li><li>',$part2).'</li>
		</ul>
	</td>
	<td>
		<ul>
			<li>'.implode('</li><li>',$part3).'</li>
		</ul>
	</td>
	</tr>
	<tr>
	<td colspan="3">'.$pages.'
			<div class="clr"></div>
		<hr />
		<form action="'.$Mainclass->Url->ConstructUrl(array('do'=>'userlist','unique'=>$_GET['unique'])).'" method="post">
			'.$Mainclass->lang['users']['search'].Template::Edit('name',isset($_POST['name']) ? $_POST['name'] : '').Template::Button($Mainclass->lang['users']['find']).'
		</form>
	</td>
</tr>
</table>
</body>
</html>';
	$Mainclass->ShowDecoration(true,'');
	echo $content;
}


?>