<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
class DbDriver_mysql extends BaseClass implements DriverDB
{
	public
		$link_id=-1,
		$db;
	protected
		$Base,
		$query_id=-1,
		$open_queries=array();

	public function __construct(&$Base)
	{
		$this->Base=$Base;
	}

	public function Connect(array $params)
	{
		if(is_resource($this->link_id))
			return true;
		if(!isset($params['host']) or !isset($params['user']) or !isset($params['pass']) or !isset($params['db']))
			return false;
		$id=mysql_connect($params['host'],$params['user'],$params['pass'],!empty($params['force']));
		if($id===false)
			return false;
		$this->db=$params['db'];
		$this->link_id=$id;
		if(!$this->SelectDb(''))
		{
			$this->link_id=-1;
			$this->Base->Error('select_db');
			return false;
		}
		mysql_query('SET NAMES '.ELEANOR_DBCHARSET,$id);
		#Если проблема с кодировкой - раскоментируйте строки (по одной)
		#mysql_query('SET CHARACTER SET '.ELEANOR_DBCHARSET,$id);
		#mysql_query('SET character_set_client=\''.ELEANOR_DBCHARSET.'\'',$id);
		#mysql_query('SET character_set_results=\''.ELEANOR_DBCHARSET.'\'',$id);
		#mysql_query('SET collation_connection=\''.ELEANOR_DBCHARSET.'_general_ci\'',$id);
		return true;
	}

	public function SelectDb($name='')
	{
		return mysql_select_db($name!='' ? $name : $this->db,$this->link_id);
	}

	public function Close()
	{
		if($this->link_id===-1)
			return true;
		foreach($this->open_queries as &$v)
			$this->Free($v);
		$this->open_queries=array();
		$this->current_query='';
		$res=mysql_close($this->link_id);
		$this->query_id=$this->link_id=-1;
		return $res;
	}

	public function Free($qid)
	{
		if($qid===-1)
			$qid=$this->query_id;
		if(!is_resource($qid))
			return true;
		return mysql_free_result($qid);
	}

	public function Version()
	{
		return str_replace('-nt-max','',mysql_get_server_info($this->link_id));
	}

	public function Escape($str)
	{
		return mysql_real_escape_string($str,$this->link_id);
	}

	public function Query($query)
	{
		$this->query_id=mysql_query($query,$this->link_id);
		if(strpos($query,'SELECT')===0 and $this->query_id!==false)
			$this->open_queries[]=$this->query_id;
		return $this->query_id;
	}

	public function Error()
	{
		return mysql_error($this->link_id);
	}

	public function ErrorNo()
	{
		return mysql_errno($this->link_id);
	}

	public function Transaction($event)
	{
		switch ($event)
		{
			case 'BEGIN':
				return @mysql_query('BEGIN',$this->link_id);
			break;

			case 'COMMIT':
				return @mysql_query('COMMIT',$this->link_id);
			break;

			case 'ROLLBACK':
				return @mysql_query('ROLLBACK',$this->link_id);
			break;
		}
		return false;
	}

	public function AffectedRows()
	{
		return mysql_affected_rows($this->link_id);
	}

	public function FetchRow($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_fetch_row($qid);
	}

	public function FetchAssoc($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_fetch_assoc($qid);
	}

	public function FetchArray($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_fetch_array($qid);
	}

	public function FetchObject($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_fetch_object($qid);
	}

	public function NumRows($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_num_rows($qid);
	}

	public function NumFields($qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_num_fields($qid);
	}

	public function RowSeek($int,$qid)
	{
		if($qid==-1)
			$qid=$this->query_id;
		return mysql_data_seek($qid,$int);
	}

	public function InsertId()
	{
		return mysql_insert_id($this->link_id);
	}
}
?>