<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');
final class Admin extends BaseClass implements LoginClass
{
	public
		$error='',
		$key;
	private
		$login=null;
	public function Login($user_name='',$pass='')
	{
		if($user_name=='' and isset($_POST['user_name']))
			$user_name=$_POST['user_name'];
		if($pass=='' and isset($_POST['pass']))
			$pass=$_POST['pass'];
		if($user_name=='' or $pass=='')
		{
			$this->error=$this->Mainclass->Account->lang['empty_login'];
			return false;
		}
		if($this->Mainclass->Account->AuthByName($user_name,$pass,isset($_POST['already_md'])))
		{
			$this->login=null;
			if(!$this->CheckPermission())
			{
				$this->Mainclass->Account->LogOut();
				$this->error=$this->Mainclass->Account->lang['perm_denied'];
				return false;
			}
			$this->key=$this->Mainclass->Account->GetValue('login_key');
			$cookie=base64_encode($this->key.'|'.$this->Mainclass->Account->GetValue('id'));
			$this->Mainclass->SCookie('Admin',$cookie,365,true);
			$this->Mainclass->Account->SetStrongHold();
			if($lang=$this->Mainclass->Account->GetValue('lang') and isset($this->Mainclass->langs[$lang]))
				$this->Mainclass->lang_name=$lang;
			return $this->login=true;
		}
		$this->error=$this->Mainclass->Account->error_exp;
		return false;
	}

	public function IsUser($hard=false)
	{
		if($this->login===null or $hard)
			do
			{
				if($this->Mainclass->GCookie('Admin')===false)
				{
					$this->login=false;
					break;
				}
				$t=explode('|',base64_decode($this->Mainclass->GCookie('Admin')),2);
				$lkey=$t[0];
				$id=isset($t[1]) ? $t[1] : 0;
				if(!$lkey or !$id)
				{
					$this->login=false;
					break;
				}
				if($this->Mainclass->Account->AuthByKey($id,$lkey,true)===false)
				{
					$this->login=false;
					break;
				}
				$this->login=($this->CheckPermission() and $this->Mainclass->Account->IsStrongHold());
				if(!$this->login)
					return $this->Logout();
				$this->key=$lkey;
				return true;
			}while(false);
		return $this->login;
	}

	public function Logout()
	{
		$this->login=false;
		$this->Mainclass->Account->LogOut();
		$this->Mainclass->SCookie('Admin',false,null,true);
	}

	public function UserLink($user_name,$user_id=0)
	{
		if (!$this->IsUser())
			return false;
		return $user_id ? $this->Mainclass->services[1]['file'].'?'.$this->Mainclass->Url->ConstructUrl(array('section'=>'management','key'=>$this->key,'module'=>'users','edit'=>$user_id),false,false,false) : '';
	}

	private function CheckPermission()
	{
		$arr=$this->Mainclass->Account->GetPermission('access_cp');
		return is_array($arr) ? in_array('1',$arr) : false;
	}
}
?>