<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if (!defined('CMS'))
	die('Попытка взлома?');
class EE_SQL extends EE
{
	private
		$qerror,
		$query;

	public function __construct($error,$params)
	{
		$this->qerror=$params['error'];
		$this->query=$params['query'];
		parent::__construct($error,EE::ALT,$params+array('mess'=>$error));
	}

	public function LogIt()
	{
		$Mainclass=Mainclass::getInstance();
		if(!$Mainclass->vars['db_errors_log_file'])
			return;
		$path=$Mainclass->FormatPath($Mainclass->vars['db_errors_log_file']);
		if(!is_writeable(dirname($path)))
			die('File '.$file_name.' is write-protected!');
		if($Mainclass->vars['errors_file_max_size'] and is_file($path) and @filesize($path)>(int)$Mainclass->vars['errors_file_max_size'])
		{
			clearstatcache();
			if(Functions::CompressFile($path,substr($path,0,strrpos($path,'.')).'_'.date('Y-m-d_H-i')))
				@unlink($path);
		}
		if($fhandle=fopen($path,'a'))
		{
			$date_time=date('Y-m-d H:i:s');
			$url=$Mainclass->MyGetEnv('REQUEST_URI');
			if(isset($Mainclass->Url))
				$url=$Mainclass->Url->DecodeParam($url);
			flock($fhandle,LOCK_EX);
			fwrite($fhandle,$this->qerror."\r\n".' Query: '.$this->query."\r\n".' Line: '.$this->line.' in file '.$this->file."\r\n".' URL: '.$url."\r\n".' Date: '.$date_time."\r\n".' IP: '.$Mainclass->ip."\r\n\r\n");
			flock($fhandle,LOCK_UN);
			fclose($fhandle);
		}
	}
}
?>