<?php
if(!defined('INSTALL'))
	die('Попытка взлома?');

$tables[]="DROP TABLE IF EXISTS `{$prefix}addon_fields`";
$tables['addon_fields']="
CREATE TABLE `{$prefix}addon_fields` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`mid` int(11) UNSIGNED NOT NULL,
`unique` varchar(10) NOT NULL,
`tags` varchar(100) NOT NULL,
`type` enum('text','radio','check','edit','select','item','items','editor','user') NOT NULL,
`name` varchar(50) NOT NULL,
`default` text NOT NULL,
`eval` text NOT NULL,
`extra` text NOT NULL,
`position` int(11) UNSIGNED NOT NULL,
`status` tinyint(1) NOT NULL,
`req` tinyint(1) NOT NULL,
PRIMARY KEY  (`id`),
KEY `mid` (`mid`,`unique`),
KEY `position` (`position`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;


$tables[]="DROP TABLE IF EXISTS `{$prefix}addon_fields_l`";
$tables['addon_fields_l']="
CREATE TABLE `{$prefix}addon_fields_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(150) NOT NULL,
`descr` text NOT NULL,
KEY `id` (`id`),
KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blogs`";
$tables['blogs']="
CREATE TABLE IF NOT EXISTS `{$prefix}blogs` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(50) NOT NULL,
`crdate` datetime NOT NULL,
`author` varchar(30) NOT NULL,
`author_id` int(11) unsigned NOT NULL,
`title` varchar(100) NOT NULL,
`descr` varchar(300) NOT NULL,
`logo` varchar(100) NOT NULL,
`per_page` int(11) unsigned NOT NULL,
`last_cid` int(11) unsigned NOT NULL,
`last_id` int(11) unsigned NOT NULL,
`last_url` varchar(100) NOT NULL,
`last_title` varchar(100) NOT NULL,
`last_date` datetime NOT NULL,
`last_author` varchar(100) NOT NULL,
`last_author_id` int(11) unsigned NOT NULL,
`type` enum('personal','public') NOT NULL,
`categs` tinyint(1) NOT NULL,
`status` tinyint(1) NOT NULL,
`posts` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `url` (`url`),
KEY `author_id` (`author_id`),
KEY `last_date` (`last_date`),
KEY `crdate` (`crdate`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blogs_bt`";
$tables['blogs_bt']="
CREATE TABLE IF NOT EXISTS `{$prefix}blogs_bt` (
`pid` int(11) unsigned NOT NULL,
`tid` int(11) unsigned NOT NULL,
KEY `pid` (`pid`),
KEY `tid` (`tid`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blogs_categories`";
$tables['blogs_categories']="
CREATE TABLE IF NOT EXISTS `{$prefix}blogs_categories` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(50) NOT NULL,
`title` varchar(100) NOT NULL,
`descr` varchar(300) NOT NULL,
`bid` int(11) unsigned NOT NULL,
`posts` int(11) unsigned NOT NULL,
`logo` varchar(100) NOT NULL,
`pos` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `bid` (`bid`,`url`),
KEY `pos` (`pos`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blogs_posts`";
$tables['blogs_posts']="
CREATE TABLE IF NOT EXISTS `{$prefix}blogs_posts` (
`id` int(11) unsigned NOT NULL auto_increment,
`bid` int(11) unsigned NOT NULL,
`cid` int(11) unsigned NOT NULL,
`cats` varchar(50) NOT NULL,
`date` datetime NOT NULL,
`url` varchar(100) NOT NULL,
`title` varchar(100) NOT NULL,
`text` text NOT NULL,
`author` varchar(30) NOT NULL,
`author_id` int(11) unsigned NOT NULL,
`comments` tinyint(1) NOT NULL,
`reads` int(11) unsigned NOT NULL,
`allow_comm` tinyint(1) NOT NULL,
`show_sokr` tinyint(1) NOT NULL,
`total` int(11) unsigned NOT NULL,
`votes` int(11) unsigned NOT NULL,
`editdate` datetime NOT NULL,
`tags` varchar(50) NOT NULL,
`status` tinyint(1) NOT NULL,
PRIMARY KEY  (`id`),
KEY `cid` (`cid`),
KEY `cats` (`cats`),
KEY `bid` (`bid`,`url`),
KEY `status` (`status`,`date`),
KEY `date` (`date`),
KEY `author_id` (`author_id`,`status`),
FULLTEXT KEY `text` (`text`),
FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blogs_tags`";
$tables['blogs_tags']="
CREATE TABLE IF NOT EXISTS `{$prefix}blogs_tags` (
`id` int(11) unsigned NOT NULL auto_increment,
`bid` int(11) unsigned default NULL,
`name` varchar(30) NOT NULL,
PRIMARY KEY  (`id`),
KEY `bid` (`bid`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blocks`";
$tables['blocks']="
CREATE TABLE `{$prefix}blocks` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`service` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`cont_type` enum('file','content','plugin') NOT NULL,
`title` varchar(50) NOT NULL,
`content` text NOT NULL,
`file` varchar(100) NOT NULL,
`plugin` text NOT NULL,
`user_groups` varchar(20) NOT NULL,
`type` varchar(20) NOT NULL,
`position` int(11) UNSIGNED NOT NULL default '0',
`active` int(1) NOT NULL default '1',
`unique` varchar(20) NOT NULL,
`expire` int(11) UNSIGNED NOT NULL default '0',
`action` char(1) NOT NULL default '',
`modules` varchar(255) NOT NULL,
`free` tinyint(1) NOT NULL default '0' COMMENT 'оболочка',
`only_echo` tinyint(1) NOT NULL default '0',
`tags` varchar(200) NOT NULL,
`modules_rules` text NOT NULL,
`notitle` tinyint(1) NOT NULL,
`vars` text NOT NULL,
PRIMARY KEY  (`id`),
KEY `position` (`position`),
KEY `service` (`service`,`active`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}blocktypes`";
$tables['blocktypes']="
CREATE TABLE `{$prefix}blocktypes` (
`services` varchar(50) NOT NULL,
`name` varchar(25) NOT NULL,
`descr` varchar(50) NOT NULL,
PRIMARY KEY  (`name`),
KEY `services` (`services`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}bookmarks`";
$tables['bookmarks']="
CREATE TABLE `{$prefix}bookmarks` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`uid` int(11) UNSIGNED NOT NULL,
`mid` int(11) UNSIGNED NOT NULL,
`value` varchar(25) NOT NULL,
`title` varchar(100) NOT NULL,
`href` varchar(200) NOT NULL,
`descr` varchar(500) NOT NULL,
`imp` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `uid` (`uid`,`mid`,`value`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}bookmarkspre`";
$tables['bookmarkspre']="
CREATE TABLE `{$prefix}bookmarkspre` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`href` varchar(200) NOT NULL,
`imp` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}bookmarkspre_l`";
$tables['bookmarkspre_l']="
CREATE TABLE `{$prefix}bookmarkspre_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(200) NOT NULL,
`descr` varchar(500) NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}cache_search`";
$tables['cache_search']="
CREATE TABLE `{$prefix}cache_search` (
`id` varchar(32) NOT NULL,
`date` int(11) UNSIGNED NOT NULL,
`total_results` int(11) UNSIGNED NOT NULL,
`user_id` int(11) UNSIGNED NOT NULL,
`ip` varchar(15) NOT NULL,
`query` text NOT NULL,
`addon` text NOT NULL,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}cache_store`";
$tables['cache_store']="
CREATE TABLE `{$prefix}cache_store` (
`key` varchar(30) NOT NULL,
`value` text NOT NULL,
`is_array` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`key`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}check_voting`";
$tables['check_voting']="
CREATE TABLE `{$prefix}check_voting` (
`mid` int(11) UNSIGNED NOT NULL,
`value` varchar(25) NOT NULL,
`ip` varchar(15) NOT NULL,
`time` int(11) UNSIGNED NOT NULL,
`uid` int(11) UNSIGNED NOT NULL,
KEY `mid` (`mid`,`value`,`ip`),
KEY `time` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}comments`";
$tables['comments']="
CREATE TABLE `{$prefix}comments` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`mid` int(11) UNSIGNED NOT NULL,
`m_value` varchar(25) NOT NULL,
`date` datetime NOT NULL,
`uid` int(11) UNSIGNED NOT NULL,
`name` varchar(25) NOT NULL,
`ip` varchar(15) NOT NULL,
`parent` int(11) UNSIGNED NOT NULL,
`text` text NOT NULL,
`karma` int(11) UNSIGNED NOT NULL,
`karma_ids` text NOT NULL,
`email` VARCHAR( 50 ) NOT NULL,
`status` TINYINT NOT NULL,
`who_m_spam` VARCHAR( 50 ) NOT NULL,
PRIMARY KEY  (`id`),
KEY `mid` (`mid`,`m_value`,`status`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}config`";
$tables['config']="
CREATE TABLE `{$prefix}config` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`group` int(11) UNSIGNED NOT NULL,
`type` enum('text','radio','check','edit','select','item','items','editor','user') NOT NULL,
`name` varchar(50) NOT NULL,
`end_group` tinyint(1) UNSIGNED NOT NULL,
`protected` tinyint(1) UNSIGNED NOT NULL,
`position` int(11) UNSIGNED NOT NULL,
`cache` tinyint(1) UNSIGNED NOT NULL default '1',
`multilang` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `name` (`name`),
KEY `group` (`group`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}config_l`";
$tables['config_l']="
CREATE TABLE `{$prefix}config_l` (
`id` INT( 11 ) UNSIGNED NOT NULL ,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` VARCHAR( 200 ) NOT NULL ,
`descr` TEXT NOT NULL ,
`value` text NOT NULL,
`default` text NOT NULL,
`eval` text NOT NULL,
`extra` text NOT NULL,
`start_group` varchar(100) NOT NULL,
KEY `id` (`id`,`language`),
FULLTEXT KEY `title` (`title`),
FULLTEXT KEY `descr` (`descr`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}config_groups`";
$tables['config_groups']="
CREATE TABLE `{$prefix}config_groups` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`name` varchar(50) NOT NULL,
`protected` tinyint(1) UNSIGNED NOT NULL,
`keyword` varchar(50) NOT NULL,
`position` int(11) UNSIGNED NOT NULL default '0',
PRIMARY KEY  (`id`),
KEY `keyword` (`keyword`),
KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}config_groups_l`";
$tables['config_groups_l']="
CREATE TABLE `{$prefix}config_groups_l` (
`id` INT( 11 ) UNSIGNED NOT NULL ,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` VARCHAR( 200 ) NOT NULL ,
`descr` TEXT NOT NULL ,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}confirmation`";
$tables['confirmation']="
CREATE TABLE `{$prefix}confirmation` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`hash` varchar(32) NOT NULL,
`date` datetime NOT NULL,
`datef` datetime NOT NULL,
`data` text NOT NULL,
PRIMARY KEY  (`id`),
KEY `hash` (`hash`,`datef`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}errors`";
$tables['errors']="
CREATE TABLE `{$prefix}errors` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(50) NULL,
`num` VARCHAR(3) NOT NULL,
`image` varchar(50) NOT NULL,
`mail` varchar(50) NOT NULL,
`log` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}errors_l`";
$tables['errors_l']="
CREATE TABLE `{$prefix}errors_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(100) NOT NULL,
`text` text NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}faq`";
$tables['faq']="
CREATE TABLE `{$prefix}faq` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NULL,
`cid` int(11) UNSIGNED NOT NULL default '0',
`status` tinyint(1) NOT NULL default '1',
`pinned` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `cid` (`cid`),
KEY `status` (`status`,`pinned`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}faq_categories`";
$tables['faq_categories']="
CREATE TABLE `{$prefix}faq_categories` (
`id` int(10) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`image` varchar(100) NOT NULL,
`parent` int(11) UNSIGNED NOT NULL default '0',
`l` int(11) NOT NULL,
`r` int(11) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}faq_categories_l`";
$tables['faq_categories_l']="
CREATE TABLE `{$prefix}faq_categories_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(50) NOT NULL,
`description` text NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}faq_l`";
$tables['faq_l']="
CREATE TABLE `{$prefix}faq_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(200) NOT NULL,
`text` text NOT NULL,
KEY `id` (`id`,`language`),
FULLTEXT KEY `title` (`title`,`text`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}files`";
$tables['files']="
CREATE TABLE `{$prefix}files` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`main_cat` int(11) UNSIGNED NOT NULL,
`cats` varchar(100) NOT NULL,
`author` varchar(25) NOT NULL,
`author_id` int(11) UNSIGNED NOT NULL,
`groups` varchar(30) NOT NULL,
`icons` text NOT NULL,
`show_sokr` tinyint(1) UNSIGNED NOT NULL,
`date` DATETIME NOT NULL,
`files` text NOT NULL,
`images` text NOT NULL,
`size` varchar(20) NOT NULL,
`version` varchar(20) NOT NULL,
`license` varchar(50) NOT NULL,
`total` int(11) UNSIGNED NOT NULL,
`votes` int(11) UNSIGNED NOT NULL,
`status` tinyint(1) NOT NULL,
`comments` int(11) UNSIGNED NOT NULL,
`allow_comm` tinyint(1) UNSIGNED default '1',
`s_descr` varchar(250) NOT NULL,
`s_title` varchar(100) NOT NULL,
`pinned` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `main_cat` (`main_cat`),
KEY `cats` (`cats`),
KEY `status` (`status`,`groups`,`pinned`,`date`),
KEY `date` (`status`,`date`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}files_categories`";
$tables['files_categories']="
CREATE TABLE `{$prefix}files_categories` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`image` varchar(100) NOT NULL,
`parent` int(11) UNSIGNED NOT NULL,
`l` int(11) NOT NULL,
`r` int(11) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}files_categories_l`";
$tables['files_categories_l']="
CREATE TABLE `{$prefix}files_categories_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(50) NOT NULL,
`description` text,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}files_l`";
$tables['files_l']="
CREATE TABLE `{$prefix}files_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(100) NOT NULL,
`text` text NOT NULL,
KEY `id` (`id`,`language`),
FULLTEXT KEY `title` (`title`,`text`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}groups`";
$tables['groups']="
CREATE TABLE `{$prefix}groups` (
`id` int(10) UNSIGNED NOT NULL auto_increment,
`title` varchar(50) NOT NULL,
`html_pref` varchar(150) NOT NULL,
`html_end` varchar(150) NOT NULL,
`protected` tinyint(1) UNSIGNED NOT NULL default '0',
`access_cp` tinyint(1) UNSIGNED NOT NULL default '0',
`use_files` tinyint(1) UNSIGNED NOT NULL,
`del_files` tinyint(1) UNSIGNED NOT NULL,
`max_upload` int(11) UNSIGNED NOT NULL,
`banned` tinyint(1) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}mainpage`";
$tables['mainpage']="
CREATE TABLE `{$prefix}mainpage` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`mid` int(11) UNSIGNED NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}menu`";
$tables['menu']="
CREATE TABLE `{$prefix}menu` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`addon` text NOT NULL,
`url` varchar(100) NOT NULL,
`eval_url` varchar(250) NOT NULL,
`params` varchar(200) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
`parent` int(11) UNSIGNED NOT NULL,
`in_map` tinyint(1) UNSIGNED NOT NULL,
`status` tinyint(1) NOT NULL,
`l` int(11) NOT NULL ,
`r` int(11) NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`),
KEY `pos` (`pos`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}menu_l`";
$tables['menu_l']="
CREATE TABLE `{$prefix}menu_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(100) NOT NULL,
`descr` text NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}modules`";
$tables['modules']="
CREATE TABLE `{$prefix}modules` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`services` varchar(100) NOT NULL,
`name` varchar(50) NOT NULL,
`title` varchar(150) NOT NULL,
`descr` varchar(50) NOT NULL,
`protected` tinyint(1) UNSIGNED NOT NULL default '0',
`path` varchar(150) NOT NULL,
`multiservice` tinyint(1) UNSIGNED NOT NULL default '0',
`file` varchar(50) NOT NULL,
`is_class` tinyint(1) NOT NULL,
`resources` text NOT NULL,
`image` varchar(50) NOT NULL,
`active` tinyint(1) NOT NULL default '0',
`user_groups` varchar(100) NOT NULL,
`blocks` text NOT NULL,
`pos_load` int(11) UNSIGNED NOT NULL default '0',
`pos_unload` int(11) UNSIGNED NOT NULL default '0',
`editor` tinyint(2) NOT NULL default '-1',
`plugins` varchar(50) NOT NULL,
PRIMARY KEY  (`id`),
KEY `services` (`services`),
KEY `name` (`name`,`active`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}news`";
$tables['news']="
CREATE TABLE `{$prefix}news` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NULL,
`cats` varchar(100) NOT NULL,
`main_cat` int(11) UNSIGNED NOT NULL,
`date` DATETIME NOT NULL,
`groups` varchar(100) NOT NULL,
`author` varchar(25) NOT NULL,
`author_id` int(11) UNSIGNED NOT NULL,
`show_detail` tinyint(1) NOT NULL,
`show_sokr` tinyint(1) NOT NULL,
`total` int(11) UNSIGNED NOT NULL,
`votes` int(11) UNSIGNED NOT NULL,
`status` tinyint(1) NOT NULL,
`reads` int(11) UNSIGNED NOT NULL,
`comments` int(11) UNSIGNED NOT NULL,
`allow_comm` tinyint(1) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`s_title` varchar(100) NOT NULL,
`pinned` tinyint(1) NOT NULL,
`af` text NOT NULL COMMENT 'доп.поля',
`tags` VARCHAR(100) NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `cats` (`cats`),
KEY `main_cat` (`main_cat`),
KEY `status` (`status`,`groups`,`pinned`,`date`),
KEY `date` (`status`,`date`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}news_categories`";
$tables['news_categories']="
CREATE TABLE `{$prefix}news_categories` (
`id` int(10) UNSIGNED NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`image` varchar(100) NOT NULL,
`parent` int(11) UNSIGNED NOT NULL default '0',
`l` int(11) NOT NULL,
`r` int(11) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}news_categories_l`";
$tables['news_categories_l']="
CREATE TABLE `{$prefix}news_categories_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(50) NOT NULL,
`description` text NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}news_l`";
$tables['news_l']="
CREATE TABLE `{$prefix}news_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(100) NOT NULL,
`text` text NOT NULL,
KEY `id` (`id`,`language`),
FULLTEXT KEY `title` (`title`,`text`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}news_nt`";
$tables['news_nt']="
CREATE TABLE `{$prefix}news_nt` (
`news` int(11) UNSIGNED NOT NULL,
`tag` int(11) UNSIGNED NOT NULL,
KEY `news` (`news`),
KEY `tag` (`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}news_tags`";
$tables['news_tags']="
CREATE TABLE `{$prefix}news_tags` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`name` varchar(50) NOT NULL,
PRIMARY KEY  (`id`),
KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}own_bbcodes`";
$tables['own_bbcodes']="CREATE TABLE `{$prefix}own_bbcodes` (
`id` int(11) unsigned NOT NULL auto_increment,
`pos` int(11) unsigned NOT NULL,
`active` tinyint(1) NOT NULL,
`tag` varchar(50) NOT NULL,
`aliases` varchar(250) NOT NULL,
`single` tinyint(1) unsigned NOT NULL,
`no_parse` tinyint(1) unsigned NOT NULL,
`special` tinyint(1) unsigned NOT NULL,
`file` varchar(100) NOT NULL,
`sp_tags` varchar(250) NOT NULL,
`gr_use` varchar(250) NOT NULL,
`gr_see` varchar(250) NOT NULL,
`options` varchar(250) NOT NULL,
`sb` BOOL NOT NULL,
PRIMARY KEY  (`id`),
KEY `pos` (`pos`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}qmenu`";
$tables['qmenu']="
CREATE TABLE IF NOT EXISTS `{$prefix}qmenu` (
`id` int(11) unsigned NOT NULL auto_increment,
`aid` int(11) unsigned NOT NULL,
`pos` int(10) unsigned NOT NULL,
`mid` int(11) unsigned NOT NULL,
`title` varchar(50) NOT NULL,
`icon` varchar(50) NOT NULL,
`href` varchar(100) NOT NULL,
`eval_url` varchar(250) NOT NULL,
`link_id` int(11) unsigned NOT NULL,
PRIMARY KEY  (`id`),
KEY `aid` (`aid`,`pos`),
KEY `pos` (`pos`)
) ENGINE=MyISAM  DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}services`";
$tables['services']="
CREATE TABLE `{$prefix}services` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`name` varchar(20) NOT NULL,
`file` varchar(30) NOT NULL,
`protected` tinyint(1) UNSIGNED NOT NULL,
`theme` varchar(30) NOT NULL,
`login` varchar(30) NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}sessions`";
$tables['sessions']="
CREATE TABLE `{$prefix}sessions` (
`user_id` int(11) UNSIGNED NOT NULL,
`enter_time` int(11) UNSIGNED NOT NULL,
`ip` varchar(39) NOT NULL,
`info` text NOT NULL,
`service` varchar(20) NOT NULL,
`browser` varchar(200) NOT NULL,
`location` varchar(150) NOT NULL,
`name` varchar(25) NOT NULL,
`addon` VARCHAR( 100 ) NOT NULL,
KEY `ip` (`ip`,`user_id`,`service`),
KEY `service` (`service`,`enter_time`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}smiles`";
$tables['smiles']="
CREATE TABLE `{$prefix}smiles` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`path` varchar(200) NOT NULL,
`emotion` varchar(50) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `emotion` (`emotion`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}static`";
$tables['static']="
CREATE TABLE `{$prefix}static` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`url` varchar(70) NULL,
`show_title` tinyint(1) UNSIGNED NOT NULL,
`r` int(11) NOT NULL,
`l` int(11) NOT NULL,
`parent` int(11) unsigned NOT NULL,
`pos` int(11) unsigned NOT NULL,
`status` tinyint(1) NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `l` (`l`),
KEY `parent` (`parent`,`pos`),
KEY `status` (`status`,`pos`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}static_l`";
$tables['static_l']="
CREATE TABLE `{$prefix}static_l` (
`id` int(11) UNSIGNED NOT NULL,
`language` VARCHAR( 15 ) NOT NULL DEFAULT '',
`title` varchar(70) NOT NULL,
`text` text NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}steps`";
$tables['steps']="
CREATE TABLE `{$prefix}steps` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`unique` varchar(50) NOT NULL,
`step` varchar(30) NOT NULL,
`data` text NOT NULL,
`res1` varchar(100) NOT NULL,
`res2` varchar(100) NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `unique` (`unique`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}upgrade_hist`";
$tables['upgrade_hist']="
CREATE TABLE `{$prefix}upgrade_hist` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`version` varchar(50) NOT NULL,
`date` datetime NOT NULL,
`build` int(11) UNSIGNED NOT NULL,
`uid` int(11) UNSIGNED NOT NULL,
`descr` text NOT NULL,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}users`";
$tables['users']="
CREATE TABLE `{$prefix}users` (
`id` int(11) UNSIGNED NOT NULL auto_increment,
`forum_id` int(11) UNSIGNED NOT NULL,
`name` varchar(25) NOT NULL,
`l_name` varchar(25) NOT NULL,
`email` varchar(40) NOT NULL,
`group` int(11) UNSIGNED NOT NULL default '0',
`other_group` varchar(200) NOT NULL,
`login_keys` varchar(500) NOT NULL,
`pass_salt` varchar(20) NOT NULL,
`pass_hash` varchar(32) NOT NULL,
`failed_logins` text NOT NULL,
`ip` varchar(39) NOT NULL,
`register` date NOT NULL,
`last_visit` int(11) UNSIGNED NOT NULL default '0',
`ban_date` DATE NULL DEFAULT NULL,
`ban_explain` text NOT NULL,
`lang` varchar(30) NOT NULL,
`theme` varchar(30) NOT NULL,
`editor` tinyint(1) NOT NULL default '-1',
PRIMARY KEY  (`id`),
UNIQUE KEY `l_name` (`l_name`),
KEY `forum_id` (`forum_id`),
KEY `email` (`email`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}users_extra`";
$tables['users_extra']="
CREATE TABLE `{$prefix}users_extra` (
`id` int(11) UNSIGNED NOT NULL,
`jabber` varchar(50) NOT NULL,
`bio` text NOT NULL,
`icq` varchar(10) NOT NULL,
`aim` varchar(40) NOT NULL,
`skype` varchar(30) NOT NULL,
`website` varchar(100) NOT NULL,
`yahoo` varchar(40) NOT NULL,
`interests` text NOT NULL,
`msn` varchar(100) NOT NULL,
`location` varchar(100) NOT NULL,
`signature` text NOT NULL,
`avatar_location` varchar(200) NOT NULL,
`avatar_size` varchar(9) NOT NULL,
`avatar_type` enum('upload','local','url') default NULL,
PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}voting`";
$tables['voting']="
CREATE TABLE `{$prefix}voting` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(100) NULL,
`cid` int(11) unsigned NOT NULL,
`answers` text NOT NULL,
`date` date NOT NULL,
`date_f` date NULL,
`type` tinyint(1) unsigned NOT NULL,
`numans` int(11) unsigned NOT NULL,
`cnt` int(11) unsigned NOT NULL,
`status` tinyint(1) NOT NULL,
`comments` int(11) unsigned NOT NULL,
`allow_comm` tinyint(1) unsigned default '1',
`who` text NOT NULL,
`only_users` tinyint(1) unsigned NOT NULL,
PRIMARY KEY  (`id`),
UNIQUE KEY `url` (`url`),
KEY `cid` (`cid`),
KEY `date_f` (`date_f`),
KEY `status` (`status`,`date`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}voting_categories`";
$tables['voting_categories']="
CREATE TABLE `{$prefix}voting_categories` (
`id` int(11) unsigned NOT NULL auto_increment,
`url` varchar(100) NOT NULL,
`image` varchar(100) NOT NULL,
`parent` int(11) unsigned NOT NULL,
`l` int(11) NOT NULL,
`r` int(11) NOT NULL,
`s_descr` varchar(250) NOT NULL,
`pos` int(11) UNSIGNED NOT NULL,
PRIMARY KEY  (`id`),
KEY `l` (`l`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}voting_categories_l`";
$tables['voting_categories_l']="
CREATE TABLE `{$prefix}voting_categories_l` (
`id` int(11) unsigned NOT NULL,
`language` varchar(15) NOT NULL,
`title` varchar(50) NOT NULL,
`description` text,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;

$tables[]="DROP TABLE IF EXISTS `{$prefix}voting_l`";
$tables['voting_l']="
CREATE TABLE `{$prefix}voting_l` (
`id` int(11) unsigned NOT NULL,
`language` varchar(15) NOT NULL,
`title` varchar(150) NOT NULL,
`text` text NOT NULL,
`variants` text NOT NULL,
KEY `id` (`id`,`language`)
) ENGINE=MyISAM DEFAULT CHARSET=".ELEANOR_DBCHARSET;
?>