<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum.Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
class Update_3 extends BaseClass implements UpdateClass
{
	public function DoUpdate($step=0)
	{
		$this->DoSettings();
		return array(
						'text'=>$step ? '' : '<div align="center"><h1>'.sprintf($this->Mainclass->lang['install']['update_to_complete'],'RC4').'</h1></div>',
						'errors'=>array(),
						'url'=>1,
						'done'=>true,
		);
	}

	private function DoSettings()
	{
		$s='
<eleanor_options>
<version>1.0</version>
<option>
	<title>Включить дополнительные поля?</title>
	<name>m_news_af</name>
	<descr></descr>
	<group>module_news</group>
	<type>check</type>
	<value>
		MQ==
	</value>
	<default>
		MQ==
	</default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>0</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
<option>
	<title>Отключить капчу?</title>
	<name>captcha_off</name>
	<descr></descr>
	<group>security</group>
	<type>check</type>
	<value></value>
	<default></default>
	<eval></eval>
	<extra></extra>
	<start_group></start_group>
	<end_group>0</end_group>
	<protected>1</protected>
	<cache>1</cache>
	<onexists>full update</onexists>
</option>
</eleanor_options>';
		if (!isset($this->Mainclass->Settings))
			$this->Mainclass->LoadClass('classes/others/class_settings.php');
		if (!isset($this->Mainclass->Cache))
		{
			$this->Mainclass->LoadClass('classes/class_cache.php');
			$this->Mainclass->Cache->Init();
		}
		$this->Mainclass->Settings->ProcessImport($s);
	}
}
?>