<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
define('CMS',true);
define('INSTALL',true);
require './init.php';
$step=isset($_GET['step']) ? (int)$_GET['step'] : 1;
$num=0;
switch($step)
{
	case 3:
		Functions::Redirect((isset($_POST['update']) ? 'update' : 'install').'.php');
		die;
	case 2:
		if(isset($_GET['lang'],$preinstlled_lang[$_GET['lang']]) and $Mainclass->Functions->SetLangCookie($_GET['lang'],ELEANOR_LC))
		{
			$Mainclass->lang_name=$_GET['lang'];
			$Mainclass->lang['install']=$lang=$Mainclass->LoadLanguage('install/lang','','install-%');
			$title=$navi=$lang['srequirements'];
			$num=1;
			$can=true;
			$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
			<div class="wpmid">
			<form method="post" action="index.php?step=3">
			<table class="tablespec">
			<tr class="tshead"><th>'.$lang['parametr'].'</th><th>'.$lang['value'].'</th><th>'.$lang['status'].'</th></tr>
			<tr class="tsline"><td class="label">'.$lang['php_version'].'</td><td class="sense">'.PHP_VERSION.'</td>';

			if(version_compare(PHP_VERSION,'5.1.6','<'))
			{
				$text.='<td><img src="'.$Mainclass->Template->theme.'/images/warn.png" alt="'.$lang['error'].'" /></td>';
				$can=false;
			}
			else
				$text.='<td><img src="'.$Mainclass->Template->theme.'/images/ok.png" alt="OK" /></td>';
			$text.='</tr><tr class="tsline"><td class="label">'.$lang['php_mbstring'].'</td>';

			if(function_exists('mb_detect_encoding'))
				$text.='<td class="sense">+</td><td><img src="'.$Mainclass->Template->theme.'/images/ok.png" alt="OK" /></td>';
			else
			{
				$text.='<td class="sense">-</td><td><img src="'.$Mainclass->Template->theme.'/images/warn.png" alt="'.$lang['error'].'" /></td>';
				$can=false;
			}

			$text.='</tr><tr class="tsline"><td class="label">'.$lang['php_gd'].'</td>';
			if(function_exists('imagefttext'))
				$text.='<td class="sense">+</td><td><img src="'.$Mainclass->Template->theme.'/images/ok.png" alt="OK" /></td>';
			else
			{
				$text.='<td class="sense">-</td><td><img src="'.$Mainclass->Template->theme.'/images/warn.png" alt="'.$lang['error'].'" /></td>';
				$can=false;
			}

			$text.='</tr><tr class="tsline"><td class="label">'.$lang['php_safemode'].'</td>';
			if(ini_get('safe_mode')==0)
				$text.='<td class="sense">OFF</td><td><img src="'.$Mainclass->Template->theme.'/images/ok.png" alt="OK" /></td>';
			else
			{
				$text.='<td class="sense">ON</td><td><img src="'.$Mainclass->Template->theme.'/images/warn.png" alt="!!!" /></td>';
				$can=false;
			}

			$text.='</tr><tr class="tsline"><td class="label">'.$lang['db_drivers'].'</td>';
			if(function_exists('mysql_connect') or function_exists('mysqli_connect') or function_exists('pg_connect'))
			{
				$dbs=array();
				if(function_exists('mysql_connect'))
					$dbs[]='MySQL';
				if(function_exists('mysqli_connect'))
					$dbs[]='MySQLi';
				$text.='<td class="sense">'.join('<br />',$dbs).'</td><td><img src="'.$Mainclass->Template->theme.'/images/ok.png" alt="OK" /></td>';
			}
			else
			{
				$text.='<td>'.$lang['not_find'].'</td><td><img src="'.$Mainclass->Template->theme.'/images/warn.png" alt="'.$lang['error'].'" /></td>';
				$can=false;
			}

			$text.='</tr>
			<tr class="tsline"><td class="label" colspan="3">'.$lang['mysql_modrewr'].'</td></tr>
			</table>'
			.($can ? '<div class="submitline">'.Template::Button($lang['install'],'submit','class="button" name="install"').' '.Template::Button($lang['update'],'submit','class="button" name="update"').'</div>' : '')
			.'</form></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
			break;
		}
	default:
		$navi='Selecting language / انتخاب زبان';
		$langs='';
		foreach($preinstlled_lang as $k=>&$v)
			$langs.='<a href="index.php?step=2&amp;lang='.$k.'" title="'.$v[1].'"><img src="../images/lang_flags/'.$k.'-big.png" alt="" /><span><b>'.$v[0].'</b><br />'.$v[1].'</span></a>';
		$Mainclass->Functions->SetLangCookie(false,ELEANOR_LC);
		$title='نصب سیستم الینور فارسی';
		$text='<div class="selectlang">'.$langs.'</div>';
	break;
}
OutPut();
echo $Mainclass->Template->GetThemeFile(
										'index',
										array(
												'percent'=>0,
												'navi'=>$navi,
												'title'=>$title,
												'text'=>$text,
										)
);
?>