<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
define('CMS',true);
define('INSTALL',true);
require './init.php';
$step=isset($_GET['step']) ? (int)$_GET['step'] : 1;
$Mainclass->Functions->GetLangCookie(true,ELEANOR_LC);
$Mainclass->lang['install']=$lang=$Mainclass->LoadLanguage('install/lang','','install-%');
$percent=$num=0;
$error='';
if(true===$ability=Install::CheckAbilityInstall())
	switch($step)
	{
		case 6:
			$navi=$lang['finish'];
			$percent=100;
			$num=5;
			$Mainclass->StartSession('EL_INSTALL_SESSION',$_REQUEST['session']);
			if(isset($_SESSION['install']))
			{
				Install::InitDb($_SESSION['install']);
				$Mainclass->LoadClass('classes/class_cache.php');
				$Mainclass->Cache->Init();
				$Mainclass->LoadOptions('mailer',false);
				#Внимание! Отправка e-mail-а осуществляется в информативных целях и НЕ содержит никакой конфиденциальной информации
				$Mainclass->vars['site_name']=$_SESSION['install']['sitename'];#Заплаточка для маилера
				$path=preg_replace('#/install$#','',$Mainclass->site_path);
				$from=array(
							'[driver]',
							'[language]',
							'[antinull]',
							'[version]',
							'[sql_host]',
							'[sql_db]',
							'[sql_user]',
							'[sql_pass]',
							'[sql_prefix]',
							'[charset]',
							'[display_charset]',
							'[db_charset]',
				);
				$to=array(
							$_SESSION['install']['type'],
							$Mainclass->lang_name,
							ELEANOR_ANKEY.'_'.Strings::GenPass(10),
							ELEANOR_VERSION,
							$_SESSION['install']['host'],
							$_SESSION['install']['db'],
							$_SESSION['install']['user'],
							$_SESSION['install']['pass'],
							$_SESSION['install']['prefix'],
							ELEANOR_CHARSET,
							ELEANOR_DISPLAYCHARSET,
							ELEANOR_DBCHARSET,
				);
				foreach($preinstlled_lang as $k=>$v)
				{
					if($k==$Mainclass->lang_name or in_array($k,$_SESSION['install']['languages']))
						$from[]='#[lang_'.$k.']';
					else
						$from[]='[lang_'.$k.']';
					$to[]='';
				}
				file_put_contents($Mainclass->root_path.'install/install.lock',1);
				file_put_contents($Mainclass->root_path.'config_general.bak',str_replace($from,$to,file_get_contents($Mainclass->root_path.'config_general.bak')));
				if(file_exists($Mainclass->root_path.'config_general.php'))
					unlink($Mainclass->root_path.'config_general.php');
				$ranamed=@rename($Mainclass->root_path.'config_general.bak',$Mainclass->root_path.'config_general.php');
				$url1='http://'.$Mainclass->domain.$path.'/index.php';
				$url2='http://'.$Mainclass->domain.$path.'/admin.php';
				$title=$lang['install_finished'];
				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
				<div class="wpmid"><div class="wpcont"><div class="information" align="center"><h4 style="color: green;">'.$title.'</h4></div><div class="information">'.($ranamed ? $lang['inst_fin_text'] : $Mainclass->Template->Message($lang['inst_err_text'],'error')).'</div>
				<div class="submitline">'
				.sprintf($lang['links'],$url1,$url2).'</div></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				try
				{
					$Mainclass->Mail(
										'newsite@eleanor-cms.ru',
										'URL: http://'.$Mainclass->domain.$path.'<br />Encoding: '.ELEANOR_CHARSET,
										array(
												'html'=>true,
												'subject'=>'Новый сайт: '.htmlspecialchars($_SESSION['install']['sitename'])
										)
					);
				}
				catch(EE $e){}
				break;
			}
		break;
		case 5:
			$navi=$lang['create_admin'];
			$percent=80;
			$num=4;
			$Mainclass->StartSession('EL_INSTALL_SESSION',$_REQUEST['session']);
			if(isset($_SESSION['install']))
			{
				$error='';
				Install::InitDb($_SESSION['install']);
				if(isset($_POST['name']))
					do
					{
						if($_POST['pass']!=$_POST['rpass'])
						{
							$error=$lang['pass_mismatch'];
							break;
						}
						if(!Functions::CheckEmail($_POST['email']))
						{
							$error=$lang['err_email'];
							break;
						}
						$Mainclass->LoadClass('classes/class_cache.php');
						$Mainclass->Cache->Init();
						$Mainclass->LoadOptions('blocker',false);
						$Mainclass->LoadClass('classes/login/class_account.php');
						if($Mainclass->Account->Manage->AddUser($_POST['name'],$_POST['pass'],array('email'=>$_POST['email'],'group'=>1))===false)
						{
							$error=$Mainclass->Account->error_exp;
							break;
						}
						header('Location: install.php?step=6&session='.session_id());
						die;
					}while(false);
				$title=$lang['create_admin'];
				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
				<div class="wpmid"><div class="wpcont">'.CreateAdmin($error);
				break;
			}
		case 4:
			$navi=$lang['installing'];
			$percent=60;
			$num=3;
			$Mainclass->StartSession('EL_INSTALL_SESSION',$_REQUEST['session']);
			if(isset($_SESSION['install']))
			{
				Install::InitDb($_SESSION['install']);
				$title=$lang['install'];
				$text=DoInstall();
				break;
			}
		case 3:
			$navi=$lang['already_to_install'];
			$percent=40;
			if(isset($_POST['driver'],$_POST['host'],$_POST['name'],$_POST['user'],$_POST['pass'],$_POST['pref'],$_POST['sitename'],$_POST['email']))
			{
				do
				{
					if(!Functions::CheckEmail($_POST['email']))
					{
						$error=$lang['err_email'];
						break;
					}
					if(empty($_POST['sitename']))
						$_POST['sitename']='New site on Eleanor CMS';
					$arr=array(
								'host'=>$_POST['host'],
								'user'=>$_POST['user'],
								'pass'=>$_POST['pass'],
								'prefix'=>$_POST['pref'],
								'db'=>$_POST['name'],
								'type'=>$_POST['driver'],
								'force'=>true,
								'step'=>1,
								'sitename'=>$_POST['sitename'],
								'email'=>$_POST['email'],
								'furl'=>isset($_POST['furl']),
								'languages'=>(isset($_POST['languages']) and is_array($_POST['languages'])) ? $_POST['languages'] : array(),
					);
					$langs=array();
					foreach($arr['languages'] as &$v)
						if(isset($preinstlled_lang[$v]))
							$langs[]=$preinstlled_lang[$v][0];
					try
					{
						Install::InitDb($arr);
					}
					catch(EE $e)
					{
						$error=$e->getMessage();
						break;
					}
					if($_POST['driver']=='mysql' and !Install::CheckMySQLVersion())
					{
						$error=$lang['low_mysql'];
						break;
					}
					$Mainclass->StartSession('EL_INSTALL_SESSION');
					$_SESSION['install']=$arr;
					$num=2;
					$title=$lang['already_to_install'];
					$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
					<div class="wpmid"><div class="wpcont">
					<form method="post" action="install.php?step=4">
					<h3 class="subhead">'.$lang['db'].'</h3>
					<ul class="reset formfield">
					<li class="ffield"><span class="label">'.$lang['db_drive'].'</span><div class="ffdd"><h4>'.$_POST['driver'].'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_host'].'</span><div class="ffdd"><h4>'.$_POST['host'].'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_name'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['name']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_user'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['user']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['db_pass'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['pass']).'</h4></div></li>
					</ul>
					<br />
					<h3 class="subhead">'.$lang['gen_data'].'</h3>
					<ul class="reset formfield">
					<li class="ffield"><span class="label">'.$lang['sitename'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['sitename']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['email'].'</span><div class="ffdd"><h4>'.htmlspecialchars($_POST['email']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['furl'].'</span><div class="ffdd"><h4>'.($arr['furl'] ? $lang['yes'] : $lang['no']).'</h4></div></li>
					<li class="ffield"><span class="label">'.$lang['addonl'].'</span><div class="ffdd"><h4>'.($langs ? implode(', ',$langs) : $lang['no']).'</h4></div></li>
					</ul>
					<div class="submitline">'.Template::Control('session','hidden',session_id())
					.Template::Button($lang['back'],'button','class="button" onclick="history.go(-1)"')
					.Template::Button($lang['install_me'],'submit','class="button"').'</div></form>
					</div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				}while(false);
				if(!$error)
					break;
			}
			$_POST['agree']=1;
		case 2:
			$navi=$lang['get_data'];
			$percent=20;
			if(isset($_POST['agree']))
			{
				$db_driver=isset($_POST['driver']) ? $_POST['driver'] : 'mysql';
				$db_host=isset($_POST['host']) ? $_POST['host'] : 'localhost';
				$db_name=isset($_POST['name']) ? $_POST['name'] : '';
				$db_user=isset($_POST['user']) ? $_POST['user'] : '';
				$db_pass=isset($_POST['pass']) ? $_POST['pass'] : '';
				$db_pref=isset($_POST['pref']) ? $_POST['pref'] : 'el_';
				$sitename=isset($_POST['sitename']) ? $_POST['sitename'] : '';
				$langs=(isset($_POST['languages']) and is_array($_POST['languages'])) ? $_POST['languages'] : array();
				$email=isset($_POST['email']) ? $_POST['email'] : '';
				$furl=isset($_POST['furl']) or $step==2;
				$title=$lang['get_data'];
				$num=1;
				$db_drivers=(function_exists('mysql_connect') ? Template::Option('MySQL','mysql','mysql'==$db_driver) : '')
				.(function_exists('mysqli_connect') ? Template::Option('MySQLi','mysqli','mysqli'==$db_driver) : '');
				$languages='';
				foreach($preinstlled_lang as $k=>$v)
					if($k!=$Mainclass->lang_name)
						$languages.=Template::Option($v[0],$k,in_array($k,$langs));
				$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
				<div class="wpmid"><div class="wpcont">'
				.($error ? $Mainclass->Template->Message($error) : '')
				.'<form method="post" action="install.php?step=3">
				<h3 class="subhead">'.$lang['db'].'</h3>
				<ul class="reset formfield">
					<li class="ffield">
						<span class="label"><b>'.$lang['db_drive'].'</b></span><div class="ffdd">'.Template::Select('driver',$db_drivers,'class="f_select"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_host'].'</b></span><div class="ffdd">'.Template::Edit('host',$db_host,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_name'].'</b></span><div class="ffdd">'.Template::Edit('name',$db_name,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_user'].'</b></span><div class="ffdd">'.Template::Edit('user',$db_user,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_pass'].'</b></span><div class="ffdd">'.Template::Edit('pass',$db_pass,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['db_pref'].'</b></span><div class="ffdd">'.Template::Edit('pref',$db_pref,'class="f_text"').'
						<span class="small" style="color:red">'.$lang['db_prefinfo'].'</span>
						</div>
					</li>
				</ul>
				<br />
				<h3 class="subhead">'.$lang['gen_data'].'</h3>
				<ul class="reset formfield">
					<li class="ffield">
						<span class="label"><b>'.$lang['sitename'].'</b></span><div class="ffdd">'.Template::Edit('sitename',$sitename,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['email'].'</b></span><div class="ffdd">'.Template::Edit('email',$email,'class="f_text"').'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['furl'].'</b></span><div class="ffdd">'.Template::Check('furl',isset($furl)).'</div>
					</li>
					<li class="ffield">
						<span class="label"><b>'.$lang['addonl'].'</b><br />
						<span class="small">'.$lang['addonl_d'].'</span>
						</span><div class="ffdd">'.Template::Items('languages',$languages,5,'class="f_text"').'</div>
					</li>
				</ul>
				<div class="submitline">'.Template::Button($lang['next'],'submit','class="button"').'</div>'
				.Template::Control('agree','hidden','1')
				.'</form></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
				break;
			}
			$error=$lang['you_must_lagree'];
		#Лицензионное соглашение
		default:
			$navi=$lang['license'];
			$percent=0;
			$title=$lang['license'];
			$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div>
			<div class="wpmid"><div class="wpcont">'
			.($error ? $Mainclass->Template->Message($error) : '')
			.'<form method="post" action="install.php?step=2">'
			.Template::Text('n',file_get_contents($Mainclass->root_path.'install/lang/license-'.$Mainclass->lang_name.'.txt'),'readonly="readonly" style="width: 99%;" rows="13"')
			.'<p><label>'
			.Template::Check('agree',false).' '.$lang['i_am_agree']
			.'</label></p><div class="submitline">'.Template::Button($lang['next'],'submit','class="button"').'</div></form>
			</div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
		break;
	}
else
{
	$navi=$title=$lang['error'];
	$text='';
	foreach($ability as &$v)
		$text.=$Mainclass->Template->Message($v,'error');
}

function DoInstall()
{global $Mainclass,$lang,$percent;
	$do=isset($_GET['do']) ? (int)$_GET['do'] : 1;
	$Mainclass->LoadClass('classes/class_cache.php');
	$do=$_SESSION['install']['step']<$do ? $_SESSION['install']['step'] : $do;
	$text='<div class="wpbox wpbwhite"><div class="wptop"><b>&nbsp;</b></div><div class="wpmid"><div class="wpcont">';
	switch ($do)
	{
		case 1:#Создание таблиц
			$prefix=$Mainclass->Db->EscapeString($_SESSION['install']['prefix']);
			require $Mainclass->root_path.'install/data_install/tables.php';
			if(empty($tables))
			{
				$text=$Mainclass->Template->Message($lang['error_cont']);
				break;
			}
			$temp=array();
			foreach($tables as $k=>$v)
			{
				$v=str_replace(
								array(
										'\\d',
										'\\D',
										'\\w',
										'\\W',
										'\\s',
										'\\S',
								),
								array(
										'\\\\d',
										'\\\\D',
										'\\\\w',
										'\\\\W',
										'\\\\s',
										'\\\\S',
								),
								$v
				);
				$db_error=false;
				try
				{
					$Mainclass->Db->FQuery($v,array(),__file__,__line__);
				}
				catch(EE $e)
				{
					$db_error=$e->getMessage();
				}
				if(!is_int($k))
					$temp[]='<span style="color:'.($db_error ? 'red' : 'green').'" title="'.($db_error ? htmlspecialchars($db_error) : 'OK').'">'.$k.'</span>';
			}
			$text.='<div class="information"><h4>'.$lang['creating_tables'].'</h4>'.join(', ',$temp).'</div>';
			$url='install.php?step=4&amp;session='.session_id().'&amp;do='.++$do;
		break;
		case 2:#Создание записей в таблицы
			$percent=65;
			$prefix=$Mainclass->Db->EscapeString($_SESSION['install']['prefix']);
			$email=$Mainclass->Db->EscapeString($_SESSION['install']['email']);
			$sitename=$Mainclass->Db->EscapeString($_SESSION['install']['sitename']);
			$furl=$_SESSION['install']['furl'];
			$mainlang=$Mainclass->lang_name;
			$languages=$_SESSION['install']['languages']+array('m'=>$mainlang);
			require $Mainclass->root_path.'install/data_install/insert.php';
			if(empty($insert))
			{
				$text=$Mainclass->Template->Message($lang['error_cont']);
				break;
			}
			$temp=array();
			foreach($insert as $k=>$v)
			{
				$v=str_replace(
								array(
										'\\d',
										'\\D',
										'\\w',
										'\\W',
										'\\s',
										'\\S',
								),
								array(
										'\\\\d',
										'\\\\D',
										'\\\\w',
										'\\\\W',
										'\\\\s',
										'\\\\S',
								),
								$v
				);
				$db_error=false;
				try
				{
					$Mainclass->Db->FQuery($v,array(),__file__,__line__);
				}
				catch(EE $e)
				{
					$db_error=$e->getMessage();
				}
				if(!is_int($k))
					$temp[]='<span style="color:'.($db_error ? 'red' : 'green').'" title="'.($db_error ? htmlspecialchars($db_error) : 'OK').'">'.$k.'</span>';
			}
			$text.='<div class="information"><h4>'.$lang['inserting_v'].'</h4>'.join(', ',$temp).'</div>';
			$url='install.php?step=4&amp;session='.session_id().'&amp;do='.++$do;
		break;
		case 3:#Создание кеша настроек
			$percent=70;
			try
			{
				$Mainclass->Cache->Init();
				$Mainclass->Cache->UpdateOptionsByKeyWords();
				$text.='<div class="information"><h4>'.$lang['create_cacheo'].'</h4></div>';
				$url='install.php?step=4&amp;session='.session_id().'&amp;do='.++$do;
			}
			catch(EE $e)
			{
				$text=$Mainclass->Template->Message($e->getMessage(),'error');
				$url='install.php?step=4&amp;session='.session_id().'&amp;do='.$do;
			}
		break;
		case 4:#Создание кеша смайлов
			$percent=75;
			$arr=array();
			$Mainclass->Db->Query('SELECT `path`,`emotion` FROM `prefix_smiles` ORDER BY `pos` ASC',__file__,__line__);
			while($temp=$Mainclass->Db->Fetch_row())
				if($temp[0] and $temp[1])
					$arr[$temp[1]]=$temp[0];
			$Mainclass->Cache->Put('smiles',array_unique($arr),0,false);
			$text.='<div class="information"><h4>'.$lang['create_cachesm'].'</h4></div>';
			$url='install.php?step=5&amp;session='.session_id();
		break;
		default:
			die('Unknown event!');
		break;
	}
	$_SESSION['install']['step']=$do;
	$Mainclass->Template->RedirectScreen($url,5);
	return $text.'
	<div class="submitline"><a href="'.$url.'">'.$lang['press_here'].'</a></div>
	</div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
}

function CreateAdmin($error='')
{global $Mainclass, $lang;
	$name=isset($_POST['name']) ? $_POST['name'] : '';
	$email=isset($_POST['email']) ? $_POST['email'] : $_SESSION['install']['email'];
	return ($error ? $Mainclass->Template->Message($error) : '').Strings::AddJs('../js/jquery.min.js').Strings::AddJs('../js/jMainclass.js')
	.'<form method="post" action="install.php?step=5" onsubmit="if(Id(\'pass\').value!=Id(\'rpass\').value){alert(\''.htmlspecialchars($lang['pass_mismatch'],ENT_QUOTES).'\'); return false;}">
	<ul class="reset formfield">
		<li class="ffield"><span class="label"><b>'.$lang['a_name'].'</b></span><div class="ffdd">'.Template::Edit('name',$name,'class="f_text" style="width: 260px;"').'
		</div></li>
		<li class="ffield"><span class="label"><b>'.$lang['db_pass'].'</b></span><div class="ffdd">'.Template::Control('pass','password','','class="f_text" style="width: 260px;" id="pass"').'</div></li>
		<li class="ffield"><span class="label"><b>'.$lang['a_rpass'].'</b></span><div class="ffdd">'.Template::Control('rpass','password','','class="f_text" style="width: 260px;" id="rpass"').'</div></li>
		<li class="ffield"><span class="label"><b>'.$lang['a_email'].'</b></span><div class="ffdd">'.Template::Edit('email',$email,'class="f_text" style="width: 260px;"').'</div></li>
	</ul>
	<div class="submitline"><input class="button" type="submit" value="'.$lang['do_create_admin'].'" name="task_button"/></div>'
	.Template::Control('session','hidden',session_id()).'</form></div></div><div class="wpbtm"><b>&nbsp;</b></div></div>';
}

OutPut();
echo $Mainclass->Template->GetThemeFile(
										'index',
										array(
												'percent'=>$percent,
												'navi'=>$navi,
												'title'=>$title,
												'text'=>$text,
										)
);
?>