/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
function AddBookMark(eval_after,container)
{
	container=container || 'bookmark_params';
	var title=Trim(Id('bookmark_title').value);
	var descr=Trim(Id('bookmark_descr').value);
	var href=Trim(Id('bookmark_href').value);
	var value=Trim(Id('bookmark_value').value);
	var imp=Id('bookmark_imp').value;
	var module=Id('bookmark_module').value;
	if(!title || !href)
	{
		alert(el_lang['filled_not_all_fields']);
		return false;
	}
	Ajax(
			'"account"',
			{
				'event':'add_bookmark',
				'title':title,
				'descr':descr,
				'href':href,
				'imp':imp,
				'value':value,
				'bmodule':module
			},
			function(id)
			{
				Id(container).style.display="none";
				Id('bookmark_title').value='';
				Id('bookmark_descr').value='';
				Id('bookmark_href').value='';
				Id('bookmark_value').value='';
				if (eval_after)
					eval(eval_after);
			},
			false
	);
	return false;
}

function DeleteBookMark(id,obj,eval_after)
{
	Ajax(
			'"account"',
			{
				'event':'delete_bookmark',
				'id':id
			},
			function(results)
			{
				if (obj)
					obj.parentNode.removeChild(obj);
				if (eval_after)
					eval(eval_after);
			},
			false
	);
	return false;
}

function ShowAddBookMarkForm(value,container)
{
	container=container || 'bookmark_params';
	Ajax(
			'',
			{
				'event':'bookmark',
				'value':value || ''
			},
			function(results)
			{
				Id(container).innerHTML=results;
				Id(container).style.display="";
			},
			false
	);
	return false;
}