/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
function DoVoting(type,form_id,voting_id,mid)
{
	var form=Id(form_id);
	var ans='';
	if(type==0)
		for(var i=0;i<form.elements.length;i++)
		{
			var elmnt=form.elements[i];
			if (elmnt.type=='radio' && elmnt.checked)
			{
				ans=elmnt.value;
				break;
			}
		}
	else
		for(var i=0;i<form.elements.length;i++)
		{
			var elmnt=form.elements[i];
			if (elmnt.type=='checkbox' && elmnt.checked)
				ans+=','+elmnt.value;
		}
	if(ans=='')
	{
		alert(el_lang['no_variants']);
		return false;
	}
	Ajax(
			mid,
			{
				'event':'voting',
				'ans':ans,
				'id':voting_id
			},
			function(result)
			{
				$('#'+form_id+"_vote").html(result['answer']);
				$('#'+form_id+"_cnt").html(result['cnt']);
				$('#'+form_id+"_down").html(result['down']);
			},
			false
	);
	return false;
};

function VotingResult(form_id,vote_id,mid)
{
	var form=Id(form_id);
	Ajax(
			mid,
			{
				'event': 'results',
				'id':vote_id,
			},
			function(result)
			{
				$('#'+form_id+"_vote").html(result['answer']);
				$('#'+form_id+"_cnt").html(result['cnt']);
				$('#'+form_id+"_down").html(result['down']);
			},
			true
		);
	return false;
};

function DoCheckBoxes(id,k)
{
	var q_select=0;
	var blocked=false;
	var inputs=Id(id).getElementsByTagName("input");
	for (var i=0;i<inputs.length;i++)
	{
		var input=inputs.item(i);
		if(input.getAttribute("type")!="checkbox")
			continue;
		if(input.checked)
			q_select++;
		$(input).click(function(e)
		{
			if (this.checked)
				q_select++;
			else
				q_select--;
			IsBlock();
			return true;
		});
	}
	function IsBlock()
	{
		var dis=q_select>=k;
		if ((dis && blocked) || (!dis && !blocked))
			return true;
		blocked=dis;
		for (var i=0;i<inputs.length;i++)
		{
			var input=inputs.item(i);
			if (input.getAttribute("type")=="checkbox" && !input.checked)
				input.disabled=dis;
		}
		return true;
	}
	IsBlock();
}