/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/

/*
id - Ид главного дива
def - текущиее положение вещей
steps - количество "шагов". Если 0 - значит уже проголосовали.
width - ширина рейтинга
mid - номер модуля
arr - массив дополнительных параметров
title - подсказка дива при наведении
*/
function Rating(id,def,steps,width,height,mid,arr,title)
{
	id=Id(id);
	id.title=title;
	var rating=id.getElementsByTagName('div')[0];
	var indicator=rating.getElementsByTagName('div')[0];
	var step=width/steps;
	var curr=0;

	var MouseMove=function(e)
	{
		if (steps==0)
			return;
		var event=window.event;
		var x=(e ? e.clientX : event.clientX)-$(id).position().left;
		if (x==0)
			x=1;
		curr=Math.ceil(x / step);
		SetRating(Math.round(curr*step/width*100));
		indicator.className='hover';
	}

	var MouseOut=function(e)
	{
		if (steps==0)
			return;
		SetRating(def);
		indicator.className='active';
	}

	var Click=function(e)
	{
		if (steps==0)
			return;
		Ajax(
				mid,
				{
					'event':'rating',
					'arr':arr,
					'rate':curr
				},
				function(result)
				{
					steps=0;
					indicator.style.width=SetRating(result['r_width']);
					id.title=result['r_title'];
					indicator.className='active';
				},
				false
		);
	}

	var SetRating=function(s)
	{
		$(indicator).width(s+'%');
	}

	rating.onmousemove=MouseMove;
	$(rating).mouseleave(function(e){MouseOut(e)})
	rating.onclick=Click;
	SetRating(def);
}