<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadOptions(array('reg'),false);
BeAs(2);
$lang=$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'','lang_ajax-%');
$event=isset($_REQUEST['event']) ? $_REQUEST['event'] : '';
switch ($event)
{
	case 'check_email':
		$email=$_REQUEST['email'];
		if(!Functions::CheckEmail($email) or $Mainclass->Account->Manage->IsEmailBlocked($email))
			Result(array(
							'can'=>false,
							'mess'=>$lang['inc_email'],
			));
		else
		{
			$Mainclass->Db->FQuery('SELECT `email` FROM {"0"} WHERE `email`={"1"} LIMIT 1',array('users','s_'.$email));
			$can=$Mainclass->Db->Num_rows()==0;
			Result(array(
							'can'=>$can,
							'mess'=>$can ? $lang['email_free'] : $lang['email_in_use'],
			));
		}
	break;
	case 'check_login':
		$name=trim($_REQUEST['login']);
		$long=false;
		if($Mainclass->Account->Manage->IsNameBlocked($name) or $long=strlen($name)>(int)$Mainclass->vars['user_nick_length'])
			Result(array(
							'can'=>false,
							'mess'=>$long ? $lang['nick_too_long'] : $lang['err_nick'],
			));
		else
		{
			$Mainclass->Db->FQuery('SELECT `l_name` FROM {"0"} WHERE `l_name`=LOWER({"1"}) LIMIT 1',array('users','s_'.$name));
			$can=$Mainclass->Db->Num_rows()==0;
			Result(array(
							'can'=>$can,
							'mess'=>$can ? $lang['nick_free'] : $lang['nick_in_use'],
			));
		}
	break;
	case 'bookmark':
		require $Mainclass->FormatPath($Mainclass->GetModVal('path').'/plugins.php');
		$Plug=new $class_name($Mainclass);
		Result($Plug->BookmarkGetAddAjax(array('eval'=>'window.location.reload();')));
	break;
	case 'add_bookmark':
		if(!$Mainclass->Login->IsUser())
		{
			Error($lang['no_auth']);
			break;
		}
		$uid=$Mainclass->Account->GetValue('id');
		$value=isset($_REQUEST['value']) ? trim( $_REQUEST['value']) : '';
		$module=isset($_REQUEST['bmodule']) ? (int)$_REQUEST['bmodule'] : 0;
		$title=isset($_REQUEST['title']) ? trim($Mainclass->AJAX['title']) : '';
		$descr=isset($_REQUEST['descr']) ? Strings::CutStr(trim($_REQUEST['descr']),497) : '';
		$href=isset($_REQUEST['href']) ? trim($_REQUEST['href']) : '';
		$imp=isset($_REQUEST['imp']) ? (int)$_REQUEST['imp'] : '';
		if(!$title)
		{
			Error($lang['empty_title']);
			break;
		}
		if(!Strings::XssCheckUrl($href))
		{
			Error($lang['href_inc']);
			break;
		}
		if(!$value)
			$update=false;
		else
		{
			$Mainclass->Db->Query('SELECT `id` FROM `prefix_bookmarks` WHERE `uid`='.$uid.' AND `mid`='.$module.' AND `value`='.$Mainclass->Db->EscapeString($value).' LIMIT 1',__file__,__line__);
			$update=$Mainclass->Db->Num_rows()>0;
		}
		$Mainclass->LoadClass('classes/others/class_editor.php');
		$Mainclass->Editor->type=2;
		$descr=$Mainclass->Editor->GetHtml($descr,true);
		if($update)
		{
			list($id)=$Mainclass->Db->Fetch_row();
			$Mainclass->Db->Update('bookmarks',array('title'=>$title,'href'=>$href,'descr'=>$descr,'imp'=>$imp),'`id`='.$id.' LIMIT 1',__file__,__line__);
		}
		else
			$id=$Mainclass->Db->Insert('bookmarks',array('uid'=>$uid,'mid'=>$module,'value'=>$value,'title'=>$title,'href'=>$href,'descr'=>$descr,'imp'=>$imp),__file__,__line__);
		Result($id);
	break;
	case 'delete_bookmark':
		if(!$Mainclass->Login->IsUser())
		{
			Error($lang['no_auth']);
			break;
		}
		$uid=$Mainclass->Account->GetValue('id');
		$id=isset($_REQUEST['id']) ? (int)$_REQUEST['id'] : 0;
		$Mainclass->Db->Query('SELECT `uid` FROM `prefix_bookmarks` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
		{
			Error();
			break;
		}
		list($buid)=$Mainclass->Db->Fetch_row();
		if($buid!=$uid)
		{
			Error();
			break;
		}
		$Mainclass->Db->Delete('bookmarks','`id`='.$id.' LIMIT 1',__file__,__line__);
		Result('ok');
	break;
	default:
		Error($Mainclass->lang['main']['unknown_func']);
	break;
}

?>