<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='Module_blogs_plugins_v1';
if(!class_exists($class_name,false))
{
	class Module_blogs_plugins_v1 extends BaseClass
	{
		static $abilities=array(
									'sitemap',
									'qmenu',#Quick menu
		);

		public function GetQmenu($options=false,$id=false,$module='')
		{
			if(!$module)
				$module='blogs';
			#Загружаем опции
			if($options)
			{
				$arr=array(
								'Создать блог',
								'Новые блоги',
				);
				if($id!==false)
					return isset($arr[$id]) ? $arr[$id] : false;
				else
					return $arr;
			}
			else
				switch($id)
				{
					case 0:
						return $this->Mainclass->admin_prefix.$this->Mainclass->Url->GetDel().$this->Mainclass->Url->ConstructUrl(array('module'=>$module,'do'=>'add_blog'),false);
					break;
					case 1:
						return $this->Mainclass->admin_prefix.$this->Mainclass->Url->GetDel().$this->Mainclass->Url->ConstructUrl(array('module'=>$module,'do'=>'news'),false);
					break;
					default:
						return false;
				}
		}

#[E] Функции "блоки из плагинов"

		public function DeletePost($ids)
		{
			if(!$ids)
				return;
			$this->Mainclass->Loadclass('classes/others/class_uploader.php');
			$this->Mainclass->LoadClass('classes/others/class_comments.php');
			$ulastbids=$bids=$cats=array();
			$this->Mainclass->Db->Query('SELECT `p`.`id`,`p`.`cid`,`p`.`bid`,`b`.`last_id`=`p`.`id` `islast` FROM `prefix_blogs_posts` `p` LEFT JOIN `prefix_blogs` `b` ON `p`.`bid`=`b`.`id` WHERE `p`.`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
			while($arr=$this->Mainclass->Db->Fetch_assoc())
			{
				if($arr['islast'])
					$ulastbids[]=$arr['bid'];
				$bids[]=$arr['bid'];
				$cids[]=$arr['cid'];
				$this->Mainclass->Uploader->DeleteFile('blogs/posts',$arr['id']);
				$this->Mainclass->Uploader->DeleteFile('blogs/temp_posts',$arr['id']);
			}
			$this->Mainclass->Comments->DeleteComments($ids);
			$this->Mainclass->Db->Delete('blogs_posts','`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
			$this->Mainclass->Db->Delete('blogs_bt','`pid`'.$this->Mainclass->Db->In($ids),__file__,__line__);
			$this->Mainclass->Db->Query('UPDATE `prefix_blogs` `b`,(SELECT `bid`,COUNT(`id`) `posts` FROM `prefix_blogs_posts` WHERE `bid`'.$this->Mainclass->Db->In($bids).' GROUP BY `bid`) `p` SET `b`.`posts`=`p`.`posts` WHERE `p`.`bid`=`b`.`id`',__file__,__line__);
			$this->Mainclass->Db->Query('UPDATE `prefix_blogs_categories` `c`,(SELECT `cid`,COUNT(`id`) `posts` FROM `prefix_blogs_posts` WHERE `cid`'.$this->Mainclass->Db->In($cids).' GROUP BY `cid`) `p` SET `c`.`posts`=`p`.`posts` WHERE `p`.`cid`=`c`.`id`',__file__,__line__);
			if($ulastbids)
				$this->Mainclass->Db->Query('UPDATE `prefix_blogs` `b`,(SELECT `id`,`bid`,`cid`,`url`,`title`,`date`,`author`,`author_id` FROM `prefix_blogs_posts` GROUP BY `bid` ORDER BY `date` DESC) `p` SET `b`.`last_cid`=`p`.`cid`,`b`.`last_id`=`p`.`id`,`b`.`last_url`=`p`.`url`,`b`.`last_title`=`p`.`title`,`b`.`last_date`=`p`.`date`,`b`.`author`=`p`.`author`,`b`.`author_id`=`p`.`author_id` WHERE `b`.`id`=`p`.`bid` AND `b`.`id`'.$this->Mainclass->Db->In($ulastbids),__file__,__line__);
		}

		public function DeleteCat($ids,$deleteposts=false)
		{
			if(!$ids)
				return;
			if($deleteposts)
			{
				$this->Mainclass->Loadclass('classes/others/class_uploader.php');
				$ulastbids=$bids=$pids=array();
				$this->Mainclass->Db->Query('SELECT `p`.`id`,`p`.`bid`,`b`.`last_id`=`p`.`id` `islast` FROM `prefix_blogs_posts` `p` LEFT JOIN `prefix_blogs` `b` ON `p`.`bid`=`b`.`id` WHERE `p`.`cid`'.$this->Mainclass->Db->In($ids),__file__,__line__);
				while($arr=$this->Mainclass->Db->Fetch_assoc())
				{
					if($arr['islast'])
						$ulastbids[]=$arr['bid'];
					$bids[]=$arr['bid'];
					$pids[]=$arr['id'];
					$this->Mainclass->Uploader->DeleteFile('blogs/posts',$arr['id']);
					$this->Mainclass->Uploader->DeleteFile('blogs/temp_posts',$arr['id']);
				}
				if($pids)
				{
					$this->Mainclass->LoadClass('classes/others/class_comments.php');
					$this->Mainclass->Comments->DeleteComments($pids);
					$this->Mainclass->Db->Delete('blogs_posts','`id`'.$this->Mainclass->Db->In($pids),__file__,__line__);
					$this->Mainclass->Db->Delete('blogs_bt','`pid`'.$this->Mainclass->Db->In($pids),__file__,__line__);
					$this->Mainclass->Db->Query('UPDATE `prefix_blogs` `b`,(SELECT `bid`,COUNT(`id`) `posts` FROM `prefix_blogs_posts` WHERE `bid`'.$this->Mainclass->Db->In($bids).' GROUP BY `bid`) `p` SET `b`.`posts`=`p`.`posts` WHERE `p`.`bid`=`b`.`id`',__file__,__line__);
					if($ulastbids)
						$this->Mainclass->Db->Query('UPDATE `prefix_blogs` `b`,(SELECT `id`,`bid`,`cid`,`url`,`title`,`date`,`author`,`author_id` FROM `prefix_blogs_posts` GROUP BY `bid` ORDER BY `date` DESC) `p` SET `b`.`last_cid`=`p`.`cid`,`b`.`last_id`=`p`.`id`,`b`.`last_url`=`p`.`url`,`b`.`last_title`=`p`.`title`,`b`.`last_date`=`p`.`date`,`b`.`author`=`p`.`author`,`b`.`author_id`=`p`.`author_id` WHERE `b`.`id`=`p`.`bid` AND `b`.`id`'.$this->Mainclass->Db->In($ulastbids),__file__,__line__);
				}
			}
			else
				$this->Mainclass->Db->Update('blogs_posts',array('cid'=>0),'`cid`'.$this->Mainclass->Db->In($ids),__file__,__line__);
			$this->Mainclass->Db->Delete('blogs_categories','`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
		}

		public function DeleteBlog($ids)
		{
			if(!$ids)
				return;
			$this->Mainclass->Loadclass('classes/others/class_uploader.php');
			$pids=array();
			$this->Mainclass->Db->Query('SELECT `id` FROM `prefix_blogs_posts` WHERE `bid`'.$this->Mainclass->Db->In($ids),__file__,__line__);
			while($arr=$this->Mainclass->Db->Fetch_assoc())
			{
				$pids[]=$arr['id'];
				$this->Mainclass->Uploader->DeleteFile('blogs/posts',$arr['id']);
				$this->Mainclass->Uploader->DeleteFile('blogs/temp_posts',$arr['id']);
			}
			if($pids)
			{
				$this->Mainclass->LoadClass('classes/others/class_comments.php');
				$this->Mainclass->Comments->DeleteComments($pids);
				$this->Mainclass->Db->Delete('blogs_posts','`id`'.$this->Mainclass->Db->In($pids),__file__,__line__);
				$this->Mainclass->Db->Delete('blogs_bt','`pid`'.$this->Mainclass->Db->In($pids),__file__,__line__);
			}
			$this->Mainclass->Db->Delete('blogs_categories','`bid`'.$this->Mainclass->Db->In($ids),__file__,__line__);
			$this->Mainclass->Db->Delete('blogs','`id`'.$this->Mainclass->Db->In($ids),__file__,__line__);
		}

		public function DoSitemap($per_time,$sdata)
		{
			if(!$sdata)
				$sdata=array(
								'sdata'=>false,
								'offset_blogs'=>0,
								'blogs_fin'=>false,
								'offset_cats'=>0,
								'cats_fin'=>false,
								'offset'=>0,
				);
			$config['posts_priority']=0.9;#Приоритет записей
			$config['blogs_priority']=0.8;#Приоритет блогов
			$config['cats_priority']=0.7;#Приоритет категорий
			$config['others_priority']=0.5;#Приоритет всего остального
			$this->Mainclass->LoadOptions('module_blogs',false);
			if(!$sdata['sdata'])
			{
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('do'=>'blogs')),'','always',$config['others_priority']);
				Sitemap($this->Mainclass->SUrl->Prefix(false,true,true),'','always',$config['posts_priority']);
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('do'=>'authors')),'','weekly',$config['others_priority']);
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('do'=>'tags')),'','weekly',$config['others_priority']);
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('do'=>'search')),'','never',$config['others_priority']);
				$sdata['sdata']=true;
			}
			if(!$sdata['blogs_fin'])
			{
				$this->Mainclass->SUrl->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
				$result=$this->Mainclass->Db->Query('SELECT `id`,`url`,`posts`,`per_page` FROM `prefix_blogs` LIMIT '.$sdata['offset_blogs'].','.$per_time,__file__,__line__);
				$nums=$this->Mainclass->Db->Num_rows();
				if($nums==0 or $nums<$per_time)
					$sdata['blogs_fin']=true;
				$sdata['offset_cats']+=$nums;
				while($arr=$this->Mainclass->Db->Fetch_assoc($result))
				{
					$per_page=$arr['per_page']>0 ? $arr['per_page'] : $this->Mainclass->vars['m_blogs_per_page'];
					$arr['posts']=ceil($arr['posts']/$per_page);
					if($arr['posts']>1)
						for($i=1;$i<=$arr['posts'];$i++)
							Sitemap($this->Mainclass->SUrl->ConstructUrl(array(array($arr['url'],'bid'=>$arr['id']),array('page'=>$i))),'','monthly',$config['blogs_priority']);
					else
						Sitemap($this->Mainclass->SUrl->ConstructUrl(array(array($arr['url'],'bid'=>$arr['id']))),'','monthly',$config['blogs_priority']);
				}
			}
			if($sdata['blogs_fin'] and !$sdata['cats_fin'])
			{
				$this->Mainclass->SUrl->ending=$this->Mainclass->vars['m_blogs_cat_ending'];
				$result=$this->Mainclass->Db->Query('SELECT `c`.`id`,`c`.`url`,`c`.`posts`,`b`.`id` `bid`,`b`.`url` `burl`,`b`.`per_page` FROM `prefix_blogs_categories` `c` INNER JOIN `prefix_blogs` `b` ON `b`.`id`=`c`.`bid` LIMIT '.$sdata['offset_cats'].','.$per_time,__file__,__line__);
				$nums=$this->Mainclass->Db->Num_rows();
				if($nums==0 or $nums<$per_time)
					$sdata['cats_fin']=true;
				$sdata['offset_cats']+=$nums;
				while($arr=$this->Mainclass->Db->Fetch_assoc($result))
				{
					$per_page=$arr['per_page']>0 ? $arr['per_page'] : $this->Mainclass->vars['m_blogs_per_page'];
					$arr['posts']=ceil($arr['posts']/$per_page);
					if($arr['posts']>1)
						for($i=1;$i<=$arr['posts'];$i++)
							Sitemap($this->Mainclass->SUrl->ConstructUrl(array(array($arr['url'] ? $arr['burl'] : '','bid'=>$arr['bid'],true),array($arr['url'],'cid'=>$arr['id']),array('page'=>$i))),'','monthly',$config['cats_priority']);
					else
						Sitemap($this->Mainclass->SUrl->ConstructUrl(array(array($arr['url'] ? $arr['burl'] : '','bid'=>$arr['bid'],true),array($arr['url'],'cid'=>$arr['id']))),'','monthly',$config['cats_priority']);
				}
			}
			if($sdata['cats_fin'])
			{
				$this->Mainclass->SUrl->ending=$this->Mainclass->vars['m_blogs_ending'];
				$result=$this->Mainclass->Db->Query('SELECT `p`.`id`,`p`.`url`,`p`.`date`,`b`.`id` `bid`,`b`.`url` `burl`,`b`.`title` `btitle`,`b`.`author_id` `baid`,`b`.`categs`,`c`.`id` `cid`,`c`.`url` `curl`,`c`.`title` `ctitle` FROM `prefix_blogs_posts` `p` LEFT JOIN `prefix_blogs` `b` ON `b`.`id`=`p`.`bid` LEFT JOIN `prefix_blogs_categories` `c` ON `c`.`id`=`p`.`cid` WHERE `p`.`status`=1 LIMIT '.$sdata['offset'].','.$per_time,__file__,__line__);
				$sdata['offset']+=$this->Mainclass->Db->Num_rows();
				while($arr=$this->Mainclass->Db->Fetch_assoc($result))
					Sitemap($this->Mainclass->SUrl->ConstructUrl(array(array($arr['url'] ? $arr['burl'] : '',true),array($arr['url'] ? $arr['curl'] : '',true),array($arr['url'],'pid'=>$arr['id']))),substr($arr['date'],0,10),'monthly',$config['posts_priority']);
			}
			return $sdata;
		}
	}
}
?>