<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'errors','lang_admin-%');
$Mainclass->navigation=array(
	array($Mainclass->Url->Prefix(false),$Mainclass->lang['errors']['errors_list']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'add')),((isset($_GET['do']) and $_GET['do']=='add') ? '!' : '').$Mainclass->lang['errors']['add_error']),
);
global $mainpage;
$mainpage=false;
if(isset($_GET['do']))
	DoIt($_GET['do']);
elseif(isset($_GET['edit']))
	AddEditError((int)$_GET['edit']);
elseif(isset($_GET['save']))
	SaveError($_GET['save']=='new' ? true : (int)$_GET['save']);
elseif(isset($_GET['delete']))
	DeleteError((int)$_GET['delete']);
else
{
	Errors();
	$mainpage=true;
}

if($mainpage and isset($Mainclass->navigation[0]))
	$Mainclass->navigation[0][1]='!'.$Mainclass->navigation[0][1];

function DoIt($task)
{global $mainpage;
	switch ($task)
	{
		case 'add':
			AddEditError(true);
		break;
		default:
			Errors();
			$mainpage=true;
		break;
	}
}

function Errors()
{global $Mainclass,$title,$jscripts;
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$per_page=30;
	$offset=abs(($page-1)*$per_page);
	$n=0;
	$title=$Mainclass->lang['errors']['errors_list'];
	$content=$Mainclass->Template->Title($title)
	.$Mainclass->Template->OpenTable()
	.'<table class="tabstyle">
	<tr class="tablethhead"><th width="15">'.$Mainclass->lang['main']['id'].'</th><th>'.$Mainclass->lang['errors']['error'].'</th><th width="100">'.$Mainclass->lang['errors']['errno'].'</th><th width="80">'.$Mainclass->lang['main']['functs'].'</th></tr>';
	$Mainclass->Db->Query('SELECT `id`,`num`,`title` FROM `prefix_errors` LEFT JOIN `prefix_errors_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\') ORDER BY `id` ASC LIMIT '.$offset.', '.$per_page,__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
		$content.='<tr class="'.($n++ % 2 ? 'tabletrline2' : 'tabletrline1').'"><td align="center">'.$arr['id'].'</td><td><a href="'.($edit=$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id']))).'" title="'.$Mainclass->lang['main']['edit'].'">'.$arr['title'].'</a></td><td align="center">'.($arr['num'] ? $arr['num'] : '<i>'.$Mainclass->lang['main']['no'].'</i>').'</td><td class="function"><a href="'.$edit.'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a></td></tr>';
	$content.='</table>'.$Mainclass->Template->CloseTable();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_errors`',__file__,__line__);
	$temp=$Mainclass->Db->Fetch_row();
	$content.=Strings::Pages($temp[0],$per_page);
	$Mainclass->ShowDecoration(false);
	echo $content;
}

function AddEditError($id,$error='')
{global $Mainclass,$title,$jscripts;
	$jscripts[]='js/tabcontent.js';
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$values=array();
	$multilang=array_combine(array_keys($Mainclass->langs),array_fill(0,count($Mainclass->langs),array('title'=>'','text'=>'')));
	if($id===true)
	{
		$title=$Mainclass->lang['errors']['adding_error'];
		$values['id']='new';
		$values['url']=$values['mail']=$values['num']='';
		$values['image']='warning';
		$values['one_lang']=empty($Mainclass->vars['multilang']);
		$values['log']=false;
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT * FROM `prefix_errors` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPrefix();
			$values=$Mainclass->Db->Fetch_assoc();
			$values['one_lang']=false;
			$Mainclass->Db->Query('SELECT `language`, `title`, `text` FROM `prefix_errors_l` WHERE `id`='.$id,__file__,__line__);
			while($temp=$Mainclass->Db->Fetch_assoc())
				if(isset($multilang[$temp['language']]))
				{
					$multilang[$temp['language']]['title']=$temp['title'];
					$multilang[$temp['language']]['text']=$temp['text'];
				}
				elseif(!$temp['language'])
				{
					$multilang[$Mainclass->lang_name]['title']=$temp['title'];
					$multilang[$Mainclass->lang_name]['text']=$temp['text'];
					$values['one_lang']=true;
					break;
				}
		}
		else
			$values['id']=(int)$id;
		$title=$Mainclass->lang['errors']['editing_error'];
	}
	if($error)
	{
		$values['image']=isset($_POST['image']) ? $_POST['image'] : '';
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['mail']=isset($_POST['mail']) ? $_POST['mail'] : '';
		$values['log']=isset($_POST['log']);
		$values['num']=isset($_POST['num']) ? $_POST['num'] : '';
		$values['one_lang']=isset($_POST['one_lang']);
		foreach($multilang as $k=>$v)
			if($Mainclass->lang_name==$k)
			{
				if(isset($_POST['title']))
					$multilang[$k]['title']=$_POST['title'];
				if(isset($_POST['text']))
					$multilang[$k]['text']=$Mainclass->Editor->GetHTML('text');
			}
			else
			{
				if(isset($_POST['title_'.$k]))
					$multilang[$k]['title']=$_POST['title_'.$k];
				if(isset($_POST['text_'.$k]))
					$multilang[$k]['text']=$Mainclass->Editor->GetHTML('text_'.$k);
			}
	}
	$image_list='';
	$hdir=opendir($Mainclass->root_path.'images/errors');
	while($entry=readdir($hdir))
		if(preg_match('#\.(gif|jpg|png|jpeg|bmp)#i',$entry)>0)
			$image_list.=Template::Option($entry,'',$entry==$values['image']);
	closedir($hdir);
	$multil_text=$multil_check='';
	if($Mainclass->vars['multilang'])
	{
		$multil_check=array();
		$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
		foreach($multilang as $k=>$v)
		{
			$lang_title=ucfirst($k).' / '.ucfirst($Mainclass->langs[$k]);
			$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['text'] or !is_int($id)),'value="'.$k.'"').' '.$lang_title;
			if($k==$Mainclass->lang_name)
				continue;
			$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').slideToggle(\'slow\');return false" class="ol_heading">
			'.(file_exists($Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
			<div id="table_'.$k.'">
				<table class="tabstyle tabform">
				<tr><td class="label">'.$Mainclass->lang['main']['title'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
				<tr><td class="label">'.$Mainclass->lang['errors']['text'].'</td><td>'.$Mainclass->Editor->Area('text_'.$k,$v['text'],5).'</td></tr>
				</table>
			</div>
			</li>';
		}
		$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
		$multil_check='<tr><td class="label">'.$Mainclass->lang['main']['set_for_langs'].'</td><td>'
		.Template::Check('one_lang',$values['one_lang'])
		.' <b>'.$Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
		.join('<br />',$multil_check).'</div></td></tr>';
	}
	$content=$Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '')
	.$Mainclass->Template->OpenTable()
	.'<form action="'.$Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post"><table class="tabstyle tabform"><tr><td class="label">'.$Mainclass->lang['main']['title'].':<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$Mainclass->lang_name]['title']).'</td></tr>
	<tr><td class="label">'.$Mainclass->lang['main']['url'].':<span class="imp">*</span></td><td>'.Template::Edit('url',$values['url']).'</td></tr></table>
	<ul id="blockstabs" class="linetabs">
	<li><a href="#" rel="tab1" class="selected"><b>'.$Mainclass->lang['main']['general'].'</b></a></li>
	'.($Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2"><b>'.$Mainclass->lang['main']['other_langs'].'</b></a></li>' : '').'
	</ul>
	<div id="tab1" class="tabcontent">
		<table class="tabstyle tabform"><tr><td class="label">'.$Mainclass->lang['errors']['errno'].':</td><td>'.Template::Edit('num',$values['num'],'maxlength="3"').'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['errors']['log'].'</td><td>'.Template::Check('log',$values['log']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['errors']['email'].'</td><td>'.Template::Edit('mail',$values['mail']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['errors']['image'].'</td><td>'.Template::Select('image',$image_list,'onchange="document.images.preview.src=this.value==\'0\' ? \'images/errors/warning.png\' : \'images/errors/\'+this.value"').'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['errors']['preview'].':</td><td><img src="'.($values['image'] ? 'images/errors/'.$values['image'] : 'images/errors/warning.png').'" id="preview" alt="'.$Mainclass->lang['errors']['preview'].'" title="'.$Mainclass->lang['errors']['preview'].'" /></td></tr>
		<tr><td class="label">'.$Mainclass->lang['errors']['text'].'</td><td>'.$Mainclass->Editor->Area('text',$multilang[$Mainclass->lang_name]['text'],30).'</td></tr>
		'.$multil_check.'
		</table>
	</div>'.$multil_text;
	$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	if($ref)
		$content.=Template::Control('back','hidden',base64_encode($ref));
	$content.='<div class="submitline">'.Template::Button().' '.(is_int($id) ? Template::Button($Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$Mainclass->Url->ConstructUrl(array('delete'=>$id)).'\'"') : '').'</div>
</form>
<script type="text/javascript">
var countries=new ddtabcontent("blockstabs");
countries.setpersist(true);
countries.setselectedClassTarget("link");
countries.init();
</script>'.$Mainclass->Template->CloseTable();
	$Mainclass->ShowDecoration();
	echo $content;
}

function SaveError($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditError($id);
	if(!CheckKey())
		return ExitPrefix();
	$title=trim(isset($_POST['title']) ? $Mainclass->POST['title'] : '');
	$url=$Mainclass->Url->UrlString(isset($_POST['url']) ? $_POST['url'] : '');
	if(!$title)
		return AddEditError($id,$Mainclass->lang['errors']['empty_title']);
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	if(!$url)
		return AddEditError($id,$Mainclass->lang['errors']['empty_url']);
	$mail=isset($_POST['mail']) ? $_POST['mail'] : '';
	if($mail and !Functions::CheckEmail($mail))
		return AddEditError($id,$Mainclass->lang['errors']['wrong_email']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and,array('errors','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$num=isset($_POST['num']) ? $Mainclass->POST['num'] : '';
	$Mainclass->Loadclass('classes/others/class_editor.php');
	if($Mainclass->vars['multilang'] and !isset($_POST['one_lang']))
	{
		$langs=(empty($_POST['lang']) or !is_array($_POST['lang'])) ? array() : $_POST['lang'];
		$langs=array_intersect(array_keys($Mainclass->langs),$langs);
		if(!$langs)
			$langs=array($Mainclass->lang_name);
	}
	else
		$langs=array('');
	$arr=array(
				'url'=>$url,
				'num'=>$num,
				'image'=>isset($_POST['image']) ? $_POST['image'] : '',
				'mail'=>$mail,
				'log'=>isset($_POST['log']),
	);
	if(is_int($id))
	{
		$Mainclass->Db->Update('errors',$arr,'`id`='.$id.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Delete('errors_l','`id`='.$id.' AND `language`'.$Mainclass->Db->In($langs,true),__file__,__line__);
		foreach($langs as &$v)
		{
			if(!$v or $Mainclass->lang_name==$v)
				$values=array(
								'title'=>$title,
								'text'=>$Mainclass->Editor->GetHTML('text')
				);
			else
				$values=array(
								'title'=>$_POST['title_'.$v],
								'text'=>$Mainclass->Editor->GetHTML('text_'.$v)
				);
			$cnt=$Mainclass->Db->Update('errors_l',$values,'`id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
			if($cnt==0)
			{
				$Mainclass->Db->Query('SELECT `id` FROM `prefix_errors_l` WHERE `id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
				if($Mainclass->Db->Num_rows()==0)
					$Mainclass->Db->Insert('errors_l',$values+array('id'=>$id,'language'=>$v),__file__,__line__);
			}
		}
	}
	else
	{
		$id=$Mainclass->Db->Insert('errors',$arr,__file__,__line__);
		$values=array('id'=>array(),'language'=>array(),'title'=>array(),'text'=>array());
		foreach($langs as &$v)
		{
			$values['id'][]=$id;
			$values['language'][]=$v;
			if(!$v or $Mainclass->lang_name==$v)
			{
				$values['title'][]=$title;
				$values['text'][]=$Mainclass->Editor->GetHTML('text');
			}
			else
			{
				$values['title'][]=$_POST['title_'.$v];
				$values['text'][]=$Mainclass->Editor->GetHTML('text_'.$v);
			}
		}
		$Mainclass->Db->Insert('errors_l',$values,__file__,__line__);
	}
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteError($id)
{global $Mainclass, $title;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `title` FROM `prefix_errors` LEFT JOIN `prefix_errors_l` USING(`id`) WHERE `id`='.$id.' AND `language` IN (\'\',\''.$Mainclass->lang_name.'\') LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitPrefix();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		$Mainclass->Db->Delete('errors','`id`='.$id.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Delete('errors_l','`id`='.$id.' LIMIT 1',__file__,__line__);
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	else
	{
		list($stitle)=$Mainclass->Db->Fetch_row();
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		$title=$Mainclass->lang['errors']['del_confirm'];
		$Mainclass->ShowDecoration();
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'=>sprintf($Mainclass->lang['errors']['deleting'],$stitle).($back ? Template::Control('back','hidden',base64_encode($back)) : ''),
												)
		);
	}

}

?>