<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if (!defined('CMS'))
	die('Попытка взлома?');
$class_name='Module_faq_plugins_v1';
if (!class_exists($class_name,false))
{
	class Module_faq_plugins_v1 extends BaseClass
	{
		static $abilities=array(
									'splinter',
									'sitemap',
									'qmenu',#Quick menu
		);

		public function GetQmenu($options=false,$id=false,$module='')
		{
			if(!$module)
				$module='faq';
			#Загружаем опции
			if($options)
			{
				$arr=array(
								'Добавить ответ',
								'Новые вопросы',
				);
				if($id!==false)
					return isset($arr[$id]) ? $arr[$id] : false;
				else
					return $arr;
			}
			else
				switch($id)
				{
					case 0:
						return $this->Mainclass->admin_prefix.$this->Mainclass->Url->GetDel().$this->Mainclass->Url->ConstructUrl(array('module'=>$module,'do'=>'add'),false);
					break;
					case 1:
						return $this->Mainclass->admin_prefix.$this->Mainclass->Url->GetDel().$this->Mainclass->Url->ConstructUrl(array('module'=>$module,'do'=>'news'),false);
					break;
					default:
						return false;
				}
		}

		public function GetSplinter()
		{
			return array(
							'user'=>array(
											'cid'		=>array('Категория','i'),
											'faq'		=>array('Вопрос','i'),
											'add'		=>array('Добавление вопроса','s'),
											'categories'=>array('Начальная страница категорий','s'),
											'main'		=>array('Главная страница','s'),
											'search'	=>array('Страница поиска','s'),
											'results'	=>array('Страница результатов поиска','s'),
									)
			);
		}

		public function DoSitemap($per_time,$sdata)
		{
			if(!$sdata)
				$sdata=array(
								'sdata'=>false,
								'offset_cats'=>0,
								'cats_fin'=>false,
								'offset'=>0,
				);
			$this->Mainclass->LoadOptions('module_faq',false);
			$config['faq_priority']=0.7;#Приоритет новостей
			$config['categories_priority']=0.5;#Приоритет категорий
			$config['others_priority']=0.5;#Приоритет всего остального
			if(!$sdata['sdata'])
			{
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('do'=>'add')),'','never',$config['others_priority']);
				Sitemap($this->Mainclass->SUrl->Prefix(false,true,true),'','always',$config['faq_priority']);
				Sitemap($this->Mainclass->SUrl->ConstructUrl(array('do'=>'categories')),'','never',$config['categories_priority']);
				$sdata['sdata']=true;
			}
			$this->Mainclass->LoadClass('classes/others/class_categories_l.php');
			$this->Mainclass->Categories_l->long_url=$this->Mainclass->vars['m_faq_long_url'];
			$this->Mainclass->Categories_l->url_ending=$this->Mainclass->vars['m_faq_category_ending'];
			$this->Mainclass->Categories_l->Url=&$this->Mainclass->SUrl;
			$this->Mainclass->SUrl->ending=$this->Mainclass->vars['m_faq_ending'];
			if(!$sdata['cats_fin'])
			{
				$this->Mainclass->SUrl->ending=$this->Mainclass->vars['m_faq_category_ending'];
				$result=$this->Mainclass->Db->Query('SELECT c.`id`, COUNT(f.`id`) AS `cnt` FROM `prefix_faq_categories` AS `c` INNER JOIN `prefix_faq` AS f ON f.`cid`=c.`id` WHERE f.`status`=1 GROUP BY c.`id`',__file__,__line__);
				$nums=$this->Mainclass->Db->Num_rows();
				if($nums==0 or $nums<$per_time)
					$sdata['cats_fin']=true;
				$sdata['offset_cats']+=$nums;
				while($arr=$this->Mainclass->Db->Fetch_assoc($result))
				{
					$arr['cnt']=ceil($arr['cnt']/$this->Mainclass->vars['m_faq_per_page']);
					if ($arr['cnt']>1)
						for($i=1;$i<=$arr['cnt'];$i++)
							Sitemap($this->Mainclass->Categories_l->CategoryUrl($arr['id'],'faq_categories','',false).$this->Mainclass->SUrl->ConstructUrl(array(array('page'=>$i)),false),'','monthly',$config['categories_priority']);
					else
						Sitemap($this->Mainclass->Categories_l->CategoryUrl($arr['id'],'faq_categories'),'','monthly',$config['categories_priority']);
				}
			}
			if($sdata['cats_fin'])
			{
				$result=$this->Mainclass->Db->Query('SELECT `id`, `cid`,`url` FROM `prefix_faq` WHERE `status`=1 LIMIT '.$sdata['offset'].','.$per_time,__file__,__line__);
				$sdata['offset']+=$this->Mainclass->Db->Num_rows();
				while($arr=$this->Mainclass->Db->Fetch_assoc($result))
				{
					$url=($this->Mainclass->vars['m_faq_long_url'] ? $this->Mainclass->Categories_l->CategoryUrl($arr['cid'],'faq_categories','',false) : '').$this->Mainclass->SUrl->ConstructUrl(array(array($arr['url'],'fid'=>$arr['id'])),!$this->Mainclass->vars['m_faq_long_url']);
					Sitemap($url,'','monthly',$config['faq_priority']);
				}
			}
			return $sdata;
		}
	}
}
?>