<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
BeAs(2);
$Mainclass->LoadOptions('module_files',false);
$last=$Mainclass->Cache->Get('files_last_status',false);
if($last!=date('Ymd'))
{
	$Mainclass->Db->Update('files',array('status'=>1),'`date`<=CONCAT(CURDATE(),\' 23:59:59\') AND `status`=2');
	$Mainclass->Cache->Put('files_last_status',date('Ymd'),86500,false);
}
$event=isset($_REQUEST['event']) ? $_REQUEST['event'] : '';
switch ($event)
{
	case 'rating':
		if(!$Mainclass->vars['m_files_rating'])
			Error($Mainclass->lang['main']['rating_off']);
		$id=isset($_REQUEST['arr']['id']) ? (int)$_REQUEST['arr']['id'] : 0;
		$rate=isset($_REQUEST['rate']) ? abs((int)$_REQUEST['rate']) : 0;
		if($id<=0 or $rate==0)
			Error();
		if($rate>$Mainclass->vars['m_files_rating_steps'])
			$rate=$Mainclass->vars['m_files_rating_steps'];
		$Mainclass->Functions->PrepareVoting($id);
		if($Mainclass->Functions->CanVoting($id))
		{
			$Mainclass->Functions->AddVoting($id,$Mainclass->vars['m_files_voting_time']);
			$Mainclass->Functions->UpdateRating('files',$rate,'`id`='.$id.' LIMIT 1');
		}
		$Mainclass->Db->Query('SELECT `total`, `votes` FROM `prefix_files` WHERE `id`='.$id.' AND `status`=1 LIMIT 1',__file__,__line__);
		list($total,$votes_real)=$Mainclass->Db->Fetch_row();
		$votes=$votes_real<=0 ? 1 :	$votes_real;
		$persent=ceil($total/$votes/$Mainclass->vars['m_files_rating_steps']*100);
		$title=$Mainclass->Functions->RatingTitle($total,$votes_real);
		Result(array('r_width'=>$persent,'r_title'=>$title));
	break;
	case 'calendar':
		include $Mainclass->FormatPath($Mainclass->GetModVal('path').'/block_calendar_files.php');
		$m=isset($_REQUEST['month']) ? abs((int)$_REQUEST['month']) : date('m');
		$y=isset($_REQUEST['year']) ? abs((int)$_REQUEST['year']) : date('Y');
		$id=isset($_REQUEST['id']) ? $_REQUEST['id'] : 'cf';
		$prefix=isset($_REQUEST['url_pref']) ? $_REQUEST['url_pref'] : false;
		$ending=isset($_REQUEST['ending']) ? $_REQUEST['ending'] : false;
		if($y<1000)
			$y=date('Y');
		if($m<1)
		{
			$y--;
			$m=12;
		}
		if($m>12)
		{
			$y++;
			$m=1;
		}
		$m=sprintf('%02d',$m);
		$Mainclass->SCookie('calendar-files',$y.'-'.$m);
		$old_ending=$Mainclass->Url->ending;
		$Mainclass->url_pref=$Mainclass->Url->DynamicBegin().$Mainclass->Url->ConstructUrl(array('module'=>$Mainclass->GetModVal('name')),false,false).$Mainclass->Url->GetDel();
		Result(array('month'=>$m,'year'=>$y,'calendar'=>FilesCalendar($y,$m,GetFilesDates($y,$m),$id)));
		$Mainclass->Url->ending=$old_ending;
	break;
	case 'comments':
		$id=isset($_REQUEST['comments']['v']) ? (int)$_REQUEST['comments']['v'] : 0;
		$Mainclass->Db->Query('SELECT `status`, `allow_comm` FROM `prefix_files` WHERE `id`='.$id.' AND `status`>0 AND `allow_comm`!=0 LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
		{
			Error();
			break;
		}
		$arr=$Mainclass->Db->Fetch_assoc();
		$Mainclass->LoadClass('classes/others/class_comments.php');
		$Mainclass->Comments->new_status=$arr['allow_comm'];
		$type=$Mainclass->Comments->GetType();
		if($Mainclass->Comments->DoEvents())
			switch($type)
			{
				case 'ADD':
					$Mainclass->Db->Update('files',array('!comments'=>'`comments`+1'),'`id`='.$id.' LIMIT 1');
				break;
				case 'DELETE':
					$Mainclass->Db->Update('files',array('!comments'=>'`comments`-'.(int)$Mainclass->Comments->count_delete),'`id`='.$id.' LIMIT 1');
				break;
			}
	break;
	case 'bookmark':
		$Mainclass->SetModVal('multilang',true);
		$Mainclass->SetModVal('categories_table','files_categories');
		$Mainclass->SetModVal('category_ending',$Mainclass->vars['m_files_category_ending']);
		$Mainclass->SetModVal('general_ending',$Mainclass->vars['m_files_ending']);
		$Mainclass->LoadClass('classes/others/class_categories_l.php');
		$Mainclass->Categories_l->long_url=$Mainclass->vars['m_files_long_url'];
		$Mainclass->Categories_l->url_ending=$Mainclass->vars['m_files_category_ending'];
		$Mainclass->Categories_l->Init();
		$id=isset($_REQUEST['value']) ? (int)$_REQUEST['value'] : 0;
		$ug=$Mainclass->Account->GetUserGroups();
		sort($ug,SORT_NUMERIC);
		$ug=' OR `groups` LIKE \'%,'.implode(',%,',$ug).',%\'';
		$Mainclass->Db->Query('SELECT `url`, `main_cat`, `title`, `text`, `show_sokr` FROM `prefix_files` INNER JOIN `prefix_files_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\') AND `id`='.$id.' AND `status`=1 AND (`groups`=\'\''.$ug.') LIMIT 1',__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
		{
			Error();
			break;
		}
		$arr=$Mainclass->Db->Fetch_assoc();
		$Mainclass->Url->SetPrefix(array('module'=>$Mainclass->GetModVAl('name')));
		$url=($Mainclass->vars['m_files_long_url'] ? $Mainclass->Categories_l->CategoryUrl($arr['main_cat'],'','',false) : '').$Mainclass->Url->ConstructUrl(array(array($arr['url'],'fid'=>$id)),!$Mainclass->vars['m_files_long_url']);
		if(false===$seppos=strpos($arr['text'],'[separator]'))
			$text=$arr['text'];
		else
			$text=$arr['show_sokr'] ? str_replace('[separator]','',$arr['text']) : substr_replace($arr['text'],'',0,$seppos+11);
		require $Mainclass->root_path.'modules/account/plugins.php';
		$Plug=new $class_name($Mainclass);
		Result($Plug->BookmarkGetAddAjax(array(
												'module'=>$Mainclass->GetModVal('id'),
												'value'=>$id,
												'title'=>$arr['title'],
												'descr'=>$text,
												'href'=>$url,
												'eval'=>'Id(\'bookmark\').innerHTML=bookmark_delete.replace(\'{value}\',id)',
		)));
	break;
	default:
		Error($Mainclass->lang['main']['unknown_func']);
	break;
}
?>