<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See paramss/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'menu','lang_admin-%');
$Mainclass->navigation=array
(
	array($Mainclass->Url->Prefix(false),$Mainclass->lang['menu']['manag']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'add')),((isset($_GET['do']) and $_GET['do']=='add') ? '!' : '').$Mainclass->lang['menu']['add_item']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'resort')),$Mainclass->lang['main']['resort']),
);
global $mainpage;
$mainpage=false;
if(isset($_GET['do']))
	DoIt($_GET['do']);
elseif(isset($_GET['edit']))
	AddEditMenu((int)$_GET['edit']);
elseif(isset($_GET['save']))
	SaveMenu($_GET['save']=='new' ? true : (int)$_GET['save']);
elseif(isset($_GET['delete']))
	DeleteMenu((int)$_GET['delete']);
elseif(isset($_GET['swap']))
	SwapMenu((int)$_GET['swap']);
elseif(isset($_GET['up']))
	MoveMenuUp((int)$_GET['up']);
elseif(isset($_GET['down']))
	MoveMenuDown((int)$_GET['down']);
else
{
	ShowMenus();
	$mainpage=true;
}

if($mainpage and isset($Mainclass->navigation[0]))
	$Mainclass->navigation[0][1]='!'.$Mainclass->navigation[0][1];

function DoIt($task)
{global $Mainclass, $mainpage;
	switch ($task)
	{
		case 'add':
			AddEditMenu(true);
		break;
		case 'resort':
			Resort();
		break;
		default:
			ShowMenus();
			$mainpage=true;
		break;
	}
}

function ShowMenus()
{global $Mainclass, $title, $jscripts;
	$title=$Mainclass->GetModVal('title');
	$parent=isset($_GET['parent']) ? (int)$_GET['parent'] : 0;
	$content=FormatMenu($parent);
	$Mainclass->navigation[1]=array($Mainclass->Url->ConstructUrl(array('do'=>'add','parent'=>$parent)),$Mainclass->lang['menu']['add_item']);
	$Mainclass->ShowDecoration(false);
	echo $Mainclass->Template->Title($Mainclass->lang['menu']['manag']).$content;
}

function FormatMenu($parent=0)
{global $Mainclass;
	$parent=(int)$parent;
	$result=$Mainclass->Template->OpenTable();
	if($parent>0)
	{
		$hist=$dump=array();
		$Mainclass->Db->Query('SELECT `id`,`title`,`parent` FROM `prefix_menu` LEFT JOIN `prefix_menu_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\')',__file__,__line__);
		while($arr=$Mainclass->Db->Fetch_assoc())
			$dump[]=$arr;
		$len=0;
		$t_par=$parent;
		while($len!=count($dump) and $t_par!=0)
		{
			$len=count($dump);
			foreach($dump as $k=>$v)
				if($v['id']==$t_par)
				{
					if($hist)
						$v['title']='<a href="'.$Mainclass->Url->ConstructUrl(array('parent'=>$v['id'])).'" title="'.$Mainclass->lang['menu']['id'].$v['id'].'">'.$v['title'].'</a>';
					else
						$v['title']='<span title="'.$Mainclass->lang['menu']['id'].$v['id'].'">'.$v['title'].'</span>';
					array_unshift($hist,$v['title']);
					$t_par=$v['parent'];
					unset($dump[$k]);
					break;
				}
		}
		$result.='<table class="filtertable"><tr><td>'.implode(' &raquo; ',$hist).'</td></tr></table>';
		$where='m.`parent`='.$parent;
	}
	else
	{
		$result.='<table class="filtertable"><tr><td>'.$Mainclass->lang['menu']['zero_level'].'</td></tr></table>';
		$where='m.`parent`=0';
	}
	$Mainclass->Db->Query('SELECT m.`id`, l.`title`, m.`url`, m.`eval_url`, m.`pos`, m.`in_map`, m.`status`, COUNT(c.`id`) `cnt` FROM `prefix_menu` `m` LEFT JOIN `prefix_menu_l` `l` USING(`id`) LEFT JOIN `prefix_menu` `c` ON m.`id`=c.`parent` WHERE l.`language` IN (\'\',\''.$Mainclass->lang_name.'\') AND '.$where.' GROUP BY m.`id` ORDER BY m.`pos` ASC',__file__,__line__);
	$max_pos=$Mainclass->Db->Num_rows()-1;
	$n=0;
	$result.='<table class="tabstyle"><tr class="tablethhead"><th width="15">'.$Mainclass->lang['main']['id'].'</th><th>'.$Mainclass->lang['main']['title'].'</th><th>'.$Mainclass->lang['menu']['link'].'</th><th width="100">'.$Mainclass->lang['menu']['in_map'].'</th><th width="100">'.$Mainclass->lang['main']['functs'].'</th></tr>';
	if($Mainclass->Db->Num_rows()==0)
		$result.='<tr><td colspan="5" align="center"><b>'.$Mainclass->lang['menu']['no_menu'].'</b></td></tr>';
	else
		while($arr=$Mainclass->Db->Fetch_assoc())
		{
			if($arr['status']>=0)
				$status=$arr['status']
					? '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['deactivate'].'"><img src="'.$Mainclass->Template->GetImage('active.png').'" alt="'.$Mainclass->lang['main']['deactivate'].'" /></a>'
					: '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['activate'].'"><img src="'.$Mainclass->Template->GetImage('inactive.png').'" alt="'.$Mainclass->lang['main']['activate'].'" /></a>';
			else
				$status='';
			$updown=($arr['pos']>0 ? '<a href="'.$Mainclass->Url->ConstructUrl(array('up'=>$arr['id'])).'" title="'.$Mainclass->lang['menu']['up'].'"><img src="'.$Mainclass->Template->GetImage('up.png').'" alt="'.$Mainclass->lang['menu']['up'].'"  /></a>' : '')
					.($arr['pos']<$max_pos ? '<a href="'.$Mainclass->Url->ConstructUrl(array('down'=>$arr['id'])).'" title="'.$Mainclass->lang['menu']['down'].'"><img src="'.$Mainclass->Template->GetImage('down.png').'" alt="'.$Mainclass->lang['menu']['down'].'" /></a>' : '');
			if(!$arr['title'])
				$arr['title']=$Mainclass->lang['menu']['no_name'];
			if($arr['eval_url'] and $arr['url'])
				$url='<i>'.$Mainclass->lang['main']['no'].'</i>';
			else
				$url=$arr['eval_url'] ? '<span style="color:green" title="'.htmlspecialchars($arr['eval_url']).'">Eval</span>' : htmlspecialchars($arr['url']);
			$result.='<tr class="'.($n++ % 2 ? 'tabletrline1' : 'tabletrline2').'"><td align="center">'.$arr['id'].'</td><td align="left"><a href="'.$Mainclass->Url->ConstructUrl(array('parent'=>$arr['id'])).'">'.$arr['title'].'</a> <span title="'.$Mainclass->lang['menu']['inside'].$arr['cnt'].'">('.$arr['cnt'].')</span></td><td>'.$url.'</td><td>'.($arr['in_map'] ? $Mainclass->lang['menu']['yes'] : $Mainclass->lang['main']['no']).'</td><td class="function">'.$updown.$status.'<a href="'.$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" style="margin: 0 1px;" /></a><a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" style="margin: 0 1px;" /></a></td></tr>';
		}
	$result.='</table>';
	return $result.$Mainclass->Template->CloseTable();
}

function SwapMenu($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Update('menu',array('!status'=>'NOT `status`'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	$Mainclass->Cache->CleanCacheByTag('menu');
	ExitBack();
}

function Resort($redirect=true)
{global $Mainclass;
	$parent='';
	$result=$Mainclass->Db->Query('SELECT `id`,`pos`,`parent` FROM `prefix_menu` ORDER BY `parent` ASC, `pos` ASC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc($result))
	{
		if($parent!=$arr['parent'])
		{
			$n=0;
			$parent=$arr['parent'];
		}
		if($arr['pos']!=$n)
			$Mainclass->Db->Update('menu',array('pos'=>$n),'`id`='.$arr['id'].' LIMIT 1',__file__,__line__);
		++$n;
	}
	RestoreRLMenuByParent();
	if($redirect)
		ExitBack();
}

function MoveMenuUp($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `pos`,`l`,`r`,`parent` FROM `prefix_menu` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($posit,$l,$r,$parent)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_menu` WHERE `parent`='.$parent.' AND `pos`=(SELECT MAX(`pos`) FROM `prefix_menu` WHERE `parent`='.$parent.' AND `pos`<'.$posit.')',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if((int)$cnt>1)
	{
		Resort(false);
		$Mainclass->Db->Query('SELECT `pos` FROM `prefix_menu` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($posit)=$Mainclass->Db->Fetch_row();
	}
	$Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_menu` WHERE `pos`='.--$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
	if($old=$Mainclass->Db->Fetch_assoc())
	{
		#Смещение категории, на место которой мы ставим текущую
		$offset_a=$old['r']-$old['l']+1;
		#Смещение текущей категории на новое место
		$offset_b=$r-$l+1;
		if($r>$old['r'])
		{
			$Mainclass->Db->Update('menu',array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
			$Mainclass->Db->Update('menu',array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
		}
		else
		{
			$Mainclass->Db->Update('menu',array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
			$Mainclass->Db->Update('menu',array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
		}
		$Mainclass->Db->Update('menu',array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
		$Mainclass->Cache->CleanCacheByTag('menu');
	}
	$Mainclass->Db->Update('menu',array('!pos'=>'`pos`+1'),'`parent`='.$parent.' AND `pos`='.$posit.' LIMIT 1',__file__,__line__);
	$Mainclass->Db->Update('menu',array('!pos'=>'`pos`-1'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	ExitBack();
}

function MoveMenuDown($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `pos`,`l`,`r`,`parent` FROM `prefix_menu` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
	list($posit,$l,$r,$parent)=$Mainclass->Db->Fetch_row();
	$Mainclass->Db->Query('SELECT COUNT(`id`) FROM `prefix_menu` WHERE `parent`='.$parent.' AND `pos`=(SELECT MIN(`pos`) FROM `prefix_menu` WHERE `parent`='.$parent.' AND `pos`>'.$posit.')',__file__,__line__);
	list($cnt)=$Mainclass->Db->Fetch_row();
	if((int)$cnt>1)
	{
		Resort(false);
		$Mainclass->Db->Query('SELECT `pos` FROM `prefix_menu` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
		list($posit)=$Mainclass->Db->Fetch_row();
	}
	$Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_menu` WHERE `pos`='.++$posit.' AND `parent`='.$parent.' LIMIT 1',__file__,__line__);
	if($old=$Mainclass->Db->Fetch_assoc())
	{
		#Смещение категории, на место которой мы ставим текущую
		$offset_a=$old['r']-$old['l']+1;
		#Смещение текущей категории на новое место
		$offset_b=$r-$l+1;
		if($r>$old['r'])
		{
			$Mainclass->Db->Update('menu',array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
			$Mainclass->Db->Update('menu',array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
		}
		else
		{
			$Mainclass->Db->Update('menu',array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
			$Mainclass->Db->Update('menu',array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
		}
		$Mainclass->Db->Update('menu',array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
		$Mainclass->Cache->CleanCacheByTag('menu');
	}
	$Mainclass->Db->Update('menu', array('!pos'=>'`pos`-1'),'`parent`='.$parent.' AND `pos`='.$posit.' LIMIT 1',__file__,__line__);
	$Mainclass->Db->Update('menu', array('!pos'=>'`pos`+1'),'`id`='.$id.' LIMIT 1',__file__,__line__);
	ExitBack();
}

function AddEditMenu($id,$error='')
{global $Mainclass, $title, $jscripts;
	$jscripts[]='js/tabcontent.js';
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	$Mainclass->Editor->own_bb=false;
	$values=array();
	$multilang=array_combine(array_keys($Mainclass->langs),array_fill(0,count($Mainclass->langs),array('title'=>'','descr'=>'')));
	if($id===true)
	{
		$title=$Mainclass->lang['menu']['adding_item'];
		$values['id']='new';
		$values['url']=$values['eval_url']=$values['params']=$values['pos']=$values['addon']='';
		$values['parent']=isset($_GET['parent']) ? (int)$_GET['parent'] : 0;
		$values['in_map']=$values['status']=true;
		$values['one_lang']=!$Mainclass->vars['multilang'];
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT * FROM `prefix_menu` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPrefix();
			$values=$Mainclass->Db->Fetch_assoc();
			$values['one_lang']=false;
			$Mainclass->Db->Query('SELECT `language`, `title`, `descr` FROM `prefix_menu_l` WHERE `id`='.$id,__file__,__line__);
			while($temp=$Mainclass->Db->Fetch_assoc())
				if(isset($multilang[$temp['language']]))
				{
					$multilang[$temp['language']]['title']=$temp['title'];
					$multilang[$temp['language']]['descr']=$temp['descr'];
				}
				elseif(!$temp['language'])
				{
					$multilang[$Mainclass->lang_name]['title']=$temp['title'];
					$multilang[$Mainclass->lang_name]['descr']=$temp['descr'];
					$values['one_lang']=true;
					break;
				}
		}
		else
			$values['id']=(int)$id;
		$title=$Mainclass->lang['menu']['editing_item'];
	}
	if($error)
	{
		$values['addon']=isset($_POST['addon']) ? $_POST['addon'] : '';
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['eval_url']=isset($_POST['eval_url']) ? $_POST['eval_url'] : '';
		$values['params']=isset($_POST['params']) ? $_POST['params'] : '';
		$values['parent']=isset($_POST['parent']) ? (int)$_POST['parent'] : 0;
		$values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : '';
		$values['in_map']=isset($_POST['in_map']);
		$values['status']=isset($_POST['status']);
		$values['one_lang']=isset($_POST['one_lang']);
		foreach($multilang as $k=>$v)
			if($Mainclass->lang_name==$k)
			{
				if(isset($_POST['title']))
					$multilang[$k]['title']=$_POST['title'];
				if(isset($_POST['descr']))
					$multilang[$k]['descr']=$Mainclass->Editor->GetHTML('descr');
			}
			else
			{
				if(isset($_POST['title_'.$k]))
					$multilang[$k]['title']=$_POST['title_'.$k];
				if(isset($_POST['descr_'.$k]))
					$multilang[$k]['descr']=$Mainclass->Editor->GetHTML('descr_'.$k);
			}
	}
	$parents=Template::Option($Mainclass->lang['main']['no'],0);
	$nested=$arr=$titles=$poses=array();
	$Mainclass->Db->Query('SELECT `id`,`title`,`parent`,`pos` FROM `prefix_menu` INNER JOIN `prefix_menu_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\')'.($id===true ? '' : ' AND `id`!='.$id).' ORDER BY `pos` DESC',__file__,__line__);
	while($temp=$Mainclass->Db->Fetch_assoc())
	{
		if($temp['parent']==0)
		{
			$poses[$temp['id']]=$temp['pos'];
			$titles[$temp['id']]=$temp['title'];
			$nested[$temp['id']]=0;
		}
		else
			$arr[]=$temp;
	}
	asort($poses,SORT_NUMERIC);
	$keys=array_keys($poses);
	unset($poses);
	$len=0;
	while(count($arr)!=$len)
	{
		$len=count($arr);
		foreach($arr as $k=>$v)
			if(false!==$id=array_search($v['parent'],$keys))
			{
				$nested[$v['id']]=$nested[$v['parent']]+1;
				$titles[$v['id']]=str_repeat('&nbsp;&nbsp;&nbsp;',$nested[$v['id']]).'›&nbsp;'.$v['title'];
				array_splice($keys,$id+1,0,array((int)$v['id']));
				unset($arr[$k]);
			}
	}
	foreach($keys as &$v)
		$parents.=Template::Option($titles[$v],$v,$v==$values['parent']);
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
	$multil_text=$multil_check='';
	if($Mainclass->vars['multilang'])
	{
		$multil_check=array();
		$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
		foreach($multilang as $k=>$v)
		{
			$lang_title=ucfirst($k).' / '.Strings::ucfirst($Mainclass->langs[$k]);
			$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['descr'] or !is_int($id)),'value="'.$k.'"').' '.$lang_title;
			if($k==$Mainclass->lang_name)
				continue;
			$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').slideToggle(\'slow\');return false" class="ol_heading">
			'.(file_exists($Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
			<div id="table_'.$k.'">
				<table class="tabstyle tabform">
				<tr><td class="label">'.$Mainclass->lang['main']['name'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
				<tr><td class="label">'.$Mainclass->lang['menu']['descr'].'</td><td>'.$Mainclass->Editor->Area('descr_'.$k,$v['descr'],5).'</td></tr>
				</table>
			</div>
			</li>';
		}
		$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
		$multil_check='<tr><td class="label">'.$Mainclass->lang['main']['set_for_langs'].'</td><td>'
		.Template::Check('one_lang',$values['one_lang'])
		.' <b>'.$Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
		.join('<br />',$multil_check).'</div></td></tr>';
	}
	$content=$Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '')
	.$Mainclass->Template->OpenTable()
	.'<ul id="blockstabs" class="linetabs">
	<li><a href="#" rel="tab1" class="selected"><b>'.$Mainclass->lang['main']['general'].'</b></a></li>
	'.($Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2"><b>'.$Mainclass->lang['main']['other_langs'].'</b></a></li>' : '').'
	</ul>
	<form action="'.$Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post">
	<div id="tab1" class="tabcontent">
		<table class="tabstyle tabform">
		<tr><td class="label">'.$Mainclass->lang['main']['name'].':<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$Mainclass->lang_name]['title']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['addon'].'</td><td>'.Template::Text('addon',$values['addon']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['descr'].'</td><td>'.$Mainclass->Editor->Area('descr',$multilang[$Mainclass->lang_name]['descr'],5).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['url'].'</td><td>'.Template::Edit('url',str_replace('&amp;','&amp;amp;',$values['url'])).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['eurl'].'</td><td>'.Template::Edit('eval_url',$values['eval_url']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['params'].'</td><td>'.Template::Edit('params',$values['params']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['parent'].'<span class="imp">*</span></td><td>'.Template::Select('parent',$parents).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['pos'].'</td><td>'.Template::Edit('pos',$values['pos']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['menu']['put_in_map'].'</td><td>'.Template::Check('in_map',$values['in_map']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['main']['status'].'</td><td>'.($back ? Template::Control('back','hidden',base64_encode($back)) : '').Template::Check('status',$values['status']).'</td></tr>
		'.$multil_check.'</table>
	</div>'.$multil_text;
	$content.='<div class="submitline">'.Template::Button().' '.(is_int($id) ? Template::Button($Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$Mainclass->Url->ConstructUrl(array('delete'=>$id)).'\'"') : '').'</div>
	</form>
	<script type="text/javascript">
	var countries=new ddtabcontent("blockstabs");
	countries.setpersist(true);
	countries.setselectedClassTarget("link");
	countries.init();
	</script>'.$Mainclass->Template->CloseTable();
	$Mainclass->ShowDecoration();
	echo $content;
}

function SaveMenu($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditMenu($id);
	if(!CheckKey())
		return ExitPrefix();
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return AddEditMenu($id,$Mainclass->lang['menu']['empty_title']);
	$url=isset($_POST['url']) ? $_POST['url'] : '';
	$eval_url=isset($_POST['eval_url']) ? $_POST['eval_url'] : '';
	if($eval_url and false===@eval($eval_url))
		return AddEditMenu($id,$Mainclass->lang['menu']['eurl_error']);
	$Mainclass->LoadClass('classes/others/class_editor.php');
	$Mainclass->Editor->type=0;
	if($Mainclass->vars['multilang'] and !isset($_POST['one_lang']))
	{
		$langs=(empty($_POST['lang']) or !is_array($_POST['lang'])) ? array() : $_POST['lang'];
		$langs=array_intersect(array_keys($Mainclass->langs),$langs);
		if(!$langs)
			$langs=array($Mainclass->lang_name);
	}
	else
		$langs=array('');
	$arr_values=array(
						'addon'		=>isset($_POST['addon']) ? $_POST['addon'] : '',
						'url'		=>$url,
						'eval_url'	=>$eval_url,
						'params'	=>isset($_POST['params']) ? $_POST['params'] : '',
						'pos'		=>'',
						'parent'	=>isset($_POST['parent']) ? (int)$_POST['parent'] : 0,
						'in_map'	=>isset($_POST['in_map']),
						'status'	=>isset($_POST['status']),
	);
	$Mainclass->Db->Transaction('BEGIN');
	if(is_int($id))
	{
		$arr_values['pos']=isset($_POST['pos']) ? (int)$_POST['pos'] : 0;
		$Mainclass->Db->Query('SELECT `pos`,`parent`,`l`,`r` FROM `prefix_menu` WHERE `id`='.$id,__file__,__line__);
		list($old_pos,$parent,$l,$r)=$Mainclass->Db->Fetch_row();
		if($old_pos!=$arr_values['pos'])
		{
			$Mainclass->Db->Query('SELECT `l`,`r` FROM `prefix_menu` WHERE `pos`='.$arr_values['pos'].' AND `parent`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
			if($old=$Mainclass->Db->Fetch_assoc())
			{
				#Смещение категории, на место которой мы ставим текущую
				$offset_a=$old['r']-$old['l']+1;
				#Смещение текущей категории на новое место
				$offset_b=$r-$l+1;
				if($r>$old['r'])
				{
					$Mainclass->Db->Update('menu',array('!r'=>'-(`r`+'.$offset_b.')','!l'=>'-(`l`+'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<'.$l,__file__,__line__);
					$Mainclass->Db->Update('menu',array('!r'=>'`r`-'.$offset_a,'!l'=>'`l`-'.$offset_a),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
				}
				else
				{
					$Mainclass->Db->Update('menu',array('!r'=>'-(`r`-'.$offset_b.')','!l'=>'-(`l`-'.$offset_b.')'),'`l`>='.$old['l'].' AND `r`<='.$old['r'],__file__,__line__);
					$Mainclass->Db->Update('menu',array('!r'=>'`r`+'.$offset_a,'!l'=>'`l`+'.$offset_a),'`l`>='.$l.' AND `r`<'.$old['l'],__file__,__line__);
				}
				$Mainclass->Db->Update('menu',array('!r'=>'ABS(`r`)','!l'=>'ABS(`l`)'),'',__file__,__line__);
			}
			$Mainclass->Db->Update('menu',array('!pos'=>'`pos`-1'),'`parent`='.$parent.' AND `pos`>'.$old_pos,__file__,__line__);
			$Mainclass->Db->Update('menu',array('!pos'=>'`pos`+1'),'`parent`='.$parent.' AND `pos`>='.$arr_values['pos'],__file__,__line__);
		}
		if($parent!=$arr_values['parent'])
		{
			$r=(int)$r;
			$l=(int)$l;
			$Mainclass->Db->Query('SELECT `r` FROM `prefix_menu` WHERE `id`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
			{
				#$rp=0;
				$Mainclass->Db->Query('SELECT MAX(`r`)+1 FROM `prefix_menu` WHERE `parent`='.$arr_values['parent'].' LIMIT 1',__file__,__line__);
				list($rp)=$Mainclass->Db->Fetch_row();
			}
			else
				list($rp)=$Mainclass->Db->Fetch_row();
			if($rp>$l and $rp<$r)
				$arr_values['parent']=$parent;
			else
			{
				$rp=(int)$rp;
				$cnt=$r-$l+1;
				$Mainclass->Db->Update('menu',array('!l'=>'-1*`l`','!r'=>'-1*`r`'),'`l`>='.$l.' AND `r`<='.$r,__file__,__line__);
				$Mainclass->Db->Update('menu',array('!r'=>'`r`-'.$cnt),'`r`>'.$r,__file__,__line__);
				$Mainclass->Db->Update('menu',array('!l'=>'`l`-'.$cnt),'`l`>'.$r,__file__,__line__);
				if($rp>$r)
					$rp-=$cnt;
				$Mainclass->Db->Update('menu',array('!r'=>'`r`+'.$cnt),'`r`>='.$rp,__file__,__line__);
				$Mainclass->Db->Update('menu',array('!l'=>'`l`+'.$cnt),'`l`>'.$rp,__file__,__line__);
				if($rp==0)
					$rp=1;
				$Mainclass->Db->Update('menu',array('!l'=>'`l`*-1-'.$l.'+'.$rp,'!r'=>'`r`*-1-'.$l.'+'.$rp),'`l`<0',__file__,__line__);
				unset($arr_values['l'],$arr_values['r']);
			}
		}
		$Mainclass->Db->Update('menu',$arr_values,'`id`='.$id,__file__,__line__);
		$Mainclass->Db->Delete('menu_l','`id`='.$id.' AND `language`'.$Mainclass->Db->In($langs,true),__file__,__line__);
		foreach($langs as &$v)
		{
			if(!$v or $Mainclass->lang_name==$v)
				$values=array(
								'title'=>$title,
								'descr'=>$Mainclass->Editor->GetHTML('descr'),
				);
			else
				$values=array(
								'title'=>$_POST['title_'.$v],
								'descr'=>$Mainclass->Editor->GetHTML('descr_'.$v),
				);
			$cnt=$Mainclass->Db->Update('menu_l',$values,'`id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
			if($cnt==0)
			{
				$Mainclass->Db->Query('SELECT `id` FROM `prefix_menu_l` WHERE `id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
				if($Mainclass->Db->Num_rows()==0)
					$Mainclass->Db->Insert('menu_l',$values+array('id'=>$id,'language'=>$v),__file__,__line__);
			}
		}
	}
	else
	{
		$arr_values['pos']=isset($_POST['pos']) ? $_POST['pos'] : 0;
		if($arr_values['pos']==='')
		{
			$Mainclass->Db->Query('SELECT MAX(`pos`) FROM `prefix_menu` WHERE `parent`='.$arr_values['parent'].'',__file__,__line__);
			$temp=$Mainclass->Db->Fetch_row();
			$arr_values['pos'] = $temp[0]==null ? 0 : (int)$temp[0]+1;
		}
		else
			$Mainclass->Db->Update('menu',array('!pos'=>'`pos`+1'),'`pos`>='.$arr_values['pos'].' AND `parent`='.$arr_values['parent'],__file__,__line__);

		if($arr_values['parent']==0)
			$Mainclass->Db->Query('SELECT MAX(`r`)+1 FROM `prefix_menu`',__file__,__line__);
		else
			$Mainclass->Db->Query('SELECT `r` FROM `prefix_menu` WHERE `id`='.$arr_values['parent'],__file__,__line__);
		if($Mainclass->Db->Num_rows()==0)
			return ExitPrefix();
		list($r)=$Mainclass->Db->Fetch_row();
		$Mainclass->Db->Update('menu',array('!l'=>'`l`+2'),'`l`>'.(int)$r,__file__,__line__);
		$Mainclass->Db->Update('menu',array('!r'=>'`r`+2'),'`r`>='.(int)$r,__file__,__line__);
		$arr_values['l']=$r++;
		$arr_values['r']=$r;

		$id=$Mainclass->Db->Insert('menu',$arr_values,__file__,__line__);
		$values=array('id'=>array(),'language'=>array(),'title'=>array(),'descr'=>array());

		foreach($langs as &$v)
		{
			$values['id'][]=$id;
			$values['language'][]=$v;
			if(!$v or $Mainclass->lang_name==$v)
			{
				$values['title'][]=$title;
				$values['descr'][]=$Mainclass->Editor->GetHTML('descr');
			}
			else
			{
				$values['title'][]=$_POST['title_'.$v];
				$values['descr'][]=$Mainclass->Editor->GetHTML('descr_'.$v);
			}
		}
		$Mainclass->Db->Insert('menu_l',$values,__file__,__line__);
	}
	$Mainclass->Db->Transaction('COMMIT');
	$Mainclass->Cache->CleanCacheByTag('menu');
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteMenu($id)
{global $Mainclass, $title;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Query('SELECT `title`,`r`,`l` FROM `prefix_menu` LEFT JOIN `prefix_menu_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\') AND `id`='.$id.' LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitBack();
	list($ftitle,$r,$l)=$Mainclass->Db->Fetch_row();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		$kill=array($id);
		$Mainclass->Db->Query('SELECT `id` FROM `prefix_menu` WHERE `l`>'.$l.' AND `r`<'.$r,__file__,__line__);
		while($temp=$Mainclass->Db->Fetch_row())
			$kill[]=$temp[0];
		$cnt=$Mainclass->Db->Delete('menu','`id`'.$Mainclass->Db->In($kill),__file__,__line__);
		$Mainclass->Db->Update('menu',array('!r'=>'`r`-'.$cnt),'`r`>'.$l,__file__,__line__);
		$Mainclass->Db->Update('menu',array('!r'=>'`r`-'.$cnt,'!l'=>'`l`-'.$cnt),'`l`>'.$l,__file__,__line__);
		$Mainclass->Cache->CleanCacheByTag('menu');
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	else
	{
		$title=$Mainclass->lang['menu']['del_confirm'];
		$Mainclass->ShowDecoration(false);
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'=>sprintf($Mainclass->lang['menu']['deleting'],$ftitle).($back ? Template::Control('back','hidden',base64_encode($back)) :''),
												)
		);
	}
}

function RestoreRLMenuByParent()
{global $Mainclass;
	$tosort=$tree=$tree_=$dump=array();
	$Mainclass->Db->Query('SELECT `id`,`parent`,`pos` FROM `prefix_menu` ORDER BY `pos` DESC',__file__,__line__);
	while($arr=$Mainclass->Db->Fetch_assoc())
		if($arr['parent']==0)
		{
			$tree_[$arr['id']]=array('id'=>$arr['id'],'parent'=>0,'nest'=>0);
			$tosort[$arr['id']]=$arr['pos'];
		}
		else
			$dump[]=array('id'=>$arr['id'],'parent'=>$arr['parent']);
	asort($tosort,SORT_NUMERIC);
	$tosort=array_keys($tosort);
	foreach($tosort as &$v)
		$tree[]=$tree_[$v];
	unset($tree_);
	$len=0;
	while(count($dump)!=$len)
	{
		$len=count($dump);
		foreach($dump as $k=>&$v)
			if(false!==$id=array_search($v['parent'],$tosort))
			{
				array_splice($tree,$id+1,0,array(array('id'=>(int)$v['id'],'parent'=>(int)$v['parent'],'nest'=>$tree[$id]['nest']+1)));
				array_splice($tosort,$id+1,0,array($v['id']));
				unset($dump[$k]);
			}
	}
	unset($tosort);
	$onest=-1;
	$ids=array();
	$n=1;
	foreach($tree as $k=>&$v)
	{
		if($v['nest']>$onest)
			$tree[$k]['l']=$n;
		else
		{
			$id=array_pop($ids);
			$tree[$id]['r']=$n;
			$q=$tree[$id]['nest']-$v['nest'];
			for(;$q>0;--$q)
				if(null!==$id=array_pop($ids))
					$tree[$id]['r']=++$n;
			$tree[$k]['l']=++$n;
		}
		$ids[]=$k;
		$onest=$v['nest'];
		++$n;
	}
	while(null!==$id=array_pop($ids))
		$tree[$id]['r']=$n++;
	foreach($tree as &$v)
		$Mainclass->Db->Update('menu',array('r'=>$v['r'],'l'=>$v['l']),'`id`='.(int)$v['id'].' LIMIT 1',__file__,__line__);
}
?>