<?php
/*
//-----------------------------------------------------------//
// Eleanor CMS: Content Management System                    //
// ==========================================================//
//     Transfer To Persian By Eleanor Team 			         //
//             Support:www.Eleanor.ir                        //
//         Forum: http://forum@Eleanor.ir                    //
//         E-Mail: Support@Eleanor.ir                        //
//        Copyright © 2010-2011 Eleanor.ir                   //
// ==========================================================//                                      
// Copyright (c)2009-2010 By Nanosoft (R) Corporation (TM)   //
//-----------------------------------------------------------//
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$Mainclass->LoadLanguage($Mainclass->GetModVal('path'),'voting','lang_admin-%');
$Mainclass->Loadclass('classes/others/class_categories_l_admin.php');
$Mainclass->Categories_l->table_name='voting_categories';
$Mainclass->Db->Query('SELECT COUNT(`status`) FROM `prefix_voting` WHERE `status`=-1',__file__,__line__);
list($ncnt)=$Mainclass->Db->Fetch_row();
$Mainclass->navigation=array
(
	array($Mainclass->Url->Prefix(false),$Mainclass->lang['voting']['list_votings']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'add')),((isset($_GET['do']) and $_GET['do']=='add') ? '!' : '').$Mainclass->lang['voting']['add_voting']),
	array($Mainclass->Url->ConstructUrl(array('do'=>'news')),((isset($_GET['do']) and $_GET['do']=='news') ? '!' : '').$Mainclass->lang['voting']['new_voting']).' ('.$ncnt.')',
	array($Mainclass->Url->ConstructUrl(array('do'=>'options')),((isset($_GET['do']) and $_GET['do']=='options' and !isset($_GET['event'])) ? '!' : '').$Mainclass->lang['main']['options']),
	10=>array(
			$Mainclass->Url->ConstructUrl(array('do'=>'categories')),
			((isset($_GET['do']) and $_GET['do']=='categories' and !isset($_GET['event'])) ? '!' : '').$Mainclass->lang['main']['cats_manag'],
			'submenu'=>$Mainclass->Categories_l->GetNavigation(array('do'=>'categories')),
	),
);
global $mainpage;
$mainpage=false;
if(isset($_GET['do']))
	DoIt($_GET['do']);
elseif(isset($_GET['edit']))
	AddEditVoting((int)$_GET['edit']);
elseif(isset($_GET['save']))
	SaveVoting($_GET['save']=='new' ? true : (int)$_GET['save']);
elseif(isset($_GET['delete']))
	DeleteVoting((int)$_GET['delete']);
elseif(isset($_GET['swap']))
	SwapVoting((int)$_GET['swap']);
else
{
	ShowVotings();
	$mainpage=true;
}

if($mainpage and isset($Mainclass->navigation[0]))
	$Mainclass->navigation[0][1]='!'.$Mainclass->navigation[0][1];

function DoIt($task)
{global $Mainclass,$mainpage,$jscripts,$title;
	switch($task)
	{
		case 'add':
			AddEditVoting(true);
		break;
		case 'news':
			ShowVotings(-1);
		break;
		case 'categories':
			$Mainclass->Url->SetPrefix(array('do'=>'categories'),true);
			$Mainclass->Categories_l->delete_func_callback='DeleteVotingsCategories';
			$content=$Mainclass->Categories_l->AdminInit();
			$title=$Mainclass->Categories_l->title;
			$jscripts=array_merge($jscripts,$Mainclass->Categories_l->jscripts);
			$Mainclass->ShowDecoration();
			echo $content;
		break;
		case 'options':
			VotingOptions();
		break;
		default:
			ShowVotings();
			$mainpage=true;
		break;
	}
}

function VotingOptions()
{global $Mainclass,$title,$jscripts;
	$Mainclass->Url->SetPrefix(array(array('do'=>'options')),true);
	$Mainclass->LoadClass('classes/others/class_settings.php');
	$content=$Mainclass->Settings->ShowGroup('module_voting',false);
	$title=$Mainclass->Settings->title;
	$jscripts=array_merge($jscripts,$Mainclass->Settings->jscripts);
	$Mainclass->navigation=array_merge($Mainclass->navigation,$Mainclass->Settings->navigation);
	$Mainclass->ShowDecoration();
	echo $content;
}

function ShowVotings($active=1)
{global $Mainclass,$title;
	$page=isset($_GET['page']) ? (int)$_GET['page'] : 1;
	if($page<=0)
		$page=1;
	$per_page=30;
	$offset=($page-1)*$per_page;
	switch ($active)
	{
		case -1:
			$title=$Mainclass->lang['voting']['new_voting'];
			$where='`status`=-1';
			$pages_arr=array('do'=>'news');
		break;
		case 1:
		default:
			$title=$Mainclass->lang['voting']['list_votings'];
			$where='`status`>=0';
			$pages_arr=array('do'=>'news');
		break;
	}
	$ficat=0;
	$fititle='';
	if(!empty($_REQUEST['filter']))
	{
		$pages_arr['filter']=1;
		if(!empty($_REQUEST['ficat']))
		{
			$pages_arr['ficat']=$ficat=$_REQUEST['ficat'];
			$where.=' AND `cid`='.(int)$ficat;
		}
		if(!empty($_REQUEST['fititle']))
		{
			$pages_arr['fititle']=$fititle=$_REQUEST['fititle'];
			$where.=' AND `title` LIKE \'%'.$Mainclass->Db->EscapeString($fititle).'%\'';
		}
	}
	if(CheckKey() and isset($_POST['op'])  and $_POST['mass'] and is_array($_POST['mass']))
	{
		switch($_POST['op'])
		{
			case 'd':
				$Mainclass->Db->Update('voting',array('status'=>0),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 'a':
				$Mainclass->Db->Update('voting',array('status'=>1),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 'f':
				$Mainclass->Db->Update('voting',array('status'=>3),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 's':
				$Mainclass->Db->Update('voting',array('!status'=>'NOT `status`'),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 'k':
				$Mainclass->LoadClass('classes/others/class_comments.php');
				$Mainclass->Comments->DeleteComments($_POST['mass']);
				$Mainclass->Db->Delete('voting','`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
				$Mainclass->Db->Delete('voting_l','`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
			case 'n':
				$Mainclass->Db->Update('voting',array('status'=>-1),'`id`'.$Mainclass->Db->In($_POST['mass']),__file__,__line__);
			break;
		}
	}
	$op_list=Template::Option($Mainclass->lang['main']['activate'],'a').Template::Option($Mainclass->lang['main']['deactivate'],'d').Template::Option($Mainclass->lang['main']['turn_active'],'s').Template::Option($Mainclass->lang['main']['delete'],'k').Template::Option($Mainclass->lang['main']['mark_new'],'n').Template::Option($Mainclass->lang['voting']['finish'],'f');
	$n=0;
	$used_cats=array();
	$cat_list=$Mainclass->Categories_l->GetCatOptions($ficat);
	$content=$Mainclass->Template->Title($title)
	.$Mainclass->Template->OpenTable()
	.'<form action="" method="post"><table class="filtertable"><tr><td><b>'.$Mainclass->lang['main']['filter'].':</b> '.Template::Edit('fititle',$fititle).' '.Template::Select('ficat',Template::Option('-'.$Mainclass->lang['main']['category'].'-',0).$cat_list).'
	'.Template::Button($Mainclass->lang['main']['apply'],'submit').Template::Control('filter','hidden',1).'</td></tr></table></form>
	<form id="voting_form" action="'.$Mainclass->Url->ConstructUrl($pages_arr).'" method="post" onsubmit="return (CheckGroup(this) && confirm(\''.$Mainclass->lang['main']['are_you_sure'].'\'))"><table class="tabstyle">
	<tr class="tablethhead"><th width="15">'.$Mainclass->lang['main']['id'].'</th><th>'.$Mainclass->lang['main']['name'].'</th><th>'.$Mainclass->lang['voting']['category'].'</th><th>'.$Mainclass->lang['voting']['type'].'</th><th width="80">'.$Mainclass->lang['main']['functs'].'</th><th width="20">'.Template::Check('mass',false,'id="voting_mass_check"').'</th></tr>';
	$Mainclass->Db->Query('SELECT `id`,`cid`,`title`,`type`,`numans`,`status` FROM `prefix_voting` LEFT JOIN `prefix_voting_l` USING(`id`) WHERE '.$where.' AND `language`IN(\'\',\''.$Mainclass->lang_name.'\') ORDER BY `id` DESC LIMIT '.$offset.', '.$per_page,__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		$content.='<tr><td colspan="6" align="center"><b>'.$Mainclass->lang['voting']['no_votings'].'</b></td></tr>';
	while($arr=$Mainclass->Db->Fetch_assoc())
	{
		$used_cats[]=$arr['cid'];
		if($arr['status']>=0 and $arr['status']<3)
			$act=$arr['status'] ? '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['deactivate'].'"><img src="'.$Mainclass->Template->GetImage('active.png').'" alt="'.$Mainclass->lang['main']['deactivate'].'" /></a>' : '<a href="'.$Mainclass->Url->ConstructUrl(array('swap'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['activate'].'"><img src="'.$Mainclass->Template->GetImage('inactive.png').'" alt="'.$Mainclass->lang['main']['activate'].'" /></a>';
		else
			$act='';
		if($arr['status']==2)
			$type=$Mainclass->lang['voting']['finished'];
		else
			$type=$arr['type'] ? $Mainclass->lang['voting']['multi'].'('.$arr['numans'].')' : $Mainclass->lang['voting']['single'];
		$content.='<tr class="'.($n++ % 2 ? 'tabletrline2' : 'tabletrline1').'">
		<td align="center">'.$arr['id'].'</td>
		<td><a href="'.($edit=$Mainclass->Url->ConstructUrl(array('edit'=>$arr['id']))).'" title="'.$Mainclass->lang['main']['edit'].'">'.$arr['title'].'</a></td>
		<td align="center">cat_'.$arr['cid'].'_</td>
		<td align="center">'.$type.'</td>
		<td class="function">'.$act.'<a href="'.$edit.'" title="'.$Mainclass->lang['main']['edit'].'"><img src="'.$Mainclass->Template->GetImage('edit.png').'" alt="'.$Mainclass->lang['main']['edit'].'" /></a>
		<a href="'.$Mainclass->Url->ConstructUrl(array('delete'=>$arr['id'])).'" title="'.$Mainclass->lang['main']['delete'].'"><img src="'.$Mainclass->Template->GetImage('delete.png').'" alt="'.$Mainclass->lang['main']['delete'].'" /></a></td>
		<td align="center">'.Template::Check('mass[]',false,'value="'.$arr['id'].'"').'</td>
		</tr>';
	}
	$used_cats=array_unique($used_cats);
	if($used_cats)
	{
		$Mainclass->Db->Query('SELECT `id`, `title` FROM `prefix_voting_categories` INNER JOIN `prefix_voting_categories_l` USING(`id`) WHERE `language` IN (\'\',\''.$Mainclass->lang_name.'\') AND `id`'.$Mainclass->Db->In($used_cats),__file__,__line__);
		while($temp=$Mainclass->Db->Fetch_assoc())
			$content=str_replace('cat_'.$temp['id'].'_',$temp['title'],$content);
	}
	$content.='</table><div class="submitline" style="text-align: right;">'.$Mainclass->lang['main']['with_selected'].Template::Select('op',$op_list).' '.Template::Button($Mainclass->lang['main']['ok']).'</div></form>
	<script type="text/javascript">
	One2AllCheckboxes("voting_form","voting_mass_check","mass[]");
	</script>'.$Mainclass->Template->CloseTable();
	$Mainclass->Db->Query('SELECT COUNT(DISTINCT `id`) FROM `prefix_voting` LEFT JOIN `prefix_voting_l` USING(`id`) WHERE '.$where.' AND `language`IN(\'\',\''.$Mainclass->lang_name.'\')',__file__,__line__);
	$temp=$Mainclass->Db->Fetch_row();
	$Mainclass->ShowDecoration(false);
	echo $content.Strings::Pages($temp[0],$per_page,$pages_arr);
}

function SwapVoting($id)
{global $Mainclass;
	if(!CheckKey())
		return ExitPrefix();
	$Mainclass->Db->Update('voting',array('!status'=>'NOT `status`'),'`id`=\''.$id.'\' LIMIT 1');
	ExitBack();
}

function AddEditVoting($id,$error='')
{global $Mainclass,$title,$jscripts;
	require $Mainclass->root_path.'addons/addons.php';
	$jscripts[]='js/tabcontent.js';
	$jscripts[]='js/eleanor_tooltip.js';
	$Mainclass->Loadclass('classes/others/class_editor.php');
	$values=array();
	$multilang=array_combine(array_keys($Mainclass->langs),array_fill(0,count($Mainclass->langs),array('title'=>'','text'=>'','variants'=>'')));
	if($id===true)
	{
		$title=$Mainclass->lang['voting']['adding_voting'];
		$values['who']=$values['url']=$values['numans']=$values['date_f']='';
		$values['id']='new';
		$values['cid']=$values['type']=$values['cnt']=0;
		$values['status']=1;
		$values['allow_comm']=1;
		$values['date']=date('Y-m-d');
		$values['only_users']=false;
		$values['one_lang']=empty($Mainclass->vars['multilang']);
	}
	else
	{
		if(!$error)
		{
			$Mainclass->Db->Query('SELECT * FROM `prefix_voting` WHERE `id`='.$id.' LIMIT 1',__file__,__line__);
			if($Mainclass->Db->Num_rows()==0)
				ExitPrefix();
			$values=$Mainclass->Db->Fetch_assoc();
			$values['id']=(int)$values['id'];#НУЖНО!!! ДЛЯ скрытия неиспользуемых языков
			$values['who']=trim($values['id'],',');
			$values['one_lang']=false;
			$Mainclass->Db->Query('SELECT `language`,`title`,`text`,`variants` FROM `prefix_voting_l` WHERE `id`='.$id,__file__,__line__);
			while($temp=$Mainclass->Db->Fetch_assoc())
				if(isset($multilang[$temp['language']]))
				{
					$multilang[$temp['language']]['title']=$temp['title'];
					$multilang[$temp['language']]['text']=$temp['text'];
					$multilang[$temp['language']]['variants']=$temp['variants'];
				}
				elseif(!$temp['language'])
				{
					$multilang[$Mainclass->lang_name]['title']=$temp['title'];
					$multilang[$Mainclass->lang_name]['text']=$temp['text'];
					$multilang[$Mainclass->lang_name]['variants']=$temp['variants'];
					$values['one_lang']=true;
					break;
				}
			$variants=explode('·',$multilang[$Mainclass->lang_name]['variants']);
			$values['answers']=explode('·',$values['answers']);
			if(($c=count($variants))>count($values['answers']))
				$values['answers']=array_pad($values['answers'],$c,0);
			$multilang[$Mainclass->lang_name]['variants']='';
			foreach($variants as $k=>$v)
				$multilang[$Mainclass->lang_name]['variants'].=$v.'='.$values['answers'][$k]."\r\n";
			$multilang[$Mainclass->lang_name]['variants']=rtrim($multilang[$Mainclass->lang_name]['variants']);
			unset($variants,$values['answers']);
			foreach($multilang as $k=>$v)
				$multilang[$k]['variants']=str_replace('·',"\r\n",$v['variants']);
		}
		else
			$values['id']=(int)$id;
		$title=$Mainclass->lang['voting']['editing_voting'];
	}
	if($error)
	{
		$values['url']=isset($_POST['url']) ? $_POST['url'] : '';
		$values['who']=isset($_POST['who']) ? $_POST['who'] : '';
		$values['date']=isset($_POST['date']) ? $_POST['date'] : '';
		$values['date_f']=isset($_POST['date_f']) ? $_POST['date_f'] : '';
		$values['type']=isset($_POST['type']) ? (int)$_POST['type'] : '';
		$values['numans']=isset($_POST['numans']) ? (int)$_POST['numans'] : '';
		$values['cnt']=isset($_POST['cnt']) ? (int)$_POST['cnt'] : '';
		$values['cid']=isset($_POST['cid']) ? (int)$_POST['cid'] : '';
		$values['status']=isset($_POST['status']) ? (int)$_POST['status'] : 0;
		$values['one_lang']=isset($_POST['one_lang']);
		$values['only_users']=isset($_POST['one_lang']);
		$values['allow_comm']=isset($_POST['allow_comm']) ? (int)$_POST['allow_comm'] : 1;
		foreach($multilang as $k=>$v)
			if($Mainclass->lang_name==$k)
			{
				if(isset($_POST['title']))
					$multilang[$k]['title']=$_POST['title'];
				if(isset($_POST['text']))
					$multilang[$k]['text']=$Mainclass->Editor->GetHTML('text');
				if(isset($_POST['variants']))
					$multilang[$k]['variants']=$_POST['variants'];
			}
			else
			{
				if(isset($_POST['title_'.$k]))
					$multilang[$k]['title']=$_POST['title_'.$k];
				if(isset($_POST['text_'.$k]))
					$multilang[$k]['text']=$Mainclass->Editor->GetHTML('text_'.$k);
				if(isset($_POST['variants_'.$k]))
					$multilang[$k]['variants_'.$k]=$_POST['variants_'.$k];
			}
	}
	$cat_list=$Mainclass->Categories_l->GetCatOptions($values['cid']);
	$date=Calendar('date',$values['date']);
	$date_f=Calendar('date_f',$values['date_f']);
	$ac=Template::Option($Mainclass->lang['main']['yes'],1,$values['allow_comm']==1).Template::Option($Mainclass->lang['main']['no'],0,$values['allow_comm']==0).Template::Option($Mainclass->lang['voting']['with_mod'],-1,$values['allow_comm']==-1);
	$vtype=Template::Option($Mainclass->lang['voting']['single_v'],0,$values['type']==0).Template::Option($Mainclass->lang['voting']['multi_v'],1,$values['type']==1);
	if($cat_list)
	{
		$multil_text=$multil_check='';
		if($Mainclass->vars['multilang'])
		{
			$multil_check=array();
			$multil_text='<div id="tab4" class="tabcontent"><ul class="editlang">';
			foreach($multilang as $k=>$v)
			{
				$lang_title=ucfirst($k).' / '.ucfirst($Mainclass->langs[$k]);
				$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['text'] or $v['variants'] or !is_int($id)),'value="'.$k.'"').' '.$lang_title;
				if($k==$Mainclass->lang_name)
					continue;
				$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').slideToggle(\'slow\');return false" class="ol_heading">
				'.(file_exists($Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
				<div id="table_'.$k.'">
					<table class="tabstyle tabform">
					<tr><td class="label">'.$Mainclass->lang['main']['name'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
					<tr><td class="label">'.$Mainclass->lang['voting']['descr'].'</td><td>'.$Mainclass->Editor->Area('text_'.$k,$v['text'],5).'</td></tr>
					<tr><td class="label">'.$Mainclass->lang['voting']['variants_t'].'</td><td>'.Template::Text('variants_'.$k,$v['variants']).'</td></tr>
					</table>
				</div>
				</li>';
			}
			$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
			$multil_check='<tr><td class="label">'.$Mainclass->lang['main']['set_for_langs'].'</td><td>'
			.Template::Check('one_lang',$values['one_lang'])
			.' <b>'.$Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
			.join('<br />',$multil_check).'</div></td></tr>';
		}
		$content=$Mainclass->Template->Title($title).($error ? $Mainclass->Template->Message($error) : '')

		.$Mainclass->Template->OpenTable()
		.'<form action="'.$Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post"><table class="tabstyle tabform"><tr><td class="label">'.$Mainclass->lang['main']['name'].':<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$Mainclass->lang_name]['title']).'</td></tr>
		<tr><td class="label">'.$Mainclass->lang['voting']['cat'].'<span class="imp">*</span></td><td>'.Template::Select('cid',$cat_list).'</td></tr></table>
		<ul id="blockstabs" class="linetabs">
		<li><a href="#" rel="tab1" class="selected"><b>'.$Mainclass->lang['main']['general'].'</b></a></li>
		<li><a href="#" rel="tab2"><b>'.$Mainclass->lang['voting']['variants'].'</b></a></li>
		<li><a href="#" rel="tab3"><b>'.$Mainclass->lang['main']['settings'].'</b></a></li>
		'.($Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab4"><b>'.$Mainclass->lang['main']['other_langs'].'</b></a></li>' : '').'
		</ul>
		<div id="tab1" class="tabcontent">
			<table class="tabstyle tabform"><tr><td class="label">'.$Mainclass->lang['main']['url_l'].'</td><td>'.Template::Edit('url',$values['url']).'</td></tr><tr><td class="label">'.$Mainclass->lang['voting']['descr'].'</td><td>'.$Mainclass->Editor->Area('text',$multilang[$Mainclass->lang_name]['text'],5).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['main']['status'].'</td><td>'.Template::Select('status',Template::Option($Mainclass->lang['voting']['new'],-1,$values['status']==-1).Template::Option($Mainclass->lang['main']['inactive'],0,$values['status']==0).Template::Option($Mainclass->lang['main']['active'],1,$values['status']==1).Template::Option($Mainclass->lang['voting']['finished'],3,$values['status']==3)).'</td></tr>
			'.$multil_check.'</table>
		</div>
		<div id="tab2" class="tabcontent">
			<table class="tabstyle tabform">
			<tr><td class="label">'.$Mainclass->lang['voting']['variants_t'].'</td><td>'.Template::Text('variants',$multilang[$Mainclass->lang_name]['variants']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['type'].'<span class="imp">*</span></td><td>'.Template::Select('type',$vtype).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['numans'].'</td><td>'.Template::Edit('numans',$values['numans']).'</td></tr>
			</table>
		</div>
		<div id="tab3" class="tabcontent">
			<table class="tabstyle tabform">
			<tr><td class="label">'.$Mainclass->lang['voting']['date'].'</td><td>'.$date.'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['date_f'].'</td><td>'.$date_f.'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['cnt'].'</td><td>'.Template::Edit('cnt',$values['cnt']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['allow_comment'].'</td><td>'.Template::Select('allow_comm',$ac).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['only_users'].'</td><td>'.Template::Check('only_users',$values['only_users']).'</td></tr>
			<tr><td class="label">'.$Mainclass->lang['voting']['who_voted'].'</td><td>'.Template::Edit('who',$values['who']).'</td></tr>
			</table>
		</div>'.$multil_text;
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		if($ref)
			$content.=Template::Control('back','hidden',base64_encode($ref));
		$content.='<div class="submitline">'.Template::Button().' '.(is_int($id) ? Template::Button($Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$Mainclass->Url->ConstructUrl(array('delete'=>$id)).'\'"') : '').'</div>
		</form>
		<script type="text/javascript">
		var countries=new ddtabcontent("blockstabs");
		countries.setpersist(true);
		countries.setselectedClassTarget("link");
		countries.init();
		</script>'.$Mainclass->Template->CloseTable();
	}
	else
		$content=$Mainclass->Template->Message($Mainclass->lang['voting']['no_categories']);
	$Mainclass->ShowDecoration();
	echo $content;
}

function SaveVoting($id)
{global $Mainclass;
	if($_SERVER['REQUEST_METHOD']!='POST')
		return AddEditVoting($id);
	if(!CheckKey())
		return ExitPrefix();
	$title=isset($_POST['title']) ? trim($Mainclass->POST['title']) : '';
	if(!$title)
		return AddEditVoting($id,$Mainclass->lang['voting']['empty_name']);
	$url=isset($_POST['url']) ? $Mainclass->Url->UrlString($_POST['url']) : '';
	if(!$url)
		$_POST['url']=$url=$Mainclass->Url->UrlString($_POST['title']);
	$q_and=$id===true ? '' : ' AND `id`!='.$id;
	$Mainclass->Db->FQuery('SELECT `id` FROM {"0"} WHERE `url`={"1"}'.$q_and.' LIMIT 1',array('voting','s_'.$url),__file__,__line__);
	if($Mainclass->Db->Num_rows()!=0)
		$url=null;
	$variants=isset($_POST['variants']) ? trim($Mainclass->POST['variants']) : '';
	if(!$variants)
		return AddEditVoting($id,$Mainclass->lang['voting']['no_variants']);
	$variants=str_replace(array("\r",'·'),'',$variants);
	$variants=explode("\n",$variants);
	if(count($variants)<2)
		return AddEditVoting($id,$Mainclass->lang['voting']['one_ans']);
	$answers=array_fill(0,count($variants),0);
	foreach($variants as $k=>&$v)
		if(preg_match('#=(\d+)$#',$v,$matches)>0)
		{
			if(!$v)
			{
				unset($variants[$k],$answers[$k]);
				continue;
			}
			$answers[$k]=$matches[1];
			$variants[$k]=mb_substr($v,0,-1-mb_strlen($matches[1],ELEANOR_CHARSET),ELEANOR_CHARSET);
		}
	$variants=array_values($variants);
	$date=isset($_POST['date']) ? Strings::CheckDate($_POST['date']) : date('Y-m-d');
	if(empty($_POST['date_f']))
		$date_f=null;
	else
	{
		$date_f=Strings::CheckDate($_POST['date_f']);
		if((strtotime($date_f)-strtotime($date))<86400)
			return AddEditVoting($id,$Mainclass->lang['voting']['date_fin_must']);
	};
	$numans=isset($_POST['numans']) ? (int)$_POST['numans'] : '';
	$type=isset($_POST['type']) ? (int)$_POST['type'] : '';
	if($numans<2)
	{
		$numans=1;
		$type=0;
	}
	elseif($numans>$variants)
		$numans=$variants;
	$Mainclass->Loadclass('classes/others/class_editor.php');
	if($Mainclass->vars['multilang'] and !isset($_POST['one_lang']))
	{
		$langs=(empty($_POST['lang']) or !is_array($_POST['lang'])) ? array() : $_POST['lang'];
		$langs=array_intersect(array_keys($Mainclass->langs),$langs);
		if(!$langs)
			$langs=array($Mainclass->lang_name);
	}
	else
		$langs=array('');
	$status=isset($_POST['status']) ? (int)$_POST['status'] : '';
	if($status>0)
		$status=$Mainclass->MyTime()>strtotime($date) ? 1 : 2;
	$arr_values=array(
						'url'		=>$url,
						'cid'		=>isset($_POST['cid']) ? (int)$_POST['cid'] : '',
						'answers'	=>implode('·',$answers),
						'who'		=>isset($_POST['who']) ? ','.Strings::CleanForExplode($_POST['who']).',' : ',',
						'date'		=>$date,
						'date_f'	=>$date_f,
						'type'		=>$type,
						'numans'	=>$numans,
						'cnt'		=>isset($_POST['cnt']) ? (int)$_POST['cnt'] : '',
						'status'	=>$status,
						'allow_comm'=>isset($_POST['allow_comm']) ? (int)$_POST['allow_comm'] : 1,
						'only_users'=>isset($_POST['only_users']),
	);
	if(is_int($id))
	{
		$Mainclass->Db->Update('voting',$arr_values,'`id`='.$id.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Delete('voting_l','`id`='.$id.' AND `language`'.$Mainclass->Db->In($langs,true),__file__,__line__);
		foreach($langs as &$v)
		{
			if(!$v or $Mainclass->lang_name==$v)
				$values=array(
								'title'=>$title,
								'text'=>$Mainclass->Editor->GetHTML('text'),
								'variants'=>implode('·',$variants),
				);
			else
			{
				$variants_l=isset($_POST['variants_'.$v]) ? str_replace(array("\r",'·'),'',trim($Mainclass->POST['variants_'.$v])) : '';
				$variants_l=$variants_l ? explode("\n",$variants_l) : array();
				if(($c_v=count($variants))>($c_v_l=count($variants_l)))
					$variants_l=array_merge($variants_l,array_slice($variants,$c_v_l-$c_v));
				elseif($c_v<$c_v_l)
					array_splice($variants_l,$c_v_l-$c_v);
				$values=array(
								'title'=>$_POST['title_'.$v],
								'text'=>$Mainclass->Editor->GetHTML('text_'.$v),
								'variants'=>implode('·',$variants_l),
				);
			}
			$cnt=$Mainclass->Db->Update('voting_l',$values,'`id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
			if($cnt==0)
			{
				$Mainclass->Db->Query('SELECT `id` FROM `prefix_voting_l` WHERE `id`='.$id.' AND `language`=\''.$v.'\' LIMIT 1',__file__,__line__);
				if($Mainclass->Db->Num_rows()==0)
					$Mainclass->Db->Insert('voting_l',$values+array('id'=>$id,'language'=>$v),__file__,__line__);
			}
		}
	}
	else
	{
		$id=$Mainclass->Db->Insert('voting',$arr_values,__file__,__line__);
		$values=array('id'=>array(),'language'=>array(),'title'=>array(),'text'=>array(),'variants'=>array());
		foreach($langs as &$v)
		{
			$values['id'][]=$id;
			$values['language'][]=$v;
			if(!$v or $Mainclass->lang_name==$v)
			{
				$values['title'][]=$title;
				$values['text'][]=$Mainclass->Editor->GetHTML('text');
				$values['variants'][]=implode('·',$variants);
			}
			else
			{
				$variants_l=isset($_POST['variants_'.$v]) ? str_replace(array("\r",'·'),'',trim($Mainclass->POST['variants_'.$v])) : '';
				$variants_l=$variants_l ? explode("\n",$variants_l) : array();
				if(($c_v=count($variants))>($c_v_l=count($variants_l)))
					$variants_l=array_merge($variants_l,array_slice($variants,$c_v_l-$c_v));
				elseif($c_v<$c_v_l)
					array_splice($variants_l,$c_v_l-$c_v);
				$values['title'][]=$_POST['title_'.$v];
				$values['text'][]=$Mainclass->Editor->GetHTML('text_'.$v);
				$values['variants'][]=implode('·',$variants_l);
			}
		}
		$Mainclass->Db->Insert('voting_l',$values,__file__,__line__);
	}
	CleanCache();
	if(empty($_POST['back']))
		ExitPrefix();
	else
		Functions::Redirect(base64_decode($_POST['back']));
}

function DeleteVotingCategories($ids)
{global $Mainclass;
	$Mainclass->Db->Query('SELECT DISTINCT `id` FROM `prefix_voting` WHERE `cid`'.$Mainclass->Db->In($ids),__file__,__line__);
	$ids=array();
	while($t=$Mainclass->Db->Fetch_row())
		$ids[]=$t[0];
	if($ids)
	{
		$Mainclass->LoadClass('classes/others/class_comments.php');
		$Mainclass->Comments->DeleteComments($arr);
		$Mainclass->Db->Delete('voting','`id`'.$Mainclass->Db->In($arr),__file__,__line__);
		$Mainclass->Db->Delete('voting_l','`id`'.$Mainclass->Db->In($arr),__file__,__line__);
	}
	CleanCache();
}

function CleanCache()
{global $Mainclass;
	$Mainclass->Cache->CleanCacheByTag('voting_mainpage');
}

function DeleteVoting($id)
{global $Mainclass,$title;
	if(!CheckKey())
		Functions::Redirect(html_entity_decode($Mainclass->Url->ConstructUrl(array('delete'=>$id))));
	$Mainclass->Db->Query('SELECT `title` FROM `prefix_voting` LEFT JOIN `prefix_voting_l` USING(`id`) WHERE `id`='.$id.' AND `language` IN (\'\',\''.$Mainclass->lang_name.'\') LIMIT 1',__file__,__line__);
	if($Mainclass->Db->Num_rows()==0)
		ExitBack();
	if(isset($_POST['ok']) and $_POST['ok']=='ok')
	{
		if(!CheckKey())
			return ExitPrefix();
		$Mainclass->LoadClass('classes/others/class_comments.php');
		$Mainclass->Comments->DeleteComments($id);
		$Mainclass->Db->Delete('voting','`id`='.$id.' LIMIT 1',__file__,__line__);
		$Mainclass->Db->Delete('voting_l','`id`='.$id.' LIMIT 1',__file__,__line__);
		CleanCache();
		if(empty($_POST['back']))
			ExitPrefix();
		else
			Functions::Redirect(base64_decode($_POST['back']));
	}
	else
	{
		list($ftitle)=$Mainclass->Db->Fetch_row();
		$title=$Mainclass->lang['voting']['submit_del'];
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $Mainclass->MyGetEnv('HTTP_REFERER');
		if(isset($_GET['no_back']))
			$back='';
		$Mainclass->ShowDecoration(false);
		echo $Mainclass->Template->GetThemeFile(
												'Confirm',
												array(
														'message'	=>sprintf($Mainclass->lang['voting']['deleting'],$ftitle).($back ? Template::Control('back','hidden',base64_encode($back)) : ''),
												)
		);
	}
}
?>