<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='ClCatTPL';
class ClCatTPL extends BaseClass
{
	public function AddonRow($name,$descr,$value)
	{
		return '<tr><td class="label">'.$name.(empty($descr) ? '' : '<br /><span class="small">'.$descr.'</span>').'</td><td>'.$value.'</td></tr>';
	}

	public function AddonInfo($title)
	{
		return '<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>';
	}

	public function AddEditCat($error,$title,$lang,$values,$addon,$image_list,$cat_options)
	{
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		return $this->Mainclass->Template->Title($title).($error ? $this->Mainclass->Template->Message($error) : '')
		.$this->Mainclass->Template->OpenTable()
		.'<form action="'.$this->Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post">
		<table class="tabstyle tabform">
		<tr><td class="label">'.$this->Mainclass->lang['main']['title'].'<span class="imp">*</span></td><td>'.Template::Edit('title',$values['title']).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['main']['url'].':</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
		<tr><td class="label">'.$lang['pos'].'</td><td>'.Template::Edit('pos',$values['pos']).'</td></tr>
		<tr><td class="label">'.$lang['meta_descr'].'</td><td>'.Template::Edit('s_descr',$values['s_descr'],'maxlength="250"').'</td></tr>
		<tr><td class="label">'.$lang['parent'].'</td><td>'.Template::Select('parent',Template::Option($this->Mainclass->lang['main']['no'],'0').$cat_options).'</td></tr>
		<tr><td class="label">'.$this->Mainclass->lang['main']['descr'].':</td><td>'.$this->Mainclass->Editor->Area('descr',$values['descr'],5).'</td></tr>
		<tr><td class="label">'.$lang['picture'].'</td><td>'.Template::Select('image',Template::Option($this->Mainclass->lang['main']['no'],'0',empty($values['image'])).join('',$image_list),'onchange="document.images.preview.src=this.value==\'0\' ? \'images/categories/none.png\' : this.value"').'</td></tr>
		<tr><td class="label">'.$lang['preview'].':</td><td><img src="'.((!$values['image'] or !is_file($this->Mainclass->FormatPath($values['image']))) ? 'images/categories/none.png' : $values['image']).'" id="preview" alt="'.$lang['preview'].'" title="'.$lang['preview'].'" /></td></tr>'
		.$addon.'<tr><td class="label"></td><td>'.Template::Button().(is_int($values['id']) ? Template::Button($this->Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('delete'=>$values['id'])).'\'"') : '').($back ? Template::Control('back','hidden',base64_encode($back)) : '').'</td></tr></table></form>'.$this->Mainclass->Template->CloseTable();
	}

	public function CatsListHead($title)
	{
		return $this->Mainclass->Template->Title($title)
		.$this->Mainclass->Template->OpenTable()
		.'<table class="tabstyle"><tr class="tablethhead"><th width="15">'.$this->Mainclass->lang['main']['id'].'</th><th>'.$this->Mainclass->lang['main']['name'].'</th><th>'.$this->Mainclass->lang['main']['url'].'</th><th width="80">'.$this->Mainclass->lang['main']['functs'].'</th></tr>';
	}

	public function CatsListRow($n,$v,$values,$updown)
	{
		return '<tr class="'.($n % 2 ? 'tabletrline2' : 'tabletrline1').'"><td>'.$v.'</td><td>'.$values['title'].'</td><td>'.$values['url'].'</td><td class="function">'.$updown.'<a href="'.$this->Mainclass->Url->ConstructUrl(array('edit'=>$v)).'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array('delete'=>$v)).'" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></td></tr>';
	}

	public function CatsListEmpty($lang)
	{
		return '<tr><td colspan="4" align="center"><b>'.$lang['no_categories'].'</b></td></tr>';
	}

	public function CatsListFoot()
	{
		return '</table>'.$this->Mainclass->Template->CloseTable();
	}
}
?>