<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='ClCatLagTPL';
class ClCatLagTPL extends BaseClass
{
	public function AddonRow($name,$descr,$value)
	{
		return '<tr><td class="label">'.$name.(empty($descr) ? '' : '<br /><span class="small">'.$descr.'</span>').'</td><td>'.$value.'</td></tr>';
	}

	public function AddonInfo($title)
	{
		return '<tr class="infolabel"><td colspan="2">'.$title.'</td></tr>';
	}

	public function AddEditCat($error,$title,$lang,$values,$multilang,$addon,$image_list,$cat_options)
	{
		$multil_text=$multil_check='';
		if($this->Mainclass->vars['multilang'])
		{
			$multil_check=array();
			$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
			foreach($multilang as $k=>$v)
			{
				$lang_title=ucfirst($k).' / '.ucfirst($this->Mainclass->langs[$k]);
				$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['description'] or !is_int($values['id'])),'value="'.$k.'"').' '.$lang_title;
				if($k==$this->Mainclass->lang_name)
					continue;
				$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').toggle();return false" class="ol_heading">
				'.(file_exists($this->Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
				<div id="table_'.$k.'">
					<table class="tabstyle tabform">
					<tr><td class="label">'.$this->Mainclass->lang['main']['title'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
					<tr><td class="label">'.$this->Mainclass->lang['main']['descr'].':</td><td>'.$this->Mainclass->Editor->Area('description_'.$k,$v['description'],5).'</td></tr>
					</table>
				</div>
				</li>';
			}
			$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
			$multil_check='<tr><td class="label">'.$this->Mainclass->lang['main']['set_for_langs'].'</td><td>'
			.Template::Check('one_lang',$values['one_lang'])
			.' <b>'.$this->Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
			.join('<br />',$multil_check).'</div></td></tr>';
		}
		$content=$this->Mainclass->Template->Title($title).($error ? $this->Mainclass->Template->Message($error) : '')
		.$this->Mainclass->Template->OpenTable()
		.'<ul id="blockstabs" class="linetabs">
		<li><a href="#" rel="tab1" class="selected"><b>'.$this->Mainclass->lang['main']['general'].'</b></a></li>
		'.($this->Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2" class="selected"><b>'.$this->Mainclass->lang['main']['other_langs'].'</b></a></li>' : '').'
		</ul>
		<form action="'.$this->Mainclass->Url->ConstructUrl(array('save'=>$values['id'])).'" method="post">
		<div id="tab1" class="tabcontent">
			<table class="tabstyle tabform">
			<tr><td class="label">'.$this->Mainclass->lang['main']['title'].'<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[ELEANOR_DEFAULT_LANGUAGE]['title']).'</td></tr>
			<tr><td class="label">'.$this->Mainclass->lang['main']['url'].':</td><td>'.Template::Edit('url',$values['url']).'</td></tr>
			<tr><td class="label">'.$lang['pos'].'</td><td>'.Template::Edit('pos',$values['pos']).'</td></tr>
			<tr><td class="label">'.$lang['meta_descr'].'</td><td>'.Template::Edit('s_descr',$values['s_descr'],'maxlength="250"').'</td></tr>
			<tr><td class="label">'.$lang['parent'].'</td><td>'.Template::Select('parent',Template::Option($this->Mainclass->lang['main']['no'],'0').$cat_options).'</td></tr>
			<tr><td class="label">'.$this->Mainclass->lang['main']['descr'].':</td><td>'.$this->Mainclass->Editor->Area('description',$multilang[ELEANOR_DEFAULT_LANGUAGE]['description'],5).'</td></tr>
			<tr><td class="label">'.$lang['picture'].'</td><td>'.Template::Select('image',Template::Option($this->Mainclass->lang['main']['no'],'0',empty($values['image'])).join('',$image_list),'onchange="document.images.preview.src=this.value==\'0\' ? \'images/categories/none.png\' : this.value"').'</td></tr>
			<tr><td class="label">'.$lang['preview'].':</td><td><img src="'.((!$values['image'] or !is_file($this->Mainclass->FormatPath($values['image']))) ? 'images/categories/none.png' : $values['image']).'" id="preview" alt="'.$lang['preview'].'" title="'.$lang['preview'].'" /></td></tr>
			'.$multil_check.$addon.'
			</table>
		</div>'.$multil_text;
		$back=isset($_POST['back']) ? base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		$content.='<div class="submitline">'.Template::Button().(is_int($values['id']) ? Template::Button($this->Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('delete'=>$values['id'])).'\'"') : '')
		.(!$back ? Template::Control('back','hidden',base64_encode($back)) : '').'</div>
		</form>
		<script type="text/javascript">
		var countries=new ddtabcontent("blockstabs");
		countries.setpersist(true);
		countries.setselectedClassTarget("link");
		countries.init();
		</script>'.$this->Mainclass->Template->CloseTable();
		return $content;
	}

	public function CatsListHead($title)
	{
		return $this->Mainclass->Template->Title($title)
		.$this->Mainclass->Template->OpenTable()
		.'<table class="tabstyle"><tr class="tablethhead"><th width="15">'.$this->Mainclass->lang['main']['id'].'</th><th>'.$this->Mainclass->lang['main']['name'].'</th><th>'.$this->Mainclass->lang['main']['url'].'</th><th width="80">'.$this->Mainclass->lang['main']['functs'].'</th></tr>';
	}

	public function CatsListRow($n,$v,$values,$updown)
	{
		return '<tr class="'.($n % 2 ? 'tabletrline2' : 'tabletrline1').'"><td align="center">'.$v.'</td><td>'.$values['title'].'</td><td >'.$values['url'].'</td><td class="function">'.$updown.'<a href="'.$this->Mainclass->Url->ConstructUrl(array('edit'=>$v)).'" title="'.$this->Mainclass->lang['main']['edit'].'"><img src="'.$this->Mainclass->Template->GetImage('edit.png').'" alt="'.$this->Mainclass->lang['main']['edit'].'" /></a><a href="'.$this->Mainclass->Url->ConstructUrl(array('delete'=>$v)).'" title="'.$this->Mainclass->lang['main']['delete'].'"><img src="'.$this->Mainclass->Template->GetImage('delete.png').'" alt="'.$this->Mainclass->lang['main']['delete'].'" /></a></td></tr>';
	}

	public function CatsListEmpty($lang)
	{
		return '<tr><td colspan="4" align="center"><b>'.$lang['no_categories'].'</b></td></tr>';
	}

	public function CatsListFoot()
	{
		return '</table>'.$this->Mainclass->Template->CloseTable();
	}
}
?>