<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor.ir, http://eleanor-cms.com
	E-mail: support@eleanor.ir
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym. See addons/copyrights/info.txt for more information.
*/
if(!defined('CMS'))
	die('Попытка взлома?');
$class_name='SettingsTPL';
class SettingsTPL extends BaseClass
{
	public function AddEditGroup($error,$htitle,$lang,$values,$multilang,$addon)
	{
		$multil_text=$multil_check='';
		if($this->Mainclass->vars['multilang'])
		{
			$multil_check=array();
			$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
			foreach($multilang as $k=>$v)
			{
				$lang_title=ucfirst($k).' / '.Strings::Ucfirst($this->Mainclass->langs[$k]);
				$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['descr'] or !is_int($values['id'])),'value="'.$k.'"').' '.$lang_title;
				if($k==$this->Mainclass->lang_name)
					continue;
				$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').slideToggle(\'slow\'); return false;" class="ol_heading">
				'.(file_exists($this->Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
				<div id="table_'.$k.'">
					<table class="tabstyle tabform">
					<tr><td class="label">'.$this->Mainclass->lang['main']['name'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
					<tr><td class="label">'.$lang['descr'].'</td><td>'.Template::Text('descr_'.$k,$v['descr']).'</td></tr>
					</table>
				</div>
				</li>';
			}
			$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
			$multil_check='<tr><td class="label">'.$this->Mainclass->lang['main']['set_for_langs'].'</td><td>'
			.Template::Check('one_lang',$values['one_lang'])
			.' <b>'.$this->Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
			.join('<br />',$multil_check).'</div></td></tr>';
		}

		$content=$this->Mainclass->Template->OpenTable()
		.($error ? $this->Mainclass->Template->Message($error) : '')
		.'<ul id="blockstabs" class="linetabs"><li><a href="#" rel="tab1" class="selected"><b>'.$this->Mainclass->lang['main']['general'].'</b></a></li>'
		.($this->Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2"><b>'.$this->Mainclass->lang['main']['other_langs'].'</b></a></li>' : '')
		.'</ul>
		<form action="'.$this->Mainclass->Url->ConstructUrl(array('save_group'=>$values['id'])).'" method="post">
		<div id="tab1" class="tabcontent">
			<table class="tabstyle tabform">
			<tr><td class="label">'.$this->Mainclass->lang['main']['name'].':<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$this->Mainclass->lang_name]['title']).'</td></tr>
			<tr><td class="label">'.$lang['descr'].'</td><td>'.Template::Text('descr',$multilang[$this->Mainclass->lang_name]['descr']).'</td></tr>
			<tr><td class="label">'.$lang['pos'].'</td><td>'.Template::Edit('position',$values['position']).'</td></tr>
			<tr><td class="label">'.$lang['keyw_g'].'<span class="imp">*</span></td><td>'.Template::Edit('keyword',$values['keyword'],$addon).'</td></tr>
			<tr><td class="label">'.$lang['priv_name'].'<span class="imp">*</span></td><td>'.Template::Edit('name',$values['name'],$addon).'</td></tr>'
		.($values['id']==='new' ? '<tr><td class="label">'.$lang['prot_g'].'</td><td>'.Template::Check('safe',isset($_POST['safe'])).'</td></tr>' : '')
		.$multil_check
		.'</table></div>'.$multil_text;
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		if(!empty($ref))
			$content.=Template::Control('back','hidden',base64_encode($ref));
		$content.='<div class="submitline">'.Template::Button().' '.($addon ? '' : Template::Button($this->Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('delete_group'=>$values['id'])).'\'"')).'</div></form></div></div></div>
		<script type="text/javascript">
		var countries=new ddtabcontent("blockstabs");
		countries.setpersist(true);
		countries.setselectedClassTarget("link");
		countries.init();
		</script>'.$this->Mainclass->Template->CloseTable();
		return $content;
	}

	public function OptionsGroupsRows($descr,$buttons)
	{
		return '<tr><td style="width:80%">'.$descr.'</td><td class="function">'.$buttons.'</td></tr>';
	}

	public function OptionsGroupsTable($content,$surl)
	{
		return $this->Mainclass->Template->OpenTable().'<table class="tabstyle tabform">'.$content.'</table>'
		.($surl ? '<form action="'.$surl.'" method="post"><div class="submitline" style="text-align: right;"><input style="width: 200px;" type="text" value="" name="sett_search_word" /><input class="button" type="submit" value="تایید" /></div></form>' : '').$this->Mainclass->Template->CloseTable();
	}

	public function OptionsHead($title)
	{
		return '';
	}

	public function OptionsListRows($descr,$option,$buttons,$multilang)
	{
		if($multilang)
		{
			$u=uniqid('lang_');
			$text=$flags='';
			$lang_sel='';
			foreach($option as $k=>$v)
			{
				if(!$lang_sel and $k==$this->Mainclass->lang_name)
					$lang_sel=' class="selected"';
				$text.='<div id="'.$u.$k.'" class="langtabcont">'.$v.'</div>';
				$flags.='<a href="#" rel="'.$u.$k.'"'.$lang_sel.' title="'.$k.'"><img src="images/lang_flags/'.$k.'.png" alt="'.$k.'" /></a>';
			}
			$text.='<div id="'.$u.'" class="langtabs">'.$flags.'</div>
			<script type="text/javascript">//<![CDATA[
			var '.$u.'=new ddtabcontent("'.$u.'");
			'.$u.'.setpersist(true);
			'.$u.'.setselectedClassTarget("link");
			'.$u.'.init();
			//]]></script>';
		}
		else
			$text=$option;
		return '<tr><td class="label">'.$descr.'</td><td>'.$text.'</td><td class="function" width="110">'.$buttons.'</td></tr>';
	}

	public function OptionsListTableCat($title,$content)
	{
		return $this->Mainclass->Template->Title($title).$this->Mainclass->Template->OpenTable().'<table class="tabstyle tabform">'.$content.'</table>'.$this->Mainclass->Template->CloseTable();
	}

	public function AddEditOption($lang,$htitle,$error,$values,$multilang,$cont_groups,$cont_types,$addon)
	{
		$multil_text=$multil_check='';
		if($this->Mainclass->vars['multilang'])
		{
			$multil_check=array();
			$multil_text='<div id="tab2" class="tabcontent"><ul class="editlang">';
			foreach($multilang as $k=>$v)
			{
				$lang_title=ucfirst($k).' / '.Strings::Ucfirst($this->Mainclass->langs[$k]);
				$multil_check[]=Template::Check('lang[]',$visible=($v['title'] or $v['descr'] or $v['value'] or $v['default'] or $v['extra']or $v['eval'] or !is_int($values['id'])),'value="'.$k.'"').' '.$lang_title;
				if($k==$this->Mainclass->lang_name)
					continue;
				$multil_text.='<li id="lang_'.$k.'" style="display:'.($visible ? 'block' : 'none').'"><a href="#" onclick="$(\'#table_'.$k.'\').slideToggle(\'slow\');return false" class="ol_heading">
				'.(file_exists($this->Mainclass->root_path.'images/lang_flags/'.$k.'.png') ? '<img src="images/lang_flags/'.$k.'.png" alt="'.$lang_title.'" /> ' : '').'<span>'.$lang_title.'</span></a>
				<div id="table_'.$k.'">
					<table class="tabstyle tabform">
					<tr><td class="label">'.$this->Mainclass->lang['main']['name'].':</td><td>'.Template::Edit('title_'.$k,$v['title']).'</td></tr>
					<tr><td class="label">'.$lang['descr'].'</td><td>'.Template::Text('descr_'.$k,$v['descr']).'</td></tr>
					<tr class="multilang"'.($values['multilang'] ? '' : ' style="display:none"').'><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($lang['hint_def'],ENT_QUOTES).'\')">(?)</span>'.$lang['value_op'].'</td><td>'.Template::Text('value_'.$k,$v['value']).'</td></tr>
					<tr class="multilang"'.($values['multilang'] ? '' : ' style="display:none"').'><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($lang['hint_def'],ENT_QUOTES).'\')">(?)</span>'.$lang['def_opt'].'</td><td>'.Template::Text('default_'.$k,$v['default']).'</td></tr>
					<tr class="multilang"'.($values['multilang'] ? '' : ' style="display:none"').'><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($lang['hint_extra'],ENT_QUOTES).'\')">(?)</span>'.$lang['addon_'].'</td><td>'.Template::Text('extra_'.$k,$v['extra'],$addon).'</td></tr>
					<tr class="multilang"'.($values['multilang'] ? '' : ' style="display:none"').'><td class="label">'.$lang['php_code'].'</td><td>'.Template::Text('eval_'.$k,$v['eval'],$addon).'</td></tr>
					<tr><td class="label">'.$lang['beg_subg'].'</td><td>'.Template::Edit('start_group_'.$k,$v['start_group']).'</td></tr>
					</table>
				</div>
				</li>';
			}
			$multil_text.='</ul><script type="text/javascript">DoMultiLangChecks()</script></div>';
			$multil_check='<tr><td class="label">'.$this->Mainclass->lang['main']['set_for_langs'].'</td><td>'
			.Template::Check('one_lang',$values['one_lang'])
			.' <b>'.$this->Mainclass->lang['main']['for_all_langs'].'</b><br /><div id="lang_checks" style="display:'.($values['one_lang'] ? 'none' : 'block').'">'
			.join('<br />',$multil_check).'</div></td></tr>';
		}
		$content=($error ? $this->Mainclass->Template->Message($error) : '')
		.$this->Mainclass->Template->OpenTable()
		.'<ul id="blockstabs" class="linetabs"><li><a href="#" rel="tab1" class="selected"><b>'.$this->Mainclass->lang['main']['general'].'</b></a></li>'
		.($this->Mainclass->vars['multilang'] ? '<li id="langs_tab" style="display:'.($values['one_lang'] ? 'none' : 'block').'"><a href="#" rel="tab2"><b>'.$this->Mainclass->lang['main']['other_langs'].'</b></a></li>' : '')
		.'</ul>
		<form action="'.$this->Mainclass->Url->ConstructUrl(array('save_option'=>$values['id'])).'" method="post">
		<div id="tab1" class="tabcontent">
			<table class="tabstyle tabform">
			<tr><td class="label">'.$this->Mainclass->lang['main']['name'].':<span class="imp">*</span></td><td>'.Template::Edit('title',$multilang[$this->Mainclass->lang_name]['title']).'</td></tr>
			<tr><td class="label">'.$lang['descr'].'</td><td>'.Template::Text('descr',$multilang[$this->Mainclass->lang_name]['descr']).'</td></tr>
			<tr><td class="label">'.$lang['group'].'<span class="imp">*</span></td><td>'.Template::Select('group',$cont_groups).'</td></tr>
			<tr><td class="label">'.$lang['pos'].'</td><td>'.Template::Edit('position',$values['position']).'</td></tr>
			<tr><td class="label">'.$lang['type'].'</td><td>'.Template::Select('type',$cont_types,$addon).'</td></tr>
			<tr><td class="label">'.$lang['key'].'</td><td>'.Template::Edit('name',$values['name'],$addon).'</td></tr>
			<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($lang['hint_def'],ENT_QUOTES).'\')">(?)</span>'.$lang['value_op'].'</td><td>'.Template::Text('value',$multilang[$this->Mainclass->lang_name]['value']).'</td></tr>
			<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($lang['hint_def'],ENT_QUOTES).'\')">(?)</span>'.$lang['def_opt'].'</td><td>'.Template::Text('default',$multilang[$this->Mainclass->lang_name]['default']).'</td></tr>
			<tr><td class="label"><span class="labinfo" onmouseover="ElTip(this,\''.htmlspecialchars($lang['hint_extra'],ENT_QUOTES).'\')">(?)</span>'.$lang['addon_'].'</td><td>'.Template::Text('extra',$multilang[$this->Mainclass->lang_name]['extra'],$addon).'</td></tr>
			<tr><td class="label">'.$lang['php_code'].'</td><td>'.Template::Text('eval',$multilang[$this->Mainclass->lang_name]['eval'],$addon).'</td></tr>
			<tr><td class="label">'.$lang['beg_subg'].'</td><td>'.Template::Edit('start_group',$multilang[$this->Mainclass->lang_name]['start_group']).'</td></tr>
			<tr><td class="label">'.$lang['end_subg'].'</td><td>'.Template::Check('end_group',$values['end_group']).'</td></tr>
			<tr><td class="label">'.$lang['add_to_cache'].'</td><td>'.Template::Check('cache',$values['cache'],$addon).'</td></tr>
			<tr><td class="label">'.$lang['multilang'].'</td><td>'.Template::Check('multilang',$values['multilang'],'onclick="if(this.checked) $(\'.multilang\').show();else $(\'.multilang\').hide();"').'</td></tr>'
		.($values['id']==='new' ? '<tr><td class="label">'.$lang['prot_opt'].'</td><td>'.Template::Check('safe',isset($_POST['safe'])).'</td></tr>' : '')
		.$multil_check
		.'</table></div>'.$multil_text;
		$ref=isset($_POST['back']) ? @base64_decode($_POST['back']) : $this->Mainclass->MyGetEnv('HTTP_REFERER');
		if(!empty($ref))
			$content.=Template::Control('back','hidden',base64_encode($ref));
		$content.='<div class="submitline">'.Template::Button().' '.($addon ? '' : Template::Button($this->Mainclass->lang['main']['delete'],'button','onclick="window.location=\''.$this->Mainclass->Url->ConstructUrl(array('sett_DeleteOption'=>$values['id'])).'\'"')).'</div></form>
		<script type="text/javascript">
		var countries=new ddtabcontent("blockstabs");
		countries.setpersist(true);
		countries.setselectedClassTarget("link");
		countries.init();
		</script>'.$this->Mainclass->Template->CloseTable();
		return $content;
	}

	public function ExpOptsDiv($lang,$o_gid,$options)
	{
		return '<div><a href="#" onclick="$(\'#optsdiv_'.$o_gid.'\').slideToggle(\'false\');return false">'.$lang['show_hide_g'].'</a><div id="optsdiv_'.$o_gid.'" style="display:none"><table class="tabstyle">'.$options.'</table></div></div>';
	}

	public function ExpOptsTr($ng,$o_gid,$o_title,$options)
	{
		return '<tr class="'.($ng % 2 ? 'tabletrline2' : 'tabletrline1').'"><td align="center" >'.Template::Check('groups[]',false,'value="'.$o_gid.'" id="gr_'.$o_gid.'"').'</td><td><b>'.$o_title.'</b>'.$options.'</td></tr>';
	}

	public function ExpOptsValuesTr($no,$cid,$descr,$title)
	{
		return '<tr class="'.($no % 2 ? 'tabletrline2' : 'tabletrline1').'"><td align="center" width="15">'.Template::Check('options[]',false,'value="'.$cid.'"').'</td><td title="'.htmlspecialchars(strip_tags($descr),ENT_QUOTES).'"><i>'.$title.'</i></td></tr>';
	}

	public function ExpPage($lang,$content)
	{
		return $this->Mainclass->Template->OpenTable()
		.'<form action="'.$this->Mainclass->Url->ConstructUrl(array(array('sett_do'=>'export_do'))).'" method="post"><table class="tabstyle" id="table_ch"><tr class="tablethhead"><th width="15">'.Template::Check('all',false,'id="all_ch"').'</th><th>'.EL_OPTIONS.'</th></tr>'
		.$content.'</table><div class="submitline">'.Template::Button($lang['do_export']).'</div></form>'.$this->Mainclass->Template->CloseTable();
	}

	public function ImportPage($lang,$error)
	{
		return ($error ? $this->Mainclass->Template->Message($error) : '')
		.$this->Mainclass->Template->OpenTable()
		.'<form action="'.$this->Mainclass->Url->ConstructUrl(array(array('sett_do'=>'import_do'))).'" method="post" enctype="multipart/form-data"><table class="tabstyle tabform"><tr class="tabletrline1"><td class="label">'.$lang['select_file_im'].'</td><td>'.Template::Control('import','file').'</td></tr>		</table><div class="submitline">'.Template::Button($lang['do_import']).'</div></form>'
		.$this->Mainclass->Template->CloseTable();
	}
}
?>